
# Ensures that the stubs are picked up - thanks, numpy project
import typing
json = dict
from pathlib import Path
from typing import Set, Type, TypeVar
T = TypeVar('T')
import MessageQueue
import datetime
import numpy
from . import nn_archive as nn_archive, node as node
from _typeshed import Incomplete
from typing import Callable, ClassVar, Iterable, Iterator, overload

LINE_LIST: PointsAnnotationType
LINE_LOOP: PointsAnnotationType
LINE_STRIP: PointsAnnotationType
POINTS: PointsAnnotationType
UNKNOWN: PointsAnnotationType
X_LINK_ALREADY_OPEN: XLinkError_t
X_LINK_ANY_PLATFORM: XLinkPlatform
X_LINK_ANY_PROTOCOL: XLinkProtocol
X_LINK_ANY_STATE: XLinkDeviceState
X_LINK_BOOTED: XLinkDeviceState
X_LINK_BOOTED_NON_EXCLUSIVE: XLinkDeviceState
X_LINK_BOOTLOADER: XLinkDeviceState
X_LINK_COMMUNICATION_FAIL: XLinkError_t
X_LINK_COMMUNICATION_NOT_OPEN: XLinkError_t
X_LINK_COMMUNICATION_UNKNOWN_ERROR: XLinkError_t
X_LINK_DEVICE_ALREADY_IN_USE: XLinkError_t
X_LINK_DEVICE_NOT_FOUND: XLinkError_t
X_LINK_ERROR: XLinkError_t
X_LINK_FLASH_BOOTED: XLinkDeviceState
X_LINK_GATE: XLinkDeviceState
X_LINK_GATE_BOOTED: XLinkDeviceState
X_LINK_INIT_PCIE_ERROR: XLinkError_t
X_LINK_INIT_TCP_IP_ERROR: XLinkError_t
X_LINK_INIT_USB_ERROR: XLinkError_t
X_LINK_INSUFFICIENT_PERMISSIONS: XLinkError_t
X_LINK_IPC: XLinkProtocol
X_LINK_MYRIAD_2: XLinkPlatform
X_LINK_MYRIAD_X: XLinkPlatform
X_LINK_NMB_OF_PROTOCOLS: XLinkProtocol
X_LINK_NOT_IMPLEMENTED: XLinkError_t
X_LINK_OUT_OF_MEMORY: XLinkError_t
X_LINK_PCIE: XLinkProtocol
X_LINK_RVC3: XLinkPlatform
X_LINK_RVC4: XLinkPlatform
X_LINK_SUCCESS: XLinkError_t
X_LINK_TCP_IP: XLinkProtocol
X_LINK_TIMEOUT: XLinkError_t
X_LINK_UNBOOTED: XLinkDeviceState
X_LINK_USB_CDC: XLinkProtocol
X_LINK_USB_VSC: XLinkProtocol
__bootloader_version__: str
__build_datetime__: str
__commit__: str
__commit_datetime__: str
__device_rvc3_version__: str
__device_rvc4_version__: str
__device_version__: str
__init_subclass__: Callable
__version__: str
createSubnode: Callable

class ADatatype:
    def __init__(self) -> None:
        """__init__(self: depthai.ADatatype) -> None"""

class AprilTag:
    bottomLeft: Point2f
    bottomRight: Point2f
    decisionMargin: Incomplete
    hamming: int
    id: int
    topLeft: Point2f
    topRight: Point2f
    def __init__(self) -> None:
        """__init__(self: depthai.AprilTag) -> None"""

class AprilTagConfig(Buffer):
    class Family:
        __members__: ClassVar[dict] = ...  # read-only
        TAG_16H5: ClassVar[AprilTagConfig.Family] = ...
        TAG_25H9: ClassVar[AprilTagConfig.Family] = ...
        TAG_36H10: ClassVar[AprilTagConfig.Family] = ...
        TAG_36H11: ClassVar[AprilTagConfig.Family] = ...
        TAG_CIR21H7: ClassVar[AprilTagConfig.Family] = ...
        TAG_STAND41H12: ClassVar[AprilTagConfig.Family] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.AprilTagConfig.Family, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.AprilTagConfig.Family) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.AprilTagConfig.Family) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class QuadThresholds:
        criticalDegree: float
        deglitch: bool
        maxLineFitMse: float
        maxNmaxima: int
        minClusterPixels: int
        minWhiteBlackDiff: int
        def __init__(self) -> None:
            """__init__(self: depthai.AprilTagConfig.QuadThresholds) -> None"""
    decodeSharpening: float
    family: AprilTagConfig.Family
    maxHammingDistance: int
    quadDecimate: int
    quadSigma: float
    quadThresholds: AprilTagConfig.QuadThresholds
    refineEdges: bool
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.AprilTagConfig) -> None

        2. __init__(self: depthai.AprilTagConfig) -> None
        """
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.AprilTagConfig) -> None

        2. __init__(self: depthai.AprilTagConfig) -> None
        """
    def setFamily(self, family: AprilTagConfig.Family) -> AprilTagConfig:
        """setFamily(self: depthai.AprilTagConfig, family: depthai.AprilTagConfig.Family) -> depthai.AprilTagConfig

        Parameter ``family``:
            AprilTag family
        """

class AprilTagProperties:
    initialConfig: AprilTagConfig
    inputConfigSync: bool
    numThreads: int
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class AprilTags(Buffer):
    aprilTags: list[AprilTag]
    def __init__(self) -> None:
        """__init__(self: depthai.AprilTags) -> None"""
    def getSequenceNum(self) -> int:
        """getSequenceNum(self: depthai.AprilTags) -> int

        Retrieves image sequence number
        """
    def getTimestamp(self) -> datetime.timedelta:
        """getTimestamp(self: depthai.AprilTags) -> datetime.timedelta

        Retrieves timestamp related to dai::Clock::now()
        """
    def getTimestampDevice(self) -> datetime.timedelta:
        """getTimestampDevice(self: depthai.AprilTags) -> datetime.timedelta

        Retrieves timestamp directly captured from device's monotonic clock, not
        synchronized to host time. Used mostly for debugging
        """

class Asset:
    alignment: int
    data: numpy.ndarray[numpy.uint8]
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Asset) -> None

        2. __init__(self: depthai.Asset, arg0: str) -> None
        """
    @overload
    def __init__(self, arg0: str) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Asset) -> None

        2. __init__(self: depthai.Asset, arg0: str) -> None
        """
    @property
    def key(self) -> str: ...

class AssetManager:
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.AssetManager) -> None

        2. __init__(self: depthai.AssetManager, arg0: str) -> None
        """
    @overload
    def __init__(self, arg0: str) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.AssetManager) -> None

        2. __init__(self: depthai.AssetManager, arg0: str) -> None
        """
    def addExisting(self, assets: list[Asset]) -> None:
        """addExisting(self: depthai.AssetManager, assets: list[depthai.Asset]) -> None

        Adds all assets in an array to the AssetManager

        Parameter ``assets``:
            Vector of assets to add
        """
    @overload
    def get(self, key: str) -> Asset:
        """get(*args, **kwargs)
        Overloaded function.

        1. get(self: depthai.AssetManager, key: str) -> depthai.Asset

        Returns:
            Asset assigned to the specified key or a nullptr otherwise

        2. get(self: depthai.AssetManager, key: str) -> depthai.Asset

        Returns:
            Asset assigned to the specified key or a nullptr otherwise
        """
    @overload
    def get(self, key: str) -> Asset:
        """get(*args, **kwargs)
        Overloaded function.

        1. get(self: depthai.AssetManager, key: str) -> depthai.Asset

        Returns:
            Asset assigned to the specified key or a nullptr otherwise

        2. get(self: depthai.AssetManager, key: str) -> depthai.Asset

        Returns:
            Asset assigned to the specified key or a nullptr otherwise
        """
    @overload
    def getAll(self) -> list[Asset]:
        """getAll(*args, **kwargs)
        Overloaded function.

        1. getAll(self: depthai.AssetManager) -> list[depthai.Asset]

        Returns:
            All asset stored in the AssetManager

        2. getAll(self: depthai.AssetManager) -> list[depthai.Asset]

        Returns:
            All asset stored in the AssetManager
        """
    @overload
    def getAll(self) -> list[Asset]:
        """getAll(*args, **kwargs)
        Overloaded function.

        1. getAll(self: depthai.AssetManager) -> list[depthai.Asset]

        Returns:
            All asset stored in the AssetManager

        2. getAll(self: depthai.AssetManager) -> list[depthai.Asset]

        Returns:
            All asset stored in the AssetManager
        """
    def getRootPath(self) -> str:
        """getRootPath(self: depthai.AssetManager) -> str

        Get root path of the asset manager

        Returns:
            Root path
        """
    def remove(self, key: str) -> None:
        """remove(self: depthai.AssetManager, key: str) -> None

        Removes asset with key

        Parameter ``key``:
            Key of asset to remove
        """
    @overload
    def set(self, asset: Asset) -> Asset:
        """set(*args, **kwargs)
        Overloaded function.

        1. set(self: depthai.AssetManager, asset: depthai.Asset) -> depthai.Asset

        Adds or overwrites an asset object to AssetManager.

        Parameter ``asset``:
            Asset to add

        Returns:
            Shared pointer to asset

        2. set(self: depthai.AssetManager, key: str, asset: depthai.Asset) -> depthai.Asset

        Adds or overwrites an asset object to AssetManager with a specified key. Key
        value will be assigned to an Asset as well

        Parameter ``key``:
            Key under which the asset should be stored

        Parameter ``asset``:
            Asset to store

        Returns:
            Shared pointer to asset

        3. set(self: depthai.AssetManager, key: str, path: Path, alignment: int = 64) -> depthai.Asset

        Loads file into asset manager under specified key.

        Parameter ``key``:
            Key under which the asset should be stored

        Parameter ``path``:
            Path to file which to load as asset

        Parameter ``alignment``:
            [Optional] alignment of asset data in asset storage. Default is 64B

        4. set(self: depthai.AssetManager, key: str, data: list[int], alignment: int = 64) -> depthai.Asset

        Loads file into asset manager under specified key.

        Parameter ``key``:
            Key under which the asset should be stored

        Parameter ``data``:
            Asset data

        Parameter ``alignment``:
            [Optional] alignment of asset data in asset storage. Default is 64B

        Returns:
            Shared pointer to asset
        """
    @overload
    def set(self, key: str, asset: Asset) -> Asset:
        """set(*args, **kwargs)
        Overloaded function.

        1. set(self: depthai.AssetManager, asset: depthai.Asset) -> depthai.Asset

        Adds or overwrites an asset object to AssetManager.

        Parameter ``asset``:
            Asset to add

        Returns:
            Shared pointer to asset

        2. set(self: depthai.AssetManager, key: str, asset: depthai.Asset) -> depthai.Asset

        Adds or overwrites an asset object to AssetManager with a specified key. Key
        value will be assigned to an Asset as well

        Parameter ``key``:
            Key under which the asset should be stored

        Parameter ``asset``:
            Asset to store

        Returns:
            Shared pointer to asset

        3. set(self: depthai.AssetManager, key: str, path: Path, alignment: int = 64) -> depthai.Asset

        Loads file into asset manager under specified key.

        Parameter ``key``:
            Key under which the asset should be stored

        Parameter ``path``:
            Path to file which to load as asset

        Parameter ``alignment``:
            [Optional] alignment of asset data in asset storage. Default is 64B

        4. set(self: depthai.AssetManager, key: str, data: list[int], alignment: int = 64) -> depthai.Asset

        Loads file into asset manager under specified key.

        Parameter ``key``:
            Key under which the asset should be stored

        Parameter ``data``:
            Asset data

        Parameter ``alignment``:
            [Optional] alignment of asset data in asset storage. Default is 64B

        Returns:
            Shared pointer to asset
        """
    @overload
    def set(self, key: str, path: Path, alignment: int = ...) -> Asset:
        """set(*args, **kwargs)
        Overloaded function.

        1. set(self: depthai.AssetManager, asset: depthai.Asset) -> depthai.Asset

        Adds or overwrites an asset object to AssetManager.

        Parameter ``asset``:
            Asset to add

        Returns:
            Shared pointer to asset

        2. set(self: depthai.AssetManager, key: str, asset: depthai.Asset) -> depthai.Asset

        Adds or overwrites an asset object to AssetManager with a specified key. Key
        value will be assigned to an Asset as well

        Parameter ``key``:
            Key under which the asset should be stored

        Parameter ``asset``:
            Asset to store

        Returns:
            Shared pointer to asset

        3. set(self: depthai.AssetManager, key: str, path: Path, alignment: int = 64) -> depthai.Asset

        Loads file into asset manager under specified key.

        Parameter ``key``:
            Key under which the asset should be stored

        Parameter ``path``:
            Path to file which to load as asset

        Parameter ``alignment``:
            [Optional] alignment of asset data in asset storage. Default is 64B

        4. set(self: depthai.AssetManager, key: str, data: list[int], alignment: int = 64) -> depthai.Asset

        Loads file into asset manager under specified key.

        Parameter ``key``:
            Key under which the asset should be stored

        Parameter ``data``:
            Asset data

        Parameter ``alignment``:
            [Optional] alignment of asset data in asset storage. Default is 64B

        Returns:
            Shared pointer to asset
        """
    @overload
    def set(self, key: str, data: list[int], alignment: int = ...) -> Asset:
        """set(*args, **kwargs)
        Overloaded function.

        1. set(self: depthai.AssetManager, asset: depthai.Asset) -> depthai.Asset

        Adds or overwrites an asset object to AssetManager.

        Parameter ``asset``:
            Asset to add

        Returns:
            Shared pointer to asset

        2. set(self: depthai.AssetManager, key: str, asset: depthai.Asset) -> depthai.Asset

        Adds or overwrites an asset object to AssetManager with a specified key. Key
        value will be assigned to an Asset as well

        Parameter ``key``:
            Key under which the asset should be stored

        Parameter ``asset``:
            Asset to store

        Returns:
            Shared pointer to asset

        3. set(self: depthai.AssetManager, key: str, path: Path, alignment: int = 64) -> depthai.Asset

        Loads file into asset manager under specified key.

        Parameter ``key``:
            Key under which the asset should be stored

        Parameter ``path``:
            Path to file which to load as asset

        Parameter ``alignment``:
            [Optional] alignment of asset data in asset storage. Default is 64B

        4. set(self: depthai.AssetManager, key: str, data: list[int], alignment: int = 64) -> depthai.Asset

        Loads file into asset manager under specified key.

        Parameter ``key``:
            Key under which the asset should be stored

        Parameter ``data``:
            Asset data

        Parameter ``alignment``:
            [Optional] alignment of asset data in asset storage. Default is 64B

        Returns:
            Shared pointer to asset
        """
    def size(self) -> int:
        """size(self: depthai.AssetManager) -> int

        Returns:
            Number of asset stored in the AssetManager
        """

class BenchmarkReport(Buffer):
    def __init__(self) -> None:
        """__init__(self: depthai.BenchmarkReport) -> None"""
    @property
    def averageLatency(self) -> float: ...
    @property
    def fps(self) -> float: ...
    @property
    def latencies(self) -> list[float]: ...
    @property
    def numMessagesReceived(self) -> float: ...
    @property
    def timeTotal(self) -> float: ...

class BoardConfig:
    class GPIO:
        class Direction:
            __members__: ClassVar[dict] = ...  # read-only
            INPUT: ClassVar[BoardConfig.GPIO.Direction] = ...
            OUTPUT: ClassVar[BoardConfig.GPIO.Direction] = ...
            __entries: ClassVar[dict] = ...
            def __init__(self, value: int) -> None:
                """__init__(self: depthai.BoardConfig.GPIO.Direction, value: int) -> None"""
            def __eq__(self, other: object) -> bool:
                """__eq__(self: object, other: object) -> bool"""
            def __hash__(self) -> int:
                """__hash__(self: object) -> int"""
            def __index__(self) -> int:
                """__index__(self: depthai.BoardConfig.GPIO.Direction) -> int"""
            def __int__(self) -> int:
                """__int__(self: depthai.BoardConfig.GPIO.Direction) -> int"""
            def __ne__(self, other: object) -> bool:
                """__ne__(self: object, other: object) -> bool"""
            @property
            def name(self) -> str: ...
            @property
            def value(self) -> int: ...

        class Drive:
            __members__: ClassVar[dict] = ...  # read-only
            MA_12: ClassVar[BoardConfig.GPIO.Drive] = ...
            MA_2: ClassVar[BoardConfig.GPIO.Drive] = ...
            MA_4: ClassVar[BoardConfig.GPIO.Drive] = ...
            MA_8: ClassVar[BoardConfig.GPIO.Drive] = ...
            __entries: ClassVar[dict] = ...
            def __init__(self, value: int) -> None:
                """__init__(self: depthai.BoardConfig.GPIO.Drive, value: int) -> None"""
            def __eq__(self, other: object) -> bool:
                """__eq__(self: object, other: object) -> bool"""
            def __hash__(self) -> int:
                """__hash__(self: object) -> int"""
            def __index__(self) -> int:
                """__index__(self: depthai.BoardConfig.GPIO.Drive) -> int"""
            def __int__(self) -> int:
                """__int__(self: depthai.BoardConfig.GPIO.Drive) -> int"""
            def __ne__(self, other: object) -> bool:
                """__ne__(self: object, other: object) -> bool"""
            @property
            def name(self) -> str: ...
            @property
            def value(self) -> int: ...

        class Level:
            __members__: ClassVar[dict] = ...  # read-only
            HIGH: ClassVar[BoardConfig.GPIO.Level] = ...
            LOW: ClassVar[BoardConfig.GPIO.Level] = ...
            __entries: ClassVar[dict] = ...
            def __init__(self, value: int) -> None:
                """__init__(self: depthai.BoardConfig.GPIO.Level, value: int) -> None"""
            def __eq__(self, other: object) -> bool:
                """__eq__(self: object, other: object) -> bool"""
            def __hash__(self) -> int:
                """__hash__(self: object) -> int"""
            def __index__(self) -> int:
                """__index__(self: depthai.BoardConfig.GPIO.Level) -> int"""
            def __int__(self) -> int:
                """__int__(self: depthai.BoardConfig.GPIO.Level) -> int"""
            def __ne__(self, other: object) -> bool:
                """__ne__(self: object, other: object) -> bool"""
            @property
            def name(self) -> str: ...
            @property
            def value(self) -> int: ...

        class Mode:
            __members__: ClassVar[dict] = ...  # read-only
            ALT_MODE_0: ClassVar[BoardConfig.GPIO.Mode] = ...
            ALT_MODE_1: ClassVar[BoardConfig.GPIO.Mode] = ...
            ALT_MODE_2: ClassVar[BoardConfig.GPIO.Mode] = ...
            ALT_MODE_3: ClassVar[BoardConfig.GPIO.Mode] = ...
            ALT_MODE_4: ClassVar[BoardConfig.GPIO.Mode] = ...
            ALT_MODE_5: ClassVar[BoardConfig.GPIO.Mode] = ...
            ALT_MODE_6: ClassVar[BoardConfig.GPIO.Mode] = ...
            DIRECT: ClassVar[BoardConfig.GPIO.Mode] = ...
            __entries: ClassVar[dict] = ...
            def __init__(self, value: int) -> None:
                """__init__(self: depthai.BoardConfig.GPIO.Mode, value: int) -> None"""
            def __eq__(self, other: object) -> bool:
                """__eq__(self: object, other: object) -> bool"""
            def __hash__(self) -> int:
                """__hash__(self: object) -> int"""
            def __index__(self) -> int:
                """__index__(self: depthai.BoardConfig.GPIO.Mode) -> int"""
            def __int__(self) -> int:
                """__int__(self: depthai.BoardConfig.GPIO.Mode) -> int"""
            def __ne__(self, other: object) -> bool:
                """__ne__(self: object, other: object) -> bool"""
            @property
            def name(self) -> str: ...
            @property
            def value(self) -> int: ...

        class Pull:
            __members__: ClassVar[dict] = ...  # read-only
            BUS_KEEPER: ClassVar[BoardConfig.GPIO.Pull] = ...
            NO_PULL: ClassVar[BoardConfig.GPIO.Pull] = ...
            PULL_DOWN: ClassVar[BoardConfig.GPIO.Pull] = ...
            PULL_UP: ClassVar[BoardConfig.GPIO.Pull] = ...
            __entries: ClassVar[dict] = ...
            def __init__(self, value: int) -> None:
                """__init__(self: depthai.BoardConfig.GPIO.Pull, value: int) -> None"""
            def __eq__(self, other: object) -> bool:
                """__eq__(self: object, other: object) -> bool"""
            def __hash__(self) -> int:
                """__hash__(self: object) -> int"""
            def __index__(self) -> int:
                """__index__(self: depthai.BoardConfig.GPIO.Pull) -> int"""
            def __int__(self) -> int:
                """__int__(self: depthai.BoardConfig.GPIO.Pull) -> int"""
            def __ne__(self, other: object) -> bool:
                """__ne__(self: object, other: object) -> bool"""
            @property
            def name(self) -> str: ...
            @property
            def value(self) -> int: ...
        ALT_MODE_0: ClassVar[BoardConfig.GPIO.Mode] = ...
        ALT_MODE_1: ClassVar[BoardConfig.GPIO.Mode] = ...
        ALT_MODE_2: ClassVar[BoardConfig.GPIO.Mode] = ...
        ALT_MODE_3: ClassVar[BoardConfig.GPIO.Mode] = ...
        ALT_MODE_4: ClassVar[BoardConfig.GPIO.Mode] = ...
        ALT_MODE_5: ClassVar[BoardConfig.GPIO.Mode] = ...
        ALT_MODE_6: ClassVar[BoardConfig.GPIO.Mode] = ...
        BUS_KEEPER: ClassVar[BoardConfig.GPIO.Pull] = ...
        DIRECT: ClassVar[BoardConfig.GPIO.Mode] = ...
        HIGH: ClassVar[BoardConfig.GPIO.Level] = ...
        INPUT: ClassVar[BoardConfig.GPIO.Direction] = ...
        LOW: ClassVar[BoardConfig.GPIO.Level] = ...
        MA_12: ClassVar[BoardConfig.GPIO.Drive] = ...
        MA_2: ClassVar[BoardConfig.GPIO.Drive] = ...
        MA_4: ClassVar[BoardConfig.GPIO.Drive] = ...
        MA_8: ClassVar[BoardConfig.GPIO.Drive] = ...
        NO_PULL: ClassVar[BoardConfig.GPIO.Pull] = ...
        OUTPUT: ClassVar[BoardConfig.GPIO.Direction] = ...
        PULL_DOWN: ClassVar[BoardConfig.GPIO.Pull] = ...
        PULL_UP: ClassVar[BoardConfig.GPIO.Pull] = ...
        direction: BoardConfig.GPIO.Direction
        drive: BoardConfig.GPIO.Drive
        level: BoardConfig.GPIO.Level
        mode: BoardConfig.GPIO.Mode
        pull: BoardConfig.GPIO.Pull
        schmitt: bool
        slewFast: bool
        @overload
        def __init__(self) -> None:
            """__init__(*args, **kwargs)
            Overloaded function.

            1. __init__(self: depthai.BoardConfig.GPIO) -> None

            2. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction) -> None

            3. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Level) -> None

            4. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Level, arg2: depthai.BoardConfig.GPIO.Pull) -> None

            5. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Mode) -> None

            6. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Mode, arg2: depthai.BoardConfig.GPIO.Pull) -> None
            """
        @overload
        def __init__(self, arg0: BoardConfig.GPIO.Direction) -> None:
            """__init__(*args, **kwargs)
            Overloaded function.

            1. __init__(self: depthai.BoardConfig.GPIO) -> None

            2. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction) -> None

            3. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Level) -> None

            4. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Level, arg2: depthai.BoardConfig.GPIO.Pull) -> None

            5. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Mode) -> None

            6. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Mode, arg2: depthai.BoardConfig.GPIO.Pull) -> None
            """
        @overload
        def __init__(self, arg0: BoardConfig.GPIO.Direction, arg1: BoardConfig.GPIO.Level) -> None:
            """__init__(*args, **kwargs)
            Overloaded function.

            1. __init__(self: depthai.BoardConfig.GPIO) -> None

            2. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction) -> None

            3. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Level) -> None

            4. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Level, arg2: depthai.BoardConfig.GPIO.Pull) -> None

            5. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Mode) -> None

            6. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Mode, arg2: depthai.BoardConfig.GPIO.Pull) -> None
            """
        @overload
        def __init__(self, arg0: BoardConfig.GPIO.Direction, arg1: BoardConfig.GPIO.Level, arg2: BoardConfig.GPIO.Pull) -> None:
            """__init__(*args, **kwargs)
            Overloaded function.

            1. __init__(self: depthai.BoardConfig.GPIO) -> None

            2. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction) -> None

            3. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Level) -> None

            4. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Level, arg2: depthai.BoardConfig.GPIO.Pull) -> None

            5. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Mode) -> None

            6. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Mode, arg2: depthai.BoardConfig.GPIO.Pull) -> None
            """
        @overload
        def __init__(self, arg0: BoardConfig.GPIO.Direction, arg1: BoardConfig.GPIO.Mode) -> None:
            """__init__(*args, **kwargs)
            Overloaded function.

            1. __init__(self: depthai.BoardConfig.GPIO) -> None

            2. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction) -> None

            3. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Level) -> None

            4. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Level, arg2: depthai.BoardConfig.GPIO.Pull) -> None

            5. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Mode) -> None

            6. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Mode, arg2: depthai.BoardConfig.GPIO.Pull) -> None
            """
        @overload
        def __init__(self, arg0: BoardConfig.GPIO.Direction, arg1: BoardConfig.GPIO.Mode, arg2: BoardConfig.GPIO.Pull) -> None:
            """__init__(*args, **kwargs)
            Overloaded function.

            1. __init__(self: depthai.BoardConfig.GPIO) -> None

            2. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction) -> None

            3. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Level) -> None

            4. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Level, arg2: depthai.BoardConfig.GPIO.Pull) -> None

            5. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Mode) -> None

            6. __init__(self: depthai.BoardConfig.GPIO, arg0: depthai.BoardConfig.GPIO.Direction, arg1: depthai.BoardConfig.GPIO.Mode, arg2: depthai.BoardConfig.GPIO.Pull) -> None
            """

    class GPIOMap:
        def __init__(self) -> None:
            """__init__(self: depthai.BoardConfig.GPIOMap) -> None"""
        def items(self) -> BoardConfig.ItemsView:
            """items(self: depthai.BoardConfig.GPIOMap) -> depthai.BoardConfig.ItemsView"""
        def keys(self) -> BoardConfig.KeysView:
            """keys(self: depthai.BoardConfig.GPIOMap) -> depthai.BoardConfig.KeysView"""
        def values(self) -> BoardConfig.ValuesView:
            """values(self: depthai.BoardConfig.GPIOMap) -> depthai.BoardConfig.ValuesView"""
        def __bool__(self) -> bool:
            """__bool__(self: depthai.BoardConfig.GPIOMap) -> bool

            Check whether the map is nonempty
            """
        @overload
        def __contains__(self, arg0: int) -> bool:
            """__contains__(*args, **kwargs)
            Overloaded function.

            1. __contains__(self: depthai.BoardConfig.GPIOMap, arg0: int) -> bool

            2. __contains__(self: depthai.BoardConfig.GPIOMap, arg0: object) -> bool
            """
        @overload
        def __contains__(self, arg0: object) -> bool:
            """__contains__(*args, **kwargs)
            Overloaded function.

            1. __contains__(self: depthai.BoardConfig.GPIOMap, arg0: int) -> bool

            2. __contains__(self: depthai.BoardConfig.GPIOMap, arg0: object) -> bool
            """
        def __delitem__(self, arg0: int) -> None:
            """__delitem__(self: depthai.BoardConfig.GPIOMap, arg0: int) -> None"""
        def __getitem__(self, arg0: int) -> BoardConfig.GPIO:
            """__getitem__(self: depthai.BoardConfig.GPIOMap, arg0: int) -> depthai.BoardConfig.GPIO"""
        def __iter__(self) -> Iterator[int]:
            """__iter__(self: depthai.BoardConfig.GPIOMap) -> Iterator[int]"""
        def __len__(self) -> int:
            """__len__(self: depthai.BoardConfig.GPIOMap) -> int"""
        def __setitem__(self, arg0: int, arg1: BoardConfig.GPIO) -> None:
            """__setitem__(self: depthai.BoardConfig.GPIOMap, arg0: int, arg1: depthai.BoardConfig.GPIO) -> None"""

    class ItemsView:
        def __init__(self, *args, **kwargs) -> None:
            """Initialize self.  See help(type(self)) for accurate signature."""
        def __iter__(self) -> Iterator:
            """__iter__(self: depthai.BoardConfig.ItemsView) -> Iterator"""
        def __len__(self) -> int:
            """__len__(self: depthai.BoardConfig.ItemsView) -> int"""

    class KeysView:
        def __init__(self, *args, **kwargs) -> None:
            """Initialize self.  See help(type(self)) for accurate signature."""
        def __contains__(self, arg0: object) -> bool:
            """__contains__(self: depthai.BoardConfig.KeysView, arg0: object) -> bool"""
        def __iter__(self) -> Iterator:
            """__iter__(self: depthai.BoardConfig.KeysView) -> Iterator"""
        def __len__(self) -> int:
            """__len__(self: depthai.BoardConfig.KeysView) -> int"""

    class Network:
        mtu: int
        xlinkTcpNoDelay: bool
        def __init__(self) -> None:
            """__init__(self: depthai.BoardConfig.Network) -> None"""

    class UART:
        tmp: int
        def __init__(self) -> None:
            """__init__(self: depthai.BoardConfig.UART) -> None"""

    class UARTMap:
        def __init__(self) -> None:
            """__init__(self: depthai.BoardConfig.UARTMap) -> None"""
        def items(self) -> BoardConfig.ItemsView:
            """items(self: depthai.BoardConfig.UARTMap) -> depthai.BoardConfig.ItemsView"""
        def keys(self) -> BoardConfig.KeysView:
            """keys(self: depthai.BoardConfig.UARTMap) -> depthai.BoardConfig.KeysView"""
        def values(self) -> BoardConfig.ValuesView:
            """values(self: depthai.BoardConfig.UARTMap) -> depthai.BoardConfig.ValuesView"""
        def __bool__(self) -> bool:
            """__bool__(self: depthai.BoardConfig.UARTMap) -> bool

            Check whether the map is nonempty
            """
        @overload
        def __contains__(self, arg0: int) -> bool:
            """__contains__(*args, **kwargs)
            Overloaded function.

            1. __contains__(self: depthai.BoardConfig.UARTMap, arg0: int) -> bool

            2. __contains__(self: depthai.BoardConfig.UARTMap, arg0: object) -> bool
            """
        @overload
        def __contains__(self, arg0: object) -> bool:
            """__contains__(*args, **kwargs)
            Overloaded function.

            1. __contains__(self: depthai.BoardConfig.UARTMap, arg0: int) -> bool

            2. __contains__(self: depthai.BoardConfig.UARTMap, arg0: object) -> bool
            """
        def __delitem__(self, arg0: int) -> None:
            """__delitem__(self: depthai.BoardConfig.UARTMap, arg0: int) -> None"""
        def __getitem__(self, arg0: int) -> BoardConfig.UART:
            """__getitem__(self: depthai.BoardConfig.UARTMap, arg0: int) -> depthai.BoardConfig.UART"""
        def __iter__(self) -> Iterator[int]:
            """__iter__(self: depthai.BoardConfig.UARTMap) -> Iterator[int]"""
        def __len__(self) -> int:
            """__len__(self: depthai.BoardConfig.UARTMap) -> int"""
        def __setitem__(self, arg0: int, arg1: BoardConfig.UART) -> None:
            """__setitem__(self: depthai.BoardConfig.UARTMap, arg0: int, arg1: depthai.BoardConfig.UART) -> None"""

    class USB:
        flashBootedPid: int
        flashBootedVid: int
        manufacturer: str
        maxSpeed: UsbSpeed
        pid: int
        productName: str
        vid: int
        def __init__(self) -> None:
            """__init__(self: depthai.BoardConfig.USB) -> None"""

    class UVC:
        cameraName: str
        enable: bool
        frameType: ImgFrame.Type
        height: int
        width: int
        @overload
        def __init__(self) -> None:
            """__init__(*args, **kwargs)
            Overloaded function.

            1. __init__(self: depthai.BoardConfig.UVC) -> None

            2. __init__(self: depthai.BoardConfig.UVC, arg0: int, arg1: int) -> None
            """
        @overload
        def __init__(self, arg0: int, arg1: int) -> None:
            """__init__(*args, **kwargs)
            Overloaded function.

            1. __init__(self: depthai.BoardConfig.UVC) -> None

            2. __init__(self: depthai.BoardConfig.UVC, arg0: int, arg1: int) -> None
            """

    class ValuesView:
        def __init__(self, *args, **kwargs) -> None:
            """Initialize self.  See help(type(self)) for accurate signature."""
        def __iter__(self) -> Iterator:
            """__iter__(self: depthai.BoardConfig.ValuesView) -> Iterator"""
        def __len__(self) -> int:
            """__len__(self: depthai.BoardConfig.ValuesView) -> int"""
    emmc: bool | None
    gpio: BoardConfig.GPIOMap
    logDevicePrints: bool | None
    logPath: str | None
    logSizeMax: int | None
    logVerbosity: LogLevel | None
    mipi4LaneRgb: bool | None
    network: BoardConfig.Network
    pcieInternalClock: bool | None
    sysctl: list[str]
    uart: BoardConfig.UARTMap
    usb: BoardConfig.USB
    usb3PhyInternalClock: bool | None
    uvc: BoardConfig.UVC | None
    watchdogInitialDelayMs: int | None
    watchdogTimeoutMs: int | None
    def __init__(self) -> None:
        """__init__(self: depthai.BoardConfig) -> None"""

class Buffer(ADatatype):
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Buffer) -> None

        2. __init__(self: depthai.Buffer, arg0: int) -> None
        """
    @overload
    def __init__(self, arg0: int) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Buffer) -> None

        2. __init__(self: depthai.Buffer, arg0: int) -> None
        """
    def getData(self) -> numpy.ndarray[numpy.uint8]:
        """getData(self: object) -> numpy.ndarray[numpy.uint8]

        Get non-owning reference to internal buffer

        Returns:
            Reference to internal buffer
        """
    def getSequenceNum(self) -> int:
        """getSequenceNum(self: depthai.Buffer) -> int

        Retrieves image sequence number
        """
    def getTimestamp(self) -> datetime.timedelta:
        """getTimestamp(self: depthai.Buffer) -> datetime.timedelta

        Retrieves timestamp related to dai::Clock::now()
        """
    def getTimestampDevice(self) -> datetime.timedelta:
        """getTimestampDevice(self: depthai.Buffer) -> datetime.timedelta

        Retrieves timestamp directly captured from device's monotonic clock, not
        synchronized to host time. Used mostly for debugging
        """
    def getVisualizationMessage(self) -> ImgAnnotations | ImgFrame | None:
        """getVisualizationMessage(self: depthai.Buffer) -> Union[depthai.ImgAnnotations, depthai.ImgFrame, None]

        Get visualizable message

        Returns:
            Visualizable message, either ImgFrame, ImgAnnotations or std::monostate
            (None)
        """
    @overload
    def setData(self, arg0: list[int]) -> None:
        """setData(*args, **kwargs)
        Overloaded function.

        1. setData(self: depthai.Buffer, arg0: list[int]) -> None

        Parameter ``data``:
            Copies data to internal buffer

        2. setData(self: depthai.Buffer, arg0: numpy.ndarray[numpy.uint8]) -> None

        Parameter ``data``:
            Copies data to internal buffer

        3. setData(self: depthai.Buffer, arg0: Buffer) -> None

        Parameter ``data``:
            Copies data to internal buffer
        """
    @overload
    def setData(self, arg0: numpy.ndarray[numpy.uint8]) -> None:
        """setData(*args, **kwargs)
        Overloaded function.

        1. setData(self: depthai.Buffer, arg0: list[int]) -> None

        Parameter ``data``:
            Copies data to internal buffer

        2. setData(self: depthai.Buffer, arg0: numpy.ndarray[numpy.uint8]) -> None

        Parameter ``data``:
            Copies data to internal buffer

        3. setData(self: depthai.Buffer, arg0: Buffer) -> None

        Parameter ``data``:
            Copies data to internal buffer
        """
    @overload
    def setData(self, arg0: Buffer) -> None:
        """setData(*args, **kwargs)
        Overloaded function.

        1. setData(self: depthai.Buffer, arg0: list[int]) -> None

        Parameter ``data``:
            Copies data to internal buffer

        2. setData(self: depthai.Buffer, arg0: numpy.ndarray[numpy.uint8]) -> None

        Parameter ``data``:
            Copies data to internal buffer

        3. setData(self: depthai.Buffer, arg0: Buffer) -> None

        Parameter ``data``:
            Copies data to internal buffer
        """
    def setSequenceNum(self, arg0: int) -> None:
        """setSequenceNum(self: depthai.Buffer, arg0: int) -> None

        Sets image sequence number
        """
    def setTimestamp(self, arg0: datetime.timedelta) -> None:
        """setTimestamp(self: depthai.Buffer, arg0: datetime.timedelta) -> None

        Sets image timestamp related to dai::Clock::now()
        """
    def setTimestampDevice(self, arg0: datetime.timedelta) -> None:
        """setTimestampDevice(self: depthai.Buffer, arg0: datetime.timedelta) -> None

        Sets image timestamp related to dai::Clock::now()
        """

class CalibrationHandler:
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.CalibrationHandler) -> None

        2. __init__(self: depthai.CalibrationHandler, arg0: Path) -> None

        Construct a new Calibration Handler object using the eeprom json file created
        from calibration procedure.

        Parameter ``eepromDataPath``:
            takes the full path to the json file containing the calibration and device
            info.

        3. __init__(self: depthai.CalibrationHandler, arg0: Path, arg1: Path) -> None

        Construct a new Calibration Handler object using the board config json file and
        .calib binary files created using gen1 calibration.

        Parameter ``calibrationDataPath``:
            Full Path to the .calib binary file from the gen1 calibration. (Supports
            only Version 5)

        Parameter ``boardConfigPath``:
            Full Path to the board config json file containing device information.

        4. __init__(self: depthai.CalibrationHandler, arg0: depthai.EepromData) -> None

        Construct a new Calibration Handler object from EepromData object.

        Parameter ``eepromData``:
            EepromData data structure containing the calibration data.
        """
    @overload
    def __init__(self, arg0: Path) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.CalibrationHandler) -> None

        2. __init__(self: depthai.CalibrationHandler, arg0: Path) -> None

        Construct a new Calibration Handler object using the eeprom json file created
        from calibration procedure.

        Parameter ``eepromDataPath``:
            takes the full path to the json file containing the calibration and device
            info.

        3. __init__(self: depthai.CalibrationHandler, arg0: Path, arg1: Path) -> None

        Construct a new Calibration Handler object using the board config json file and
        .calib binary files created using gen1 calibration.

        Parameter ``calibrationDataPath``:
            Full Path to the .calib binary file from the gen1 calibration. (Supports
            only Version 5)

        Parameter ``boardConfigPath``:
            Full Path to the board config json file containing device information.

        4. __init__(self: depthai.CalibrationHandler, arg0: depthai.EepromData) -> None

        Construct a new Calibration Handler object from EepromData object.

        Parameter ``eepromData``:
            EepromData data structure containing the calibration data.
        """
    @overload
    def __init__(self, arg0: Path, arg1: Path) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.CalibrationHandler) -> None

        2. __init__(self: depthai.CalibrationHandler, arg0: Path) -> None

        Construct a new Calibration Handler object using the eeprom json file created
        from calibration procedure.

        Parameter ``eepromDataPath``:
            takes the full path to the json file containing the calibration and device
            info.

        3. __init__(self: depthai.CalibrationHandler, arg0: Path, arg1: Path) -> None

        Construct a new Calibration Handler object using the board config json file and
        .calib binary files created using gen1 calibration.

        Parameter ``calibrationDataPath``:
            Full Path to the .calib binary file from the gen1 calibration. (Supports
            only Version 5)

        Parameter ``boardConfigPath``:
            Full Path to the board config json file containing device information.

        4. __init__(self: depthai.CalibrationHandler, arg0: depthai.EepromData) -> None

        Construct a new Calibration Handler object from EepromData object.

        Parameter ``eepromData``:
            EepromData data structure containing the calibration data.
        """
    @overload
    def __init__(self, arg0: EepromData) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.CalibrationHandler) -> None

        2. __init__(self: depthai.CalibrationHandler, arg0: Path) -> None

        Construct a new Calibration Handler object using the eeprom json file created
        from calibration procedure.

        Parameter ``eepromDataPath``:
            takes the full path to the json file containing the calibration and device
            info.

        3. __init__(self: depthai.CalibrationHandler, arg0: Path, arg1: Path) -> None

        Construct a new Calibration Handler object using the board config json file and
        .calib binary files created using gen1 calibration.

        Parameter ``calibrationDataPath``:
            Full Path to the .calib binary file from the gen1 calibration. (Supports
            only Version 5)

        Parameter ``boardConfigPath``:
            Full Path to the board config json file containing device information.

        4. __init__(self: depthai.CalibrationHandler, arg0: depthai.EepromData) -> None

        Construct a new Calibration Handler object from EepromData object.

        Parameter ``eepromData``:
            EepromData data structure containing the calibration data.
        """
    def eepromToJson(self) -> json:
        """eepromToJson(self: depthai.CalibrationHandler) -> json

        Get JSON representation of calibration data

        Returns:
            JSON structure
        """
    def eepromToJsonFile(self, destPath: Path) -> bool:
        """eepromToJsonFile(self: depthai.CalibrationHandler, destPath: Path) -> bool

        Write raw calibration/board data to json file.

        Parameter ``destPath``:
            Full path to the json file in which raw calibration data will be stored

        Returns:
            True on success, false otherwise
        """
    @staticmethod
    def fromJson(arg0: json) -> CalibrationHandler:
        """fromJson(arg0: json) -> depthai.CalibrationHandler

        Construct a new Calibration Handler object from JSON EepromData.

        Parameter ``eepromDataJson``:
            EepromData as JSON
        """
    def getBaselineDistance(self, cam1: CameraBoardSocket = ..., cam2: CameraBoardSocket = ..., useSpecTranslation: bool = ...) -> float:
        """getBaselineDistance(self: depthai.CalibrationHandler, cam1: depthai.CameraBoardSocket = <CameraBoardSocket.???: 2>, cam2: depthai.CameraBoardSocket = <CameraBoardSocket.???: 1>, useSpecTranslation: bool = True) -> float

        Get the baseline distance between two specified cameras. By default it will get
        the baseline between CameraBoardSocket.RIGHT and CameraBoardSocket.LEFT.

        Parameter ``cam1``:
            First camera

        Parameter ``cam2``:
            Second camera

        Parameter ``useSpecTranslation``:
            Enabling this bool uses the translation information from the board design
            data (not the calibration data)

        Returns:
            baseline distance in centimeters
        """
    def getCameraExtrinsics(self, srcCamera: CameraBoardSocket, dstCamera: CameraBoardSocket, useSpecTranslation: bool = ...) -> list[list[float]]:
        """getCameraExtrinsics(self: depthai.CalibrationHandler, srcCamera: depthai.CameraBoardSocket, dstCamera: depthai.CameraBoardSocket, useSpecTranslation: bool = False) -> list[list[float]]

        Get the Camera Extrinsics object between two cameras from the calibration data
        if there is a linked connection between any two cameras then the relative
        rotation and translation (in centimeters) is returned by this function.

        Parameter ``srcCamera``:
            Camera Id of the camera which will be considered as origin.

        Parameter ``dstCamera``:
            Camera Id of the destination camera to which we are fetching the rotation
            and translation from the SrcCamera

        Parameter ``useSpecTranslation``:
            Enabling this bool uses the translation information from the board design
            data

        Returns:
            a transformationMatrix which is 4x4 in homogeneous coordinate system

        Matrix representation of transformation matrix \\f[ \\text{Transformation Matrix}
        = \\left [ \\begin{matrix} r_{00} & r_{01} & r_{02} & T_x \\\\ r_{10} & r_{11} &
        r_{12} & T_y \\\\ r_{20} & r_{21} & r_{22} & T_z \\\\ 0 & 0 & 0 & 1 \\end{matrix}
        \\right ] \\f]
        """
    def getCameraIntrinsics(self, cameraId: CameraBoardSocket, resizeWidth: int = ..., resizeHeight: int = ..., topLeftPixelId: Point2f = ..., bottomRightPixelId: Point2f = ..., keepAspectRatio: bool = ...) -> list[list[float]]:
        """getCameraIntrinsics(*args, **kwargs)
        Overloaded function.

        1. getCameraIntrinsics(self: depthai.CalibrationHandler, cameraId: depthai.CameraBoardSocket, resizeWidth: int = -1, resizeHeight: int = -1, topLeftPixelId: depthai.Point2f = <depthai.Point2f object at 0x7fff41729ab0>, bottomRightPixelId: depthai.Point2f = <depthai.Point2f object at 0x7fff41729af0>, keepAspectRatio: bool = True) -> list[list[float]]

        Get the Camera Intrinsics object

        Parameter ``cameraId``:
            Uses the cameraId to identify which camera intrinsics to return

        Parameter ``resizewidth``:
            resized width of the image for which intrinsics is requested. resizewidth =
            -1 represents width is same as default intrinsics

        Parameter ``resizeHeight``:
            resized height of the image for which intrinsics is requested. resizeHeight
            = -1 represents height is same as default intrinsics

        Parameter ``topLeftPixelId``:
            (x, y) point represents the top left corner coordinates of the cropped image
            which is used to modify the intrinsics for the respective cropped image

        Parameter ``bottomRightPixelId``:
            (x, y) point represents the bottom right corner coordinates of the cropped
            image which is used to modify the intrinsics for the respective cropped
            image

        Parameter ``keepAspectRatio``:
            Enabling this will scale on width or height depending on which provides the
            max resolution and crops the remaining part of the other side

        Returns:
            Represents the 3x3 intrinsics matrix of the respective camera at the
            requested size and crop dimensions.

        Matrix representation of intrinsic matrix \\f[ \\text{Intrinsic Matrix} = \\left [
        \\begin{matrix} f_x & 0 & c_x \\\\ 0 & f_y & c_y \\\\ 0 & 0 & 1 \\end{matrix} \\right ]
        \\f]

        2. getCameraIntrinsics(self: depthai.CalibrationHandler, cameraId: depthai.CameraBoardSocket, destShape: depthai.Size2f, topLeftPixelId: depthai.Point2f = <depthai.Point2f object at 0x7fff416ae8f0>, bottomRightPixelId: depthai.Point2f = <depthai.Point2f object at 0x7fff41729cb0>, keepAspectRatio: bool = True) -> list[list[float]]

        Get the Camera Intrinsics object

        Parameter ``cameraId``:
            Uses the cameraId to identify which camera intrinsics to return

        Parameter ``destShape``:
            resized width and height of the image for which intrinsics is requested.

        Parameter ``topLeftPixelId``:
            (x, y) point represents the top left corner coordinates of the cropped image
            which is used to modify the intrinsics for the respective cropped image

        Parameter ``bottomRightPixelId``:
            (x, y) point represents the bottom right corner coordinates of the cropped
            image which is used to modify the intrinsics for the respective cropped
            image

        Parameter ``keepAspectRatio``:
            Enabling this will scale on width or height depending on which provides the
            max resolution and crops the remaining part of the other side

        Returns:
            Represents the 3x3 intrinsics matrix of the respective camera at the
            requested size and crop dimensions.

        Matrix representation of intrinsic matrix \\f[ \\text{Intrinsic Matrix} = \\left [
        \\begin{matrix} f_x & 0 & c_x \\\\ 0 & f_y & c_y \\\\ 0 & 0 & 1 \\end{matrix} \\right ]
        \\f]

        3. getCameraIntrinsics(self: depthai.CalibrationHandler, cameraId: depthai.CameraBoardSocket, destShape: tuple[int, int], topLeftPixelId: depthai.Point2f = <depthai.Point2f object at 0x7fff416ad0f0>, bottomRightPixelId: depthai.Point2f = <depthai.Point2f object at 0x7fff41729df0>, keepAspectRatio: bool = True) -> list[list[float]]

        Get the Camera Intrinsics object

        Parameter ``cameraId``:
            Uses the cameraId to identify which camera intrinsics to return

        Parameter ``destShape``:
            resized width and height of the image for which intrinsics is requested.

        Parameter ``topLeftPixelId``:
            (x, y) point represents the top left corner coordinates of the cropped image
            which is used to modify the intrinsics for the respective cropped image

        Parameter ``bottomRightPixelId``:
            (x, y) point represents the bottom right corner coordinates of the cropped
            image which is used to modify the intrinsics for the respective cropped
            image

        Parameter ``keepAspectRatio``:
            Enabling this will scale on width or height depending on which provides the
            max resolution and crops the remaining part of the other side

        Returns:
            Represents the 3x3 intrinsics matrix of the respective camera at the
            requested size and crop dimensions.

        Matrix representation of intrinsic matrix \\f[ \\text{Intrinsic Matrix} = \\left [
        \\begin{matrix} f_x & 0 & c_x \\\\ 0 & f_y & c_y \\\\ 0 & 0 & 1 \\end{matrix} \\right ]
        \\f]
        """
    def getCameraRotationMatrix(self, srcCamera: CameraBoardSocket, dstCamera: CameraBoardSocket) -> list[list[float]]:
        """getCameraRotationMatrix(self: depthai.CalibrationHandler, srcCamera: depthai.CameraBoardSocket, dstCamera: depthai.CameraBoardSocket) -> list[list[float]]

        Get the Camera rotation matrix between two cameras from the calibration data.

        Parameter ``srcCamera``:
            Camera Id of the camera which will be considered as origin.

        Parameter ``dstCamera``:
            Camera Id of the destination camera to which we are fetching the rotation
            vector from the SrcCamera

        Returns:
            a 3x3 rotation matrix Matrix representation of rotation matrix \\f[
            \\text{Rotation Matrix} = \\left [ \\begin{matrix} r_{00} & r_{01} & r_{02}\\\\\n            r_{10} & r_{11} & r_{12}\\\\ r_{20} & r_{21} & r_{22}\\\\ \\end{matrix} \\right ]
            \\f]
        """
    def getCameraToImuExtrinsics(self, cameraId: CameraBoardSocket, useSpecTranslation: bool = ...) -> list[list[float]]:
        """getCameraToImuExtrinsics(self: depthai.CalibrationHandler, cameraId: depthai.CameraBoardSocket, useSpecTranslation: bool = False) -> list[list[float]]

        Get the Camera To Imu Extrinsics object From the data loaded if there is a
        linked connection between IMU and the given camera then there relative rotation
        and translation from the camera to IMU is returned.

        Parameter ``cameraId``:
            Camera Id of the camera which will be considered as origin. from which
            Transformation matrix to the IMU will be found

        Parameter ``useSpecTranslation``:
            Enabling this bool uses the translation information from the board design
            data

        Returns:
            Returns a transformationMatrix which is 4x4 in homogeneous coordinate system

        Matrix representation of transformation matrix \\f[ \\text{Transformation Matrix}
        = \\left [ \\begin{matrix} r_{00} & r_{01} & r_{02} & T_x \\\\ r_{10} & r_{11} &
        r_{12} & T_y \\\\ r_{20} & r_{21} & r_{22} & T_z \\\\ 0 & 0 & 0 & 1 \\end{matrix}
        \\right ] \\f]
        """
    def getCameraTranslationVector(self, srcCamera: CameraBoardSocket, dstCamera: CameraBoardSocket, useSpecTranslation: bool = ...) -> list[float]:
        """getCameraTranslationVector(self: depthai.CalibrationHandler, srcCamera: depthai.CameraBoardSocket, dstCamera: depthai.CameraBoardSocket, useSpecTranslation: bool = True) -> list[float]

        Get the Camera translation vector between two cameras from the calibration data.

        Parameter ``srcCamera``:
            Camera Id of the camera which will be considered as origin.

        Parameter ``dstCamera``:
            Camera Id of the destination camera to which we are fetching the translation
            vector from the SrcCamera

        Parameter ``useSpecTranslation``:
            Disabling this bool uses the translation information from the calibration
            data (not the board design data)

        Returns:
            a translation vector like [x, y, z] in centimeters
        """
    def getDefaultIntrinsics(self, cameraId: CameraBoardSocket) -> tuple[list[list[float]], int, int]:
        """getDefaultIntrinsics(self: depthai.CalibrationHandler, cameraId: depthai.CameraBoardSocket) -> tuple[list[list[float]], int, int]

        Get the Default Intrinsics object

        Parameter ``cameraId``:
            Uses the cameraId to identify which camera intrinsics to return

        Returns:
            Represents the 3x3 intrinsics matrix of the respective camera along with
            width and height at which it was calibrated.

        Matrix representation of intrinsic matrix \\f[ \\text{Intrinsic Matrix} = \\left [
        \\begin{matrix} f_x & 0 & c_x \\\\ 0 & f_y & c_y \\\\ 0 & 0 & 1 \\end{matrix} \\right ]
        \\f]
        """
    def getDistortionCoefficients(self, cameraId: CameraBoardSocket) -> list[float]:
        """getDistortionCoefficients(self: depthai.CalibrationHandler, cameraId: depthai.CameraBoardSocket) -> list[float]

        Get the Distortion Coefficients object

        Parameter ``cameraId``:
            Uses the cameraId to identify which distortion Coefficients to return.

        Returns:
            the distortion coefficients of the requested camera in this order:
            [k1,k2,p1,p2,k3,k4,k5,k6,s1,s2,s3,s4,τx,τy] for CameraModel::Perspective or
            [k1, k2, k3, k4] for CameraModel::Fisheye see
            https://docs.opencv.org/4.5.4/d9/d0c/group__calib3d.html for Perspective
            model (Rational Polynomial Model) see
            https://docs.opencv.org/4.5.4/db/d58/group__calib3d__fisheye.html for
            Fisheye model
        """
    def getDistortionModel(self, cameraId: CameraBoardSocket) -> CameraModel:
        """getDistortionModel(self: depthai.CalibrationHandler, cameraId: depthai.CameraBoardSocket) -> depthai.CameraModel

        Get the distortion model of the given camera

        Parameter ``cameraId``:
            of the camera with lens position is requested.

        Returns:
            lens position of the camera with given cameraId at which it was calibrated.
        """
    def getEepromData(self) -> EepromData:
        """getEepromData(self: depthai.CalibrationHandler) -> depthai.EepromData

        Get the Eeprom Data object

        Returns:
            EepromData object which contains the raw calibration data
        """
    def getFov(self, cameraId: CameraBoardSocket, useSpec: bool = ...) -> float:
        """getFov(self: depthai.CalibrationHandler, cameraId: depthai.CameraBoardSocket, useSpec: bool = True) -> float

        Get the Fov of the camera

        Parameter ``cameraId``:
            of the camera of which we are fetching fov.

        Parameter ``useSpec``:
            Disabling this bool will calculate the fov based on intrinsics (focal
            length, image width), instead of getting it from the camera specs

        Returns:
            field of view of the camera with given cameraId.
        """
    def getImuToCameraExtrinsics(self, cameraId: CameraBoardSocket, useSpecTranslation: bool = ...) -> list[list[float]]:
        """getImuToCameraExtrinsics(self: depthai.CalibrationHandler, cameraId: depthai.CameraBoardSocket, useSpecTranslation: bool = False) -> list[list[float]]

        Get the Imu To Camera Extrinsics object from the data loaded if there is a
        linked connection between IMU and the given camera then there relative rotation
        and translation from the IMU to Camera is returned.

        Parameter ``cameraId``:
            Camera Id of the camera which will be considered as destination. To which
            Transformation matrix from the IMU will be found.

        Parameter ``useSpecTranslation``:
            Enabling this bool uses the translation information from the board design
            data

        Returns:
            Returns a transformationMatrix which is 4x4 in homogeneous coordinate system

        Matrix representation of transformation matrix \\f[ \\text{Transformation Matrix}
        = \\left [ \\begin{matrix} r_{00} & r_{01} & r_{02} & T_x \\\\ r_{10} & r_{11} &
        r_{12} & T_y \\\\ r_{20} & r_{21} & r_{22} & T_z \\\\ 0 & 0 & 0 & 1 \\end{matrix}
        \\right ] \\f]
        """
    def getLensPosition(self, cameraId: CameraBoardSocket) -> int:
        """getLensPosition(self: depthai.CalibrationHandler, cameraId: depthai.CameraBoardSocket) -> int

        Get the lens position of the given camera

        Parameter ``cameraId``:
            of the camera with lens position is requested.

        Returns:
            lens position of the camera with given cameraId at which it was calibrated.
        """
    def getStereoLeftCameraId(self) -> CameraBoardSocket:
        """getStereoLeftCameraId(self: depthai.CalibrationHandler) -> depthai.CameraBoardSocket

        Get the camera id of the camera which is used as left camera of the stereo setup

        Returns:
            cameraID of the camera used as left camera
        """
    def getStereoLeftRectificationRotation(self) -> list[list[float]]:
        """getStereoLeftRectificationRotation(self: depthai.CalibrationHandler) -> list[list[float]]

        Get the Stereo Left Rectification Rotation object

        Returns:
            returns a 3x3 rectification rotation matrix
        """
    def getStereoRightCameraId(self) -> CameraBoardSocket:
        """getStereoRightCameraId(self: depthai.CalibrationHandler) -> depthai.CameraBoardSocket

        Get the camera id of the camera which is used as right camera of the stereo
        setup

        Returns:
            cameraID of the camera used as right camera
        """
    def getStereoRightRectificationRotation(self) -> list[list[float]]:
        """getStereoRightRectificationRotation(self: depthai.CalibrationHandler) -> list[list[float]]

        Get the Stereo Right Rectification Rotation object

        Returns:
            returns a 3x3 rectification rotation matrix
        """
    @overload
    def setBoardInfo(self, boardName: str, boardRev: str) -> None:
        """setBoardInfo(*args, **kwargs)
        Overloaded function.

        1. setBoardInfo(self: depthai.CalibrationHandler, boardName: str, boardRev: str) -> None

        Set the Board Info object

        Parameter ``version``:
            Sets the version of the Calibration data(Current version is 6)

        Parameter ``boardName``:
            Sets your board name.

        Parameter ``boardRev``:
            set your board revision id.

        2. setBoardInfo(self: depthai.CalibrationHandler, productName: str, boardName: str, boardRev: str, boardConf: str, hardwareConf: str, batchName: str, batchTime: int, boardOptions: int, boardCustom: str = '') -> None

        Set the Board Info object. Creates version 7 EEPROM data

        Parameter ``productName``:
            Sets product name (alias).

        Parameter ``boardName``:
            Sets board name.

        Parameter ``boardRev``:
            Sets board revision id.

        Parameter ``boardConf``:
            Sets board configuration id.

        Parameter ``hardwareConf``:
            Sets hardware configuration id.

        Parameter ``batchName``:
            Sets batch name.

        Parameter ``batchTime``:
            Sets batch time (unix timestamp).

        Parameter ``boardCustom``:
            Sets a custom board (Default empty string).

        3. setBoardInfo(self: depthai.CalibrationHandler, deviceName: str, productName: str, boardName: str, boardRev: str, boardConf: str, hardwareConf: str, batchName: str, batchTime: int, boardOptions: int, boardCustom: str = '') -> None

        Set the Board Info object. Creates version 7 EEPROM data

        Parameter ``deviceName``:
            Sets device name.

        Parameter ``productName``:
            Sets product name (alias).

        Parameter ``boardName``:
            Sets board name.

        Parameter ``boardRev``:
            Sets board revision id.

        Parameter ``boardConf``:
            Sets board configuration id.

        Parameter ``hardwareConf``:
            Sets hardware configuration id.

        Parameter ``batchName``:
            Sets batch name. Not supported anymore

        Parameter ``batchTime``:
            Sets batch time (unix timestamp).

        Parameter ``boardCustom``:
            Sets a custom board (Default empty string).
        """
    @overload
    def setBoardInfo(self, productName: str, boardName: str, boardRev: str, boardConf: str, hardwareConf: str, batchName: str, batchTime: int, boardOptions: int, boardCustom: str = ...) -> None:
        """setBoardInfo(*args, **kwargs)
        Overloaded function.

        1. setBoardInfo(self: depthai.CalibrationHandler, boardName: str, boardRev: str) -> None

        Set the Board Info object

        Parameter ``version``:
            Sets the version of the Calibration data(Current version is 6)

        Parameter ``boardName``:
            Sets your board name.

        Parameter ``boardRev``:
            set your board revision id.

        2. setBoardInfo(self: depthai.CalibrationHandler, productName: str, boardName: str, boardRev: str, boardConf: str, hardwareConf: str, batchName: str, batchTime: int, boardOptions: int, boardCustom: str = '') -> None

        Set the Board Info object. Creates version 7 EEPROM data

        Parameter ``productName``:
            Sets product name (alias).

        Parameter ``boardName``:
            Sets board name.

        Parameter ``boardRev``:
            Sets board revision id.

        Parameter ``boardConf``:
            Sets board configuration id.

        Parameter ``hardwareConf``:
            Sets hardware configuration id.

        Parameter ``batchName``:
            Sets batch name.

        Parameter ``batchTime``:
            Sets batch time (unix timestamp).

        Parameter ``boardCustom``:
            Sets a custom board (Default empty string).

        3. setBoardInfo(self: depthai.CalibrationHandler, deviceName: str, productName: str, boardName: str, boardRev: str, boardConf: str, hardwareConf: str, batchName: str, batchTime: int, boardOptions: int, boardCustom: str = '') -> None

        Set the Board Info object. Creates version 7 EEPROM data

        Parameter ``deviceName``:
            Sets device name.

        Parameter ``productName``:
            Sets product name (alias).

        Parameter ``boardName``:
            Sets board name.

        Parameter ``boardRev``:
            Sets board revision id.

        Parameter ``boardConf``:
            Sets board configuration id.

        Parameter ``hardwareConf``:
            Sets hardware configuration id.

        Parameter ``batchName``:
            Sets batch name. Not supported anymore

        Parameter ``batchTime``:
            Sets batch time (unix timestamp).

        Parameter ``boardCustom``:
            Sets a custom board (Default empty string).
        """
    @overload
    def setBoardInfo(self, deviceName: str, productName: str, boardName: str, boardRev: str, boardConf: str, hardwareConf: str, batchName: str, batchTime: int, boardOptions: int, boardCustom: str = ...) -> None:
        """setBoardInfo(*args, **kwargs)
        Overloaded function.

        1. setBoardInfo(self: depthai.CalibrationHandler, boardName: str, boardRev: str) -> None

        Set the Board Info object

        Parameter ``version``:
            Sets the version of the Calibration data(Current version is 6)

        Parameter ``boardName``:
            Sets your board name.

        Parameter ``boardRev``:
            set your board revision id.

        2. setBoardInfo(self: depthai.CalibrationHandler, productName: str, boardName: str, boardRev: str, boardConf: str, hardwareConf: str, batchName: str, batchTime: int, boardOptions: int, boardCustom: str = '') -> None

        Set the Board Info object. Creates version 7 EEPROM data

        Parameter ``productName``:
            Sets product name (alias).

        Parameter ``boardName``:
            Sets board name.

        Parameter ``boardRev``:
            Sets board revision id.

        Parameter ``boardConf``:
            Sets board configuration id.

        Parameter ``hardwareConf``:
            Sets hardware configuration id.

        Parameter ``batchName``:
            Sets batch name.

        Parameter ``batchTime``:
            Sets batch time (unix timestamp).

        Parameter ``boardCustom``:
            Sets a custom board (Default empty string).

        3. setBoardInfo(self: depthai.CalibrationHandler, deviceName: str, productName: str, boardName: str, boardRev: str, boardConf: str, hardwareConf: str, batchName: str, batchTime: int, boardOptions: int, boardCustom: str = '') -> None

        Set the Board Info object. Creates version 7 EEPROM data

        Parameter ``deviceName``:
            Sets device name.

        Parameter ``productName``:
            Sets product name (alias).

        Parameter ``boardName``:
            Sets board name.

        Parameter ``boardRev``:
            Sets board revision id.

        Parameter ``boardConf``:
            Sets board configuration id.

        Parameter ``hardwareConf``:
            Sets hardware configuration id.

        Parameter ``batchName``:
            Sets batch name. Not supported anymore

        Parameter ``batchTime``:
            Sets batch time (unix timestamp).

        Parameter ``boardCustom``:
            Sets a custom board (Default empty string).
        """
    def setCameraExtrinsics(self, srcCameraId: CameraBoardSocket, destCameraId: CameraBoardSocket, rotationMatrix: list[list[float]], translation: list[float], specTranslation: list[float] = ...) -> None:
        """setCameraExtrinsics(self: depthai.CalibrationHandler, srcCameraId: depthai.CameraBoardSocket, destCameraId: depthai.CameraBoardSocket, rotationMatrix: list[list[float]], translation: list[float], specTranslation: list[float] = [0.0, 0.0, 0.0]) -> None

        Set the Camera Extrinsics object

        Parameter ``srcCameraId``:
            Camera Id of the camera which will be considered as relative origin.

        Parameter ``destCameraId``:
            Camera Id of the camera which will be considered as destination from
            srcCameraId.

        Parameter ``rotationMatrix``:
            Rotation between srcCameraId and destCameraId origins.

        Parameter ``translation``:
            Translation between srcCameraId and destCameraId origins.

        Parameter ``specTranslation``:
            Translation between srcCameraId and destCameraId origins from the design.
        """
    def setCameraIntrinsics(self, cameraId: CameraBoardSocket, intrinsics: list[list[float]], frameSize: Size2f) -> None:
        """setCameraIntrinsics(*args, **kwargs)
        Overloaded function.

        1. setCameraIntrinsics(self: depthai.CalibrationHandler, cameraId: depthai.CameraBoardSocket, intrinsics: list[list[float]], frameSize: depthai.Size2f) -> None

        Set the Camera Intrinsics object

        Parameter ``cameraId``:
            CameraId of the camera for which Camera intrinsics are being loaded

        Parameter ``intrinsics``:
            3x3 intrinsics matrix

        Parameter ``frameSize``:
            Represents the width and height of the image at which intrinsics are
            calculated.

        Matrix representation of intrinsic matrix \\f[ \\text{Intrinsic Matrix} = \\left [
        \\begin{matrix} f_x & 0 & c_x \\\\ 0 & f_y & c_y \\\\ 0 & 0 & 1 \\end{matrix} \\right ]
        \\f]

        2. setCameraIntrinsics(self: depthai.CalibrationHandler, cameraId: depthai.CameraBoardSocket, intrinsics: list[list[float]], width: int, height: int) -> None

        Set the Camera Intrinsics object

        Parameter ``cameraId``:
            CameraId of the camera for which Camera intrinsics are being loaded

        Parameter ``intrinsics``:
            3x3 intrinsics matrix

        Parameter ``width``:
            Represents the width of the image at which intrinsics are calculated.

        Parameter ``height``:
            Represents the height of the image at which intrinsics are calculated.

        Matrix representation of intrinsic matrix \\f[ \\text{Intrinsic Matrix} = \\left [
        \\begin{matrix} f_x & 0 & c_x \\\\ 0 & f_y & c_y \\\\ 0 & 0 & 1 \\end{matrix} \\right ]
        \\f]

        3. setCameraIntrinsics(self: depthai.CalibrationHandler, cameraId: depthai.CameraBoardSocket, intrinsics: list[list[float]], frameSize: tuple[int, int]) -> None

        Set the Camera Intrinsics object

        Parameter ``cameraId``:
            CameraId of the camera for which Camera intrinsics are being loaded

        Parameter ``intrinsics``:
            3x3 intrinsics matrix

        Parameter ``frameSize``:
            Represents the width and height of the image at which intrinsics are
            calculated.

        Matrix representation of intrinsic matrix \\f[ \\text{Intrinsic Matrix} = \\left [
        \\begin{matrix} f_x & 0 & c_x \\\\ 0 & f_y & c_y \\\\ 0 & 0 & 1 \\end{matrix} \\right ]
        \\f]
        """
    def setCameraType(self, cameraId: CameraBoardSocket, cameraModel: CameraModel) -> None:
        """setCameraType(self: depthai.CalibrationHandler, cameraId: depthai.CameraBoardSocket, cameraModel: depthai.CameraModel) -> None

        Set the Camera Type object

        Parameter ``cameraId``:
            CameraId of the camera for which cameraModel Type is being updated.

        Parameter ``cameraModel``:
            Type of the model the camera represents
        """
    def setDeviceName(self, deviceName: str) -> None:
        """setDeviceName(self: depthai.CalibrationHandler, deviceName: str) -> None

        Set the deviceName which responses to getDeviceName of Device

        Parameter ``deviceName``:
            Sets device name.
        """
    def setDistortionCoefficients(self, cameraId: CameraBoardSocket, distortionCoefficients: list[float]) -> None:
        """setDistortionCoefficients(self: depthai.CalibrationHandler, cameraId: depthai.CameraBoardSocket, distortionCoefficients: list[float]) -> None

        Sets the distortion Coefficients obtained from camera calibration

        Parameter ``cameraId``:
            Camera Id of the camera for which distortion coefficients are computed

        Parameter ``distortionCoefficients``:
            Distortion Coefficients of the respective Camera.
        """
    def setFov(self, cameraId: CameraBoardSocket, hfov: float) -> None:
        """setFov(self: depthai.CalibrationHandler, cameraId: depthai.CameraBoardSocket, hfov: float) -> None

        Set the Fov of the Camera

        Parameter ``cameraId``:
            Camera Id of the camera

        Parameter ``hfov``:
            Horizontal fov of the camera from Camera Datasheet
        """
    def setImuExtrinsics(self, destCameraId: CameraBoardSocket, rotationMatrix: list[list[float]], translation: list[float], specTranslation: list[float] = ...) -> None:
        """setImuExtrinsics(self: depthai.CalibrationHandler, destCameraId: depthai.CameraBoardSocket, rotationMatrix: list[list[float]], translation: list[float], specTranslation: list[float] = [0.0, 0.0, 0.0]) -> None

        Set the Imu to Camera Extrinsics object

        Parameter ``destCameraId``:
            Camera Id of the camera which will be considered as destination from IMU.

        Parameter ``rotationMatrix``:
            Rotation between srcCameraId and destCameraId origins.

        Parameter ``translation``:
            Translation between IMU and destCameraId origins.

        Parameter ``specTranslation``:
            Translation between IMU and destCameraId origins from the design.
        """
    def setLensPosition(self, cameraId: CameraBoardSocket, lensPosition: int) -> None:
        """setLensPosition(self: depthai.CalibrationHandler, cameraId: depthai.CameraBoardSocket, lensPosition: int) -> None

        Sets the distortion Coefficients obtained from camera calibration

        Parameter ``cameraId``:
            Camera Id of the camera

        Parameter ``lensPosition``:
            lens posiotion value of the camera at the time of calibration
        """
    def setProductName(self, productName: str) -> None:
        """setProductName(self: depthai.CalibrationHandler, productName: str) -> None

        Set the productName which acts as alisas for users to identify the device

        Parameter ``productName``:
            Sets product name (alias).
        """
    def setStereoLeft(self, cameraId: CameraBoardSocket, rectifiedRotation: list[list[float]]) -> None:
        """setStereoLeft(self: depthai.CalibrationHandler, cameraId: depthai.CameraBoardSocket, rectifiedRotation: list[list[float]]) -> None

        Set the Stereo Left Rectification object

        Parameter ``cameraId``:
            CameraId of the camera which will be used as left Camera of stereo Setup

        Parameter ``rectifiedRotation``:
            Rectification rotation of the left camera required for feature matching

        Homography of the Left Rectification = Intrinsics_right * rectifiedRotation *
        inv(Intrinsics_left)
        """
    def setStereoRight(self, cameraId: CameraBoardSocket, rectifiedRotation: list[list[float]]) -> None:
        """setStereoRight(self: depthai.CalibrationHandler, cameraId: depthai.CameraBoardSocket, rectifiedRotation: list[list[float]]) -> None

        Set the Stereo Right Rectification object

        Parameter ``cameraId``:
            CameraId of the camera which will be used as left Camera of stereo Setup

        Parameter ``rectifiedRotation``:
            Rectification rotation of the left camera required for feature matching

        Homography of the Right Rectification = Intrinsics_right * rectifiedRotation *
        inv(Intrinsics_right)
        """

class CameraBoardSocket:
    CENTER: ClassVar[CameraBoardSocket] = ...  # read-only
    LEFT: ClassVar[CameraBoardSocket] = ...  # read-only
    RGB: ClassVar[CameraBoardSocket] = ...  # read-only
    RIGHT: ClassVar[CameraBoardSocket] = ...  # read-only
    __members__: ClassVar[dict] = ...  # read-only
    AUTO: ClassVar[CameraBoardSocket] = ...
    CAM_A: ClassVar[CameraBoardSocket] = ...
    CAM_B: ClassVar[CameraBoardSocket] = ...
    CAM_C: ClassVar[CameraBoardSocket] = ...
    CAM_D: ClassVar[CameraBoardSocket] = ...
    CAM_E: ClassVar[CameraBoardSocket] = ...
    CAM_F: ClassVar[CameraBoardSocket] = ...
    CAM_G: ClassVar[CameraBoardSocket] = ...
    CAM_H: ClassVar[CameraBoardSocket] = ...
    VERTICAL: ClassVar[CameraBoardSocket] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.CameraBoardSocket, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.CameraBoardSocket) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.CameraBoardSocket) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class CameraControl(Buffer):
    class AntiBandingMode:
        __members__: ClassVar[dict] = ...  # read-only
        AUTO: ClassVar[CameraControl.AntiBandingMode] = ...
        MAINS_50_HZ: ClassVar[CameraControl.AntiBandingMode] = ...
        MAINS_60_HZ: ClassVar[CameraControl.AntiBandingMode] = ...
        OFF: ClassVar[CameraControl.AntiBandingMode] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.CameraControl.AntiBandingMode, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.CameraControl.AntiBandingMode) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.CameraControl.AntiBandingMode) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class AutoFocusMode:
        __members__: ClassVar[dict] = ...  # read-only
        AUTO: ClassVar[CameraControl.AutoFocusMode] = ...
        CONTINUOUS_PICTURE: ClassVar[CameraControl.AutoFocusMode] = ...
        CONTINUOUS_VIDEO: ClassVar[CameraControl.AutoFocusMode] = ...
        EDOF: ClassVar[CameraControl.AutoFocusMode] = ...
        MACRO: ClassVar[CameraControl.AutoFocusMode] = ...
        OFF: ClassVar[CameraControl.AutoFocusMode] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.CameraControl.AutoFocusMode, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.CameraControl.AutoFocusMode) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.CameraControl.AutoFocusMode) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class AutoWhiteBalanceMode:
        __members__: ClassVar[dict] = ...  # read-only
        AUTO: ClassVar[CameraControl.AutoWhiteBalanceMode] = ...
        CLOUDY_DAYLIGHT: ClassVar[CameraControl.AutoWhiteBalanceMode] = ...
        DAYLIGHT: ClassVar[CameraControl.AutoWhiteBalanceMode] = ...
        FLUORESCENT: ClassVar[CameraControl.AutoWhiteBalanceMode] = ...
        INCANDESCENT: ClassVar[CameraControl.AutoWhiteBalanceMode] = ...
        OFF: ClassVar[CameraControl.AutoWhiteBalanceMode] = ...
        SHADE: ClassVar[CameraControl.AutoWhiteBalanceMode] = ...
        TWILIGHT: ClassVar[CameraControl.AutoWhiteBalanceMode] = ...
        WARM_FLUORESCENT: ClassVar[CameraControl.AutoWhiteBalanceMode] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.CameraControl.AutoWhiteBalanceMode, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.CameraControl.AutoWhiteBalanceMode) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.CameraControl.AutoWhiteBalanceMode) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class CaptureIntent:
        __members__: ClassVar[dict] = ...  # read-only
        CUSTOM: ClassVar[CameraControl.CaptureIntent] = ...
        PREVIEW: ClassVar[CameraControl.CaptureIntent] = ...
        STILL_CAPTURE: ClassVar[CameraControl.CaptureIntent] = ...
        VIDEO_RECORD: ClassVar[CameraControl.CaptureIntent] = ...
        VIDEO_SNAPSHOT: ClassVar[CameraControl.CaptureIntent] = ...
        ZERO_SHUTTER_LAG: ClassVar[CameraControl.CaptureIntent] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.CameraControl.CaptureIntent, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.CameraControl.CaptureIntent) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.CameraControl.CaptureIntent) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class Command:
        __members__: ClassVar[dict] = ...  # read-only
        AE_AUTO: ClassVar[CameraControl.Command] = ...
        AE_LOCK: ClassVar[CameraControl.Command] = ...
        AE_MANUAL: ClassVar[CameraControl.Command] = ...
        AE_REGION: ClassVar[CameraControl.Command] = ...
        AE_TARGET_FPS_RANGE: ClassVar[CameraControl.Command] = ...
        AF_MODE: ClassVar[CameraControl.Command] = ...
        AF_REGION: ClassVar[CameraControl.Command] = ...
        AF_TRIGGER: ClassVar[CameraControl.Command] = ...
        ANTIBANDING_MODE: ClassVar[CameraControl.Command] = ...
        AWB_LOCK: ClassVar[CameraControl.Command] = ...
        AWB_MODE: ClassVar[CameraControl.Command] = ...
        BRIGHTNESS: ClassVar[CameraControl.Command] = ...
        CAPTURE_INTENT: ClassVar[CameraControl.Command] = ...
        CHROMA_DENOISE: ClassVar[CameraControl.Command] = ...
        CONTRAST: ClassVar[CameraControl.Command] = ...
        CONTROL_MODE: ClassVar[CameraControl.Command] = ...
        CUSTOM_CAPTURE: ClassVar[CameraControl.Command] = ...
        CUSTOM_CAPT_MODE: ClassVar[CameraControl.Command] = ...
        CUSTOM_EXP_BRACKETS: ClassVar[CameraControl.Command] = ...
        CUSTOM_USECASE: ClassVar[CameraControl.Command] = ...
        EFFECT_MODE: ClassVar[CameraControl.Command] = ...
        EXPOSURE_COMPENSATION: ClassVar[CameraControl.Command] = ...
        FRAME_DURATION: ClassVar[CameraControl.Command] = ...
        LUMA_DENOISE: ClassVar[CameraControl.Command] = ...
        MOVE_LENS: ClassVar[CameraControl.Command] = ...
        NOISE_REDUCTION_STRENGTH: ClassVar[CameraControl.Command] = ...
        RESOLUTION: ClassVar[CameraControl.Command] = ...
        SATURATION: ClassVar[CameraControl.Command] = ...
        SCENE_MODE: ClassVar[CameraControl.Command] = ...
        SENSITIVITY: ClassVar[CameraControl.Command] = ...
        SHARPNESS: ClassVar[CameraControl.Command] = ...
        START_STREAM: ClassVar[CameraControl.Command] = ...
        STILL_CAPTURE: ClassVar[CameraControl.Command] = ...
        STOP_STREAM: ClassVar[CameraControl.Command] = ...
        STREAM_FORMAT: ClassVar[CameraControl.Command] = ...
        WB_COLOR_TEMP: ClassVar[CameraControl.Command] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.CameraControl.Command, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.CameraControl.Command) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.CameraControl.Command) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class ControlMode:
        __members__: ClassVar[dict] = ...  # read-only
        AUTO: ClassVar[CameraControl.ControlMode] = ...
        OFF: ClassVar[CameraControl.ControlMode] = ...
        USE_SCENE_MODE: ClassVar[CameraControl.ControlMode] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.CameraControl.ControlMode, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.CameraControl.ControlMode) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.CameraControl.ControlMode) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class EffectMode:
        __members__: ClassVar[dict] = ...  # read-only
        AQUA: ClassVar[CameraControl.EffectMode] = ...
        BLACKBOARD: ClassVar[CameraControl.EffectMode] = ...
        MONO: ClassVar[CameraControl.EffectMode] = ...
        NEGATIVE: ClassVar[CameraControl.EffectMode] = ...
        OFF: ClassVar[CameraControl.EffectMode] = ...
        POSTERIZE: ClassVar[CameraControl.EffectMode] = ...
        SEPIA: ClassVar[CameraControl.EffectMode] = ...
        SOLARIZE: ClassVar[CameraControl.EffectMode] = ...
        WHITEBOARD: ClassVar[CameraControl.EffectMode] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.CameraControl.EffectMode, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.CameraControl.EffectMode) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.CameraControl.EffectMode) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class FrameSyncMode:
        __members__: ClassVar[dict] = ...  # read-only
        INPUT: ClassVar[CameraControl.FrameSyncMode] = ...
        OFF: ClassVar[CameraControl.FrameSyncMode] = ...
        OUTPUT: ClassVar[CameraControl.FrameSyncMode] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.CameraControl.FrameSyncMode, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.CameraControl.FrameSyncMode) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.CameraControl.FrameSyncMode) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class SceneMode:
        __members__: ClassVar[dict] = ...  # read-only
        ACTION: ClassVar[CameraControl.SceneMode] = ...
        BARCODE: ClassVar[CameraControl.SceneMode] = ...
        BEACH: ClassVar[CameraControl.SceneMode] = ...
        CANDLELIGHT: ClassVar[CameraControl.SceneMode] = ...
        FACE_PRIORITY: ClassVar[CameraControl.SceneMode] = ...
        FIREWORKS: ClassVar[CameraControl.SceneMode] = ...
        LANDSCAPE: ClassVar[CameraControl.SceneMode] = ...
        NIGHT: ClassVar[CameraControl.SceneMode] = ...
        NIGHT_PORTRAIT: ClassVar[CameraControl.SceneMode] = ...
        PARTY: ClassVar[CameraControl.SceneMode] = ...
        PORTRAIT: ClassVar[CameraControl.SceneMode] = ...
        SNOW: ClassVar[CameraControl.SceneMode] = ...
        SPORTS: ClassVar[CameraControl.SceneMode] = ...
        STEADYPHOTO: ClassVar[CameraControl.SceneMode] = ...
        SUNSET: ClassVar[CameraControl.SceneMode] = ...
        THEATRE: ClassVar[CameraControl.SceneMode] = ...
        UNSUPPORTED: ClassVar[CameraControl.SceneMode] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.CameraControl.SceneMode, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.CameraControl.SceneMode) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.CameraControl.SceneMode) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    aeLockMode: bool
    aeMaxExposureTimeUs: int
    afRegion: Incomplete
    antiBandingMode: CameraControl.AntiBandingMode
    autoFocusMode: CameraControl.AutoFocusMode
    awbLockMode: bool
    awbMode: CameraControl.AutoWhiteBalanceMode
    brightness: int
    captureIntent: CameraControl.CaptureIntent
    chromaDenoise: int
    cmdMask: int
    contrast: int
    controlMode: CameraControl.ControlMode
    effectMode: CameraControl.EffectMode
    expCompensation: int
    expManual: Incomplete
    lensPosition: int
    lumaDenoise: int
    saturation: int
    sceneMode: CameraControl.SceneMode
    sharpness: int
    wbColorTemp: int
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.CameraControl) -> None

        2. __init__(self: depthai.CameraControl) -> None
        """
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.CameraControl) -> None

        2. __init__(self: depthai.CameraControl) -> None
        """
    def clearCommand(self, arg0: CameraControl.Command) -> None:
        """clearCommand(self: depthai.CameraControl, arg0: depthai.CameraControl.Command) -> None"""
    def clearMiscControls(self) -> None:
        """clearMiscControls(self: depthai.CameraControl) -> None

        Clear the list of miscellaneous controls set by `setControl`
        """
    def getCaptureStill(self) -> bool:
        """getCaptureStill(self: depthai.CameraControl) -> bool

        Check whether command to capture a still is set

        Returns:
            True if capture still command is set
        """
    def getCommand(self, arg0: CameraControl.Command) -> bool:
        """getCommand(self: depthai.CameraControl, arg0: depthai.CameraControl.Command) -> bool"""
    def getExposureTime(self) -> datetime.timedelta:
        """getExposureTime(self: depthai.CameraControl) -> datetime.timedelta

        Retrieves exposure time
        """
    def getLensPosition(self) -> int:
        """getLensPosition(self: depthai.CameraControl) -> int

        Retrieves lens position, range 0..255. Returns -1 if not available
        """
    def getLensPositionRaw(self) -> float:
        """getLensPositionRaw(self: depthai.CameraControl) -> float

        Retrieves lens position, range 0.0f..1.0f.
        """
    def getMiscControls(self) -> list[tuple[str, str]]:
        """getMiscControls(self: depthai.CameraControl) -> list[tuple[str, str]]

        Get the list of miscellaneous controls set by `setControl`

        Returns:
            A list of <key, value> pairs as strings
        """
    def getSensitivity(self) -> int:
        """getSensitivity(self: depthai.CameraControl) -> int

        Retrieves sensitivity, as an ISO value
        """
    def setAntiBandingMode(self, mode: CameraControl.AntiBandingMode) -> CameraControl:
        """setAntiBandingMode(self: depthai.CameraControl, mode: depthai.CameraControl.AntiBandingMode) -> depthai.CameraControl

        Set a command to specify anti-banding mode. Anti-banding / anti-flicker works in
        auto-exposure mode, by controlling the exposure time to be applied in multiples
        of half the mains period, for example in multiple of 10ms for 50Hz (period 20ms)
        AC-powered illumination sources.

        If the scene would be too bright for the smallest exposure step (10ms in the
        example, with ISO at a minimum of 100), anti-banding is not effective.

        Parameter ``mode``:
            Anti-banding mode to use. Default: `MAINS_50_HZ`
        """
    def setAutoExposureCompensation(self, compensation: int) -> CameraControl:
        """setAutoExposureCompensation(self: depthai.CameraControl, compensation: int) -> depthai.CameraControl

        Set a command to specify auto exposure compensation

        Parameter ``compensation``:
            Compensation value between -9..9, default 0
        """
    def setAutoExposureEnable(self) -> CameraControl:
        """setAutoExposureEnable(self: depthai.CameraControl) -> depthai.CameraControl

        Set a command to enable auto exposure
        """
    @overload
    def setAutoExposureLimit(self, maxExposureTimeUs: int) -> CameraControl:
        """setAutoExposureLimit(*args, **kwargs)
        Overloaded function.

        1. setAutoExposureLimit(self: depthai.CameraControl, maxExposureTimeUs: int) -> depthai.CameraControl

        Set a command to specify the maximum exposure time limit for auto-exposure. By
        default the AE algorithm prioritizes increasing exposure over ISO, up to around
        frame-time (subject to further limits imposed by anti-banding)

        Parameter ``maxExposureTimeUs``:
            Maximum exposure time in microseconds

        2. setAutoExposureLimit(self: depthai.CameraControl, maxExposureTime: datetime.timedelta) -> depthai.CameraControl

        Set a command to specify the maximum exposure time limit for auto-exposure. By
        default the AE algorithm prioritizes increasing exposure over ISO, up to around
        frame-time (subject to further limits imposed by anti-banding)

        Parameter ``maxExposureTime``:
            Maximum exposure time
        """
    @overload
    def setAutoExposureLimit(self, maxExposureTime: datetime.timedelta) -> CameraControl:
        """setAutoExposureLimit(*args, **kwargs)
        Overloaded function.

        1. setAutoExposureLimit(self: depthai.CameraControl, maxExposureTimeUs: int) -> depthai.CameraControl

        Set a command to specify the maximum exposure time limit for auto-exposure. By
        default the AE algorithm prioritizes increasing exposure over ISO, up to around
        frame-time (subject to further limits imposed by anti-banding)

        Parameter ``maxExposureTimeUs``:
            Maximum exposure time in microseconds

        2. setAutoExposureLimit(self: depthai.CameraControl, maxExposureTime: datetime.timedelta) -> depthai.CameraControl

        Set a command to specify the maximum exposure time limit for auto-exposure. By
        default the AE algorithm prioritizes increasing exposure over ISO, up to around
        frame-time (subject to further limits imposed by anti-banding)

        Parameter ``maxExposureTime``:
            Maximum exposure time
        """
    def setAutoExposureLock(self, lock: bool) -> CameraControl:
        """setAutoExposureLock(self: depthai.CameraControl, lock: bool) -> depthai.CameraControl

        Set a command to specify lock auto exposure

        Parameter ``lock``:
            Auto exposure lock mode enabled or disabled
        """
    def setAutoExposureRegion(self, startX: int, startY: int, width: int, height: int) -> CameraControl:
        """setAutoExposureRegion(self: depthai.CameraControl, startX: int, startY: int, width: int, height: int) -> depthai.CameraControl

        Set a command to specify auto exposure region in pixels. Note: the region should
        be mapped to the configured sensor resolution, before ISP scaling

        Parameter ``startX``:
            X coordinate of top left corner of region

        Parameter ``startY``:
            Y coordinate of top left corner of region

        Parameter ``width``:
            Region width

        Parameter ``height``:
            Region height
        """
    def setAutoFocusLensRange(self, infinityPosition: int, macroPosition: int) -> CameraControl:
        """setAutoFocusLensRange(self: depthai.CameraControl, infinityPosition: int, macroPosition: int) -> depthai.CameraControl

        Set autofocus lens range, `infinityPosition < macroPosition`, valid values
        `0..255`. May help to improve autofocus in case the lens adjustment is not
        typical/tuned
        """
    def setAutoFocusMode(self, mode: CameraControl.AutoFocusMode) -> CameraControl:
        """setAutoFocusMode(self: depthai.CameraControl, mode: depthai.CameraControl.AutoFocusMode) -> depthai.CameraControl

        Set a command to specify autofocus mode. Default `CONTINUOUS_VIDEO`
        """
    def setAutoFocusRegion(self, startX: int, startY: int, width: int, height: int) -> CameraControl:
        """setAutoFocusRegion(self: depthai.CameraControl, startX: int, startY: int, width: int, height: int) -> depthai.CameraControl

        Set a command to specify focus region in pixels. Note: the region should be
        mapped to the configured sensor resolution, before ISP scaling

        Parameter ``startX``:
            X coordinate of top left corner of region

        Parameter ``startY``:
            Y coordinate of top left corner of region

        Parameter ``width``:
            Region width

        Parameter ``height``:
            Region height
        """
    def setAutoFocusTrigger(self) -> CameraControl:
        """setAutoFocusTrigger(self: depthai.CameraControl) -> depthai.CameraControl

        Set a command to trigger autofocus
        """
    def setAutoWhiteBalanceLock(self, lock: bool) -> CameraControl:
        """setAutoWhiteBalanceLock(self: depthai.CameraControl, lock: bool) -> depthai.CameraControl

        Set a command to specify auto white balance lock

        Parameter ``lock``:
            Auto white balance lock mode enabled or disabled
        """
    def setAutoWhiteBalanceMode(self, mode: CameraControl.AutoWhiteBalanceMode) -> CameraControl:
        """setAutoWhiteBalanceMode(self: depthai.CameraControl, mode: depthai.CameraControl.AutoWhiteBalanceMode) -> depthai.CameraControl

        Set a command to specify auto white balance mode

        Parameter ``mode``:
            Auto white balance mode to use. Default `AUTO`
        """
    def setBrightness(self, value: int) -> CameraControl:
        """setBrightness(self: depthai.CameraControl, value: int) -> depthai.CameraControl

        Set a command to adjust image brightness

        Parameter ``value``:
            Brightness, range -10..10, default 0
        """
    def setCaptureIntent(self, mode: CameraControl.CaptureIntent) -> CameraControl:
        """setCaptureIntent(self: depthai.CameraControl, mode: depthai.CameraControl.CaptureIntent) -> depthai.CameraControl

        Set a command to specify capture intent mode

        Parameter ``mode``:
            Capture intent mode
        """
    def setCaptureStill(self, capture: bool) -> CameraControl:
        """setCaptureStill(self: depthai.CameraControl, capture: bool) -> depthai.CameraControl

        Set a command to capture a still image
        """
    def setChromaDenoise(self, value: int) -> CameraControl:
        """setChromaDenoise(self: depthai.CameraControl, value: int) -> depthai.CameraControl

        Set a command to adjust chroma denoise amount

        Parameter ``value``:
            Chroma denoise amount, range 0..4, default 1
        """
    def setCommand(self, arg0: CameraControl.Command, arg1: bool) -> None:
        """setCommand(self: depthai.CameraControl, arg0: depthai.CameraControl.Command, arg1: bool) -> None"""
    def setContrast(self, value: int) -> CameraControl:
        """setContrast(self: depthai.CameraControl, value: int) -> depthai.CameraControl

        Set a command to adjust image contrast

        Parameter ``value``:
            Contrast, range -10..10, default 0
        """
    def setControlMode(self, mode: CameraControl.ControlMode) -> CameraControl:
        """setControlMode(self: depthai.CameraControl, mode: depthai.CameraControl.ControlMode) -> depthai.CameraControl

        Set a command to specify control mode

        Parameter ``mode``:
            Control mode
        """
    def setEffectMode(self, mode: CameraControl.EffectMode) -> CameraControl:
        """setEffectMode(self: depthai.CameraControl, mode: depthai.CameraControl.EffectMode) -> depthai.CameraControl

        Set a command to specify effect mode

        Parameter ``mode``:
            Effect mode
        """
    def setExternalTrigger(self, numFramesBurst: int, numFramesDiscard: int) -> CameraControl:
        """setExternalTrigger(self: depthai.CameraControl, numFramesBurst: int, numFramesDiscard: int) -> depthai.CameraControl

        Set a command to enable external trigger snapshot mode

        A rising edge on the sensor FSIN pin will make it capture a sequence of
        `numFramesBurst` frames. First `numFramesDiscard` will be skipped as configured
        (can be set to 0 as well), as they may have degraded quality
        """
    def setFrameSyncMode(self, mode: CameraControl.FrameSyncMode) -> CameraControl:
        """setFrameSyncMode(self: depthai.CameraControl, mode: depthai.CameraControl.FrameSyncMode) -> depthai.CameraControl

        Set the frame sync mode for continuous streaming operation mode, translating to
        how the camera pin FSIN/FSYNC is used: input/output/disabled
        """
    def setLumaDenoise(self, value: int) -> CameraControl:
        """setLumaDenoise(self: depthai.CameraControl, value: int) -> depthai.CameraControl

        Set a command to adjust luma denoise amount

        Parameter ``value``:
            Luma denoise amount, range 0..4, default 1
        """
    @overload
    def setManualExposure(self, exposureTimeUs: int, sensitivityIso: int) -> CameraControl:
        """setManualExposure(*args, **kwargs)
        Overloaded function.

        1. setManualExposure(self: depthai.CameraControl, exposureTimeUs: int, sensitivityIso: int) -> depthai.CameraControl

        Set a command to manually specify exposure

        Parameter ``exposureTimeUs``:
            Exposure time in microseconds

        Parameter ``sensitivityIso``:
            Sensitivity as ISO value, usual range 100..1600

        2. setManualExposure(self: depthai.CameraControl, exposureTime: datetime.timedelta, sensitivityIso: int) -> depthai.CameraControl

        Set a command to manually specify exposure

        Parameter ``exposureTime``:
            Exposure time

        Parameter ``sensitivityIso``:
            Sensitivity as ISO value, usual range 100..1600
        """
    @overload
    def setManualExposure(self, exposureTime: datetime.timedelta, sensitivityIso: int) -> CameraControl:
        """setManualExposure(*args, **kwargs)
        Overloaded function.

        1. setManualExposure(self: depthai.CameraControl, exposureTimeUs: int, sensitivityIso: int) -> depthai.CameraControl

        Set a command to manually specify exposure

        Parameter ``exposureTimeUs``:
            Exposure time in microseconds

        Parameter ``sensitivityIso``:
            Sensitivity as ISO value, usual range 100..1600

        2. setManualExposure(self: depthai.CameraControl, exposureTime: datetime.timedelta, sensitivityIso: int) -> depthai.CameraControl

        Set a command to manually specify exposure

        Parameter ``exposureTime``:
            Exposure time

        Parameter ``sensitivityIso``:
            Sensitivity as ISO value, usual range 100..1600
        """
    def setManualFocus(self, lensPosition: int) -> CameraControl:
        """setManualFocus(self: depthai.CameraControl, lensPosition: int) -> depthai.CameraControl

        Set a command to specify manual focus position

        Parameter ``lensPosition``:
            specify lens position 0..255
        """
    def setManualFocusRaw(self, lensPositionRaw: float) -> CameraControl:
        """setManualFocusRaw(self: depthai.CameraControl, lensPositionRaw: float) -> depthai.CameraControl

        Set a command to specify manual focus position (more precise control).

        Parameter ``lensPositionRaw``:
            specify lens position 0.0f .. 1.0f

        Returns:
            CameraControl&
        """
    def setManualWhiteBalance(self, colorTemperatureK: int) -> CameraControl:
        """setManualWhiteBalance(self: depthai.CameraControl, colorTemperatureK: int) -> depthai.CameraControl

        Set a command to manually specify white-balance color correction

        Parameter ``colorTemperatureK``:
            Light source color temperature in kelvins, range 1000..12000
        """
    @overload
    def setMisc(self, control: str, value: str) -> CameraControl:
        """setMisc(*args, **kwargs)
        Overloaded function.

        1. setMisc(self: depthai.CameraControl, control: str, value: str) -> depthai.CameraControl

        Set a miscellaneous control. The controls set by this function get appended to a
        list, processed after the standard controls

        Parameter ``control``:
            Control name

        Parameter ``value``:
            Value as a string

        2. setMisc(self: depthai.CameraControl, control: str, value: int) -> depthai.CameraControl

        Set a miscellaneous control. The controls set by this function get appended to a
        list, processed after the standard controls

        Parameter ``control``:
            Control name

        Parameter ``value``:
            Value as an integer number

        3. setMisc(self: depthai.CameraControl, control: str, value: float) -> depthai.CameraControl

        Set a miscellaneous control. The controls set by this function get appended to a
        list, processed after the standard controls

        Parameter ``control``:
            Control name

        Parameter ``value``:
            Value as a floating point number
        """
    @overload
    def setMisc(self, control: str, value: int) -> CameraControl:
        """setMisc(*args, **kwargs)
        Overloaded function.

        1. setMisc(self: depthai.CameraControl, control: str, value: str) -> depthai.CameraControl

        Set a miscellaneous control. The controls set by this function get appended to a
        list, processed after the standard controls

        Parameter ``control``:
            Control name

        Parameter ``value``:
            Value as a string

        2. setMisc(self: depthai.CameraControl, control: str, value: int) -> depthai.CameraControl

        Set a miscellaneous control. The controls set by this function get appended to a
        list, processed after the standard controls

        Parameter ``control``:
            Control name

        Parameter ``value``:
            Value as an integer number

        3. setMisc(self: depthai.CameraControl, control: str, value: float) -> depthai.CameraControl

        Set a miscellaneous control. The controls set by this function get appended to a
        list, processed after the standard controls

        Parameter ``control``:
            Control name

        Parameter ``value``:
            Value as a floating point number
        """
    @overload
    def setMisc(self, control: str, value: float) -> CameraControl:
        """setMisc(*args, **kwargs)
        Overloaded function.

        1. setMisc(self: depthai.CameraControl, control: str, value: str) -> depthai.CameraControl

        Set a miscellaneous control. The controls set by this function get appended to a
        list, processed after the standard controls

        Parameter ``control``:
            Control name

        Parameter ``value``:
            Value as a string

        2. setMisc(self: depthai.CameraControl, control: str, value: int) -> depthai.CameraControl

        Set a miscellaneous control. The controls set by this function get appended to a
        list, processed after the standard controls

        Parameter ``control``:
            Control name

        Parameter ``value``:
            Value as an integer number

        3. setMisc(self: depthai.CameraControl, control: str, value: float) -> depthai.CameraControl

        Set a miscellaneous control. The controls set by this function get appended to a
        list, processed after the standard controls

        Parameter ``control``:
            Control name

        Parameter ``value``:
            Value as a floating point number
        """
    def setSaturation(self, value: int) -> CameraControl:
        """setSaturation(self: depthai.CameraControl, value: int) -> depthai.CameraControl

        Set a command to adjust image saturation

        Parameter ``value``:
            Saturation, range -10..10, default 0
        """
    def setSceneMode(self, mode: CameraControl.SceneMode) -> CameraControl:
        """setSceneMode(self: depthai.CameraControl, mode: depthai.CameraControl.SceneMode) -> depthai.CameraControl

        Set a command to specify scene mode

        Parameter ``mode``:
            Scene mode
        """
    def setSharpness(self, value: int) -> CameraControl:
        """setSharpness(self: depthai.CameraControl, value: int) -> depthai.CameraControl

        Set a command to adjust image sharpness

        Parameter ``value``:
            Sharpness, range 0..4, default 1
        """
    def setStartStreaming(self) -> CameraControl:
        """setStartStreaming(self: depthai.CameraControl) -> depthai.CameraControl

        Set a command to start streaming
        """
    def setStopStreaming(self) -> CameraControl:
        """setStopStreaming(self: depthai.CameraControl) -> depthai.CameraControl

        Set a command to stop streaming
        """
    def setStrobeDisable(self) -> CameraControl:
        """setStrobeDisable(self: depthai.CameraControl) -> depthai.CameraControl

        Disable STROBE output
        """
    def setStrobeExternal(self, gpioNumber: int, activeLevel: int) -> CameraControl:
        """setStrobeExternal(self: depthai.CameraControl, gpioNumber: int, activeLevel: int) -> depthai.CameraControl

        Enable STROBE output driven by a MyriadX GPIO, optionally configuring the
        polarity This normally requires a FSIN/FSYNC/trigger input for MyriadX (usually
        GPIO 41), to generate timings
        """
    def setStrobeSensor(self, activeLevel: int) -> CameraControl:
        """setStrobeSensor(self: depthai.CameraControl, activeLevel: int) -> depthai.CameraControl

        Enable STROBE output on sensor pin, optionally configuring the polarity. Note:
        for many sensors the polarity is high-active and not configurable
        """

class CameraExposureOffset:
    __members__: ClassVar[dict] = ...  # read-only
    END: ClassVar[CameraExposureOffset] = ...
    MIDDLE: ClassVar[CameraExposureOffset] = ...
    START: ClassVar[CameraExposureOffset] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.CameraExposureOffset, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.CameraExposureOffset) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.CameraExposureOffset) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class CameraFeatures:
    calibrationResolution: CameraSensorConfig | None
    configs: list[CameraSensorConfig]
    hasAutofocus: bool
    hasAutofocusIC: bool
    height: int
    name: str
    orientation: CameraImageOrientation
    sensorName: str
    socket: CameraBoardSocket
    supportedTypes: list[CameraSensorType]
    width: int
    def __init__(self) -> None:
        """__init__(self: depthai.CameraFeatures) -> None"""

class CameraImageOrientation:
    __members__: ClassVar[dict] = ...  # read-only
    AUTO: ClassVar[CameraImageOrientation] = ...
    HORIZONTAL_MIRROR: ClassVar[CameraImageOrientation] = ...
    NORMAL: ClassVar[CameraImageOrientation] = ...
    ROTATE_180_DEG: ClassVar[CameraImageOrientation] = ...
    VERTICAL_FLIP: ClassVar[CameraImageOrientation] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.CameraImageOrientation, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.CameraImageOrientation) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.CameraImageOrientation) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class CameraInfo:
    cameraType: CameraModel
    distortionCoeff: list[float]
    extrinsics: Extrinsics
    height: int
    intrinsicMatrix: list[list[float]]
    specHfovDeg: float
    width: int
    def __init__(self) -> None:
        """__init__(self: depthai.CameraInfo) -> None"""

class CameraModel:
    __members__: ClassVar[dict] = ...  # read-only
    Equirectangular: ClassVar[CameraModel] = ...
    Fisheye: ClassVar[CameraModel] = ...
    Perspective: ClassVar[CameraModel] = ...
    RadialDivision: ClassVar[CameraModel] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.CameraModel, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.CameraModel) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.CameraModel) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class CameraSensorConfig:
    fov: Rect
    height: int
    maxFps: float
    minFps: float
    type: CameraSensorType
    width: int
    def __init__(self) -> None:
        """__init__(self: depthai.CameraSensorConfig) -> None"""

class CameraSensorType:
    __members__: ClassVar[dict] = ...  # read-only
    COLOR: ClassVar[CameraSensorType] = ...
    MONO: ClassVar[CameraSensorType] = ...
    THERMAL: ClassVar[CameraSensorType] = ...
    TOF: ClassVar[CameraSensorType] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.CameraSensorType, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.CameraSensorType) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.CameraSensorType) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class Capability:
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class CapabilityRangeFloat:
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def discrete(self, arg0: list[float]) -> None:
        """discrete(self: depthai.CapabilityRangeFloat, arg0: list[float]) -> None"""
    def fixed(self, arg0: float) -> None:
        """fixed(self: depthai.CapabilityRangeFloat, arg0: float) -> None"""
    @overload
    def minMax(self, arg0: tuple[float, float]) -> None:
        """minMax(*args, **kwargs)
        Overloaded function.

        1. minMax(self: depthai.CapabilityRangeFloat, arg0: tuple[float, float]) -> None

        2. minMax(self: depthai.CapabilityRangeFloat, arg0: tuple[float, float]) -> None

        3. minMax(self: depthai.CapabilityRangeFloat, arg0: float, arg1: float) -> None
        """
    @overload
    def minMax(self, arg0: tuple[float, float]) -> None:
        """minMax(*args, **kwargs)
        Overloaded function.

        1. minMax(self: depthai.CapabilityRangeFloat, arg0: tuple[float, float]) -> None

        2. minMax(self: depthai.CapabilityRangeFloat, arg0: tuple[float, float]) -> None

        3. minMax(self: depthai.CapabilityRangeFloat, arg0: float, arg1: float) -> None
        """
    @overload
    def minMax(self, arg0: float, arg1: float) -> None:
        """minMax(*args, **kwargs)
        Overloaded function.

        1. minMax(self: depthai.CapabilityRangeFloat, arg0: tuple[float, float]) -> None

        2. minMax(self: depthai.CapabilityRangeFloat, arg0: tuple[float, float]) -> None

        3. minMax(self: depthai.CapabilityRangeFloat, arg0: float, arg1: float) -> None
        """

class CapabilityRangeFloatPair:
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def discrete(self, arg0: list[tuple[float, float]]) -> None:
        """discrete(self: depthai.CapabilityRangeFloatPair, arg0: list[tuple[float, float]]) -> None"""
    def fixed(self, arg0: tuple[float, float]) -> None:
        """fixed(self: depthai.CapabilityRangeFloatPair, arg0: tuple[float, float]) -> None"""
    @overload
    def minMax(self, arg0: tuple[tuple[float, float], tuple[float, float]]) -> None:
        """minMax(*args, **kwargs)
        Overloaded function.

        1. minMax(self: depthai.CapabilityRangeFloatPair, arg0: tuple[tuple[float, float], tuple[float, float]]) -> None

        2. minMax(self: depthai.CapabilityRangeFloatPair, arg0: tuple[tuple[float, float], tuple[float, float]]) -> None

        3. minMax(self: depthai.CapabilityRangeFloatPair, arg0: tuple[float, float], arg1: tuple[float, float]) -> None
        """
    @overload
    def minMax(self, arg0: tuple[tuple[float, float], tuple[float, float]]) -> None:
        """minMax(*args, **kwargs)
        Overloaded function.

        1. minMax(self: depthai.CapabilityRangeFloatPair, arg0: tuple[tuple[float, float], tuple[float, float]]) -> None

        2. minMax(self: depthai.CapabilityRangeFloatPair, arg0: tuple[tuple[float, float], tuple[float, float]]) -> None

        3. minMax(self: depthai.CapabilityRangeFloatPair, arg0: tuple[float, float], arg1: tuple[float, float]) -> None
        """
    @overload
    def minMax(self, arg0: tuple[float, float], arg1: tuple[float, float]) -> None:
        """minMax(*args, **kwargs)
        Overloaded function.

        1. minMax(self: depthai.CapabilityRangeFloatPair, arg0: tuple[tuple[float, float], tuple[float, float]]) -> None

        2. minMax(self: depthai.CapabilityRangeFloatPair, arg0: tuple[tuple[float, float], tuple[float, float]]) -> None

        3. minMax(self: depthai.CapabilityRangeFloatPair, arg0: tuple[float, float], arg1: tuple[float, float]) -> None
        """

class CapabilityRangeUint:
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def discrete(self, arg0: list[int]) -> None:
        """discrete(self: depthai.CapabilityRangeUint, arg0: list[int]) -> None"""
    def fixed(self, arg0: int) -> None:
        """fixed(self: depthai.CapabilityRangeUint, arg0: int) -> None"""
    @overload
    def minMax(self, arg0: tuple[int, int]) -> None:
        """minMax(*args, **kwargs)
        Overloaded function.

        1. minMax(self: depthai.CapabilityRangeUint, arg0: tuple[int, int]) -> None

        2. minMax(self: depthai.CapabilityRangeUint, arg0: tuple[int, int]) -> None

        3. minMax(self: depthai.CapabilityRangeUint, arg0: int, arg1: int) -> None
        """
    @overload
    def minMax(self, arg0: tuple[int, int]) -> None:
        """minMax(*args, **kwargs)
        Overloaded function.

        1. minMax(self: depthai.CapabilityRangeUint, arg0: tuple[int, int]) -> None

        2. minMax(self: depthai.CapabilityRangeUint, arg0: tuple[int, int]) -> None

        3. minMax(self: depthai.CapabilityRangeUint, arg0: int, arg1: int) -> None
        """
    @overload
    def minMax(self, arg0: int, arg1: int) -> None:
        """minMax(*args, **kwargs)
        Overloaded function.

        1. minMax(self: depthai.CapabilityRangeUint, arg0: tuple[int, int]) -> None

        2. minMax(self: depthai.CapabilityRangeUint, arg0: tuple[int, int]) -> None

        3. minMax(self: depthai.CapabilityRangeUint, arg0: int, arg1: int) -> None
        """

class CapabilityRangeUintPair:
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def discrete(self, arg0: list[tuple[int, int]]) -> None:
        """discrete(self: depthai.CapabilityRangeUintPair, arg0: list[tuple[int, int]]) -> None"""
    def fixed(self, arg0: tuple[int, int]) -> None:
        """fixed(self: depthai.CapabilityRangeUintPair, arg0: tuple[int, int]) -> None"""
    @overload
    def minMax(self, arg0: tuple[tuple[int, int], tuple[int, int]]) -> None:
        """minMax(*args, **kwargs)
        Overloaded function.

        1. minMax(self: depthai.CapabilityRangeUintPair, arg0: tuple[tuple[int, int], tuple[int, int]]) -> None

        2. minMax(self: depthai.CapabilityRangeUintPair, arg0: tuple[tuple[int, int], tuple[int, int]]) -> None

        3. minMax(self: depthai.CapabilityRangeUintPair, arg0: tuple[int, int], arg1: tuple[int, int]) -> None
        """
    @overload
    def minMax(self, arg0: tuple[tuple[int, int], tuple[int, int]]) -> None:
        """minMax(*args, **kwargs)
        Overloaded function.

        1. minMax(self: depthai.CapabilityRangeUintPair, arg0: tuple[tuple[int, int], tuple[int, int]]) -> None

        2. minMax(self: depthai.CapabilityRangeUintPair, arg0: tuple[tuple[int, int], tuple[int, int]]) -> None

        3. minMax(self: depthai.CapabilityRangeUintPair, arg0: tuple[int, int], arg1: tuple[int, int]) -> None
        """
    @overload
    def minMax(self, arg0: tuple[int, int], arg1: tuple[int, int]) -> None:
        """minMax(*args, **kwargs)
        Overloaded function.

        1. minMax(self: depthai.CapabilityRangeUintPair, arg0: tuple[tuple[int, int], tuple[int, int]]) -> None

        2. minMax(self: depthai.CapabilityRangeUintPair, arg0: tuple[tuple[int, int], tuple[int, int]]) -> None

        3. minMax(self: depthai.CapabilityRangeUintPair, arg0: tuple[int, int], arg1: tuple[int, int]) -> None
        """

class ChipTemperature:
    average: float
    css: float
    dss: float
    mss: float
    upa: float
    def __init__(self) -> None:
        """__init__(self: depthai.ChipTemperature) -> None"""

class ChipTemperatureS3:
    average: float
    css: float
    mss: float
    nce: float
    soc: float
    def __init__(self) -> None:
        """__init__(self: depthai.ChipTemperatureS3) -> None"""

class CircleAnnotation:
    diameter: float
    fillColor: Color
    outlineColor: Color
    position: Point2f
    thickness: float
    def __init__(self) -> None:
        """__init__(self: depthai.CircleAnnotation) -> None"""

class Clock:
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def now(self) -> datetime.timedelta:
        """now() -> datetime.timedelta"""

class Color:
    a: float
    b: float
    g: float
    r: float
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Color) -> None

        2. __init__(self: depthai.Color, r: float, g: float, b: float, a: float = 1.0) -> None
        """
    @overload
    def __init__(self, r: float, g: float, b: float, a: float = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Color) -> None

        2. __init__(self: depthai.Color, r: float, g: float, b: float, a: float = 1.0) -> None
        """

class ColorCameraProperties:
    class ColorOrder:
        __members__: ClassVar[dict] = ...  # read-only
        BGR: ClassVar[ColorCameraProperties.ColorOrder] = ...
        RGB: ClassVar[ColorCameraProperties.ColorOrder] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.ColorCameraProperties.ColorOrder, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.ColorCameraProperties.ColorOrder) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.ColorCameraProperties.ColorOrder) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class SensorResolution:
        __members__: ClassVar[dict] = ...  # read-only
        THE_1080_P: ClassVar[ColorCameraProperties.SensorResolution] = ...
        THE_1200_P: ClassVar[ColorCameraProperties.SensorResolution] = ...
        THE_1280X962: ClassVar[ColorCameraProperties.SensorResolution] = ...
        THE_12_MP: ClassVar[ColorCameraProperties.SensorResolution] = ...
        THE_1352X1012: ClassVar[ColorCameraProperties.SensorResolution] = ...
        THE_13_MP: ClassVar[ColorCameraProperties.SensorResolution] = ...
        THE_1440X1080: ClassVar[ColorCameraProperties.SensorResolution] = ...
        THE_2000X1500: ClassVar[ColorCameraProperties.SensorResolution] = ...
        THE_2024X1520: ClassVar[ColorCameraProperties.SensorResolution] = ...
        THE_2028X1520: ClassVar[ColorCameraProperties.SensorResolution] = ...
        THE_2104X1560: ClassVar[ColorCameraProperties.SensorResolution] = ...
        THE_240X180: ClassVar[ColorCameraProperties.SensorResolution] = ...
        THE_4000X3000: ClassVar[ColorCameraProperties.SensorResolution] = ...
        THE_48_MP: ClassVar[ColorCameraProperties.SensorResolution] = ...
        THE_4_K: ClassVar[ColorCameraProperties.SensorResolution] = ...
        THE_5312X6000: ClassVar[ColorCameraProperties.SensorResolution] = ...
        THE_5_MP: ClassVar[ColorCameraProperties.SensorResolution] = ...
        THE_720_P: ClassVar[ColorCameraProperties.SensorResolution] = ...
        THE_800_P: ClassVar[ColorCameraProperties.SensorResolution] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.ColorCameraProperties.SensorResolution, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.ColorCameraProperties.SensorResolution) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.ColorCameraProperties.SensorResolution) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class WarpMeshSource:
        __members__: ClassVar[dict] = ...  # read-only
        AUTO: ClassVar[ColorCameraProperties.WarpMeshSource] = ...
        CALIBRATION: ClassVar[ColorCameraProperties.WarpMeshSource] = ...
        NONE: ClassVar[ColorCameraProperties.WarpMeshSource] = ...
        URI: ClassVar[ColorCameraProperties.WarpMeshSource] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.ColorCameraProperties.WarpMeshSource, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.ColorCameraProperties.WarpMeshSource) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.ColorCameraProperties.WarpMeshSource) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    boardSocket: CameraBoardSocket
    calibAlpha: float
    eventFilter: list[FrameEvent]
    fps: float
    imageOrientation: CameraImageOrientation
    initialControl: CameraControl
    isp3aFps: int
    ispScale: Incomplete
    numFramesPoolIsp: int
    numFramesPoolPreview: int
    numFramesPoolRaw: int
    numFramesPoolStill: int
    numFramesPoolVideo: int
    previewHeight: int
    previewKeepAspectRatio: bool
    previewWidth: int
    resolution: ColorCameraProperties.SensorResolution
    sensorCropX: float
    sensorCropY: float
    stillHeight: int
    stillWidth: int
    videoHeight: int
    videoWidth: int
    warpMeshHeight: int
    warpMeshSource: ColorCameraProperties.WarpMeshSource
    warpMeshStepHeight: int
    warpMeshStepWidth: int
    warpMeshUri: str
    warpMeshWidth: int
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class Colormap:
    __members__: ClassVar[dict] = ...  # read-only
    JET: ClassVar[Colormap] = ...
    NONE: ClassVar[Colormap] = ...
    STEREO_JET: ClassVar[Colormap] = ...
    STEREO_TURBO: ClassVar[Colormap] = ...
    TURBO: ClassVar[Colormap] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.Colormap, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.Colormap) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.Colormap) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class CpuUsage:
    average: float
    msTime: int
    def __init__(self) -> None:
        """__init__(self: depthai.CpuUsage) -> None"""

class CrashDump:
    class CrashReport:
        class ErrorSourceInfo:
            class AssertContext:
                fileName: str
                functionName: str
                line: int
                def __init__(self) -> None:
                    """__init__(self: depthai.CrashDump.CrashReport.ErrorSourceInfo.AssertContext) -> None"""

            class TrapContext:
                trapAddress: int
                trapName: str
                trapNumber: int
                def __init__(self) -> None:
                    """__init__(self: depthai.CrashDump.CrashReport.ErrorSourceInfo.TrapContext) -> None"""
            assertContext: CrashDump.CrashReport.ErrorSourceInfo.AssertContext
            errorId: int
            trapContext: CrashDump.CrashReport.ErrorSourceInfo.TrapContext
            def __init__(self) -> None:
                """__init__(self: depthai.CrashDump.CrashReport.ErrorSourceInfo) -> None"""

        class ThreadCallstack:
            class CallstackContext:
                callSite: int
                calledTarget: int
                context: str
                framePointer: int
                def __init__(self) -> None:
                    """__init__(self: depthai.CrashDump.CrashReport.ThreadCallstack.CallstackContext) -> None"""
            callStack: list[CrashDump.CrashReport.ThreadCallstack.CallstackContext]
            instructionPointer: int
            stackBottom: int
            stackPointer: int
            stackTop: int
            threadId: int
            threadName: str
            threadStatus: str
            def __init__(self) -> None:
                """__init__(self: depthai.CrashDump.CrashReport.ThreadCallstack) -> None"""
        crashedThreadId: int
        errorSource: str
        processor: ProcessorType
        threadCallstack: list[CrashDump.CrashReport.ThreadCallstack]
        def __init__(self) -> None:
            """__init__(self: depthai.CrashDump.CrashReport) -> None"""
    crashReports: list[CrashDump.CrashReport]
    depthaiCommitHash: str
    deviceId: str
    def __init__(self) -> None:
        """__init__(self: depthai.CrashDump) -> None"""
    def serializeToJson(self) -> json:
        """serializeToJson(self: depthai.CrashDump) -> json"""

class DatatypeEnum:
    __members__: ClassVar[dict] = ...  # read-only
    ADatatype: ClassVar[DatatypeEnum] = ...
    AprilTagConfig: ClassVar[DatatypeEnum] = ...
    AprilTags: ClassVar[DatatypeEnum] = ...
    BenchmarkReport: ClassVar[DatatypeEnum] = ...
    Buffer: ClassVar[DatatypeEnum] = ...
    CameraControl: ClassVar[DatatypeEnum] = ...
    EdgeDetectorConfig: ClassVar[DatatypeEnum] = ...
    EncodedFrame: ClassVar[DatatypeEnum] = ...
    FeatureTrackerConfig: ClassVar[DatatypeEnum] = ...
    IMUData: ClassVar[DatatypeEnum] = ...
    ImageAlignConfig: ClassVar[DatatypeEnum] = ...
    ImageManipConfig: ClassVar[DatatypeEnum] = ...
    ImageManipConfigV2: ClassVar[DatatypeEnum] = ...
    ImgAnnotations: ClassVar[DatatypeEnum] = ...
    ImgDetections: ClassVar[DatatypeEnum] = ...
    ImgFrame: ClassVar[DatatypeEnum] = ...
    MessageGroup: ClassVar[DatatypeEnum] = ...
    NNData: ClassVar[DatatypeEnum] = ...
    PointCloudConfig: ClassVar[DatatypeEnum] = ...
    PointCloudData: ClassVar[DatatypeEnum] = ...
    SpatialImgDetections: ClassVar[DatatypeEnum] = ...
    SpatialLocationCalculatorConfig: ClassVar[DatatypeEnum] = ...
    SpatialLocationCalculatorData: ClassVar[DatatypeEnum] = ...
    StereoDepthConfig: ClassVar[DatatypeEnum] = ...
    SystemInformation: ClassVar[DatatypeEnum] = ...
    SystemInformationS3: ClassVar[DatatypeEnum] = ...
    ThermalConfig: ClassVar[DatatypeEnum] = ...
    ToFConfig: ClassVar[DatatypeEnum] = ...
    TrackedFeatures: ClassVar[DatatypeEnum] = ...
    Tracklets: ClassVar[DatatypeEnum] = ...
    TransformData: ClassVar[DatatypeEnum] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.DatatypeEnum, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.DatatypeEnum) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.DatatypeEnum) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class DetectionNetworkType:
    __members__: ClassVar[dict] = ...  # read-only
    MOBILENET: ClassVar[DetectionNetworkType] = ...
    YOLO: ClassVar[DetectionNetworkType] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.DetectionNetworkType, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.DetectionNetworkType) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.DetectionNetworkType) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class DetectionParserOptions:
    anchorMasks: dict[str, list[int]]
    anchors: list[float]
    classes: int
    confidenceThreshold: float
    coordinates: int
    iouThreshold: float
    nnFamily: DetectionNetworkType
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class DetectionParserProperties:
    parser: DetectionParserOptions
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class Device(DeviceBase):
    class Config:
        board: BoardConfig
        logLevel: LogLevel | None
        nonExclusiveMode: bool
        outputLogLevel: LogLevel | None
        version: OpenVINO.Version
        def __init__(self) -> None:
            """__init__(self: depthai.Device.Config) -> None"""

    class ReconnectionStatus:
        __members__: ClassVar[dict] = ...  # read-only
        RECONNECTED: ClassVar[Device.ReconnectionStatus] = ...
        RECONNECTING: ClassVar[Device.ReconnectionStatus] = ...
        RECONNECT_FAILED: ClassVar[Device.ReconnectionStatus] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.Device.ReconnectionStatus, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.Device.ReconnectionStatus) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.Device.ReconnectionStatus) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    @overload
    def __init__(self, pipeline: Pipeline) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Device, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.Device, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.Device, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.Device, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.Device, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.Device, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.Device, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.Device, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.Device, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.Device, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, pipeline: Pipeline, usb2Mode: bool) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Device, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.Device, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.Device, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.Device, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.Device, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.Device, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.Device, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.Device, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.Device, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.Device, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, pipeline: Pipeline, maxUsbSpeed: UsbSpeed) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Device, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.Device, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.Device, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.Device, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.Device, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.Device, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.Device, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.Device, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.Device, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.Device, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, pipeline: Pipeline, pathToCmd: Path) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Device, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.Device, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.Device, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.Device, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.Device, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.Device, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.Device, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.Device, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.Device, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.Device, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, pipeline: Pipeline, devInfo: DeviceInfo, usb2Mode: bool = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Device, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.Device, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.Device, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.Device, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.Device, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.Device, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.Device, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.Device, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.Device, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.Device, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, pipeline: Pipeline, deviceInfo: DeviceInfo, maxUsbSpeed: UsbSpeed) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Device, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.Device, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.Device, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.Device, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.Device, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.Device, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.Device, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.Device, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.Device, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.Device, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, pipeline: Pipeline, devInfo: DeviceInfo, pathToCmd: Path) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Device, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.Device, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.Device, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.Device, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.Device, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.Device, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.Device, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.Device, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.Device, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.Device, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, version: OpenVINO.Version = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Device, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.Device, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.Device, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.Device, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.Device, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.Device, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.Device, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.Device, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.Device, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.Device, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, version: OpenVINO.Version, usb2Mode: bool = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Device, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.Device, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.Device, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.Device, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.Device, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.Device, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.Device, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.Device, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.Device, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.Device, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, version: OpenVINO.Version, maxUsbSpeed: UsbSpeed) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Device, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.Device, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.Device, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.Device, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.Device, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.Device, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.Device, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.Device, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.Device, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.Device, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, version: OpenVINO.Version, pathToCmd: Path) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Device, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.Device, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.Device, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.Device, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.Device, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.Device, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.Device, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.Device, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.Device, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.Device, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, version: OpenVINO.Version, deviceInfo: DeviceInfo, usb2Mode: bool = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Device, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.Device, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.Device, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.Device, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.Device, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.Device, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.Device, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.Device, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.Device, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.Device, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, version: OpenVINO.Version, deviceInfo: DeviceInfo, maxUsbSpeed: UsbSpeed) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Device, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.Device, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.Device, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.Device, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.Device, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.Device, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.Device, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.Device, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.Device, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.Device, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, version: OpenVINO.Version, deviceDesc: DeviceInfo, pathToCmd: Path) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Device, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.Device, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.Device, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.Device, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.Device, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.Device, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.Device, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.Device, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.Device, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.Device, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, config: Device.Config) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Device, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.Device, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.Device, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.Device, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.Device, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.Device, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.Device, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.Device, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.Device, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.Device, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, config: Device.Config, deviceInfo: DeviceInfo) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Device, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.Device, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.Device, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.Device, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.Device, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.Device, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.Device, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.Device, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.Device, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.Device, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, deviceInfo: DeviceInfo) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Device, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.Device, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.Device, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.Device, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.Device, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.Device, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.Device, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.Device, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.Device, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.Device, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, deviceInfo: DeviceInfo, maxUsbSpeed: UsbSpeed) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Device, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.Device, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.Device, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.Device, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.Device, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.Device, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.Device, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.Device, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.Device, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.Device, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, nameOrDeviceId: str) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Device, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.Device, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.Device, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.Device, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.Device, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.Device, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.Device, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.Device, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.Device, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.Device, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, nameOrDeviceId: str, maxUsbSpeed: UsbSpeed) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Device, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.Device, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.Device, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.Device, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.Device, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.Device, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.Device, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.Device, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.Device, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.Device, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.Device, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.Device, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.Device, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    def getPlatform(self) -> Platform:
        """getPlatform(self: depthai.Device) -> depthai.Platform

        Get the platform of the connected device

        Returns:
            Platform Platform enum
        """
    def getPlatformAsString(self) -> str:
        """getPlatformAsString(self: depthai.Device) -> str

        Get the platform of the connected device as string

        Returns:
            std::string String representation of Platform
        """

class DeviceBase:
    @overload
    def __init__(self, pipeline: Pipeline) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.DeviceBase, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.DeviceBase, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.DeviceBase, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.DeviceBase, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, pipeline: Pipeline, usb2Mode: bool) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.DeviceBase, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.DeviceBase, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.DeviceBase, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.DeviceBase, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, pipeline: Pipeline, maxUsbSpeed: UsbSpeed) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.DeviceBase, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.DeviceBase, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.DeviceBase, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.DeviceBase, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, pipeline: Pipeline, pathToCmd: Path) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.DeviceBase, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.DeviceBase, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.DeviceBase, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.DeviceBase, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, pipeline: Pipeline, devInfo: DeviceInfo, usb2Mode: bool = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.DeviceBase, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.DeviceBase, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.DeviceBase, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.DeviceBase, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, pipeline: Pipeline, deviceInfo: DeviceInfo, maxUsbSpeed: UsbSpeed) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.DeviceBase, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.DeviceBase, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.DeviceBase, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.DeviceBase, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, pipeline: Pipeline, devInfo: DeviceInfo, pathToCmd: Path) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.DeviceBase, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.DeviceBase, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.DeviceBase, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.DeviceBase, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, version: OpenVINO.Version = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.DeviceBase, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.DeviceBase, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.DeviceBase, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.DeviceBase, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, version: OpenVINO.Version, usb2Mode: bool = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.DeviceBase, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.DeviceBase, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.DeviceBase, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.DeviceBase, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, version: OpenVINO.Version, maxUsbSpeed: UsbSpeed) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.DeviceBase, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.DeviceBase, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.DeviceBase, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.DeviceBase, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, version: OpenVINO.Version, pathToCmd: Path) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.DeviceBase, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.DeviceBase, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.DeviceBase, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.DeviceBase, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, version: OpenVINO.Version, deviceInfo: DeviceInfo, usb2Mode: bool = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.DeviceBase, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.DeviceBase, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.DeviceBase, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.DeviceBase, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, version: OpenVINO.Version, deviceInfo: DeviceInfo, maxUsbSpeed: UsbSpeed) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.DeviceBase, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.DeviceBase, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.DeviceBase, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.DeviceBase, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, version: OpenVINO.Version, deviceDesc: DeviceInfo, pathToCmd: Path) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.DeviceBase, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.DeviceBase, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.DeviceBase, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.DeviceBase, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, config: Device.Config) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.DeviceBase, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.DeviceBase, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.DeviceBase, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.DeviceBase, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, config: Device.Config, deviceInfo: DeviceInfo) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.DeviceBase, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.DeviceBase, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.DeviceBase, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.DeviceBase, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, deviceInfo: DeviceInfo) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.DeviceBase, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.DeviceBase, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.DeviceBase, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.DeviceBase, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, deviceInfo: DeviceInfo, maxUsbSpeed: UsbSpeed) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.DeviceBase, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.DeviceBase, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.DeviceBase, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.DeviceBase, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, nameOrDeviceId: str) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.DeviceBase, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.DeviceBase, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.DeviceBase, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.DeviceBase, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    @overload
    def __init__(self, nameOrDeviceId: str, maxUsbSpeed: UsbSpeed) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        2. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, usb2Mode: bool) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        3. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        4. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``pathToCmd``:
            Path to custom device firmware

        5. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        6. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        7. __init__(self: depthai.DeviceBase, pipeline: depthai.Pipeline, devInfo: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``pipeline``:
            Pipeline to be executed on the device

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        8. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version = <Version.???: 7>) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with.

        9. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, usb2Mode: bool = False) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        10. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        11. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, pathToCmd: Path) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``pathToCmd``:
            Path to custom device firmware

        12. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, usb2Mode: bool = False) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``usb2Mode``:
            Boot device using USB2 mode firmware

        13. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        14. __init__(self: depthai.DeviceBase, version: depthai.OpenVINO.Version, deviceDesc: depthai.DeviceInfo, pathToCmd: Path) -> None

        Connects to device specified by devInfo.

        Parameter ``version``:
            OpenVINO version which the device will be booted with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``pathToCmd``:
            Path to custom device firmware

        15. __init__(self: depthai.DeviceBase, config: depthai.Device.Config) -> None

        Connects to any available device with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        16. __init__(self: depthai.DeviceBase, config: depthai.Device.Config, deviceInfo: depthai.DeviceInfo) -> None

        Connects to device 'devInfo' with custom config.

        Parameter ``config``:
            Device custom configuration to boot with

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        17. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        18. __init__(self: depthai.DeviceBase, deviceInfo: depthai.DeviceInfo, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``devInfo``:
            DeviceInfo which specifies which device to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed

        19. __init__(self: depthai.DeviceBase, nameOrDeviceId: str) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        20. __init__(self: depthai.DeviceBase, nameOrDeviceId: str, maxUsbSpeed: depthai.UsbSpeed) -> None

        Connects to any available device with a DEFAULT_SEARCH_TIME timeout. Uses
        OpenVINO version OpenVINO::VERSION_UNIVERSAL

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``maxUsbSpeed``:
            Maximum allowed USB speed
        """
    def addLogCallback(self, callback: Callable[[LogMessage], None]) -> int:
        """addLogCallback(self: depthai.DeviceBase, callback: Callable[[depthai.LogMessage], None]) -> int

        Add a callback for device logging. The callback will be called from a separate
        thread with the LogMessage being passed.

        Parameter ``callback``:
            Callback to call whenever a log message arrives

        Returns:
            Id which can be used to later remove the callback
        """
    def close(self) -> None:
        """close(self: depthai.DeviceBase) -> None

        Closes the connection to device. Better alternative is the usage of context manager: `with depthai.Device(pipeline) as device:`
        """
    def crashDevice(self) -> None:
        """crashDevice(self: depthai.DeviceBase) -> None

        Crashes the device $.. warning::

        ONLY FOR TESTING PURPOSES, it causes an unrecoverable crash on the device
        """
    def factoryResetCalibration(self) -> None:
        """factoryResetCalibration(self: depthai.DeviceBase) -> None

        Factory reset EEPROM data if factory backup is available.

        Throws:
            std::runtime_exception If factory reset was unsuccessful
        """
    def flashCalibration(self, calibrationDataHandler: CalibrationHandler) -> bool:
        """flashCalibration(self: depthai.DeviceBase, calibrationDataHandler: depthai.CalibrationHandler) -> bool

        Stores the Calibration and Device information to the Device EEPROM

        Parameter ``calibrationObj``:
            CalibrationHandler object which is loaded with calibration information.

        Returns:
            true on successful flash, false on failure
        """
    def flashCalibration2(self, arg0: CalibrationHandler) -> None:
        """flashCalibration2(self: depthai.DeviceBase, arg0: depthai.CalibrationHandler) -> None

        Stores the Calibration and Device information to the Device EEPROM

        Throws:
            std::runtime_exception if failed to flash the calibration

        Parameter ``calibrationObj``:
            CalibrationHandler object which is loaded with calibration information.
        """
    def flashEepromClear(self) -> None:
        """flashEepromClear(self: depthai.DeviceBase) -> None

        Destructive action, deletes User area EEPROM contents Requires PROTECTED
        permissions

        Throws:
            std::runtime_exception if failed to flash the calibration

        Returns:
            True on successful flash, false on failure
        """
    def flashFactoryCalibration(self, arg0: CalibrationHandler) -> None:
        """flashFactoryCalibration(self: depthai.DeviceBase, arg0: depthai.CalibrationHandler) -> None

        Stores the Calibration and Device information to the Device EEPROM in Factory
        area To perform this action, correct env variable must be set

        Throws:
            std::runtime_exception if failed to flash the calibration

        Returns:
            True on successful flash, false on failure
        """
    def flashFactoryEepromClear(self) -> None:
        """flashFactoryEepromClear(self: depthai.DeviceBase) -> None

        Destructive action, deletes Factory area EEPROM contents Requires FACTORY
        PROTECTED permissions

        Throws:
            std::runtime_exception if failed to flash the calibration

        Returns:
            True on successful flash, false on failure
        """
    @staticmethod
    def getAllAvailableDevices() -> list[DeviceInfo]:
        """getAllAvailableDevices() -> list[depthai.DeviceInfo]

        Returns all available devices

        Returns:
            Vector of available devices
        """
    @staticmethod
    def getAllConnectedDevices() -> list[DeviceInfo]:
        """getAllConnectedDevices() -> list[depthai.DeviceInfo]

        Returns information of all connected devices. The devices could be both
        connectable as well as already connected to devices.

        Returns:
            Vector of connected device information
        """
    @overload
    @staticmethod
    def getAnyAvailableDevice(timeout: datetime.timedelta) -> tuple[bool, DeviceInfo]:
        """getAnyAvailableDevice(*args, **kwargs)
        Overloaded function.

        1. getAnyAvailableDevice(timeout: datetime.timedelta) -> tuple[bool, depthai.DeviceInfo]

        Waits for any available device with a timeout

        Parameter ``timeout``:
            duration of time to wait for the any device

        Returns:
            Tuple of bool and DeviceInfo. Bool specifies if device was found. DeviceInfo
            specifies the found device

        2. getAnyAvailableDevice() -> tuple[bool, depthai.DeviceInfo]

        Gets any available device

        Returns:
            Tuple of bool and DeviceInfo. Bool specifies if device was found. DeviceInfo
            specifies the found device
        """
    @overload
    @staticmethod
    def getAnyAvailableDevice() -> tuple[bool, DeviceInfo]:
        """getAnyAvailableDevice(*args, **kwargs)
        Overloaded function.

        1. getAnyAvailableDevice(timeout: datetime.timedelta) -> tuple[bool, depthai.DeviceInfo]

        Waits for any available device with a timeout

        Parameter ``timeout``:
            duration of time to wait for the any device

        Returns:
            Tuple of bool and DeviceInfo. Bool specifies if device was found. DeviceInfo
            specifies the found device

        2. getAnyAvailableDevice() -> tuple[bool, depthai.DeviceInfo]

        Gets any available device

        Returns:
            Tuple of bool and DeviceInfo. Bool specifies if device was found. DeviceInfo
            specifies the found device
        """
    def getAvailableStereoPairs(self) -> list[StereoPair]:
        """getAvailableStereoPairs(self: depthai.DeviceBase) -> list[depthai.StereoPair]

        Get stereo pairs taking into account the calibration and connected cameras.

        @note This method will always return a subset of `getStereoPairs`.

        Returns:
            Vector of stereo pairs
        """
    def getBootloaderVersion(self) -> Version | None:
        """getBootloaderVersion(self: depthai.DeviceBase) -> Optional[depthai.Version]

        Gets Bootloader version if it was booted through Bootloader

        Returns:
            DeviceBootloader::Version if booted through Bootloader or none otherwise
        """
    def getCameraSensorNames(self) -> dict[CameraBoardSocket, str]:
        """getCameraSensorNames(self: depthai.DeviceBase) -> dict[depthai.CameraBoardSocket, str]

        Get sensor names for cameras that are connected to the device

        Returns:
            Map/dictionary with camera sensor names, indexed by socket
        """
    def getChipTemperature(self) -> ChipTemperature:
        """getChipTemperature(self: depthai.DeviceBase) -> depthai.ChipTemperature

        Retrieves current chip temperature as measured by device

        Returns:
            Temperature of various onboard sensors
        """
    def getCmxMemoryUsage(self) -> MemoryInfo:
        """getCmxMemoryUsage(self: depthai.DeviceBase) -> depthai.MemoryInfo

        Retrieves current CMX memory information from device

        Returns:
            Used, remaining and total cmx memory
        """
    def getConnectedCameraFeatures(self) -> list[CameraFeatures]:
        """getConnectedCameraFeatures(self: depthai.DeviceBase) -> list[depthai.CameraFeatures]

        Get cameras that are connected to the device with their features/properties

        Returns:
            Vector of connected camera features
        """
    def getConnectedCameras(self) -> list[CameraBoardSocket]:
        """getConnectedCameras(self: depthai.DeviceBase) -> list[depthai.CameraBoardSocket]

        Get cameras that are connected to the device

        Returns:
            Vector of connected cameras
        """
    def getConnectedIMU(self) -> str:
        """getConnectedIMU(self: depthai.DeviceBase) -> str

        Get connected IMU type

        Returns:
            IMU type
        """
    def getConnectionInterfaces(self) -> list[connectionInterface]:
        """getConnectionInterfaces(self: depthai.DeviceBase) -> list[depthai.connectionInterface]

        Get connection interfaces for device

        Returns:
            Vector of connection type
        """
    def getCrashDump(self, clearCrashDump: bool = ...) -> CrashDump:
        """getCrashDump(self: depthai.DeviceBase, clearCrashDump: bool = True) -> depthai.CrashDump

        Retrieves crash dump for debugging.
        """
    def getDdrMemoryUsage(self) -> MemoryInfo:
        """getDdrMemoryUsage(self: depthai.DeviceBase) -> depthai.MemoryInfo

        Retrieves current DDR memory information from device

        Returns:
            Used, remaining and total ddr memory
        """
    @staticmethod
    def getDeviceById(deviceId: str) -> tuple[bool, DeviceInfo]:
        """getDeviceById(deviceId: str) -> tuple[bool, depthai.DeviceInfo]

        Finds a device by Device ID. Example: 14442C10D13EABCE00

        Parameter ``deviceId``:
            Device ID which uniquely specifies a device

        Returns:
            Tuple of bool and DeviceInfo. Bool specifies if device was found. DeviceInfo
            specifies the found device
        """
    def getDeviceId(self) -> str:
        """getDeviceId(self: depthai.DeviceBase) -> str

        Get DeviceId of device

        Returns:
            DeviceId of connected device
        """
    def getDeviceInfo(self) -> DeviceInfo:
        """getDeviceInfo(self: depthai.DeviceBase) -> depthai.DeviceInfo

        Get the Device Info object o the device which is currently running

        Returns:
            DeviceInfo of the current device in execution
        """
    def getDeviceName(self) -> object:
        """getDeviceName(self: depthai.DeviceBase) -> object

        Get device name if available

        Returns:
            device name or empty string if not available
        """
    @overload
    @staticmethod
    def getEmbeddedDeviceBinary(usb2Mode: bool, version: OpenVINO.Version = ...) -> list[int]:
        """getEmbeddedDeviceBinary(*args, **kwargs)
        Overloaded function.

        1. getEmbeddedDeviceBinary(usb2Mode: bool, version: depthai.OpenVINO.Version = <Version.???: 7>) -> list[int]

        Gets device firmware binary for a specific OpenVINO version

        Parameter ``usb2Mode``:
            USB2 mode firmware

        Parameter ``version``:
            Version of OpenVINO which firmware will support

        Returns:
            Firmware binary

        2. getEmbeddedDeviceBinary(config: depthai.Device.Config) -> list[int]

        Gets device firmware binary for a specific configuration

        Parameter ``config``:
            FW with applied configuration

        Returns:
            Firmware binary
        """
    @overload
    @staticmethod
    def getEmbeddedDeviceBinary(config: Device.Config) -> list[int]:
        """getEmbeddedDeviceBinary(*args, **kwargs)
        Overloaded function.

        1. getEmbeddedDeviceBinary(usb2Mode: bool, version: depthai.OpenVINO.Version = <Version.???: 7>) -> list[int]

        Gets device firmware binary for a specific OpenVINO version

        Parameter ``usb2Mode``:
            USB2 mode firmware

        Parameter ``version``:
            Version of OpenVINO which firmware will support

        Returns:
            Firmware binary

        2. getEmbeddedDeviceBinary(config: depthai.Device.Config) -> list[int]

        Gets device firmware binary for a specific configuration

        Parameter ``config``:
            FW with applied configuration

        Returns:
            Firmware binary
        """
    def getEmbeddedIMUFirmwareVersion(self) -> Version:
        """getEmbeddedIMUFirmwareVersion(self: depthai.DeviceBase) -> depthai.Version

        Get embedded IMU firmware version to which IMU can be upgraded

        Returns:
            Get embedded IMU firmware version to which IMU can be upgraded.
        """
    @staticmethod
    def getFirstAvailableDevice(skipInvalidDevices: bool = ...) -> tuple[bool, DeviceInfo]:
        """getFirstAvailableDevice(skipInvalidDevices: bool = True) -> tuple[bool, depthai.DeviceInfo]

        Gets first available device. Device can be either in XLINK_UNBOOTED or
        XLINK_BOOTLOADER state

        Returns:
            Tuple of bool and DeviceInfo. Bool specifies if device was found. DeviceInfo
            specifies the found device
        """
    @staticmethod
    def getGlobalProfilingData() -> ProfilingData:
        """getGlobalProfilingData() -> depthai.ProfilingData

        Get current global accumulated profiling data

        Returns:
            ProfilingData from all devices
        """
    def getIMUFirmwareUpdateStatus(self) -> tuple[bool, float]:
        """getIMUFirmwareUpdateStatus(self: depthai.DeviceBase) -> tuple[bool, float]

        Get IMU firmware update status

        Returns:
            Whether IMU firmware update is done and last firmware update progress as
            percentage. return value true and 100 means that the update was successful
            return value true and other than 100 means that the update failed
        """
    def getIMUFirmwareVersion(self) -> Version:
        """getIMUFirmwareVersion(self: depthai.DeviceBase) -> depthai.Version

        Get connected IMU firmware version

        Returns:
            IMU firmware version
        """
    def getIrDrivers(self) -> list[tuple[str, int, int]]:
        '''getIrDrivers(self: depthai.DeviceBase) -> list[tuple[str, int, int]]

        Retrieves detected IR laser/LED drivers.

        Returns:
            Vector of tuples containing: driver name, I2C bus, I2C address. For OAK-D-
            Pro it should be `[{"LM3644", 2, 0x63}]`
        '''
    def getLeonCssCpuUsage(self) -> CpuUsage:
        """getLeonCssCpuUsage(self: depthai.DeviceBase) -> depthai.CpuUsage

        Retrieves average CSS Leon CPU usage

        Returns:
            Average CPU usage and sampling duration
        """
    def getLeonCssHeapUsage(self) -> MemoryInfo:
        """getLeonCssHeapUsage(self: depthai.DeviceBase) -> depthai.MemoryInfo

        Retrieves current CSS Leon CPU heap information from device

        Returns:
            Used, remaining and total heap memory
        """
    def getLeonMssCpuUsage(self) -> CpuUsage:
        """getLeonMssCpuUsage(self: depthai.DeviceBase) -> depthai.CpuUsage

        Retrieves average MSS Leon CPU usage

        Returns:
            Average CPU usage and sampling duration
        """
    def getLeonMssHeapUsage(self) -> MemoryInfo:
        """getLeonMssHeapUsage(self: depthai.DeviceBase) -> depthai.MemoryInfo

        Retrieves current MSS Leon CPU heap information from device

        Returns:
            Used, remaining and total heap memory
        """
    def getLogLevel(self) -> LogLevel:
        """getLogLevel(self: depthai.DeviceBase) -> depthai.LogLevel

        Gets current logging severity level of the device.

        Returns:
            Logging severity level
        """
    def getLogOutputLevel(self) -> LogLevel:
        """getLogOutputLevel(self: depthai.DeviceBase) -> depthai.LogLevel

        Gets logging level which decides printing level to standard output.

        Returns:
            Standard output printing severity
        """
    def getMxId(self) -> str:
        """getMxId(self: depthai.DeviceBase) -> str

        Get MxId of device

        Returns:
            MxId of connected device
        """
    def getProductName(self) -> object:
        """getProductName(self: depthai.DeviceBase) -> object

        Get product name if available

        Returns:
            product name or empty string if not available
        """
    def getProfilingData(self) -> ProfilingData:
        """getProfilingData(self: depthai.DeviceBase) -> depthai.ProfilingData

        Get current accumulated profiling data

        Returns:
            ProfilingData from the specific device
        """
    def getStereoPairs(self) -> list[StereoPair]:
        """getStereoPairs(self: depthai.DeviceBase) -> list[depthai.StereoPair]

        Get stereo pairs based on the device type.

        Returns:
            Vector of stereo pairs
        """
    def getSystemInformationLoggingRate(self) -> float:
        '''getSystemInformationLoggingRate(self: depthai.DeviceBase) -> float

        Gets current rate of system information logging ("info" severity) in Hz.

        Returns:
            Logging rate in Hz
        '''
    def getUsbSpeed(self) -> UsbSpeed:
        """getUsbSpeed(self: depthai.DeviceBase) -> depthai.UsbSpeed

        Retrieves USB connection speed

        Returns:
            USB connection speed of connected device if applicable. Unknown otherwise.
        """
    def getXLinkChunkSize(self) -> int:
        """getXLinkChunkSize(self: depthai.DeviceBase) -> int

        Gets current XLink chunk size.

        Returns:
            XLink chunk size in bytes
        """
    def hasCrashDump(self) -> bool:
        """hasCrashDump(self: depthai.DeviceBase) -> bool

        Retrieves whether the is crash dump stored on device or not.
        """
    def isClosed(self) -> bool:
        """isClosed(self: depthai.DeviceBase) -> bool

        Is the device already closed (or disconnected)

        .. warning::
            This function is thread-unsafe and may return outdated incorrect values. It
            is only meant for use in simple single-threaded code. Well written code
            should handle exceptions when calling any DepthAI apis to handle hardware
            events and multithreaded use.
        """
    def isEepromAvailable(self) -> bool:
        """isEepromAvailable(self: depthai.DeviceBase) -> bool

        Check if EEPROM is available

        Returns:
            True if EEPROM is present on board, false otherwise
        """
    def isPipelineRunning(self) -> bool:
        """isPipelineRunning(self: depthai.DeviceBase) -> bool

        Checks if devices pipeline is already running

        Returns:
            True if running, false otherwise
        """
    def readCalibration(self) -> CalibrationHandler:
        """readCalibration(self: depthai.DeviceBase) -> depthai.CalibrationHandler

        Fetches the EEPROM data from the device and loads it into CalibrationHandler
        object If no calibration is flashed, it returns default

        Returns:
            The CalibrationHandler object containing the calibration currently flashed
            on device EEPROM
        """
    def readCalibration2(self) -> CalibrationHandler:
        """readCalibration2(self: depthai.DeviceBase) -> depthai.CalibrationHandler

        Fetches the EEPROM data from the device and loads it into CalibrationHandler
        object

        Throws:
            std::runtime_exception if no calibration is flashed

        Returns:
            The CalibrationHandler object containing the calibration currently flashed
            on device EEPROM
        """
    def readCalibrationOrDefault(self) -> CalibrationHandler:
        """readCalibrationOrDefault(self: depthai.DeviceBase) -> depthai.CalibrationHandler

        Fetches the EEPROM data from the device and loads it into CalibrationHandler
        object If no calibration is flashed, it returns default

        Returns:
            The CalibrationHandler object containing the calibration currently flashed
            on device EEPROM
        """
    def readCalibrationRaw(self) -> list[int]:
        """readCalibrationRaw(self: depthai.DeviceBase) -> list[int]

        Fetches the raw EEPROM data from User area

        Throws:
            std::runtime_exception if any error occurred

        Returns:
            Binary dump of User area EEPROM data
        """
    def readFactoryCalibration(self) -> CalibrationHandler:
        """readFactoryCalibration(self: depthai.DeviceBase) -> depthai.CalibrationHandler

        Fetches the EEPROM data from Factory area and loads it into CalibrationHandler
        object

        Throws:
            std::runtime_exception if no calibration is flashed

        Returns:
            The CalibrationHandler object containing the calibration currently flashed
            on device EEPROM in Factory Area
        """
    def readFactoryCalibrationOrDefault(self) -> CalibrationHandler:
        """readFactoryCalibrationOrDefault(self: depthai.DeviceBase) -> depthai.CalibrationHandler

        Fetches the EEPROM data from Factory area and loads it into CalibrationHandler
        object If no calibration is flashed, it returns default

        Returns:
            The CalibrationHandler object containing the calibration currently flashed
            on device EEPROM in Factory Area
        """
    def readFactoryCalibrationRaw(self) -> list[int]:
        """readFactoryCalibrationRaw(self: depthai.DeviceBase) -> list[int]

        Fetches the raw EEPROM data from Factory area

        Throws:
            std::runtime_exception if any error occurred

        Returns:
            Binary dump of Factory area EEPROM data
        """
    def removeLogCallback(self, callbackId: int) -> bool:
        """removeLogCallback(self: depthai.DeviceBase, callbackId: int) -> bool

        Removes a callback

        Parameter ``callbackId``:
            Id of callback to be removed

        Returns:
            True if callback was removed, false otherwise
        """
    def setIrFloodLightBrightness(self, mA: float, mask: int = ...) -> bool:
        """setIrFloodLightBrightness(self: depthai.DeviceBase, mA: float, mask: int = -1) -> bool

        Sets the brightness of the IR Flood Light. Limits: up to 1500mA at 30% duty
        cycle. The duty cycle is controlled by the `left` camera STROBE, aligned to
        start of exposure. If the dot projector is also enabled, its lower duty cycle
        limits take precedence. The emitter is turned off by default

        Parameter ``mA``:
            Current in mA that will determine brightness, 0 or negative to turn off

        Parameter ``mask``:
            Optional mask to modify only Left (0x1) or Right (0x2) sides on OAK-D-Pro-W-
            DEV

        Returns:
            True on success, false if not found or other failure
        """
    def setIrFloodLightIntensity(self, intensity: float, mask: int = ...) -> bool:
        """setIrFloodLightIntensity(self: depthai.DeviceBase, intensity: float, mask: int = -1) -> bool

        Sets the intensity of the IR Flood Light. Limits: Intensity is directly
        normalized to 0 - 1500mA current. The duty cycle is 30% when exposure time is
        longer than 30% frame time. Otherwise, duty cycle is 100% of exposure time. The
        duty cycle is controlled by the `left` camera STROBE, aligned to start of
        exposure. The emitter is turned off by default

        Parameter ``intensity``:
            Intensity on range 0 to 1, that will determine brightness, 0 or negative to
            turn off

        Parameter ``mask``:
            Optional mask to modify only Left (0x1) or Right (0x2) sides on OAK-D-Pro-W-
            DEV

        Returns:
            True on success, false if not found or other failure
        """
    def setIrLaserDotProjectorBrightness(self, mA: float, mask: int = ...) -> bool:
        """setIrLaserDotProjectorBrightness(self: depthai.DeviceBase, mA: float, mask: int = -1) -> bool

        Sets the brightness of the IR Laser Dot Projector. Limits: up to 765mA at 30%
        duty cycle, up to 1200mA at 6% duty cycle. The duty cycle is controlled by
        `left` camera STROBE, aligned to start of exposure. The emitter is turned off by
        default

        Parameter ``mA``:
            Current in mA that will determine brightness, 0 or negative to turn off

        Parameter ``mask``:
            Optional mask to modify only Left (0x1) or Right (0x2) sides on OAK-D-Pro-W-
            DEV

        Returns:
            True on success, false if not found or other failure
        """
    def setIrLaserDotProjectorIntensity(self, intensity: float, mask: int = ...) -> bool:
        """setIrLaserDotProjectorIntensity(self: depthai.DeviceBase, intensity: float, mask: int = -1) -> bool

        Sets the intensity of the IR Laser Dot Projector. Limits: up to 765mA at 30%
        frame time duty cycle when exposure time is longer than 30% frame time.
        Otherwise, duty cycle is 100% of exposure time, with current increased up to max
        1200mA to make up for shorter duty cycle. The duty cycle is controlled by `left`
        camera STROBE, aligned to start of exposure. The emitter is turned off by
        default

        Parameter ``intensity``:
            Intensity on range 0 to 1, that will determine brightness. 0 or negative to
            turn off

        Parameter ``mask``:
            Optional mask to modify only Left (0x1) or Right (0x2) sides on OAK-D-Pro-W-
            DEV

        Returns:
            True on success, false if not found or other failure
        """
    def setLogLevel(self, level: LogLevel) -> None:
        """setLogLevel(self: depthai.DeviceBase, level: depthai.LogLevel) -> None

        Sets the devices logging severity level. This level affects which logs are
        transferred from device to host.

        Parameter ``level``:
            Logging severity
        """
    def setLogOutputLevel(self, level: LogLevel) -> None:
        """setLogOutputLevel(self: depthai.DeviceBase, level: depthai.LogLevel) -> None

        Sets logging level which decides printing level to standard output. If lower
        than setLogLevel, no messages will be printed

        Parameter ``level``:
            Standard output printing severity
        """
    def setMaxReconnectionAttempts(self, maxAttempts: int, callback: Callable[[Device.ReconnectionStatus], None] = ...) -> None:
        """setMaxReconnectionAttempts(self: depthai.DeviceBase, maxAttempts: int, callback: Callable[[depthai.Device.ReconnectionStatus], None] = None) -> None

        Sets max number of automatic reconnection attempts

        Parameter ``maxAttempts``:
            Maximum number of reconnection attempts, 0 to disable reconnection

        Parameter ``callBack``:
            Callback to be called when reconnection is attempted
        """
    def setSystemInformationLoggingRate(self, rateHz: float) -> None:
        '''setSystemInformationLoggingRate(self: depthai.DeviceBase, rateHz: float) -> None

        Sets rate of system information logging ("info" severity). Default 1Hz If
        parameter is less or equal to zero, then system information logging will be
        disabled

        Parameter ``rateHz``:
            Logging rate in Hz
        '''
    @overload
    def setTimesync(self, arg0: datetime.timedelta, arg1: int, arg2: bool) -> None:
        """setTimesync(*args, **kwargs)
        Overloaded function.

        1. setTimesync(self: depthai.DeviceBase, arg0: datetime.timedelta, arg1: int, arg2: bool) -> None

        Configures Timesync service on device. It keeps host and device clocks in sync
        First time timesync is started it waits until the initial sync is completed
        Afterwards the function changes the following parameters

        Parameter ``period``:
            Interval between timesync runs

        Parameter ``numSamples``:
            Number of timesync samples per run which are used to compute a better value.
            Set to zero to disable timesync

        Parameter ``random``:
            If true partial timesync requests will be performed at random intervals,
            otherwise at fixed intervals

        2. setTimesync(self: depthai.DeviceBase, enable: bool) -> None

        Enables or disables Timesync service on device. It keeps host and device clocks
        in sync.

        Parameter ``enable``:
            Enables or disables consistent timesyncing
        """
    @overload
    def setTimesync(self, enable: bool) -> None:
        """setTimesync(*args, **kwargs)
        Overloaded function.

        1. setTimesync(self: depthai.DeviceBase, arg0: datetime.timedelta, arg1: int, arg2: bool) -> None

        Configures Timesync service on device. It keeps host and device clocks in sync
        First time timesync is started it waits until the initial sync is completed
        Afterwards the function changes the following parameters

        Parameter ``period``:
            Interval between timesync runs

        Parameter ``numSamples``:
            Number of timesync samples per run which are used to compute a better value.
            Set to zero to disable timesync

        Parameter ``random``:
            If true partial timesync requests will be performed at random intervals,
            otherwise at fixed intervals

        2. setTimesync(self: depthai.DeviceBase, enable: bool) -> None

        Enables or disables Timesync service on device. It keeps host and device clocks
        in sync.

        Parameter ``enable``:
            Enables or disables consistent timesyncing
        """
    def setXLinkChunkSize(self, sizeBytes: int) -> None:
        """setXLinkChunkSize(self: depthai.DeviceBase, sizeBytes: int) -> None

        Sets the chunk size for splitting device-sent XLink packets. A larger value
        could increase performance, and 0 disables chunking. A negative value is
        ignored. Device defaults are configured per protocol, currently 64*1024 for both
        USB and Ethernet.

        Parameter ``sizeBytes``:
            XLink chunk size in bytes
        """
    def startIMUFirmwareUpdate(self, forceUpdate: bool = ...) -> bool:
        """startIMUFirmwareUpdate(self: depthai.DeviceBase, forceUpdate: bool = False) -> bool

        Starts IMU firmware update asynchronously only if IMU node is not running. If
        current firmware version is the same as embedded firmware version then it's no-
        op. Can be overridden by forceUpdate parameter. State of firmware update can be
        monitored using getIMUFirmwareUpdateStatus API.

        Parameter ``forceUpdate``:
            Force firmware update or not. Will perform FW update regardless of current
            version and embedded firmware version.

        Returns:
            Returns whether firmware update can be started. Returns false if IMU node is
            started.
        """
    @overload
    def startPipeline(self) -> None:
        """startPipeline(*args, **kwargs)
        Overloaded function.

        1. startPipeline(self: depthai.DeviceBase) -> None

        Starts the execution of the devices pipeline

        Returns:
            True if pipeline started, false otherwise

        2. startPipeline(self: depthai.DeviceBase, arg0: depthai.Pipeline) -> bool

        Starts the execution of a given pipeline

        Parameter ``pipeline``:
            OpenVINO version of the pipeline must match the one which the device was
            booted with.

        Returns:
            True if pipeline started, false otherwise
        """
    @overload
    def startPipeline(self, arg0: Pipeline) -> bool:
        """startPipeline(*args, **kwargs)
        Overloaded function.

        1. startPipeline(self: depthai.DeviceBase) -> None

        Starts the execution of the devices pipeline

        Returns:
            True if pipeline started, false otherwise

        2. startPipeline(self: depthai.DeviceBase, arg0: depthai.Pipeline) -> bool

        Starts the execution of a given pipeline

        Parameter ``pipeline``:
            OpenVINO version of the pipeline must match the one which the device was
            booted with.

        Returns:
            True if pipeline started, false otherwise
        """
    def __enter__(self) -> DeviceBase:
        """__enter__(self: depthai.DeviceBase) -> depthai.DeviceBase"""
    def __exit__(self, arg0: object, arg1: object, arg2: object) -> None:
        """__exit__(self: depthai.DeviceBase, arg0: object, arg1: object, arg2: object) -> None"""

class DeviceBootloader:
    class ApplicationInfo:
        applicationName: str
        firmwareVersion: str
        hasApplication: bool
        def __init__(self) -> None:
            """__init__(self: depthai.DeviceBootloader.ApplicationInfo) -> None"""

    class Config:
        appMem: DeviceBootloader.Memory
        network: DeviceBootloader.NetworkConfig
        usb: DeviceBootloader.UsbConfig
        def __init__(self) -> None:
            """__init__(self: depthai.DeviceBootloader.Config) -> None"""
        def fromJson(self) -> DeviceBootloader.Config:
            """fromJson(self: json) -> depthai.DeviceBootloader.Config"""
        def getDnsAltIPv4(self) -> str:
            """getDnsAltIPv4(self: depthai.DeviceBootloader.Config) -> str"""
        def getDnsIPv4(self) -> str:
            """getDnsIPv4(self: depthai.DeviceBootloader.Config) -> str"""
        def getIPv4(self) -> str:
            """getIPv4(self: depthai.DeviceBootloader.Config) -> str"""
        def getIPv4Gateway(self) -> str:
            """getIPv4Gateway(self: depthai.DeviceBootloader.Config) -> str"""
        def getIPv4Mask(self) -> str:
            """getIPv4Mask(self: depthai.DeviceBootloader.Config) -> str"""
        def getMacAddress(self) -> str:
            """getMacAddress(self: depthai.DeviceBootloader.Config) -> str"""
        def getNetworkTimeout(self) -> datetime.timedelta:
            """getNetworkTimeout(self: depthai.DeviceBootloader.Config) -> datetime.timedelta"""
        def getUsbMaxSpeed(self) -> UsbSpeed:
            """getUsbMaxSpeed(self: depthai.DeviceBootloader.Config) -> depthai.UsbSpeed"""
        def getUsbTimeout(self) -> datetime.timedelta:
            """getUsbTimeout(self: depthai.DeviceBootloader.Config) -> datetime.timedelta"""
        def isStaticIPV4(self) -> bool:
            """isStaticIPV4(self: depthai.DeviceBootloader.Config) -> bool"""
        def setDnsIPv4(self, arg0: str, arg1: str) -> None:
            """setDnsIPv4(self: depthai.DeviceBootloader.Config, arg0: str, arg1: str) -> None"""
        def setDynamicIPv4(self, arg0: str, arg1: str, arg2: str) -> None:
            """setDynamicIPv4(self: depthai.DeviceBootloader.Config, arg0: str, arg1: str, arg2: str) -> None"""
        def setMacAddress(self, arg0: str) -> None:
            """setMacAddress(self: depthai.DeviceBootloader.Config, arg0: str) -> None"""
        def setNetworkTimeout(self, arg0: datetime.timedelta) -> None:
            """setNetworkTimeout(self: depthai.DeviceBootloader.Config, arg0: datetime.timedelta) -> None"""
        def setStaticIPv4(self, arg0: str, arg1: str, arg2: str) -> None:
            """setStaticIPv4(self: depthai.DeviceBootloader.Config, arg0: str, arg1: str, arg2: str) -> None"""
        def setUsbMaxSpeed(self, arg0: UsbSpeed) -> None:
            """setUsbMaxSpeed(self: depthai.DeviceBootloader.Config, arg0: depthai.UsbSpeed) -> None"""
        def setUsbTimeout(self, arg0: datetime.timedelta) -> None:
            """setUsbTimeout(self: depthai.DeviceBootloader.Config, arg0: datetime.timedelta) -> None"""
        def toJson(self) -> json:
            """toJson(self: depthai.DeviceBootloader.Config) -> json"""

    class Memory:
        __members__: ClassVar[dict] = ...  # read-only
        AUTO: ClassVar[DeviceBootloader.Memory] = ...
        EMMC: ClassVar[DeviceBootloader.Memory] = ...
        FLASH: ClassVar[DeviceBootloader.Memory] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.DeviceBootloader.Memory, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.DeviceBootloader.Memory) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.DeviceBootloader.Memory) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class MemoryInfo:
        available: bool
        info: str
        size: int
        def __init__(self) -> None:
            """__init__(self: depthai.DeviceBootloader.MemoryInfo) -> None"""

    class NetworkConfig:
        ipv4: int
        ipv4Dns: int
        ipv4DnsAlt: int
        ipv4Gateway: int
        ipv4Mask: int
        ipv6: Incomplete
        ipv6Dns: Incomplete
        ipv6DnsAlt: Incomplete
        ipv6Gateway: Incomplete
        ipv6Prefix: int
        mac: Incomplete
        staticIpv4: bool
        staticIpv6: bool
        timeoutMs: int
        def __init__(self) -> None:
            """__init__(self: depthai.DeviceBootloader.NetworkConfig) -> None"""

    class Section:
        __members__: ClassVar[dict] = ...  # read-only
        APPLICATION: ClassVar[DeviceBootloader.Section] = ...
        AUTO: ClassVar[DeviceBootloader.Section] = ...
        BOOTLOADER: ClassVar[DeviceBootloader.Section] = ...
        BOOTLOADER_CONFIG: ClassVar[DeviceBootloader.Section] = ...
        HEADER: ClassVar[DeviceBootloader.Section] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.DeviceBootloader.Section, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.DeviceBootloader.Section) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.DeviceBootloader.Section) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class Type:
        __members__: ClassVar[dict] = ...  # read-only
        AUTO: ClassVar[DeviceBootloader.Type] = ...
        NETWORK: ClassVar[DeviceBootloader.Type] = ...
        USB: ClassVar[DeviceBootloader.Type] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.DeviceBootloader.Type, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.DeviceBootloader.Type) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.DeviceBootloader.Type) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class UsbConfig:
        maxUsbSpeed: int
        pid: int
        timeoutMs: int
        vid: int
        def __init__(self) -> None:
            """__init__(self: depthai.DeviceBootloader.UsbConfig) -> None"""
    def __init__(self, devInfo: DeviceInfo, allowFlashingBootloader: bool = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceBootloader, devInfo: depthai.DeviceInfo, allowFlashingBootloader: bool = False) -> None

        Connects to device in bootloader of specified type. Throws if it wasn't
        possible. This constructor will automatically boot into specified bootloader
        type if not already running

        Parameter ``devInfo``:
            DeviceInfo of which to boot or connect to

        Parameter ``type``:
            Type of bootloader to boot/connect to.

        Parameter ``allowFlashingBootloader``:
            Set to true to allow flashing the devices bootloader. Defaults to false

        2. __init__(self: depthai.DeviceBootloader, devInfo: depthai.DeviceInfo, pathToCmd: Path, allowFlashingBootloader: bool = False) -> None

        Connects to or boots device in bootloader mode depending on devInfo state with a
        custom bootloader firmware.

        Parameter ``devInfo``:
            DeviceInfo of which to boot or connect to

        Parameter ``pathToBootloader``:
            Custom bootloader firmware to boot

        Parameter ``allowFlashingBootloader``:
            Set to true to allow flashing the devices bootloader. Defaults to false

        3. __init__(self: depthai.DeviceBootloader, nameOrDeviceId: str, allowFlashingBootloader: bool = False) -> None

        Connects to device with specified name/device id

        Parameter ``nameOrDeviceId``:
            Creates DeviceInfo with nameOrDeviceId to connect to

        Parameter ``allowFlashingBootloader``:
            Set to true to allow flashing the devices bootloader. Defaults to false
        """
    def bootMemory(self, fw: list[int]) -> None:
        """bootMemory(self: depthai.DeviceBootloader, fw: list[int]) -> None

        Boots a custom FW in memory

        Parameter ``fw``:
            $Throws:

        A runtime exception if there are any communication issues
        """
    def bootUsbRomBootloader(self) -> None:
        """bootUsbRomBootloader(self: depthai.DeviceBootloader) -> None

        Boots into integrated ROM bootloader in USB mode

        Throws:
            A runtime exception if there are any communication issues
        """
    def close(self) -> None:
        """close(self: depthai.DeviceBootloader) -> None

        Closes the connection to device. Better alternative is the usage of context manager: `with depthai.DeviceBootloader(deviceInfo) as bootloader:`
        """
    @overload
    @staticmethod
    def createDepthaiApplicationPackage(pipeline: Pipeline, pathToCmd: Path = ..., compress: bool = ..., applicationName: str = ..., checkChecksum: bool = ...) -> list[int]:
        """createDepthaiApplicationPackage(*args, **kwargs)
        Overloaded function.

        1. createDepthaiApplicationPackage(pipeline: depthai.Pipeline, pathToCmd: Path = '', compress: bool = False, applicationName: str = '', checkChecksum: bool = False) -> list[int]

        Creates application package which can be flashed to depthai device.

        Parameter ``pipeline``:
            Pipeline from which to create the application package

        Parameter ``pathToCmd``:
            Optional path to custom device firmware

        Parameter ``compress``:
            Optional boolean which specifies if contents should be compressed

        Parameter ``applicationName``:
            Optional name the application that is flashed

        Returns:
            Depthai application package

        2. createDepthaiApplicationPackage(pipeline: depthai.Pipeline, compress: bool, applicationName: str = '', checkChecksum: bool = False) -> list[int]

        Creates application package which can be flashed to depthai device.

        Parameter ``pipeline``:
            Pipeline from which to create the application package

        Parameter ``compress``:
            Specifies if contents should be compressed

        Parameter ``applicationName``:
            Name the application that is flashed

        Returns:
            Depthai application package
        """
    @overload
    @staticmethod
    def createDepthaiApplicationPackage(pipeline: Pipeline, compress: bool, applicationName: str = ..., checkChecksum: bool = ...) -> list[int]:
        """createDepthaiApplicationPackage(*args, **kwargs)
        Overloaded function.

        1. createDepthaiApplicationPackage(pipeline: depthai.Pipeline, pathToCmd: Path = '', compress: bool = False, applicationName: str = '', checkChecksum: bool = False) -> list[int]

        Creates application package which can be flashed to depthai device.

        Parameter ``pipeline``:
            Pipeline from which to create the application package

        Parameter ``pathToCmd``:
            Optional path to custom device firmware

        Parameter ``compress``:
            Optional boolean which specifies if contents should be compressed

        Parameter ``applicationName``:
            Optional name the application that is flashed

        Returns:
            Depthai application package

        2. createDepthaiApplicationPackage(pipeline: depthai.Pipeline, compress: bool, applicationName: str = '', checkChecksum: bool = False) -> list[int]

        Creates application package which can be flashed to depthai device.

        Parameter ``pipeline``:
            Pipeline from which to create the application package

        Parameter ``compress``:
            Specifies if contents should be compressed

        Parameter ``applicationName``:
            Name the application that is flashed

        Returns:
            Depthai application package
        """
    @overload
    def flash(self, progressCallback: Callable[[float], None], pipeline: Pipeline, compress: bool = ..., applicationName: str = ..., memory: DeviceBootloader.Memory = ..., checkChecksum: bool = ...) -> tuple[bool, str]:
        """flash(*args, **kwargs)
        Overloaded function.

        1. flash(self: depthai.DeviceBootloader, progressCallback: Callable[[float], None], pipeline: depthai.Pipeline, compress: bool = False, applicationName: str = '', memory: depthai.DeviceBootloader.Memory = <Memory.AUTO: -1>, checkChecksum: bool = False) -> tuple[bool, str]

        Flashes a given pipeline to the device.

        Parameter ``progressCallback``:
            Callback that sends back a value between 0..1 which signifies current
            flashing progress

        Parameter ``pipeline``:
            Pipeline to flash to the board

        Parameter ``compress``:
            Compresses application to reduce needed memory size

        Parameter ``applicationName``:
            Name the application that is flashed

        2. flash(self: depthai.DeviceBootloader, pipeline: depthai.Pipeline, compress: bool = False, applicationName: str = '', memory: depthai.DeviceBootloader.Memory = <Memory.AUTO: -1>, checkChecksum: bool = False) -> tuple[bool, str]

        Flashes a given pipeline to the device.

        Parameter ``pipeline``:
            Pipeline to flash to the board

        Parameter ``compress``:
            Compresses application to reduce needed memory size

        Parameter ``applicationName``:
            Optional name the application that is flashed
        """
    @overload
    def flash(self, pipeline: Pipeline, compress: bool = ..., applicationName: str = ..., memory: DeviceBootloader.Memory = ..., checkChecksum: bool = ...) -> tuple[bool, str]:
        """flash(*args, **kwargs)
        Overloaded function.

        1. flash(self: depthai.DeviceBootloader, progressCallback: Callable[[float], None], pipeline: depthai.Pipeline, compress: bool = False, applicationName: str = '', memory: depthai.DeviceBootloader.Memory = <Memory.AUTO: -1>, checkChecksum: bool = False) -> tuple[bool, str]

        Flashes a given pipeline to the device.

        Parameter ``progressCallback``:
            Callback that sends back a value between 0..1 which signifies current
            flashing progress

        Parameter ``pipeline``:
            Pipeline to flash to the board

        Parameter ``compress``:
            Compresses application to reduce needed memory size

        Parameter ``applicationName``:
            Name the application that is flashed

        2. flash(self: depthai.DeviceBootloader, pipeline: depthai.Pipeline, compress: bool = False, applicationName: str = '', memory: depthai.DeviceBootloader.Memory = <Memory.AUTO: -1>, checkChecksum: bool = False) -> tuple[bool, str]

        Flashes a given pipeline to the device.

        Parameter ``pipeline``:
            Pipeline to flash to the board

        Parameter ``compress``:
            Compresses application to reduce needed memory size

        Parameter ``applicationName``:
            Optional name the application that is flashed
        """
    def flashBootHeader(self, memory: DeviceBootloader.Memory, frequency: int = ..., location: int = ..., dummyCycles: int = ..., offset: int = ...) -> tuple[bool, str]:
        """flashBootHeader(self: depthai.DeviceBootloader, memory: depthai.DeviceBootloader.Memory, frequency: int = -1, location: int = -1, dummyCycles: int = -1, offset: int = -1) -> tuple[bool, str]

        Flash optimized boot header

        Parameter ``memory``:
            Which memory to flasht the header to

        Parameter ``frequency``:
            SPI specific parameter, frequency in MHz

        Parameter ``location``:
            Target location the header should boot to. Default to location of bootloader

        Parameter ``dummyCycles``:
            SPI specific parameter

        Parameter ``offset``:
            Offset in memory to flash the header to. Defaults to offset of boot header

        Returns:
            status as std::tuple<bool, std::string>
        """
    @overload
    def flashBootloader(self, progressCallback: Callable[[float], None], path: Path = ...) -> tuple[bool, str]:
        """flashBootloader(*args, **kwargs)
        Overloaded function.

        1. flashBootloader(self: depthai.DeviceBootloader, progressCallback: Callable[[float], None], path: Path = '') -> tuple[bool, str]

        Flashes bootloader to the current board

        Parameter ``progressCallback``:
            Callback that sends back a value between 0..1 which signifies current
            flashing progress

        Parameter ``path``:
            Optional parameter to custom bootloader to flash

        2. flashBootloader(self: depthai.DeviceBootloader, memory: depthai.DeviceBootloader.Memory, type: depthai.DeviceBootloader.Type, progressCallback: Callable[[float], None], path: Path = '') -> tuple[bool, str]

        Flash selected bootloader to the current board

        Parameter ``memory``:
            Memory to flash

        Parameter ``type``:
            Bootloader type to flash

        Parameter ``progressCallback``:
            Callback that sends back a value between 0..1 which signifies current
            flashing progress

        Parameter ``path``:
            Optional parameter to custom bootloader to flash
        """
    @overload
    def flashBootloader(self, memory: DeviceBootloader.Memory, type: DeviceBootloader.Type, progressCallback: Callable[[float], None], path: Path = ...) -> tuple[bool, str]:
        """flashBootloader(*args, **kwargs)
        Overloaded function.

        1. flashBootloader(self: depthai.DeviceBootloader, progressCallback: Callable[[float], None], path: Path = '') -> tuple[bool, str]

        Flashes bootloader to the current board

        Parameter ``progressCallback``:
            Callback that sends back a value between 0..1 which signifies current
            flashing progress

        Parameter ``path``:
            Optional parameter to custom bootloader to flash

        2. flashBootloader(self: depthai.DeviceBootloader, memory: depthai.DeviceBootloader.Memory, type: depthai.DeviceBootloader.Type, progressCallback: Callable[[float], None], path: Path = '') -> tuple[bool, str]

        Flash selected bootloader to the current board

        Parameter ``memory``:
            Memory to flash

        Parameter ``type``:
            Bootloader type to flash

        Parameter ``progressCallback``:
            Callback that sends back a value between 0..1 which signifies current
            flashing progress

        Parameter ``path``:
            Optional parameter to custom bootloader to flash
        """
    def flashClear(self, memory: DeviceBootloader.Memory = ...) -> tuple[bool, str]:
        """flashClear(self: depthai.DeviceBootloader, memory: depthai.DeviceBootloader.Memory = <Memory.AUTO: -1>) -> tuple[bool, str]

        Clears flashed application on the device, by removing SBR boot structure Doesn't
        remove fast boot header capability to still boot the application
        """
    def flashConfig(self, config: DeviceBootloader.Config, memory: DeviceBootloader.Memory = ..., type: DeviceBootloader.Type = ...) -> tuple[bool, str]:
        """flashConfig(self: depthai.DeviceBootloader, config: depthai.DeviceBootloader.Config, memory: depthai.DeviceBootloader.Memory = <Memory.AUTO: -1>, type: depthai.DeviceBootloader.Type = <Type.AUTO: -1>) -> tuple[bool, str]

        Flashes configuration to bootloader

        Parameter ``configData``:
            Configuration structure

        Parameter ``memory``:
            Optional - to which memory flash configuration

        Parameter ``type``:
            Optional - for which type of bootloader to flash configuration
        """
    def flashConfigClear(self, memory: DeviceBootloader.Memory = ..., type: DeviceBootloader.Type = ...) -> tuple[bool, str]:
        """flashConfigClear(self: depthai.DeviceBootloader, memory: depthai.DeviceBootloader.Memory = <Memory.AUTO: -1>, type: depthai.DeviceBootloader.Type = <Type.AUTO: -1>) -> tuple[bool, str]

        Clears configuration data

        Parameter ``memory``:
            Optional - on which memory to clear configuration data

        Parameter ``type``:
            Optional - for which type of bootloader to clear configuration data
        """
    def flashConfigData(self, configData: json, memory: DeviceBootloader.Memory = ..., type: DeviceBootloader.Type = ...) -> tuple[bool, str]:
        """flashConfigData(self: depthai.DeviceBootloader, configData: json, memory: depthai.DeviceBootloader.Memory = <Memory.AUTO: -1>, type: depthai.DeviceBootloader.Type = <Type.AUTO: -1>) -> tuple[bool, str]

        Flashes configuration data to bootloader

        Parameter ``configData``:
            Unstructured configuration data

        Parameter ``memory``:
            Optional - to which memory flash configuration

        Parameter ``type``:
            Optional - for which type of bootloader to flash configuration
        """
    def flashConfigFile(self, configData: Path, memory: DeviceBootloader.Memory = ..., type: DeviceBootloader.Type = ...) -> tuple[bool, str]:
        """flashConfigFile(self: depthai.DeviceBootloader, configData: Path, memory: depthai.DeviceBootloader.Memory = <Memory.AUTO: -1>, type: depthai.DeviceBootloader.Type = <Type.AUTO: -1>) -> tuple[bool, str]

        Flashes configuration data to bootloader

        Parameter ``configPath``:
            Unstructured configuration data

        Parameter ``memory``:
            Optional - to which memory flash configuration

        Parameter ``type``:
            Optional - for which type of bootloader to flash configuration
        """
    @overload
    def flashCustom(self, memory: DeviceBootloader.Memory, offset: int, data: list[int], progressCallback: Callable[[float], None] = ...) -> tuple[bool, str]:
        """flashCustom(*args, **kwargs)
        Overloaded function.

        1. flashCustom(self: depthai.DeviceBootloader, memory: depthai.DeviceBootloader.Memory, offset: int, data: list[int], progressCallback: Callable[[float], None] = None) -> tuple[bool, str]

        Flash arbitrary data at custom offset in specified memory

        Parameter ``memory``:
            Memory to flash

        Parameter ``offset``:
            Offset at which to flash the given data in bytes

        Parameter ``progressCallback``:
            Callback that sends back a value between 0..1 which signifies current
            flashing progress

        Parameter ``data``:
            Data to flash

        2. flashCustom(self: depthai.DeviceBootloader, memory: depthai.DeviceBootloader.Memory, offset: int, filename: str, progressCallback: Callable[[float], None] = None) -> tuple[bool, str]

        Flash arbitrary data at custom offset in specified memory

        Parameter ``memory``:
            Memory to flash

        Parameter ``offset``:
            Offset at which to flash the given data in bytes

        Parameter ``progressCallback``:
            Callback that sends back a value between 0..1 which signifies current
            flashing progress

        Parameter ``data``:
            Data to flash
        """
    @overload
    def flashCustom(self, memory: DeviceBootloader.Memory, offset: int, filename: str, progressCallback: Callable[[float], None] = ...) -> tuple[bool, str]:
        """flashCustom(*args, **kwargs)
        Overloaded function.

        1. flashCustom(self: depthai.DeviceBootloader, memory: depthai.DeviceBootloader.Memory, offset: int, data: list[int], progressCallback: Callable[[float], None] = None) -> tuple[bool, str]

        Flash arbitrary data at custom offset in specified memory

        Parameter ``memory``:
            Memory to flash

        Parameter ``offset``:
            Offset at which to flash the given data in bytes

        Parameter ``progressCallback``:
            Callback that sends back a value between 0..1 which signifies current
            flashing progress

        Parameter ``data``:
            Data to flash

        2. flashCustom(self: depthai.DeviceBootloader, memory: depthai.DeviceBootloader.Memory, offset: int, filename: str, progressCallback: Callable[[float], None] = None) -> tuple[bool, str]

        Flash arbitrary data at custom offset in specified memory

        Parameter ``memory``:
            Memory to flash

        Parameter ``offset``:
            Offset at which to flash the given data in bytes

        Parameter ``progressCallback``:
            Callback that sends back a value between 0..1 which signifies current
            flashing progress

        Parameter ``data``:
            Data to flash
        """
    @overload
    def flashDepthaiApplicationPackage(self, progressCallback: Callable[[float], None], package: list[int], memory: DeviceBootloader.Memory = ...) -> tuple[bool, str]:
        """flashDepthaiApplicationPackage(*args, **kwargs)
        Overloaded function.

        1. flashDepthaiApplicationPackage(self: depthai.DeviceBootloader, progressCallback: Callable[[float], None], package: list[int], memory: depthai.DeviceBootloader.Memory = <Memory.AUTO: -1>) -> tuple[bool, str]

        Flashes a specific depthai application package that was generated using
        createDepthaiApplicationPackage or saveDepthaiApplicationPackage

        Parameter ``progressCallback``:
            Callback that sends back a value between 0..1 which signifies current
            flashing progress

        Parameter ``package``:
            Depthai application package to flash to the board

        2. flashDepthaiApplicationPackage(self: depthai.DeviceBootloader, package: list[int], memory: depthai.DeviceBootloader.Memory = <Memory.AUTO: -1>) -> tuple[bool, str]

        Flashes a specific depthai application package that was generated using
        createDepthaiApplicationPackage or saveDepthaiApplicationPackage

        Parameter ``package``:
            Depthai application package to flash to the board
        """
    @overload
    def flashDepthaiApplicationPackage(self, package: list[int], memory: DeviceBootloader.Memory = ...) -> tuple[bool, str]:
        """flashDepthaiApplicationPackage(*args, **kwargs)
        Overloaded function.

        1. flashDepthaiApplicationPackage(self: depthai.DeviceBootloader, progressCallback: Callable[[float], None], package: list[int], memory: depthai.DeviceBootloader.Memory = <Memory.AUTO: -1>) -> tuple[bool, str]

        Flashes a specific depthai application package that was generated using
        createDepthaiApplicationPackage or saveDepthaiApplicationPackage

        Parameter ``progressCallback``:
            Callback that sends back a value between 0..1 which signifies current
            flashing progress

        Parameter ``package``:
            Depthai application package to flash to the board

        2. flashDepthaiApplicationPackage(self: depthai.DeviceBootloader, package: list[int], memory: depthai.DeviceBootloader.Memory = <Memory.AUTO: -1>) -> tuple[bool, str]

        Flashes a specific depthai application package that was generated using
        createDepthaiApplicationPackage or saveDepthaiApplicationPackage

        Parameter ``package``:
            Depthai application package to flash to the board
        """
    def flashFastBootHeader(self, memory: DeviceBootloader.Memory, frequency: int = ..., location: int = ..., dummyCycles: int = ..., offset: int = ...) -> tuple[bool, str]:
        """flashFastBootHeader(self: depthai.DeviceBootloader, memory: depthai.DeviceBootloader.Memory, frequency: int = -1, location: int = -1, dummyCycles: int = -1, offset: int = -1) -> tuple[bool, str]

        Flash fast boot header. Application must already be present in flash, or
        location must be specified manually. Note - Can soft brick your device if
        firmware location changes.

        Parameter ``memory``:
            Which memory to flash the header to

        Parameter ``frequency``:
            SPI specific parameter, frequency in MHz

        Parameter ``location``:
            Target location the header should boot to. Default to location of bootloader

        Parameter ``dummyCycles``:
            SPI specific parameter

        Parameter ``offset``:
            Offset in memory to flash the header to. Defaults to offset of boot header

        Returns:
            status as std::tuple<bool, std::string>
        """
    def flashGpioModeBootHeader(self, memory: DeviceBootloader.Memory, mode: int) -> tuple[bool, str]:
        """flashGpioModeBootHeader(self: depthai.DeviceBootloader, memory: depthai.DeviceBootloader.Memory, mode: int) -> tuple[bool, str]

        Flash boot header which boots same as equivalent GPIO mode would

        Parameter ``gpioMode``:
            GPIO mode equivalent
        """
    def flashUsbRecoveryBootHeader(self, memory: DeviceBootloader.Memory) -> tuple[bool, str]:
        """flashUsbRecoveryBootHeader(self: depthai.DeviceBootloader, memory: depthai.DeviceBootloader.Memory) -> tuple[bool, str]

        Flash USB recovery boot header. Switches to USB ROM Bootloader

        Parameter ``memory``:
            Which memory to flash the header to
        """
    def flashUserBootloader(self, progressCallback: Callable[[float], None], path: Path = ...) -> tuple[bool, str]:
        """flashUserBootloader(self: depthai.DeviceBootloader, progressCallback: Callable[[float], None], path: Path = '') -> tuple[bool, str]

        Flashes user bootloader to the current board. Available for NETWORK bootloader
        type

        Parameter ``progressCallback``:
            Callback that sends back a value between 0..1 which signifies current
            flashing progress

        Parameter ``path``:
            Optional parameter to custom bootloader to flash
        """
    @staticmethod
    def getAllAvailableDevices() -> list[DeviceInfo]:
        """getAllAvailableDevices() -> list[depthai.DeviceInfo]

        Searches for connected devices in either UNBOOTED or BOOTLOADER states.

        Returns:
            Vector of all found devices
        """
    @staticmethod
    def getEmbeddedBootloaderBinary(arg0: DeviceBootloader.Type) -> list[int]:
        """getEmbeddedBootloaderBinary(arg0: depthai.DeviceBootloader.Type) -> list[int]

        Returns:
            Embedded bootloader binary
        """
    @staticmethod
    def getEmbeddedBootloaderVersion() -> Version:
        """getEmbeddedBootloaderVersion() -> depthai.Version

        Returns:
            Embedded bootloader version
        """
    @staticmethod
    def getFirstAvailableDevice() -> tuple[bool, DeviceInfo]:
        """getFirstAvailableDevice() -> tuple[bool, depthai.DeviceInfo]

        Searches for connected devices in either UNBOOTED or BOOTLOADER states and
        returns first available.

        Returns:
            Tuple of boolean and DeviceInfo. If found boolean is true and DeviceInfo
            describes the device. Otherwise false
        """
    def getMemoryInfo(self, arg0: DeviceBootloader.Memory) -> DeviceBootloader.MemoryInfo:
        """getMemoryInfo(self: depthai.DeviceBootloader, arg0: depthai.DeviceBootloader.Memory) -> depthai.DeviceBootloader.MemoryInfo

        Retrieves information about specified memory

        Parameter ``memory``:
            Specifies which memory to query
        """
    def getType(self) -> DeviceBootloader.Type:
        """getType(self: depthai.DeviceBootloader) -> depthai.DeviceBootloader.Type

        Returns:
            Type of currently connected bootloader
        """
    def getVersion(self) -> Version:
        """getVersion(self: depthai.DeviceBootloader) -> depthai.Version

        Returns:
            Version of current running bootloader
        """
    def isAllowedFlashingBootloader(self) -> bool:
        """isAllowedFlashingBootloader(self: depthai.DeviceBootloader) -> bool

        Returns:
            True if allowed to flash bootloader
        """
    def isEmbeddedVersion(self) -> bool:
        """isEmbeddedVersion(self: depthai.DeviceBootloader) -> bool

        Returns:
            True when bootloader was booted using latest bootloader integrated in the
            library. False when bootloader is already running on the device and just
            connected to.
        """
    def isUserBootloader(self) -> bool:
        """isUserBootloader(self: depthai.DeviceBootloader) -> bool

        Retrieves whether current bootloader is User Bootloader (B out of A/B
        configuration)
        """
    def isUserBootloaderSupported(self) -> bool:
        """isUserBootloaderSupported(self: depthai.DeviceBootloader) -> bool

        Checks whether User Bootloader is supported with current bootloader

        Returns:
            true of User Bootloader is supported, false otherwise
        """
    def readApplicationInfo(self, memory: DeviceBootloader.Memory) -> DeviceBootloader.ApplicationInfo:
        """readApplicationInfo(self: depthai.DeviceBootloader, memory: depthai.DeviceBootloader.Memory) -> depthai.DeviceBootloader.ApplicationInfo

        Reads information about flashed application in specified memory from device

        Parameter ``memory``:
            Specifies which memory to query
        """
    def readConfig(self, memory: DeviceBootloader.Memory = ..., type: DeviceBootloader.Type = ...) -> DeviceBootloader.Config:
        """readConfig(self: depthai.DeviceBootloader, memory: depthai.DeviceBootloader.Memory = <Memory.AUTO: -1>, type: depthai.DeviceBootloader.Type = <Type.AUTO: -1>) -> depthai.DeviceBootloader.Config

        Reads configuration from bootloader

        Parameter ``memory``:
            Optional - from which memory to read configuration

        Parameter ``type``:
            Optional - from which type of bootloader to read configuration

        Returns:
            Configuration structure
        """
    def readConfigData(self, memory: DeviceBootloader.Memory = ..., type: DeviceBootloader.Type = ...) -> json:
        """readConfigData(self: depthai.DeviceBootloader, memory: depthai.DeviceBootloader.Memory = <Memory.AUTO: -1>, type: depthai.DeviceBootloader.Type = <Type.AUTO: -1>) -> json

        Reads configuration data from bootloader

        Returns:
            Unstructured configuration data

        Parameter ``memory``:
            Optional - from which memory to read configuration data

        Parameter ``type``:
            Optional - from which type of bootloader to read configuration data
        """
    @overload
    def readCustom(self, memory: DeviceBootloader.Memory, offset: int, size: int, filename: str, progressCallback: Callable[[float], None] = ...) -> tuple[bool, str]:
        """readCustom(*args, **kwargs)
        Overloaded function.

        1. readCustom(self: depthai.DeviceBootloader, memory: depthai.DeviceBootloader.Memory, offset: int, size: int, filename: str, progressCallback: Callable[[float], None] = None) -> tuple[bool, str]

        Reads arbitrary data at custom offset in specified memory

        Parameter ``memory``:
            Memory to read

        Parameter ``offset``:
            Offset at which to read the specified bytes

        Parameter ``size``:
            Number of bytes to read

        Parameter ``data``:
            Data to read to. Must be at least 'size' number of bytes big

        Parameter ``progressCallback``:
            Callback that sends back a value between 0..1 which signifies current
            reading progress

        2. readCustom(self: depthai.DeviceBootloader, memory: depthai.DeviceBootloader.Memory, offset: int, size: int, progressCallback: Callable[[float], None] = None) -> tuple[bool, str, list[int]]

        Reads arbitrary data at custom offset in specified memory

        Parameter ``memory``:
            Memory to read

        Parameter ``offset``:
            Offset at which to read the specified bytes

        Parameter ``size``:
            Number of bytes to read

        Parameter ``data``:
            Data to read to. Must be at least 'size' number of bytes big

        Parameter ``progressCallback``:
            Callback that sends back a value between 0..1 which signifies current
            reading progress
        """
    @overload
    def readCustom(self, memory: DeviceBootloader.Memory, offset: int, size: int, progressCallback: Callable[[float], None] = ...) -> tuple[bool, str, list[int]]:
        """readCustom(*args, **kwargs)
        Overloaded function.

        1. readCustom(self: depthai.DeviceBootloader, memory: depthai.DeviceBootloader.Memory, offset: int, size: int, filename: str, progressCallback: Callable[[float], None] = None) -> tuple[bool, str]

        Reads arbitrary data at custom offset in specified memory

        Parameter ``memory``:
            Memory to read

        Parameter ``offset``:
            Offset at which to read the specified bytes

        Parameter ``size``:
            Number of bytes to read

        Parameter ``data``:
            Data to read to. Must be at least 'size' number of bytes big

        Parameter ``progressCallback``:
            Callback that sends back a value between 0..1 which signifies current
            reading progress

        2. readCustom(self: depthai.DeviceBootloader, memory: depthai.DeviceBootloader.Memory, offset: int, size: int, progressCallback: Callable[[float], None] = None) -> tuple[bool, str, list[int]]

        Reads arbitrary data at custom offset in specified memory

        Parameter ``memory``:
            Memory to read

        Parameter ``offset``:
            Offset at which to read the specified bytes

        Parameter ``size``:
            Number of bytes to read

        Parameter ``data``:
            Data to read to. Must be at least 'size' number of bytes big

        Parameter ``progressCallback``:
            Callback that sends back a value between 0..1 which signifies current
            reading progress
        """
    @overload
    @staticmethod
    def saveDepthaiApplicationPackage(path: Path, pipeline: Pipeline, pathToCmd: Path = ..., compress: bool = ..., applicationName: str = ..., checkChecksum: bool = ...) -> None:
        """saveDepthaiApplicationPackage(*args, **kwargs)
        Overloaded function.

        1. saveDepthaiApplicationPackage(path: Path, pipeline: depthai.Pipeline, pathToCmd: Path = '', compress: bool = False, applicationName: str = '', checkChecksum: bool = False) -> None

        Saves application package to a file which can be flashed to depthai device.

        Parameter ``path``:
            Path where to save the application package

        Parameter ``pipeline``:
            Pipeline from which to create the application package

        Parameter ``pathToCmd``:
            Optional path to custom device firmware

        Parameter ``compress``:
            Optional boolean which specifies if contents should be compressed

        Parameter ``applicationName``:
            Optional name the application that is flashed

        2. saveDepthaiApplicationPackage(path: Path, pipeline: depthai.Pipeline, compress: bool, applicationName: str = '', checkChecksum: bool = False) -> None

        Saves application package to a file which can be flashed to depthai device.

        Parameter ``path``:
            Path where to save the application package

        Parameter ``pipeline``:
            Pipeline from which to create the application package

        Parameter ``compress``:
            Specifies if contents should be compressed

        Parameter ``applicationName``:
            Optional name the application that is flashed
        """
    @overload
    @staticmethod
    def saveDepthaiApplicationPackage(path: Path, pipeline: Pipeline, compress: bool, applicationName: str = ..., checkChecksum: bool = ...) -> None:
        """saveDepthaiApplicationPackage(*args, **kwargs)
        Overloaded function.

        1. saveDepthaiApplicationPackage(path: Path, pipeline: depthai.Pipeline, pathToCmd: Path = '', compress: bool = False, applicationName: str = '', checkChecksum: bool = False) -> None

        Saves application package to a file which can be flashed to depthai device.

        Parameter ``path``:
            Path where to save the application package

        Parameter ``pipeline``:
            Pipeline from which to create the application package

        Parameter ``pathToCmd``:
            Optional path to custom device firmware

        Parameter ``compress``:
            Optional boolean which specifies if contents should be compressed

        Parameter ``applicationName``:
            Optional name the application that is flashed

        2. saveDepthaiApplicationPackage(path: Path, pipeline: depthai.Pipeline, compress: bool, applicationName: str = '', checkChecksum: bool = False) -> None

        Saves application package to a file which can be flashed to depthai device.

        Parameter ``path``:
            Path where to save the application package

        Parameter ``pipeline``:
            Pipeline from which to create the application package

        Parameter ``compress``:
            Specifies if contents should be compressed

        Parameter ``applicationName``:
            Optional name the application that is flashed
        """
    def __enter__(self) -> DeviceBootloader:
        """__enter__(self: depthai.DeviceBootloader) -> depthai.DeviceBootloader"""
    def __exit__(self, arg0: object, arg1: object, arg2: object) -> None:
        """__exit__(self: depthai.DeviceBootloader, arg0: object, arg1: object, arg2: object) -> None"""

class DeviceDesc:
    mxid: str
    name: str
    platform: XLinkPlatform
    protocol: XLinkProtocol
    state: XLinkDeviceState
    status: XLinkError_t
    def __init__(self) -> None:
        """__init__(self: depthai.DeviceDesc) -> None"""

class DeviceInfo:
    desc: object
    deviceId: str
    name: str
    platform: XLinkPlatform
    protocol: XLinkProtocol
    state: XLinkDeviceState
    status: XLinkError_t
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceInfo) -> None

        2. __init__(self: depthai.DeviceInfo, name: str, deviceId: str, state: depthai.XLinkDeviceState, protocol: depthai.XLinkProtocol, platform: depthai.XLinkPlatform, status: depthai.XLinkError_t) -> None

        3. __init__(self: depthai.DeviceInfo, deviceIdOrName: str) -> None

        Creates a DeviceInfo by checking whether supplied parameter is a DeviceID or
        IP/USB name

        Parameter ``deviceIdOrName``:
            Either DeviceId, IP Address or USB port name

        4. __init__(self: depthai.DeviceInfo, arg0: depthai.DeviceDesc) -> None
        """
    @overload
    def __init__(self, name: str, deviceId: str, state: XLinkDeviceState, protocol: XLinkProtocol, platform: XLinkPlatform, status: XLinkError_t) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceInfo) -> None

        2. __init__(self: depthai.DeviceInfo, name: str, deviceId: str, state: depthai.XLinkDeviceState, protocol: depthai.XLinkProtocol, platform: depthai.XLinkPlatform, status: depthai.XLinkError_t) -> None

        3. __init__(self: depthai.DeviceInfo, deviceIdOrName: str) -> None

        Creates a DeviceInfo by checking whether supplied parameter is a DeviceID or
        IP/USB name

        Parameter ``deviceIdOrName``:
            Either DeviceId, IP Address or USB port name

        4. __init__(self: depthai.DeviceInfo, arg0: depthai.DeviceDesc) -> None
        """
    @overload
    def __init__(self, deviceIdOrName: str) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceInfo) -> None

        2. __init__(self: depthai.DeviceInfo, name: str, deviceId: str, state: depthai.XLinkDeviceState, protocol: depthai.XLinkProtocol, platform: depthai.XLinkPlatform, status: depthai.XLinkError_t) -> None

        3. __init__(self: depthai.DeviceInfo, deviceIdOrName: str) -> None

        Creates a DeviceInfo by checking whether supplied parameter is a DeviceID or
        IP/USB name

        Parameter ``deviceIdOrName``:
            Either DeviceId, IP Address or USB port name

        4. __init__(self: depthai.DeviceInfo, arg0: depthai.DeviceDesc) -> None
        """
    @overload
    def __init__(self, arg0: DeviceDesc) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.DeviceInfo) -> None

        2. __init__(self: depthai.DeviceInfo, name: str, deviceId: str, state: depthai.XLinkDeviceState, protocol: depthai.XLinkProtocol, platform: depthai.XLinkPlatform, status: depthai.XLinkError_t) -> None

        3. __init__(self: depthai.DeviceInfo, deviceIdOrName: str) -> None

        Creates a DeviceInfo by checking whether supplied parameter is a DeviceID or
        IP/USB name

        Parameter ``deviceIdOrName``:
            Either DeviceId, IP Address or USB port name

        4. __init__(self: depthai.DeviceInfo, arg0: depthai.DeviceDesc) -> None
        """
    def getDeviceId(self) -> str:
        """getDeviceId(self: depthai.DeviceInfo) -> str"""
    def getMxId(self) -> str:
        """getMxId(self: depthai.DeviceInfo) -> str"""
    def getXLinkDeviceDesc(self) -> DeviceDesc:
        """getXLinkDeviceDesc(self: depthai.DeviceInfo) -> depthai.DeviceDesc"""

class DeviceNode(ThreadedNode):
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class DeviceNodeGroup(DeviceNode):
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class EdgeDetectorConfig(Buffer):
    def __init__(self) -> None:
        """__init__(self: depthai.EdgeDetectorConfig) -> None"""
    def getConfigData(self) -> EdgeDetectorConfigData:
        """getConfigData(self: depthai.EdgeDetectorConfig) -> depthai.EdgeDetectorConfigData

        Retrieve configuration data for EdgeDetector

        Returns:
            EdgeDetectorConfigData: sobel filter horizontal and vertical 3x3 kernels
        """
    def setSobelFilterKernels(self, horizontalKernel: list[list[int]], verticalKernel: list[list[int]]) -> None:
        """setSobelFilterKernels(self: depthai.EdgeDetectorConfig, horizontalKernel: list[list[int]], verticalKernel: list[list[int]]) -> None

        Set sobel filter horizontal and vertical 3x3 kernels

        Parameter ``horizontalKernel``:
            Used for horizontal gradient computation in 3x3 Sobel filter

        Parameter ``verticalKernel``:
            Used for vertical gradient computation in 3x3 Sobel filter
        """

class EdgeDetectorConfigData:
    sobelFilterHorizontalKernel: list[list[int]]
    sobelFilterVerticalKernel: list[list[int]]
    def __init__(self) -> None:
        """__init__(self: depthai.EdgeDetectorConfigData) -> None"""

class EdgeDetectorProperties:
    initialConfig: EdgeDetectorConfig
    numFramesPool: int
    outputFrameSize: int
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class EepromData:
    batchName: str
    batchTime: int
    boardConf: str
    boardCustom: str
    boardName: str
    boardOptions: int
    boardRev: str
    cameraData: dict[CameraBoardSocket, CameraInfo]
    deviceName: str
    hardwareConf: str
    housingExtrinsics: Extrinsics
    imuExtrinsics: Extrinsics
    miscellaneousData: list[int]
    productName: str
    stereoEnableDistortionCorrection: bool
    stereoRectificationData: StereoRectification
    stereoUseSpecTranslation: bool
    version: int
    verticalCameraSocket: CameraBoardSocket
    def __init__(self) -> None:
        """__init__(self: depthai.EepromData) -> None"""

class EepromError(RuntimeError): ...

class EncodedFrame(Buffer):
    class FrameType:
        __members__: ClassVar[dict] = ...  # read-only
        B: ClassVar[EncodedFrame.FrameType] = ...
        I: ClassVar[EncodedFrame.FrameType] = ...
        P: ClassVar[EncodedFrame.FrameType] = ...
        Unknown: ClassVar[EncodedFrame.FrameType] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.EncodedFrame.FrameType, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.EncodedFrame.FrameType) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.EncodedFrame.FrameType) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class Profile:
        __members__: ClassVar[dict] = ...  # read-only
        AVC: ClassVar[EncodedFrame.Profile] = ...
        HEVC: ClassVar[EncodedFrame.Profile] = ...
        JPEG: ClassVar[EncodedFrame.Profile] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.EncodedFrame.Profile, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.EncodedFrame.Profile) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.EncodedFrame.Profile) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    def __init__(self) -> None:
        """__init__(self: depthai.EncodedFrame) -> None"""
    def getBitrate(self) -> int:
        """getBitrate(self: depthai.EncodedFrame) -> int

        Retrieves the encoding bitrate
        """
    def getColorTemperature(self) -> int:
        """getColorTemperature(self: depthai.EncodedFrame) -> int

        Retrieves white-balance color temperature of the light source, in kelvins
        """
    def getExposureTime(self) -> datetime.timedelta:
        """getExposureTime(self: depthai.EncodedFrame) -> datetime.timedelta

        Retrieves exposure time
        """
    def getFrameType(self) -> EncodedFrame.FrameType:
        """getFrameType(self: depthai.EncodedFrame) -> depthai.EncodedFrame.FrameType

        Retrieves frame type (H26x only)
        """
    def getHeight(self) -> int:
        """getHeight(self: depthai.EncodedFrame) -> int

        Retrieves image height in pixels
        """
    def getInstanceNum(self) -> int:
        """getInstanceNum(self: depthai.EncodedFrame) -> int

        Retrieves instance number
        """
    def getLensPosition(self) -> int:
        """getLensPosition(self: depthai.EncodedFrame) -> int

        Retrieves lens position, range 0..255. Returns -1 if not available
        """
    def getLensPositionRaw(self) -> float:
        """getLensPositionRaw(self: depthai.EncodedFrame) -> float

        Retrieves lens position, range 0.0f..1.0f. Returns -1 if not available
        """
    def getLossless(self) -> bool:
        """getLossless(self: depthai.EncodedFrame) -> bool

        Returns true if encoding is lossless (JPEG only)
        """
    def getProfile(self) -> EncodedFrame.Profile:
        """getProfile(self: depthai.EncodedFrame) -> depthai.EncodedFrame.Profile

        Retrieves the encoding profile (JPEG, AVC or HEVC)
        """
    def getQuality(self) -> int:
        """getQuality(self: depthai.EncodedFrame) -> int

        Retrieves the encoding quality
        """
    def getSensitivity(self) -> int:
        """getSensitivity(self: depthai.EncodedFrame) -> int

        Retrieves sensitivity, as an ISO value
        """
    def getSequenceNum(self) -> int:
        """getSequenceNum(self: depthai.EncodedFrame) -> int

        Retrieves image sequence number
        """
    def getTimestamp(self) -> datetime.timedelta:
        """getTimestamp(self: depthai.EncodedFrame) -> datetime.timedelta

        Retrieves timestamp related to dai::Clock::now()
        """
    def getTimestampDevice(self) -> datetime.timedelta:
        """getTimestampDevice(self: depthai.EncodedFrame) -> datetime.timedelta

        Retrieves timestamp directly captured from device's monotonic clock, not
        synchronized to host time. Used mostly for debugging
        """
    def getTransformation(self) -> ImgTransformation:
        """getTransformation(self: depthai.EncodedFrame) -> depthai.ImgTransformation"""
    def getWidth(self) -> int:
        """getWidth(self: depthai.EncodedFrame) -> int

        Retrieves image width in pixels
        """
    def setBitrate(self, arg0: int) -> EncodedFrame:
        """setBitrate(self: depthai.EncodedFrame, arg0: int) -> depthai.EncodedFrame

        Retrieves the encoding bitrate
        """
    def setFrameType(self, arg0: EncodedFrame.FrameType) -> EncodedFrame:
        """setFrameType(self: depthai.EncodedFrame, arg0: depthai.EncodedFrame.FrameType) -> depthai.EncodedFrame

        Retrieves frame type (H26x only)
        """
    def setHeight(self, height: int) -> EncodedFrame:
        """setHeight(self: depthai.EncodedFrame, height: int) -> depthai.EncodedFrame

        Specifies frame height

        Parameter ``height``:
            frame height
        """
    def setLossless(self, arg0: bool) -> EncodedFrame:
        """setLossless(self: depthai.EncodedFrame, arg0: bool) -> depthai.EncodedFrame

        Returns true if encoding is lossless (JPEG only)
        """
    def setProfile(self, arg0: EncodedFrame.Profile) -> EncodedFrame:
        """setProfile(self: depthai.EncodedFrame, arg0: depthai.EncodedFrame.Profile) -> depthai.EncodedFrame

        Retrieves the encoding profile (JPEG, AVC or HEVC)
        """
    def setQuality(self, arg0: int) -> EncodedFrame:
        """setQuality(self: depthai.EncodedFrame, arg0: int) -> depthai.EncodedFrame

        Retrieves the encoding quality
        """
    @overload
    def setSize(self, width: int, height: int) -> EncodedFrame:
        """setSize(*args, **kwargs)
        Overloaded function.

        1. setSize(self: depthai.EncodedFrame, width: int, height: int) -> depthai.EncodedFrame

        Specifies frame size

        Parameter ``height``:
            frame height

        Parameter ``width``:
            frame width

        2. setSize(self: depthai.EncodedFrame, sizer: tuple[int, int]) -> depthai.EncodedFrame

        Specifies frame size

        Parameter ``size``:
            frame size
        """
    @overload
    def setSize(self, sizer: tuple[int, int]) -> EncodedFrame:
        """setSize(*args, **kwargs)
        Overloaded function.

        1. setSize(self: depthai.EncodedFrame, width: int, height: int) -> depthai.EncodedFrame

        Specifies frame size

        Parameter ``height``:
            frame height

        Parameter ``width``:
            frame width

        2. setSize(self: depthai.EncodedFrame, sizer: tuple[int, int]) -> depthai.EncodedFrame

        Specifies frame size

        Parameter ``size``:
            frame size
        """
    def setTransformation(self, arg0: ImgTransformation) -> None:
        """setTransformation(self: depthai.EncodedFrame, arg0: depthai.ImgTransformation) -> None"""
    def setWidth(self, width: int) -> EncodedFrame:
        """setWidth(self: depthai.EncodedFrame, width: int) -> depthai.EncodedFrame

        Specifies frame width

        Parameter ``width``:
            frame width
        """

class EventData:
    @overload
    def __init__(self, data: str, fileName: str, mimeType: str) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.EventData, data: str, fileName: str, mimeType: str) -> None

        2. __init__(self: depthai.EventData, fileUrl: str) -> None

        3. __init__(self: depthai.EventData, imgFrame: depthai.ImgFrame, fileName: str) -> None

        4. __init__(self: depthai.EventData, encodedFrame: depthai.EncodedFrame, fileName: str) -> None

        5. __init__(self: depthai.EventData, nnData: depthai.NNData, fileName: str) -> None
        """
    @overload
    def __init__(self, fileUrl: str) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.EventData, data: str, fileName: str, mimeType: str) -> None

        2. __init__(self: depthai.EventData, fileUrl: str) -> None

        3. __init__(self: depthai.EventData, imgFrame: depthai.ImgFrame, fileName: str) -> None

        4. __init__(self: depthai.EventData, encodedFrame: depthai.EncodedFrame, fileName: str) -> None

        5. __init__(self: depthai.EventData, nnData: depthai.NNData, fileName: str) -> None
        """
    @overload
    def __init__(self, imgFrame: ImgFrame, fileName: str) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.EventData, data: str, fileName: str, mimeType: str) -> None

        2. __init__(self: depthai.EventData, fileUrl: str) -> None

        3. __init__(self: depthai.EventData, imgFrame: depthai.ImgFrame, fileName: str) -> None

        4. __init__(self: depthai.EventData, encodedFrame: depthai.EncodedFrame, fileName: str) -> None

        5. __init__(self: depthai.EventData, nnData: depthai.NNData, fileName: str) -> None
        """
    @overload
    def __init__(self, encodedFrame: EncodedFrame, fileName: str) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.EventData, data: str, fileName: str, mimeType: str) -> None

        2. __init__(self: depthai.EventData, fileUrl: str) -> None

        3. __init__(self: depthai.EventData, imgFrame: depthai.ImgFrame, fileName: str) -> None

        4. __init__(self: depthai.EventData, encodedFrame: depthai.EncodedFrame, fileName: str) -> None

        5. __init__(self: depthai.EventData, nnData: depthai.NNData, fileName: str) -> None
        """
    @overload
    def __init__(self, nnData: NNData, fileName: str) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.EventData, data: str, fileName: str, mimeType: str) -> None

        2. __init__(self: depthai.EventData, fileUrl: str) -> None

        3. __init__(self: depthai.EventData, imgFrame: depthai.ImgFrame, fileName: str) -> None

        4. __init__(self: depthai.EventData, encodedFrame: depthai.EncodedFrame, fileName: str) -> None

        5. __init__(self: depthai.EventData, nnData: depthai.NNData, fileName: str) -> None
        """

class EventsManager:
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.EventsManager) -> None

        2. __init__(self: depthai.EventsManager, url: str, uploadCachedOnStart: bool = False, publishInterval: float = 10.0) -> None
        """
    @overload
    def __init__(self, url: str, uploadCachedOnStart: bool = ..., publishInterval: float = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.EventsManager) -> None

        2. __init__(self: depthai.EventsManager, url: str, uploadCachedOnStart: bool = False, publishInterval: float = 10.0) -> None
        """
    def checkConnection(self) -> bool:
        """checkConnection(self: depthai.EventsManager) -> bool

        Check if the device is connected to Hub. Performs a simple GET request to the
        URL/health endpoint

        Returns:
            bool
        """
    def sendEvent(self, name: str, imgFrame: ImgFrame = ..., data: list[EventData] = ..., tags: list[str] = ..., extraData: dict[str, str] = ..., deviceSerialNo: str = ...) -> bool:
        """sendEvent(self: depthai.EventsManager, name: str, imgFrame: depthai.ImgFrame = None, data: list[depthai.EventData] = [], tags: list[str] = [], extraData: dict[str, str] = {}, deviceSerialNo: str = '') -> bool

        Send an event to the events service

        Parameter ``name``:
            Name of the event

        Parameter ``imgFrame``:
            Image frame to send

        Parameter ``data``:
            List of EventData objects to send

        Parameter ``tags``:
            List of tags to send

        Parameter ``extraData``:
            Extra data to send

        Parameter ``deviceSerialNo``:
            Device serial number

        Returns:
            bool
        """
    def sendSnap(self, name: str, imgFrame: ImgFrame = ..., data: list[EventData] = ..., tags: list[str] = ..., extraData: dict[str, str] = ..., deviceSerialNo: str = ...) -> bool:
        """sendSnap(self: depthai.EventsManager, name: str, imgFrame: depthai.ImgFrame = None, data: list[depthai.EventData] = [], tags: list[str] = [], extraData: dict[str, str] = {}, deviceSerialNo: str = '') -> bool

        Send a snap to the events service. Snaps should be used for sending images and
        other large files.

        Parameter ``name``:
            Name of the snap

        Parameter ``imgFrame``:
            Image frame to send

        Parameter ``data``:
            List of EventData objects to send

        Parameter ``tags``:
            List of tags to send

        Parameter ``extraData``:
            Extra data to send

        Parameter ``deviceSerialNo``:
            Device serial number

        Returns:
            bool
        """
    def setCacheDir(self, cacheDir: str) -> None:
        """setCacheDir(self: depthai.EventsManager, cacheDir: str) -> None

        Set the cache directory for storing cached data. By default, the cache directory
        is set to /internal/private

        Parameter ``cacheDir``:
            Cache directory

        Returns:
            void
        """
    def setCacheIfCannotSend(self, cacheIfCannotUpload: bool) -> None:
        """setCacheIfCannotSend(self: depthai.EventsManager, cacheIfCannotUpload: bool) -> None

        Set whether to cache data if it cannot be sent. By default, cacheIfCannotSend is
        set to false

        Parameter ``cacheIfCannotSend``:
            bool

        Returns:
            void
        """
    def setDeviceSerialNumber(self, deviceSerialNumber: str) -> None:
        """setDeviceSerialNumber(self: depthai.EventsManager, deviceSerialNumber: str) -> None"""
    def setLogResponse(self, logResponse: bool) -> None:
        """setLogResponse(self: depthai.EventsManager, logResponse: bool) -> None

        Set whether to log the responses from the server. By default, logResponse is set
        to false

        Parameter ``logResponse``:
            bool

        Returns:
            void
        """
    def setQueueSize(self, queueSize: int) -> None:
        """setQueueSize(self: depthai.EventsManager, queueSize: int) -> None

        Set the queue size for the amount of events that can be added and sent. By
        default, the queue size is set to 10

        Parameter ``queueSize``:
            Queue size

        Returns:
            void
        """
    def setSourceAppId(self, sourceAppId: str) -> None:
        """setSourceAppId(self: depthai.EventsManager, sourceAppId: str) -> None

        Set the source app ID. By default, the source app ID is taken from the
        environment variable AGENT_APP_ID

        Parameter ``sourceAppId``:
            Source app ID

        Returns:
            void
        """
    def setSourceAppIdentifier(self, sourceAppIdentifier: str) -> None:
        """setSourceAppIdentifier(self: depthai.EventsManager, sourceAppIdentifier: str) -> None

        Set the source app identifier. By default, the source app identifier is taken
        from the environment variable AGENT_APP_IDENTIFIER

        Parameter ``sourceAppIdentifier``:
            Source app identifier

        Returns:
            void
        """
    def setToken(self, token: str) -> None:
        """setToken(self: depthai.EventsManager, token: str) -> None

        Set the token for the events service. By default, the token is taken from the
        environment variable DEPTHAI_HUB_API_KEY

        Parameter ``token``:
            Token for the events service

        Returns:
            void
        """
    def setUrl(self, url: str) -> None:
        """setUrl(self: depthai.EventsManager, url: str) -> None

        Set the URL of the events service. By default, the URL is set to https://events-
        ingest.cloud.luxonis.com

        Parameter ``url``:
            URL of the events service

        Returns:
            void
        """
    def setVerifySsl(self, verifySsl: bool) -> None:
        """setVerifySsl(self: depthai.EventsManager, verifySsl: bool) -> None

        Set whether to verify the SSL certificate. By default, verifySsl is set to false

        Parameter ``verifySsl``:
            bool

        Returns:
            void
        """
    def uploadCachedData(self) -> None:
        """uploadCachedData(self: depthai.EventsManager) -> None

        Upload cached data to the events service

        Returns:
            void
        """

class Extrinsics:
    rotationMatrix: list[list[float]]
    specTranslation: Point3f
    toCameraSocket: CameraBoardSocket
    translation: Point3f
    def __init__(self) -> None:
        """__init__(self: depthai.Extrinsics) -> None"""

class FeatureTrackerConfig(Buffer):
    class CornerDetector:
        class Thresholds:
            decreaseFactor: float
            increaseFactor: float
            initialValue: float
            max: float
            min: float
            def __init__(self) -> None:
                """__init__(self: depthai.FeatureTrackerConfig.CornerDetector.Thresholds) -> None"""

        class Type:
            __members__: ClassVar[dict] = ...  # read-only
            HARRIS: ClassVar[FeatureTrackerConfig.CornerDetector.Type] = ...
            SHI_THOMASI: ClassVar[FeatureTrackerConfig.CornerDetector.Type] = ...
            __entries: ClassVar[dict] = ...
            def __init__(self, value: int) -> None:
                """__init__(self: depthai.FeatureTrackerConfig.CornerDetector.Type, value: int) -> None"""
            def __eq__(self, other: object) -> bool:
                """__eq__(self: object, other: object) -> bool"""
            def __hash__(self) -> int:
                """__hash__(self: object) -> int"""
            def __index__(self) -> int:
                """__index__(self: depthai.FeatureTrackerConfig.CornerDetector.Type) -> int"""
            def __int__(self) -> int:
                """__int__(self: depthai.FeatureTrackerConfig.CornerDetector.Type) -> int"""
            def __ne__(self, other: object) -> bool:
                """__ne__(self: object, other: object) -> bool"""
            @property
            def name(self) -> str: ...
            @property
            def value(self) -> int: ...
        cellGridDimension: int
        enableSobel: bool
        enableSorting: bool
        numMaxFeatures: int
        numTargetFeatures: int
        thresholds: FeatureTrackerConfig.CornerDetector.Thresholds
        type: FeatureTrackerConfig.CornerDetector.Type
        def __init__(self) -> None:
            """__init__(self: depthai.FeatureTrackerConfig.CornerDetector) -> None"""

    class FeatureMaintainer:
        enable: bool
        lostFeatureErrorThreshold: float
        minimumDistanceBetweenFeatures: float
        trackedFeatureThreshold: float
        def __init__(self) -> None:
            """__init__(self: depthai.FeatureTrackerConfig.FeatureMaintainer) -> None"""

    class MotionEstimator:
        class OpticalFlow:
            epsilon: float
            maxIterations: int
            pyramidLevels: int
            searchWindowHeight: int
            searchWindowWidth: int
            def __init__(self) -> None:
                """__init__(self: depthai.FeatureTrackerConfig.MotionEstimator.OpticalFlow) -> None"""

        class Type:
            __members__: ClassVar[dict] = ...  # read-only
            HW_MOTION_ESTIMATION: ClassVar[FeatureTrackerConfig.MotionEstimator.Type] = ...
            LUCAS_KANADE_OPTICAL_FLOW: ClassVar[FeatureTrackerConfig.MotionEstimator.Type] = ...
            __entries: ClassVar[dict] = ...
            def __init__(self, value: int) -> None:
                """__init__(self: depthai.FeatureTrackerConfig.MotionEstimator.Type, value: int) -> None"""
            def __eq__(self, other: object) -> bool:
                """__eq__(self: object, other: object) -> bool"""
            def __hash__(self) -> int:
                """__hash__(self: object) -> int"""
            def __index__(self) -> int:
                """__index__(self: depthai.FeatureTrackerConfig.MotionEstimator.Type) -> int"""
            def __int__(self) -> int:
                """__int__(self: depthai.FeatureTrackerConfig.MotionEstimator.Type) -> int"""
            def __ne__(self, other: object) -> bool:
                """__ne__(self: object, other: object) -> bool"""
            @property
            def name(self) -> str: ...
            @property
            def value(self) -> int: ...
        enable: bool
        opticalFlow: FeatureTrackerConfig.MotionEstimator.OpticalFlow
        type: FeatureTrackerConfig.MotionEstimator.Type
        def __init__(self) -> None:
            """__init__(self: depthai.FeatureTrackerConfig.MotionEstimator) -> None"""
    def __init__(self) -> None:
        """__init__(self: depthai.FeatureTrackerConfig) -> None"""
    @overload
    def setCornerDetector(self, cornerDetector: FeatureTrackerConfig.CornerDetector.Type) -> FeatureTrackerConfig:
        """setCornerDetector(*args, **kwargs)
        Overloaded function.

        1. setCornerDetector(self: depthai.FeatureTrackerConfig, cornerDetector: depthai.FeatureTrackerConfig.CornerDetector.Type) -> depthai.FeatureTrackerConfig

        Set corner detector algorithm type.

        Parameter ``cornerDetector``:
            Corner detector type, HARRIS or SHI_THOMASI

        2. setCornerDetector(self: depthai.FeatureTrackerConfig, config: depthai.FeatureTrackerConfig.CornerDetector) -> depthai.FeatureTrackerConfig

        Set corner detector full configuration.

        Parameter ``config``:
            Corner detector configuration
        """
    @overload
    def setCornerDetector(self, config: FeatureTrackerConfig.CornerDetector) -> FeatureTrackerConfig:
        """setCornerDetector(*args, **kwargs)
        Overloaded function.

        1. setCornerDetector(self: depthai.FeatureTrackerConfig, cornerDetector: depthai.FeatureTrackerConfig.CornerDetector.Type) -> depthai.FeatureTrackerConfig

        Set corner detector algorithm type.

        Parameter ``cornerDetector``:
            Corner detector type, HARRIS or SHI_THOMASI

        2. setCornerDetector(self: depthai.FeatureTrackerConfig, config: depthai.FeatureTrackerConfig.CornerDetector) -> depthai.FeatureTrackerConfig

        Set corner detector full configuration.

        Parameter ``config``:
            Corner detector configuration
        """
    @overload
    def setFeatureMaintainer(self, enable: bool) -> FeatureTrackerConfig:
        """setFeatureMaintainer(*args, **kwargs)
        Overloaded function.

        1. setFeatureMaintainer(self: depthai.FeatureTrackerConfig, enable: bool) -> depthai.FeatureTrackerConfig

        Enable or disable feature maintainer.

        Parameter ``enable``:

        2. setFeatureMaintainer(self: depthai.FeatureTrackerConfig, config: depthai.FeatureTrackerConfig.FeatureMaintainer) -> depthai.FeatureTrackerConfig

        Set feature maintainer full configuration.

        Parameter ``config``:
            feature maintainer configuration
        """
    @overload
    def setFeatureMaintainer(self, config: FeatureTrackerConfig.FeatureMaintainer) -> FeatureTrackerConfig:
        """setFeatureMaintainer(*args, **kwargs)
        Overloaded function.

        1. setFeatureMaintainer(self: depthai.FeatureTrackerConfig, enable: bool) -> depthai.FeatureTrackerConfig

        Enable or disable feature maintainer.

        Parameter ``enable``:

        2. setFeatureMaintainer(self: depthai.FeatureTrackerConfig, config: depthai.FeatureTrackerConfig.FeatureMaintainer) -> depthai.FeatureTrackerConfig

        Set feature maintainer full configuration.

        Parameter ``config``:
            feature maintainer configuration
        """
    def setHwMotionEstimation(self) -> FeatureTrackerConfig:
        """setHwMotionEstimation(self: depthai.FeatureTrackerConfig) -> depthai.FeatureTrackerConfig

        Set hardware accelerated motion estimation using block matching. Faster than
        optical flow (software implementation) but might not be as accurate.
        """
    @overload
    def setMotionEstimator(self, enable: bool) -> FeatureTrackerConfig:
        """setMotionEstimator(*args, **kwargs)
        Overloaded function.

        1. setMotionEstimator(self: depthai.FeatureTrackerConfig, enable: bool) -> depthai.FeatureTrackerConfig

        Enable or disable motion estimator.

        Parameter ``enable``:

        2. setMotionEstimator(self: depthai.FeatureTrackerConfig, config: depthai.FeatureTrackerConfig.MotionEstimator) -> depthai.FeatureTrackerConfig

        Set motion estimator full configuration.

        Parameter ``config``:
            Motion estimator configuration
        """
    @overload
    def setMotionEstimator(self, config: FeatureTrackerConfig.MotionEstimator) -> FeatureTrackerConfig:
        """setMotionEstimator(*args, **kwargs)
        Overloaded function.

        1. setMotionEstimator(self: depthai.FeatureTrackerConfig, enable: bool) -> depthai.FeatureTrackerConfig

        Enable or disable motion estimator.

        Parameter ``enable``:

        2. setMotionEstimator(self: depthai.FeatureTrackerConfig, config: depthai.FeatureTrackerConfig.MotionEstimator) -> depthai.FeatureTrackerConfig

        Set motion estimator full configuration.

        Parameter ``config``:
            Motion estimator configuration
        """
    def setNumTargetFeatures(self, numTargetFeatures: int) -> FeatureTrackerConfig:
        """setNumTargetFeatures(self: depthai.FeatureTrackerConfig, numTargetFeatures: int) -> depthai.FeatureTrackerConfig

        Set number of target features to detect.

        Parameter ``numTargetFeatures``:
            Number of features
        """
    @overload
    def setOpticalFlow(self) -> FeatureTrackerConfig:
        """setOpticalFlow(*args, **kwargs)
        Overloaded function.

        1. setOpticalFlow(self: depthai.FeatureTrackerConfig) -> depthai.FeatureTrackerConfig

        Set optical flow as motion estimation algorithm type.

        2. setOpticalFlow(self: depthai.FeatureTrackerConfig, config: depthai.FeatureTrackerConfig.MotionEstimator.OpticalFlow) -> depthai.FeatureTrackerConfig

        Set optical flow full configuration.

        Parameter ``config``:
            Optical flow configuration
        """
    @overload
    def setOpticalFlow(self, config: FeatureTrackerConfig.MotionEstimator.OpticalFlow) -> FeatureTrackerConfig:
        """setOpticalFlow(*args, **kwargs)
        Overloaded function.

        1. setOpticalFlow(self: depthai.FeatureTrackerConfig) -> depthai.FeatureTrackerConfig

        Set optical flow as motion estimation algorithm type.

        2. setOpticalFlow(self: depthai.FeatureTrackerConfig, config: depthai.FeatureTrackerConfig.MotionEstimator.OpticalFlow) -> depthai.FeatureTrackerConfig

        Set optical flow full configuration.

        Parameter ``config``:
            Optical flow configuration
        """

class FeatureTrackerProperties:
    initialConfig: FeatureTrackerConfig
    numMemorySlices: int
    numShaves: int
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class FrameEvent:
    __members__: ClassVar[dict] = ...  # read-only
    NONE: ClassVar[FrameEvent] = ...
    READOUT_END: ClassVar[FrameEvent] = ...
    READOUT_START: ClassVar[FrameEvent] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.FrameEvent, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.FrameEvent) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.FrameEvent) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class GlobalProperties:
    cameraTuningBlobSize: int | None
    cameraTuningBlobUri: str
    leonOsFrequencyHz: float
    leonRtFrequencyHz: float
    pipelineName: str | None
    pipelineVersion: str | None
    sippBufferSize: int
    sippDmaBufferSize: int
    xlinkChunkSize: int
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class IMUData(Buffer):
    packets: list[IMUPacket]
    def __init__(self) -> None:
        """__init__(self: depthai.IMUData) -> None"""

class IMUPacket:
    acceleroMeter: IMUReportAccelerometer
    gyroscope: IMUReportGyroscope
    magneticField: IMUReportMagneticField
    rotationVector: IMUReportRotationVectorWAcc
    def __init__(self) -> None:
        """__init__(self: depthai.IMUPacket) -> None"""

class IMUProperties:
    batchReportThreshold: int
    enableFirmwareUpdate: bool | None
    imuSensors: list[IMUSensorConfig]
    maxBatchReports: int
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class IMUReport:
    class Accuracy:
        __members__: ClassVar[dict] = ...  # read-only
        HIGH: ClassVar[IMUReport.Accuracy] = ...
        LOW: ClassVar[IMUReport.Accuracy] = ...
        MEDIUM: ClassVar[IMUReport.Accuracy] = ...
        UNRELIABLE: ClassVar[IMUReport.Accuracy] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.IMUReport.Accuracy, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.IMUReport.Accuracy) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.IMUReport.Accuracy) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    accuracy: IMUReport.Accuracy
    sequence: int
    timestamp: Timestamp
    tsDevice: Timestamp
    def __init__(self) -> None:
        """__init__(self: depthai.IMUReport) -> None"""
    def getSequenceNum(self) -> int:
        """getSequenceNum(self: depthai.IMUReport) -> int

        Retrieves IMU report sequence number
        """
    def getTimestamp(self) -> datetime.timedelta:
        """getTimestamp(self: depthai.IMUReport) -> datetime.timedelta

        Retrieves timestamp related to dai::Clock::now()
        """
    def getTimestampDevice(self) -> datetime.timedelta:
        """getTimestampDevice(self: depthai.IMUReport) -> datetime.timedelta

        Retrieves timestamp directly captured from device's monotonic clock, not
        synchronized to host time. Used mostly for debugging
        """

class IMUReportAccelerometer(IMUReport):
    x: float
    y: float
    z: float
    def __init__(self) -> None:
        """__init__(self: depthai.IMUReportAccelerometer) -> None"""

class IMUReportGyroscope(IMUReport):
    x: float
    y: float
    z: float
    def __init__(self) -> None:
        """__init__(self: depthai.IMUReportGyroscope) -> None"""

class IMUReportMagneticField(IMUReport):
    x: float
    y: float
    z: float
    def __init__(self) -> None:
        """__init__(self: depthai.IMUReportMagneticField) -> None"""

class IMUReportRotationVectorWAcc(IMUReport):
    i: float
    j: float
    k: float
    real: float
    rotationVectorAccuracy: float
    def __init__(self) -> None:
        """__init__(self: depthai.IMUReportRotationVectorWAcc) -> None"""

class IMUSensor:
    __members__: ClassVar[dict] = ...  # read-only
    ACCELEROMETER: ClassVar[IMUSensor] = ...
    ACCELEROMETER_RAW: ClassVar[IMUSensor] = ...
    ARVR_STABILIZED_GAME_ROTATION_VECTOR: ClassVar[IMUSensor] = ...
    ARVR_STABILIZED_ROTATION_VECTOR: ClassVar[IMUSensor] = ...
    GAME_ROTATION_VECTOR: ClassVar[IMUSensor] = ...
    GEOMAGNETIC_ROTATION_VECTOR: ClassVar[IMUSensor] = ...
    GRAVITY: ClassVar[IMUSensor] = ...
    GYROSCOPE_CALIBRATED: ClassVar[IMUSensor] = ...
    GYROSCOPE_RAW: ClassVar[IMUSensor] = ...
    GYROSCOPE_UNCALIBRATED: ClassVar[IMUSensor] = ...
    LINEAR_ACCELERATION: ClassVar[IMUSensor] = ...
    MAGNETOMETER_CALIBRATED: ClassVar[IMUSensor] = ...
    MAGNETOMETER_RAW: ClassVar[IMUSensor] = ...
    MAGNETOMETER_UNCALIBRATED: ClassVar[IMUSensor] = ...
    ROTATION_VECTOR: ClassVar[IMUSensor] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.IMUSensor, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.IMUSensor) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.IMUSensor) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class IMUSensorConfig:
    changeSensitivity: int
    reportRate: int
    sensitivityEnabled: bool
    sensitivityRelative: bool
    sensorId: IMUSensor
    def __init__(self) -> None:
        """__init__(self: depthai.IMUSensorConfig) -> None"""

class ImageAlignConfig(Buffer):
    staticDepthPlane: int
    def __init__(self) -> None:
        """__init__(self: depthai.ImageAlignConfig) -> None"""

class ImageAlignProperties:
    alignHeight: int
    alignWidth: int
    initialConfig: ImageAlignConfig
    interpolation: Interpolation
    numFramesPool: int
    numShaves: int
    outKeepAspectRatio: bool
    warpHwIds: list[int]
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class ImageManipConfig(Buffer):
    class CropConfig:
        cropRatio: float
        cropRect: ImageManipConfig.CropRect
        cropRotatedRect: RotatedRect
        enableCenterCropRectangle: bool
        enableRotatedRect: bool
        normalizedCoords: bool
        widthHeightAspectRatio: float
        def __init__(self) -> None:
            """__init__(self: depthai.ImageManipConfig.CropConfig) -> None"""

    class CropRect:
        xmax: float
        xmin: float
        ymax: float
        ymin: float
        def __init__(self) -> None:
            """__init__(self: depthai.ImageManipConfig.CropRect) -> None"""

    class FormatConfig:
        flipHorizontal: bool
        flipVertical: bool
        type: ImgFrame.Type
        def __init__(self) -> None:
            """__init__(self: depthai.ImageManipConfig.FormatConfig) -> None"""

    class ResizeConfig:
        bgBlue: str
        bgGreen: str
        bgRed: str
        enableRotation: bool
        enableWarp4pt: bool
        enableWarpMatrix: bool
        height: int
        keepAspectRatio: bool
        lockAspectRatioFill: bool
        normalizedCoords: bool
        rotationAngleDeg: float
        warpBorderReplicate: bool
        warpFourPoints: list[Point2f]
        warpMatrix3x3: list[float]
        width: int
        def __init__(self) -> None:
            """__init__(self: depthai.ImageManipConfig.ResizeConfig) -> None"""
    cropConfig: ImageManipConfig.CropConfig
    enableCrop: bool
    enableFormat: bool
    enableResize: bool
    formatConfig: ImageManipConfig.FormatConfig
    interpolation: Interpolation
    resizeConfig: ImageManipConfig.ResizeConfig
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.ImageManipConfig) -> None

        2. __init__(self: depthai.ImageManipConfig) -> None
        """
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.ImageManipConfig) -> None

        2. __init__(self: depthai.ImageManipConfig) -> None
        """
    def getColormap(self) -> Colormap:
        """getColormap(self: depthai.ImageManipConfig) -> depthai.Colormap

        Returns:
            specified colormap
        """
    def getCropConfig(self) -> ImageManipConfig.CropConfig:
        """getCropConfig(self: depthai.ImageManipConfig) -> depthai.ImageManipConfig.CropConfig

        Returns:
            Crop configuration
        """
    def getCropXMax(self) -> float:
        """getCropXMax(self: depthai.ImageManipConfig) -> float

        Returns:
            Bottom right X coordinate of crop region
        """
    def getCropXMin(self) -> float:
        """getCropXMin(self: depthai.ImageManipConfig) -> float

        Returns:
            Top left X coordinate of crop region
        """
    def getCropYMax(self) -> float:
        """getCropYMax(self: depthai.ImageManipConfig) -> float

        Returns:
            Bottom right Y coordinate of crop region
        """
    def getCropYMin(self) -> float:
        """getCropYMin(self: depthai.ImageManipConfig) -> float

        Returns:
            Top left Y coordinate of crop region
        """
    def getFormatConfig(self) -> ImageManipConfig.FormatConfig:
        """getFormatConfig(self: depthai.ImageManipConfig) -> depthai.ImageManipConfig.FormatConfig

        Returns:
            Format configuration
        """
    def getInterpolation(self) -> Interpolation:
        """getInterpolation(self: depthai.ImageManipConfig) -> depthai.Interpolation

        Retrieve which interpolation method to use
        """
    def getResizeConfig(self) -> ImageManipConfig.ResizeConfig:
        """getResizeConfig(self: depthai.ImageManipConfig) -> depthai.ImageManipConfig.ResizeConfig

        Returns:
            Resize configuration
        """
    def getResizeHeight(self) -> int:
        """getResizeHeight(self: depthai.ImageManipConfig) -> int

        Returns:
            Output image height
        """
    def getResizeWidth(self) -> int:
        """getResizeWidth(self: depthai.ImageManipConfig) -> int

        Returns:
            Output image width
        """
    def isResizeThumbnail(self) -> bool:
        """isResizeThumbnail(self: depthai.ImageManipConfig) -> bool

        Returns:
            True if resize thumbnail mode is set, false otherwise
        """
    def setCenterCrop(self, ratio: float, whRatio: float = ...) -> ImageManipConfig:
        """setCenterCrop(self: depthai.ImageManipConfig, ratio: float, whRatio: float = 1.0) -> depthai.ImageManipConfig

        Specifies a centered crop.

        Parameter ``ratio``:
            Ratio between input image and crop region (0..1)

        Parameter ``whRatio``:
            Crop region aspect ratio - 1 equals to square, 1.7 equals to 16:9, ...
        """
    @overload
    def setColormap(self, colormap: Colormap, min: int, max: int) -> ImageManipConfig:
        """setColormap(*args, **kwargs)
        Overloaded function.

        1. setColormap(self: depthai.ImageManipConfig, colormap: depthai.Colormap, min: int, max: int) -> depthai.ImageManipConfig

        Specify gray to color conversion map

        Parameter ``colormap``:
            map from Colormap enum or Colormap::NONE to disable

        2. setColormap(self: depthai.ImageManipConfig, colormap: depthai.Colormap, max: int = 255) -> depthai.ImageManipConfig

        Specify gray to color conversion map

        Parameter ``colormap``:
            map from Colormap enum or Colormap::NONE to disable

        3. setColormap(self: depthai.ImageManipConfig, colormap: depthai.Colormap, max: float = 255.0) -> depthai.ImageManipConfig

        Specify gray to color conversion map

        Parameter ``colormap``:
            map from Colormap enum or Colormap::NONE to disable
        """
    @overload
    def setColormap(self, colormap: Colormap, max: int = ...) -> ImageManipConfig:
        """setColormap(*args, **kwargs)
        Overloaded function.

        1. setColormap(self: depthai.ImageManipConfig, colormap: depthai.Colormap, min: int, max: int) -> depthai.ImageManipConfig

        Specify gray to color conversion map

        Parameter ``colormap``:
            map from Colormap enum or Colormap::NONE to disable

        2. setColormap(self: depthai.ImageManipConfig, colormap: depthai.Colormap, max: int = 255) -> depthai.ImageManipConfig

        Specify gray to color conversion map

        Parameter ``colormap``:
            map from Colormap enum or Colormap::NONE to disable

        3. setColormap(self: depthai.ImageManipConfig, colormap: depthai.Colormap, max: float = 255.0) -> depthai.ImageManipConfig

        Specify gray to color conversion map

        Parameter ``colormap``:
            map from Colormap enum or Colormap::NONE to disable
        """
    @overload
    def setColormap(self, colormap: Colormap, max: float = ...) -> ImageManipConfig:
        """setColormap(*args, **kwargs)
        Overloaded function.

        1. setColormap(self: depthai.ImageManipConfig, colormap: depthai.Colormap, min: int, max: int) -> depthai.ImageManipConfig

        Specify gray to color conversion map

        Parameter ``colormap``:
            map from Colormap enum or Colormap::NONE to disable

        2. setColormap(self: depthai.ImageManipConfig, colormap: depthai.Colormap, max: int = 255) -> depthai.ImageManipConfig

        Specify gray to color conversion map

        Parameter ``colormap``:
            map from Colormap enum or Colormap::NONE to disable

        3. setColormap(self: depthai.ImageManipConfig, colormap: depthai.Colormap, max: float = 255.0) -> depthai.ImageManipConfig

        Specify gray to color conversion map

        Parameter ``colormap``:
            map from Colormap enum or Colormap::NONE to disable
        """
    @overload
    def setCropRect(self, xmin: float, ymin: float, xmax: float, ymax: float) -> ImageManipConfig:
        """setCropRect(*args, **kwargs)
        Overloaded function.

        1. setCropRect(self: depthai.ImageManipConfig, xmin: float, ymin: float, xmax: float, ymax: float) -> depthai.ImageManipConfig

        Specifies crop with rectangle with normalized values (0..1)

        Parameter ``xmin``:
            Top left X coordinate of rectangle

        Parameter ``ymin``:
            Top left Y coordinate of rectangle

        Parameter ``xmax``:
            Bottom right X coordinate of rectangle

        Parameter ``ymax``:
            Bottom right Y coordinate of rectangle

        2. setCropRect(self: depthai.ImageManipConfig, coordinates: tuple[float, float, float, float]) -> depthai.ImageManipConfig

        Specifies crop with rectangle with normalized values (0..1)

        Parameter ``coordinates``:
            Coordinate of rectangle
        """
    @overload
    def setCropRect(self, coordinates: tuple[float, float, float, float]) -> ImageManipConfig:
        """setCropRect(*args, **kwargs)
        Overloaded function.

        1. setCropRect(self: depthai.ImageManipConfig, xmin: float, ymin: float, xmax: float, ymax: float) -> depthai.ImageManipConfig

        Specifies crop with rectangle with normalized values (0..1)

        Parameter ``xmin``:
            Top left X coordinate of rectangle

        Parameter ``ymin``:
            Top left Y coordinate of rectangle

        Parameter ``xmax``:
            Bottom right X coordinate of rectangle

        Parameter ``ymax``:
            Bottom right Y coordinate of rectangle

        2. setCropRect(self: depthai.ImageManipConfig, coordinates: tuple[float, float, float, float]) -> depthai.ImageManipConfig

        Specifies crop with rectangle with normalized values (0..1)

        Parameter ``coordinates``:
            Coordinate of rectangle
        """
    def setCropRotatedRect(self, rr: RotatedRect, normalizedCoords: bool = ...) -> ImageManipConfig:
        """setCropRotatedRect(self: depthai.ImageManipConfig, rr: depthai.RotatedRect, normalizedCoords: bool = True) -> depthai.ImageManipConfig

        Specifies crop with rotated rectangle. Optionally as non normalized coordinates

        Parameter ``rr``:
            Rotated rectangle which specifies crop

        Parameter ``normalizedCoords``:
            If true coordinates are in normalized range (0..1) otherwise absolute
        """
    def setFrameType(self, type: ImgFrame.Type) -> ImageManipConfig:
        """setFrameType(self: depthai.ImageManipConfig, type: depthai.ImgFrame.Type) -> depthai.ImageManipConfig

        Specify output frame type.

        Parameter ``name``:
            Frame type
        """
    def setHorizontalFlip(self, flip: bool) -> ImageManipConfig:
        """setHorizontalFlip(self: depthai.ImageManipConfig, flip: bool) -> depthai.ImageManipConfig

        Specify horizontal flip

        Parameter ``flip``:
            True to enable flip, false otherwise
        """
    def setInterpolation(self, interpolation: Interpolation) -> ImageManipConfig:
        """setInterpolation(self: depthai.ImageManipConfig, interpolation: depthai.Interpolation) -> depthai.ImageManipConfig

        Specify which interpolation method to use

        Parameter ``interpolation``:
            type of interpolation
        """
    def setKeepAspectRatio(self, keep: bool) -> ImageManipConfig:
        """setKeepAspectRatio(self: depthai.ImageManipConfig, keep: bool) -> depthai.ImageManipConfig

        Specifies to whether to keep aspect ratio or not
        """
    @overload
    def setResize(self, w: int, h: int) -> ImageManipConfig:
        """setResize(*args, **kwargs)
        Overloaded function.

        1. setResize(self: depthai.ImageManipConfig, w: int, h: int) -> depthai.ImageManipConfig

        Specifies output image size. After crop stage the image will be stretched to
        fit.

        Parameter ``w``:
            Width in pixels

        Parameter ``h``:
            Height in pixels

        2. setResize(self: depthai.ImageManipConfig, size: tuple[int, int]) -> depthai.ImageManipConfig

        Specifies output image size. After crop stage the image will be stretched to
        fit.

        Parameter ``size``:
            Size in pixels
        """
    @overload
    def setResize(self, size: tuple[int, int]) -> ImageManipConfig:
        """setResize(*args, **kwargs)
        Overloaded function.

        1. setResize(self: depthai.ImageManipConfig, w: int, h: int) -> depthai.ImageManipConfig

        Specifies output image size. After crop stage the image will be stretched to
        fit.

        Parameter ``w``:
            Width in pixels

        Parameter ``h``:
            Height in pixels

        2. setResize(self: depthai.ImageManipConfig, size: tuple[int, int]) -> depthai.ImageManipConfig

        Specifies output image size. After crop stage the image will be stretched to
        fit.

        Parameter ``size``:
            Size in pixels
        """
    @overload
    def setResizeThumbnail(self, w: int, h: int, bgRed: int = ..., bgGreen: int = ..., bgBlue: int = ...) -> ImageManipConfig:
        """setResizeThumbnail(*args, **kwargs)
        Overloaded function.

        1. setResizeThumbnail(self: depthai.ImageManipConfig, w: int, h: int, bgRed: int = 0, bgGreen: int = 0, bgBlue: int = 0) -> depthai.ImageManipConfig

        Specifies output image size. After crop stage the image will be resized by
        preserving aspect ration. Optionally background can be specified.

        Parameter ``w``:
            Width in pixels

        Parameter ``h``:
            Height in pixels

        Parameter ``bgRed``:
            Red component

        Parameter ``bgGreen``:
            Green component

        Parameter ``bgBlue``:
            Blue component

        2. setResizeThumbnail(self: depthai.ImageManipConfig, size: tuple[int, int], bgRed: int = 0, bgGreen: int = 0, bgBlue: int = 0) -> depthai.ImageManipConfig

        Specifies output image size. After crop stage the image will be resized by
        preserving aspect ration. Optionally background can be specified.

        Parameter ``size``:
            Size in pixels

        Parameter ``bgRed``:
            Red component

        Parameter ``bgGreen``:
            Green component

        Parameter ``bgBlue``:
            Blue component
        """
    @overload
    def setResizeThumbnail(self, size: tuple[int, int], bgRed: int = ..., bgGreen: int = ..., bgBlue: int = ...) -> ImageManipConfig:
        """setResizeThumbnail(*args, **kwargs)
        Overloaded function.

        1. setResizeThumbnail(self: depthai.ImageManipConfig, w: int, h: int, bgRed: int = 0, bgGreen: int = 0, bgBlue: int = 0) -> depthai.ImageManipConfig

        Specifies output image size. After crop stage the image will be resized by
        preserving aspect ration. Optionally background can be specified.

        Parameter ``w``:
            Width in pixels

        Parameter ``h``:
            Height in pixels

        Parameter ``bgRed``:
            Red component

        Parameter ``bgGreen``:
            Green component

        Parameter ``bgBlue``:
            Blue component

        2. setResizeThumbnail(self: depthai.ImageManipConfig, size: tuple[int, int], bgRed: int = 0, bgGreen: int = 0, bgBlue: int = 0) -> depthai.ImageManipConfig

        Specifies output image size. After crop stage the image will be resized by
        preserving aspect ration. Optionally background can be specified.

        Parameter ``size``:
            Size in pixels

        Parameter ``bgRed``:
            Red component

        Parameter ``bgGreen``:
            Green component

        Parameter ``bgBlue``:
            Blue component
        """
    def setReusePreviousImage(self, reuse: bool) -> ImageManipConfig:
        """setReusePreviousImage(self: depthai.ImageManipConfig, reuse: bool) -> depthai.ImageManipConfig

        Instruct ImageManip to not remove current image from its queue and use the same
        for next message.

        Parameter ``reuse``:
            True to enable reuse, false otherwise
        """
    def setRotationDegrees(self, deg: float) -> ImageManipConfig:
        """setRotationDegrees(self: depthai.ImageManipConfig, deg: float) -> depthai.ImageManipConfig

        Specifies clockwise rotation in degrees

        Parameter ``deg``:
            Rotation in degrees
        """
    def setRotationRadians(self, rad: float) -> ImageManipConfig:
        """setRotationRadians(self: depthai.ImageManipConfig, rad: float) -> depthai.ImageManipConfig

        Specifies clockwise rotation in radians

        Parameter ``rad``:
            Rotation in radians
        """
    def setSkipCurrentImage(self, skip: bool) -> ImageManipConfig:
        """setSkipCurrentImage(self: depthai.ImageManipConfig, skip: bool) -> depthai.ImageManipConfig

        Instructs ImageManip to skip current image and wait for next in queue.

        Parameter ``skip``:
            True to skip current image, false otherwise
        """
    def setVerticalFlip(self, flip: bool) -> None:
        """setVerticalFlip(self: depthai.ImageManipConfig, flip: bool) -> None

        Specify vertical flip

        Parameter ``flip``:
            True to enable vertical flip, false otherwise
        """
    def setWarpBorderFillColor(self, red: int, green: int, blue: int) -> ImageManipConfig:
        """setWarpBorderFillColor(self: depthai.ImageManipConfig, red: int, green: int, blue: int) -> depthai.ImageManipConfig

        Specifies fill color for border pixels. Example:

        - setWarpBorderFillColor(255,255,255) -> white

        - setWarpBorderFillColor(0,0,255) -> blue

        Parameter ``red``:
            Red component

        Parameter ``green``:
            Green component

        Parameter ``blue``:
            Blue component
        """
    def setWarpBorderReplicatePixels(self) -> ImageManipConfig:
        """setWarpBorderReplicatePixels(self: depthai.ImageManipConfig) -> depthai.ImageManipConfig

        Specifies that warp replicates border pixels
        """
    def setWarpTransformFourPoints(self, pt: list[Point2f], normalizedCoords: bool) -> ImageManipConfig:
        """setWarpTransformFourPoints(self: depthai.ImageManipConfig, pt: list[depthai.Point2f], normalizedCoords: bool) -> depthai.ImageManipConfig

        Specifies warp by supplying 4 points in either absolute or normalized
        coordinates

        Parameter ``pt``:
            4 points specifying warp

        Parameter ``normalizedCoords``:
            If true pt is interpreted as normalized, absolute otherwise
        """
    def setWarpTransformMatrix3x3(self, mat: list[float]) -> ImageManipConfig:
        """setWarpTransformMatrix3x3(self: depthai.ImageManipConfig, mat: list[float]) -> depthai.ImageManipConfig

        Specifies warp with a 3x3 matrix

        Parameter ``mat``:
            3x3 matrix
        """

class ImageManipConfigV2(Buffer):
    class ResizeMode:
        __members__: ClassVar[dict] = ...  # read-only
        CENTER_CROP: ClassVar[ImageManipConfigV2.ResizeMode] = ...
        LETTERBOX: ClassVar[ImageManipConfigV2.ResizeMode] = ...
        NONE: ClassVar[ImageManipConfigV2.ResizeMode] = ...
        STRETCH: ClassVar[ImageManipConfigV2.ResizeMode] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.ImageManipConfigV2.ResizeMode, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.ImageManipConfigV2.ResizeMode) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.ImageManipConfigV2.ResizeMode) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    def __init__(self) -> None:
        """__init__(self: depthai.ImageManipConfigV2) -> None"""
    @overload
    def addCrop(self, x: int, y: int, w: int, h: int) -> ImageManipConfigV2:
        """addCrop(*args, **kwargs)
        Overloaded function.

        1. addCrop(self: depthai.ImageManipConfigV2, x: int, y: int, w: int, h: int) -> depthai.ImageManipConfigV2

        Crops the image to the specified rectangle

        Parameter ``x``:
            X coordinate of the top-left corner

        Parameter ``y``:
            Y coordinate of the top-left corner

        Parameter ``w``:
            Width of the rectangle

        Parameter ``h``:
            Height of the rectangle

        2. addCrop(self: depthai.ImageManipConfigV2, rect: depthai.Rect, normalizedCoords: bool) -> depthai.ImageManipConfigV2

        Crops the image to the specified rectangle

        Parameter ``x``:
            X coordinate of the top-left corner

        Parameter ``y``:
            Y coordinate of the top-left corner

        Parameter ``w``:
            Width of the rectangle

        Parameter ``h``:
            Height of the rectangle
        """
    @overload
    def addCrop(self, rect: Rect, normalizedCoords: bool) -> ImageManipConfigV2:
        """addCrop(*args, **kwargs)
        Overloaded function.

        1. addCrop(self: depthai.ImageManipConfigV2, x: int, y: int, w: int, h: int) -> depthai.ImageManipConfigV2

        Crops the image to the specified rectangle

        Parameter ``x``:
            X coordinate of the top-left corner

        Parameter ``y``:
            Y coordinate of the top-left corner

        Parameter ``w``:
            Width of the rectangle

        Parameter ``h``:
            Height of the rectangle

        2. addCrop(self: depthai.ImageManipConfigV2, rect: depthai.Rect, normalizedCoords: bool) -> depthai.ImageManipConfigV2

        Crops the image to the specified rectangle

        Parameter ``x``:
            X coordinate of the top-left corner

        Parameter ``y``:
            Y coordinate of the top-left corner

        Parameter ``w``:
            Width of the rectangle

        Parameter ``h``:
            Height of the rectangle
        """
    def addCropRotatedRect(self, rect: RotatedRect, normalizedCoords: bool) -> ImageManipConfigV2:
        """addCropRotatedRect(self: depthai.ImageManipConfigV2, rect: depthai.RotatedRect, normalizedCoords: bool) -> depthai.ImageManipConfigV2

        Crops the image to the specified (rotated) rectangle

        Parameter ``rect``:
            RotatedRect to crop

        Parameter ``normalizedCoords``:
            If true, the coordinates are normalized to range [0, 1] where 1 maps to the
            width/height of the image
        """
    def addFlipHorizontal(self) -> ImageManipConfigV2:
        """addFlipHorizontal(self: depthai.ImageManipConfigV2) -> depthai.ImageManipConfigV2

        Flips the image horizontally
        """
    def addFlipVertical(self) -> ImageManipConfigV2:
        """addFlipVertical(self: depthai.ImageManipConfigV2) -> depthai.ImageManipConfigV2

        Flips the image vertically
        """
    @overload
    def addRotateDeg(self, angle: float) -> ImageManipConfigV2:
        """addRotateDeg(*args, **kwargs)
        Overloaded function.

        1. addRotateDeg(self: depthai.ImageManipConfigV2, angle: float) -> depthai.ImageManipConfigV2

        Rotates the image around its center by the specified angle in degrees

        Parameter ``angle``:
            Angle in radians

        2. addRotateDeg(self: depthai.ImageManipConfigV2, angle: float, center: depthai.Point2f) -> depthai.ImageManipConfigV2

        Rotates the image around its center by the specified angle in degrees

        Parameter ``angle``:
            Angle in radians
        """
    @overload
    def addRotateDeg(self, angle: float, center: Point2f) -> ImageManipConfigV2:
        """addRotateDeg(*args, **kwargs)
        Overloaded function.

        1. addRotateDeg(self: depthai.ImageManipConfigV2, angle: float) -> depthai.ImageManipConfigV2

        Rotates the image around its center by the specified angle in degrees

        Parameter ``angle``:
            Angle in radians

        2. addRotateDeg(self: depthai.ImageManipConfigV2, angle: float, center: depthai.Point2f) -> depthai.ImageManipConfigV2

        Rotates the image around its center by the specified angle in degrees

        Parameter ``angle``:
            Angle in radians
        """
    @overload
    def addScale(self, scale: float) -> ImageManipConfigV2:
        """addScale(*args, **kwargs)
        Overloaded function.

        1. addScale(self: depthai.ImageManipConfigV2, scale: float) -> depthai.ImageManipConfigV2

        Rescales the image using the specified factors

        Parameter ``scaleX``:
            Scale factor for the X axis

        Parameter ``scaleY``:
            Scale factor for the Y axis. If not specified, scaleY is set to the same
            value as scaleX

        2. addScale(self: depthai.ImageManipConfigV2, scaleX: float, scaleY: float) -> depthai.ImageManipConfigV2

        Rescales the image using the specified factors

        Parameter ``scaleX``:
            Scale factor for the X axis

        Parameter ``scaleY``:
            Scale factor for the Y axis. If not specified, scaleY is set to the same
            value as scaleX
        """
    @overload
    def addScale(self, scaleX: float, scaleY: float) -> ImageManipConfigV2:
        """addScale(*args, **kwargs)
        Overloaded function.

        1. addScale(self: depthai.ImageManipConfigV2, scale: float) -> depthai.ImageManipConfigV2

        Rescales the image using the specified factors

        Parameter ``scaleX``:
            Scale factor for the X axis

        Parameter ``scaleY``:
            Scale factor for the Y axis. If not specified, scaleY is set to the same
            value as scaleX

        2. addScale(self: depthai.ImageManipConfigV2, scaleX: float, scaleY: float) -> depthai.ImageManipConfigV2

        Rescales the image using the specified factors

        Parameter ``scaleX``:
            Scale factor for the X axis

        Parameter ``scaleY``:
            Scale factor for the Y axis. If not specified, scaleY is set to the same
            value as scaleX
        """
    def addTransformAffine(self, mat) -> ImageManipConfigV2:
        """addTransformAffine(self: depthai.ImageManipConfigV2, mat: Annotated[list[float], FixedSize(4)]) -> depthai.ImageManipConfigV2

        Applies an affine transformation to the image

        Parameter ``matrix``:
            an array containing a 2x2 matrix representing the affine transformation
        """
    def addTransformFourPoints(self, src, dst, normalizedCoords: bool) -> ImageManipConfigV2:
        """addTransformFourPoints(self: depthai.ImageManipConfigV2, src: Annotated[list[depthai.Point2f], FixedSize(4)], dst: Annotated[list[depthai.Point2f], FixedSize(4)], normalizedCoords: bool) -> depthai.ImageManipConfigV2

        Applies a perspective transformation to the image

        Parameter ``src``:
            Source points

        Parameter ``dst``:
            Destination points

        Parameter ``normalizedCoords``:
            If true, the coordinates are normalized to range [0, 1] where 1 maps to the
            width/height of the image
        """
    def addTransformPerspective(self, mat) -> ImageManipConfigV2:
        """addTransformPerspective(self: depthai.ImageManipConfigV2, mat: Annotated[list[float], FixedSize(9)]) -> depthai.ImageManipConfigV2

        Applies a perspective transformation to the image

        Parameter ``matrix``:
            an array containing a 3x3 matrix representing the perspective transformation
        """
    def clearOps(self) -> ImageManipConfigV2:
        """clearOps(self: depthai.ImageManipConfigV2) -> depthai.ImageManipConfigV2

        Removes all operations from the list (does not affect output configuration)
        """
    def getUndistort(self) -> bool:
        """getUndistort(self: depthai.ImageManipConfigV2) -> bool

        Gets the undistort flag

        Returns:
            True if undistort is enabled, false otherwise
        """
    @overload
    def setBackgroundColor(self, r: int, g: int, b: int) -> ImageManipConfigV2:
        """setBackgroundColor(*args, **kwargs)
        Overloaded function.

        1. setBackgroundColor(self: depthai.ImageManipConfigV2, r: int, g: int, b: int) -> depthai.ImageManipConfigV2

        Sets the rgb background color of the output image

        Parameter ``red``:
            Red component of the background color

        Parameter ``green``:
            Green component of the background color

        Parameter ``blue``:
            Blue component of the background color

        2. setBackgroundColor(self: depthai.ImageManipConfigV2, val: int) -> depthai.ImageManipConfigV2

        Sets the rgb background color of the output image

        Parameter ``red``:
            Red component of the background color

        Parameter ``green``:
            Green component of the background color

        Parameter ``blue``:
            Blue component of the background color
        """
    @overload
    def setBackgroundColor(self, val: int) -> ImageManipConfigV2:
        """setBackgroundColor(*args, **kwargs)
        Overloaded function.

        1. setBackgroundColor(self: depthai.ImageManipConfigV2, r: int, g: int, b: int) -> depthai.ImageManipConfigV2

        Sets the rgb background color of the output image

        Parameter ``red``:
            Red component of the background color

        Parameter ``green``:
            Green component of the background color

        Parameter ``blue``:
            Blue component of the background color

        2. setBackgroundColor(self: depthai.ImageManipConfigV2, val: int) -> depthai.ImageManipConfigV2

        Sets the rgb background color of the output image

        Parameter ``red``:
            Red component of the background color

        Parameter ``green``:
            Green component of the background color

        Parameter ``blue``:
            Blue component of the background color
        """
    @overload
    def setColormap(self, colormap: Colormap) -> ImageManipConfigV2:
        """setColormap(*args, **kwargs)
        Overloaded function.

        1. setColormap(self: depthai.ImageManipConfigV2, colormap: depthai.Colormap) -> depthai.ImageManipConfigV2

        Sets the colormap to be applied to a grayscale image

        Parameter ``colormap``:
            Colormap type to be applied

        2. setColormap(self: depthai.ImageManipConfigV2, colormap: depthai.Colormap) -> depthai.ImageManipConfigV2

        Sets the colormap to be applied to a grayscale image

        Parameter ``colormap``:
            Colormap type to be applied
        """
    @overload
    def setColormap(self, colormap: Colormap) -> ImageManipConfigV2:
        """setColormap(*args, **kwargs)
        Overloaded function.

        1. setColormap(self: depthai.ImageManipConfigV2, colormap: depthai.Colormap) -> depthai.ImageManipConfigV2

        Sets the colormap to be applied to a grayscale image

        Parameter ``colormap``:
            Colormap type to be applied

        2. setColormap(self: depthai.ImageManipConfigV2, colormap: depthai.Colormap) -> depthai.ImageManipConfigV2

        Sets the colormap to be applied to a grayscale image

        Parameter ``colormap``:
            Colormap type to be applied
        """
    def setFrameType(self, type: ImgFrame.Type) -> ImageManipConfigV2:
        """setFrameType(self: depthai.ImageManipConfigV2, type: depthai.ImgFrame.Type) -> depthai.ImageManipConfigV2

        Sets the frame type of the output image

        Parameter ``frameType``:
            Frame type of the output image
        """
    def setOutputCenter(self, c: bool) -> ImageManipConfigV2:
        """setOutputCenter(self: depthai.ImageManipConfigV2, c: bool) -> depthai.ImageManipConfigV2

        Centers the content in the output image without resizing

        Parameter ``c``:
            True to center the content, false otherwise
        """
    def setOutputSize(self, w: int, h: int, mode: ImageManipConfigV2.ResizeMode = ...) -> ImageManipConfigV2:
        """setOutputSize(self: depthai.ImageManipConfigV2, w: int, h: int, mode: depthai.ImageManipConfigV2.ResizeMode = <ResizeMode.STRETCH: 1>) -> depthai.ImageManipConfigV2

        Sets the output size of the image

        Parameter ``w``:
            Width of the output image

        Parameter ``h``:
            Height of the output image

        Parameter ``mode``:
            Resize mode. NONE - no resize, STRETCH - stretch to fit, LETTERBOX - keep
            aspect ratio and pad with background color, CENTER_CROP - keep aspect ratio
            and crop
        """
    def setReusePreviousImage(self, reuse: bool) -> ImageManipConfigV2:
        """setReusePreviousImage(self: depthai.ImageManipConfigV2, reuse: bool) -> depthai.ImageManipConfigV2

        Instruct ImageManip to not remove current image from its queue and use the same
        for next message.

        Parameter ``reuse``:
            True to enable reuse, false otherwise
        """
    def setSkipCurrentImage(self, skip: bool) -> ImageManipConfigV2:
        """setSkipCurrentImage(self: depthai.ImageManipConfigV2, skip: bool) -> depthai.ImageManipConfigV2

        Instructs ImageManip to skip current image and wait for next in queue.

        Parameter ``skip``:
            True to skip current image, false otherwise
        """
    def setUndistort(self, undistort: bool) -> ImageManipConfigV2:
        """setUndistort(self: depthai.ImageManipConfigV2, undistort: bool) -> depthai.ImageManipConfigV2

        Sets the undistort flag
        """

class ImgAnnotation:
    circles: VectorCircleAnnotation
    points: VectorPointsAnnotation
    texts: VectorTextAnnotation
    def __init__(self) -> None:
        """__init__(self: depthai.ImgAnnotation) -> None"""

class ImgAnnotations(Buffer):
    annotations: VectorImgAnnotation
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.ImgAnnotations) -> None

        Construct ImgAnnotations message.

        2. __init__(self: depthai.ImgAnnotations, arg0: depthai.VectorImgAnnotation) -> None
        """
    @overload
    def __init__(self, arg0: VectorImgAnnotation) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.ImgAnnotations) -> None

        Construct ImgAnnotations message.

        2. __init__(self: depthai.ImgAnnotations, arg0: depthai.VectorImgAnnotation) -> None
        """
    def getSequenceNum(self) -> int:
        """getSequenceNum(self: depthai.ImgAnnotations) -> int

        Retrieves image sequence number
        """
    def getTimestamp(self) -> datetime.timedelta:
        """getTimestamp(self: depthai.ImgAnnotations) -> datetime.timedelta

        Retrieves timestamp related to dai::Clock::now()
        """
    def getTimestampDevice(self) -> datetime.timedelta:
        """getTimestampDevice(self: depthai.ImgAnnotations) -> datetime.timedelta

        Retrieves timestamp directly captured from device's monotonic clock, not
        synchronized to host time. Used mostly for debugging
        """

class ImgDetection:
    confidence: float
    label: int
    xmax: float
    xmin: float
    ymax: float
    ymin: float
    def __init__(self) -> None:
        """__init__(self: depthai.ImgDetection) -> None"""

class ImgDetections(Buffer):
    detections: list[ImgDetection]
    def __init__(self) -> None:
        """__init__(self: depthai.ImgDetections) -> None

        Construct ImgDetections message.
        """
    def getSequenceNum(self) -> int:
        """getSequenceNum(self: depthai.ImgDetections) -> int

        Retrieves image sequence number
        """
    def getTimestamp(self) -> datetime.timedelta:
        """getTimestamp(self: depthai.ImgDetections) -> datetime.timedelta

        Retrieves timestamp related to dai::Clock::now()
        """
    def getTimestampDevice(self) -> datetime.timedelta:
        """getTimestampDevice(self: depthai.ImgDetections) -> datetime.timedelta

        Retrieves timestamp directly captured from device's monotonic clock, not
        synchronized to host time. Used mostly for debugging
        """
    def getTransformation(self) -> ImgTransformation | None:
        """getTransformation(self: depthai.ImgDetections) -> Optional[depthai.ImgTransformation]"""
    def setTransformation(self, arg0: ImgTransformation | None) -> None:
        """setTransformation(self: depthai.ImgDetections, arg0: Optional[depthai.ImgTransformation]) -> None"""

class ImgFrame(Buffer):
    class Specs:
        bytesPP: int
        height: int
        p1Offset: int
        p2Offset: int
        p3Offset: int
        stride: int
        type: ImgFrame.Type
        width: int
        def __init__(self) -> None:
            """__init__(self: depthai.ImgFrame.Specs) -> None"""

    class Type:
        __members__: ClassVar[dict] = ...  # read-only
        BGR888i: ClassVar[ImgFrame.Type] = ...
        BGR888p: ClassVar[ImgFrame.Type] = ...
        BGRF16F16F16i: ClassVar[ImgFrame.Type] = ...
        BGRF16F16F16p: ClassVar[ImgFrame.Type] = ...
        BITSTREAM: ClassVar[ImgFrame.Type] = ...
        GRAY8: ClassVar[ImgFrame.Type] = ...
        GRAYF16: ClassVar[ImgFrame.Type] = ...
        HDR: ClassVar[ImgFrame.Type] = ...
        LUT16: ClassVar[ImgFrame.Type] = ...
        LUT2: ClassVar[ImgFrame.Type] = ...
        LUT4: ClassVar[ImgFrame.Type] = ...
        NONE: ClassVar[ImgFrame.Type] = ...
        NV12: ClassVar[ImgFrame.Type] = ...
        NV21: ClassVar[ImgFrame.Type] = ...
        PACK10: ClassVar[ImgFrame.Type] = ...
        PACK12: ClassVar[ImgFrame.Type] = ...
        RAW10: ClassVar[ImgFrame.Type] = ...
        RAW12: ClassVar[ImgFrame.Type] = ...
        RAW14: ClassVar[ImgFrame.Type] = ...
        RAW16: ClassVar[ImgFrame.Type] = ...
        RAW32: ClassVar[ImgFrame.Type] = ...
        RAW8: ClassVar[ImgFrame.Type] = ...
        RGB161616: ClassVar[ImgFrame.Type] = ...
        RGB888i: ClassVar[ImgFrame.Type] = ...
        RGB888p: ClassVar[ImgFrame.Type] = ...
        RGBA8888: ClassVar[ImgFrame.Type] = ...
        RGBF16F16F16i: ClassVar[ImgFrame.Type] = ...
        RGBF16F16F16p: ClassVar[ImgFrame.Type] = ...
        YUV400p: ClassVar[ImgFrame.Type] = ...
        YUV420p: ClassVar[ImgFrame.Type] = ...
        YUV422i: ClassVar[ImgFrame.Type] = ...
        YUV422p: ClassVar[ImgFrame.Type] = ...
        YUV444i: ClassVar[ImgFrame.Type] = ...
        YUV444p: ClassVar[ImgFrame.Type] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.ImgFrame.Type, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.ImgFrame.Type) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.ImgFrame.Type) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.ImgFrame) -> None

        2. __init__(self: depthai.ImgFrame, arg0: int) -> None
        """
    @overload
    def __init__(self, arg0: int) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.ImgFrame) -> None

        2. __init__(self: depthai.ImgFrame, arg0: int) -> None
        """
    def getBytesPerPixel(self) -> float:
        """getBytesPerPixel(self: depthai.ImgFrame) -> float

        Retrieves image bytes per pixel
        """
    def getCategory(self) -> int:
        """getCategory(self: depthai.ImgFrame) -> int

        Retrieves image category
        """
    def getColorTemperature(self) -> int:
        """getColorTemperature(self: depthai.ImgFrame) -> int

        Retrieves white-balance color temperature of the light source, in kelvins
        """
    def getCvFrame(self) -> numpy.ndarray:
        """getCvFrame(self: depthai.ImgFrame) -> numpy.ndarray

        @note This API only available if OpenCV support is enabled

        Retrieves cv::Mat suitable for use in common opencv functions. ImgFrame is
        converted to color BGR interleaved or grayscale depending on type.

        A copy is always made

        Returns:
            cv::Mat for use in opencv functions
        """
    def getExposureTime(self) -> datetime.timedelta:
        """getExposureTime(self: depthai.ImgFrame) -> datetime.timedelta

        Retrieves exposure time
        """
    def getFrame(self) -> numpy.ndarray:
        """getFrame(self: depthai.ImgFrame) -> numpy.ndarray

        @note This API only available if OpenCV support is enabled

        Retrieves data as cv::Mat with specified width, height and type

        Parameter ``copy``:
            If false only a reference to data is made, otherwise a copy

        Returns:
            cv::Mat with corresponding to ImgFrame parameters
        """
    def getHeight(self) -> int:
        """getHeight(self: depthai.ImgFrame) -> int

        Retrieves image height in pixels
        """
    def getInstanceNum(self) -> int:
        """getInstanceNum(self: depthai.ImgFrame) -> int

        Retrieves instance number
        """
    def getLensPosition(self) -> int:
        """getLensPosition(self: depthai.ImgFrame) -> int

        Retrieves lens position, range 0..255. Returns -1 if not available
        """
    def getLensPositionRaw(self) -> float:
        """getLensPositionRaw(self: depthai.ImgFrame) -> float

        Retrieves lens position, range 0.0f..1.0f. Returns -1 if not available
        """
    def getPlaneHeight(self) -> int:
        """getPlaneHeight(self: depthai.ImgFrame) -> int

        Retrieves image plane height in lines
        """
    def getPlaneStride(self, arg0: int) -> int:
        """getPlaneStride(self: depthai.ImgFrame, arg0: int) -> int

        Retrieves image plane stride (offset to next plane) in bytes

        Parameter ``current``:
            plane index, 0 or 1
        """
    def getSensitivity(self) -> int:
        """getSensitivity(self: depthai.ImgFrame) -> int

        Retrieves sensitivity, as an ISO value
        """
    def getSequenceNum(self) -> int:
        """getSequenceNum(self: depthai.ImgFrame) -> int

        Retrieves image sequence number
        """
    def getSourceDFov(self) -> float:
        """getSourceDFov(self: depthai.ImgFrame) -> float

        @note Fov API works correctly only on rectilinear frames Get the source diagonal
        field of view in degrees

        Returns:
            field of view in degrees
        """
    def getSourceHFov(self) -> float:
        """getSourceHFov(self: depthai.ImgFrame) -> float

        @note Fov API works correctly only on rectilinear frames Get the source
        horizontal field of view

        Parameter ``degrees``:
            field of view in degrees
        """
    def getSourceHeight(self) -> int:
        """getSourceHeight(self: depthai.ImgFrame) -> int

        Retrieves source image height in pixels
        """
    def getSourceVFov(self) -> float:
        """getSourceVFov(self: depthai.ImgFrame) -> float

        @note Fov API works correctly only on rectilinear frames Get the source vertical
        field of view

        Parameter ``degrees``:
            field of view in degrees
        """
    def getSourceWidth(self) -> int:
        """getSourceWidth(self: depthai.ImgFrame) -> int

        Retrieves source image width in pixels
        """
    def getStride(self) -> int:
        """getStride(self: depthai.ImgFrame) -> int

        Retrieves image line stride in bytes
        """
    @overload
    def getTimestamp(self) -> datetime.timedelta:
        """getTimestamp(*args, **kwargs)
        Overloaded function.

        1. getTimestamp(self: depthai.ImgFrame) -> datetime.timedelta

        Retrieves timestamp related to dai::Clock::now()

        2. getTimestamp(self: depthai.ImgFrame, offset: depthai.CameraExposureOffset) -> datetime.timedelta

        Retrieves image timestamp (at the specified offset of exposure) related to
        dai::Clock::now()
        """
    @overload
    def getTimestamp(self, offset: CameraExposureOffset) -> datetime.timedelta:
        """getTimestamp(*args, **kwargs)
        Overloaded function.

        1. getTimestamp(self: depthai.ImgFrame) -> datetime.timedelta

        Retrieves timestamp related to dai::Clock::now()

        2. getTimestamp(self: depthai.ImgFrame, offset: depthai.CameraExposureOffset) -> datetime.timedelta

        Retrieves image timestamp (at the specified offset of exposure) related to
        dai::Clock::now()
        """
    def getTimestampDevice(self) -> datetime.timedelta:
        """getTimestampDevice(*args, **kwargs)
        Overloaded function.

        1. getTimestampDevice(self: depthai.ImgFrame) -> datetime.timedelta

        Retrieves timestamp directly captured from device's monotonic clock, not
        synchronized to host time. Used mostly for debugging

        2. getTimestampDevice(self: depthai.ImgFrame, offset: depthai.CameraExposureOffset) -> datetime.timedelta

        Retrieves image timestamp (at the specified offset of exposure) directly
        captured from device's monotonic clock, not synchronized to host time. Used when
        monotonicity is required.
        """
    def getTransformation(self) -> ImgTransformation:
        """getTransformation(self: depthai.ImgFrame) -> depthai.ImgTransformation"""
    def getType(self) -> ImgFrame.Type:
        """getType(self: depthai.ImgFrame) -> depthai.ImgFrame.Type

        Retrieves image type
        """
    def getWidth(self) -> int:
        """getWidth(self: depthai.ImgFrame) -> int

        Retrieves image width in pixels
        """
    def setCategory(self, category: int) -> ImgFrame:
        """setCategory(self: depthai.ImgFrame, category: int) -> depthai.ImgFrame

        Parameter ``category``:
            Image category
        """
    def setCvFrame(self, arg0: numpy.ndarray, arg1: ImgFrame.Type) -> ImgFrame:
        """setCvFrame(self: depthai.ImgFrame, arg0: numpy.ndarray, arg1: depthai.ImgFrame.Type) -> depthai.ImgFrame

        @note This API only available if OpenCV support is enabled

        Copies cv::Mat data to the ImgFrame buffer and converts to a specific type.

        Parameter ``frame``:
            Input cv::Mat BGR frame from which to copy the data
        """
    def setFrame(self, arg0: numpy.ndarray) -> ImgFrame:
        """setFrame(self: depthai.ImgFrame, arg0: numpy.ndarray) -> depthai.ImgFrame

        @note This API only available if OpenCV support is enabled

        Copies cv::Mat data to ImgFrame buffer

        Parameter ``frame``:
            Input cv::Mat frame from which to copy the data
        """
    def setHeight(self, height: int) -> ImgFrame:
        """setHeight(self: depthai.ImgFrame, height: int) -> depthai.ImgFrame

        Specifies frame height

        Parameter ``height``:
            frame height
        """
    def setInstanceNum(self, instance: int) -> ImgFrame:
        """setInstanceNum(self: depthai.ImgFrame, instance: int) -> depthai.ImgFrame

        Instance number relates to the origin of the frame (which camera)

        Parameter ``instance``:
            Instance number
        """
    @overload
    def setSize(self, width: int, height: int) -> ImgFrame:
        """setSize(*args, **kwargs)
        Overloaded function.

        1. setSize(self: depthai.ImgFrame, width: int, height: int) -> depthai.ImgFrame

        Specifies frame size

        Parameter ``height``:
            frame height

        Parameter ``width``:
            frame width

        2. setSize(self: depthai.ImgFrame, sizer: tuple[int, int]) -> depthai.ImgFrame

        Specifies frame size

        Parameter ``size``:
            frame size
        """
    @overload
    def setSize(self, sizer: tuple[int, int]) -> ImgFrame:
        """setSize(*args, **kwargs)
        Overloaded function.

        1. setSize(self: depthai.ImgFrame, width: int, height: int) -> depthai.ImgFrame

        Specifies frame size

        Parameter ``height``:
            frame height

        Parameter ``width``:
            frame width

        2. setSize(self: depthai.ImgFrame, sizer: tuple[int, int]) -> depthai.ImgFrame

        Specifies frame size

        Parameter ``size``:
            frame size
        """
    def setStride(self, stride: int) -> ImgFrame:
        """setStride(self: depthai.ImgFrame, stride: int) -> depthai.ImgFrame

        Specifies frame stride

        Parameter ``stride``:
            frame stride
        """
    def setTransformation(self, arg0: ImgTransformation) -> None:
        """setTransformation(self: depthai.ImgFrame, arg0: depthai.ImgTransformation) -> None"""
    def setType(self, type: ImgFrame.Type) -> ImgFrame:
        """setType(self: depthai.ImgFrame, type: depthai.ImgFrame.Type) -> depthai.ImgFrame

        Specifies frame type, RGB, BGR, ...

        Parameter ``type``:
            Type of image
        """
    def setWidth(self, width: int) -> ImgFrame:
        """setWidth(self: depthai.ImgFrame, width: int) -> depthai.ImgFrame

        Specifies frame width

        Parameter ``width``:
            frame width
        """
    def validateTransformations(self) -> bool:
        """validateTransformations(self: depthai.ImgFrame) -> bool

        Check that the image transformation match the image size

        Returns:
            true if the transformations are valid
        """

class ImgFrameCapability(Capability):
    enableUndistortion: bool | None
    fps: CapabilityRangeFloat
    resizeMode: ImgResizeMode
    size: CapabilityRangeUintPair
    type: ImgFrame.Type | None
    def __init__(self) -> None:
        """__init__(self: depthai.ImgFrameCapability) -> None"""

class ImgResizeMode:
    __members__: ClassVar[dict] = ...  # read-only
    CROP: ClassVar[ImgResizeMode] = ...
    LETTERBOX: ClassVar[ImgResizeMode] = ...
    STRETCH: ClassVar[ImgResizeMode] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.ImgResizeMode, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.ImgResizeMode) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.ImgResizeMode) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class ImgTransformation:
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.ImgTransformation) -> None

        2. __init__(self: depthai.ImgTransformation, width: int, height: int) -> None

        3. __init__(self: depthai.ImgTransformation, srcWidth: int, srcHeight: int, width: int, height: int) -> None

        4. __init__(self: depthai.ImgTransformation, width: int, height: int, sourceIntrinsicMatrix: Annotated[list[Annotated[list[float], FixedSize(3)]], FixedSize(3)]) -> None

        5. __init__(self: depthai.ImgTransformation, width: int, height: int, sourceIntrinsicMatrix: Annotated[list[Annotated[list[float], FixedSize(3)]], FixedSize(3)], distortionModel: depthai.CameraModel, distortionCoefficients: list[float]) -> None
        """
    @overload
    def __init__(self, width: int, height: int) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.ImgTransformation) -> None

        2. __init__(self: depthai.ImgTransformation, width: int, height: int) -> None

        3. __init__(self: depthai.ImgTransformation, srcWidth: int, srcHeight: int, width: int, height: int) -> None

        4. __init__(self: depthai.ImgTransformation, width: int, height: int, sourceIntrinsicMatrix: Annotated[list[Annotated[list[float], FixedSize(3)]], FixedSize(3)]) -> None

        5. __init__(self: depthai.ImgTransformation, width: int, height: int, sourceIntrinsicMatrix: Annotated[list[Annotated[list[float], FixedSize(3)]], FixedSize(3)], distortionModel: depthai.CameraModel, distortionCoefficients: list[float]) -> None
        """
    @overload
    def __init__(self, srcWidth: int, srcHeight: int, width: int, height: int) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.ImgTransformation) -> None

        2. __init__(self: depthai.ImgTransformation, width: int, height: int) -> None

        3. __init__(self: depthai.ImgTransformation, srcWidth: int, srcHeight: int, width: int, height: int) -> None

        4. __init__(self: depthai.ImgTransformation, width: int, height: int, sourceIntrinsicMatrix: Annotated[list[Annotated[list[float], FixedSize(3)]], FixedSize(3)]) -> None

        5. __init__(self: depthai.ImgTransformation, width: int, height: int, sourceIntrinsicMatrix: Annotated[list[Annotated[list[float], FixedSize(3)]], FixedSize(3)], distortionModel: depthai.CameraModel, distortionCoefficients: list[float]) -> None
        """
    @overload
    def __init__(self, width: int, height: int, sourceIntrinsicMatrix) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.ImgTransformation) -> None

        2. __init__(self: depthai.ImgTransformation, width: int, height: int) -> None

        3. __init__(self: depthai.ImgTransformation, srcWidth: int, srcHeight: int, width: int, height: int) -> None

        4. __init__(self: depthai.ImgTransformation, width: int, height: int, sourceIntrinsicMatrix: Annotated[list[Annotated[list[float], FixedSize(3)]], FixedSize(3)]) -> None

        5. __init__(self: depthai.ImgTransformation, width: int, height: int, sourceIntrinsicMatrix: Annotated[list[Annotated[list[float], FixedSize(3)]], FixedSize(3)], distortionModel: depthai.CameraModel, distortionCoefficients: list[float]) -> None
        """
    @overload
    def __init__(self, width: int, height: int, sourceIntrinsicMatrix, distortionModel: CameraModel, distortionCoefficients: list[float]) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.ImgTransformation) -> None

        2. __init__(self: depthai.ImgTransformation, width: int, height: int) -> None

        3. __init__(self: depthai.ImgTransformation, srcWidth: int, srcHeight: int, width: int, height: int) -> None

        4. __init__(self: depthai.ImgTransformation, width: int, height: int, sourceIntrinsicMatrix: Annotated[list[Annotated[list[float], FixedSize(3)]], FixedSize(3)]) -> None

        5. __init__(self: depthai.ImgTransformation, width: int, height: int, sourceIntrinsicMatrix: Annotated[list[Annotated[list[float], FixedSize(3)]], FixedSize(3)], distortionModel: depthai.CameraModel, distortionCoefficients: list[float]) -> None
        """
    def addCrop(self, x: int, y: int, width: int, height: int) -> ImgTransformation:
        """addCrop(self: depthai.ImgTransformation, x: int, y: int, width: int, height: int) -> depthai.ImgTransformation

        Add a crop transformation.

        Parameter ``x``:
            X coordinate of the top-left corner of the crop

        Parameter ``y``:
            Y coordinate of the top-left corner of the crop

        Parameter ``width``:
            Width of the crop

        Parameter ``height``:
            Height of the crop
        """
    def addFlipHorizontal(self) -> ImgTransformation:
        """addFlipHorizontal(self: depthai.ImgTransformation) -> depthai.ImgTransformation

        Add a horizontal flip transformation.
        """
    def addFlipVertical(self) -> ImgTransformation:
        """addFlipVertical(self: depthai.ImgTransformation) -> depthai.ImgTransformation

        Add a vertical flip transformation.
        """
    def addPadding(self, x: int, y: int, width: int, height: int) -> ImgTransformation:
        """addPadding(self: depthai.ImgTransformation, x: int, y: int, width: int, height: int) -> depthai.ImgTransformation

        Add a pad transformation. Works like crop, but in reverse.

        Parameter ``top``:
            Padding on the top

        Parameter ``bottom``:
            Padding on the bottom

        Parameter ``left``:
            Padding on the left

        Parameter ``right``:
            Padding on the right
        """
    def addRotation(self, angle: float, rotationPoint: Point2f) -> ImgTransformation:
        """addRotation(self: depthai.ImgTransformation, angle: float, rotationPoint: depthai.Point2f) -> depthai.ImgTransformation

        Add a rotation transformation.

        Parameter ``angle``:
            Angle in degrees

        Parameter ``rotationPoint``:
            Point around which to rotate
        """
    def addScale(self, scaleX: float, scaleY: float) -> ImgTransformation:
        """addScale(self: depthai.ImgTransformation, scaleX: float, scaleY: float) -> depthai.ImgTransformation

        Add a scale transformation.

        Parameter ``scaleX``:
            Scale factor in the horizontal direction

        Parameter ``scaleY``:
            Scale factor in the vertical direction
        """
    def addTransformation(self, matrix) -> ImgTransformation:
        """addTransformation(self: depthai.ImgTransformation, matrix: Annotated[list[Annotated[list[float], FixedSize(3)]], FixedSize(3)]) -> depthai.ImgTransformation

        Add a new transformation.

        Parameter ``matrix``:
            Transformation matrix
        """
    def getDFov(self, source: bool = ...) -> float:
        """getDFov(self: depthai.ImgTransformation, source: bool = False) -> float"""
    def getDistortionCoefficients(self) -> list[float]:
        """getDistortionCoefficients(self: depthai.ImgTransformation) -> list[float]

        Retrieve the distortion coefficients of the source sensor

        Returns:
            vector of distortion coefficients
        """
    def getDistortionModel(self) -> CameraModel:
        """getDistortionModel(self: depthai.ImgTransformation) -> depthai.CameraModel

        Retrieve the distortion model of the source sensor

        Returns:
            Distortion model
        """
    def getDstMaskPt(self, x: int, y: int) -> bool:
        """getDstMaskPt(self: depthai.ImgTransformation, x: int, y: int) -> bool

        Returns true if the point is inside the image region (not in the background
        region).
        """
    def getHFov(self, source: bool = ...) -> float:
        """getHFov(self: depthai.ImgTransformation, source: bool = False) -> float"""
    def getIntrinsicMatrix(self, *args, **kwargs):
        """getIntrinsicMatrix(self: depthai.ImgTransformation) -> Annotated[list[Annotated[list[float], FixedSize(3)]], FixedSize(3)]"""
    def getIntrinsicMatrixInv(self, *args, **kwargs):
        """getIntrinsicMatrixInv(self: depthai.ImgTransformation) -> Annotated[list[Annotated[list[float], FixedSize(3)]], FixedSize(3)]"""
    def getMatrix(self, *args, **kwargs):
        """getMatrix(self: depthai.ImgTransformation) -> Annotated[list[Annotated[list[float], FixedSize(3)]], FixedSize(3)]"""
    def getMatrixInv(self, *args, **kwargs):
        """getMatrixInv(self: depthai.ImgTransformation) -> Annotated[list[Annotated[list[float], FixedSize(3)]], FixedSize(3)]"""
    def getSize(self) -> tuple[int, int]:
        """getSize(self: depthai.ImgTransformation) -> tuple[int, int]

        Retrieve the size of the frame. Should be equal to the size of the corresponding
        ImgFrame message.

        Returns:
            Size of the frame
        """
    def getSourceIntrinsicMatrix(self, *args, **kwargs):
        """getSourceIntrinsicMatrix(self: depthai.ImgTransformation) -> Annotated[list[Annotated[list[float], FixedSize(3)]], FixedSize(3)]"""
    def getSourceIntrinsicMatrixInv(self, *args, **kwargs):
        """getSourceIntrinsicMatrixInv(self: depthai.ImgTransformation) -> Annotated[list[Annotated[list[float], FixedSize(3)]], FixedSize(3)]"""
    def getSourceSize(self) -> tuple[int, int]:
        """getSourceSize(self: depthai.ImgTransformation) -> tuple[int, int]

        Retrieve the size of the source frame from which this frame was derived.

        Returns:
            Size of the frame
        """
    def getSrcCrops(self) -> list[RotatedRect]:
        """getSrcCrops(self: depthai.ImgTransformation) -> list[depthai.RotatedRect]"""
    def getSrcMaskPt(self, x: int, y: int) -> bool:
        """getSrcMaskPt(self: depthai.ImgTransformation, x: int, y: int) -> bool

        Returns true if the point is inside the transformed region of interest
        (determined by crops used).
        """
    def getVFov(self, source: bool = ...) -> float:
        """getVFov(self: depthai.ImgTransformation, source: bool = False) -> float"""
    def invTransformPoint(self, point: Point2f) -> Point2f:
        """invTransformPoint(self: depthai.ImgTransformation, point: depthai.Point2f) -> depthai.Point2f

        Transform a point from the current frame to the source frame.

        Parameter ``point``:
            Point to transform

        Returns:
            Transformed point
        """
    def invTransformRect(self, rect: RotatedRect) -> RotatedRect:
        """invTransformRect(self: depthai.ImgTransformation, rect: depthai.RotatedRect) -> depthai.RotatedRect

        Transform a rotated rect from the current frame to the source frame.

        Parameter ``rect``:
            Rectangle to transform

        Returns:
            Transformed rectangle
        """
    def isValid(self) -> bool:
        """isValid(self: depthai.ImgTransformation) -> bool

        Check if the transformations are valid. The transformations are valid if the
        source frame size and the current frame size are set.
        """
    def remapPointFrom(self, to: ImgTransformation, point: Point2f) -> Point2f:
        """remapPointFrom(self: depthai.ImgTransformation, to: depthai.ImgTransformation, point: depthai.Point2f) -> depthai.Point2f

        Remap a point to this transformation from another. If the intrinsics are
        different (e.g. different camera), the function will also use the intrinsics to
        remap the point.

        Parameter ``from``:
            Transformation to remap from

        Parameter ``point``:
            Point to remap
        """
    def remapPointTo(self, to: ImgTransformation, point: Point2f) -> Point2f:
        """remapPointTo(self: depthai.ImgTransformation, to: depthai.ImgTransformation, point: depthai.Point2f) -> depthai.Point2f

        Remap a point from this transformation to another. If the intrinsics are
        different (e.g. different camera), the function will also use the intrinsics to
        remap the point.

        Parameter ``to``:
            Transformation to remap to

        Parameter ``point``:
            Point to remap
        """
    def remapRectFrom(self, to: ImgTransformation, rect: RotatedRect) -> RotatedRect:
        """remapRectFrom(self: depthai.ImgTransformation, to: depthai.ImgTransformation, rect: depthai.RotatedRect) -> depthai.RotatedRect

        Remap a rotated rect to this transformation from another. If the intrinsics are
        different (e.g. different camera), the function will also use the intrinsics to
        remap the rect.

        Parameter ``from``:
            Transformation to remap from

        Parameter ``point``:
            RotatedRect to remap
        """
    def remapRectTo(self, to: ImgTransformation, rect: RotatedRect) -> RotatedRect:
        """remapRectTo(self: depthai.ImgTransformation, to: depthai.ImgTransformation, rect: depthai.RotatedRect) -> depthai.RotatedRect

        Remap a rotated rect from this transformation to another. If the intrinsics are
        different (e.g. different camera), the function will also use the intrinsics to
        remap the rect.

        Parameter ``to``:
            Transformation to remap to

        Parameter ``rect``:
            RotatedRect to remap
        """
    def setDistortionCoefficients(self, coefficients: list[float]) -> ImgTransformation:
        """setDistortionCoefficients(self: depthai.ImgTransformation, coefficients: list[float]) -> depthai.ImgTransformation"""
    def setDistortionModel(self, model: CameraModel) -> ImgTransformation:
        """setDistortionModel(self: depthai.ImgTransformation, model: depthai.CameraModel) -> depthai.ImgTransformation"""
    def setIntrinsicMatrix(self, intrinsicMatrix) -> ImgTransformation:
        """setIntrinsicMatrix(self: depthai.ImgTransformation, intrinsicMatrix: Annotated[list[Annotated[list[float], FixedSize(3)]], FixedSize(3)]) -> depthai.ImgTransformation"""
    def transformPoint(self, point: Point2f) -> Point2f:
        """transformPoint(self: depthai.ImgTransformation, point: depthai.Point2f) -> depthai.Point2f

        Transform a point from the source frame to the current frame.

        Parameter ``point``:
            Point to transform

        Returns:
            Transformed point
        """
    def transformRect(self, rect: RotatedRect) -> RotatedRect:
        """transformRect(self: depthai.ImgTransformation, rect: depthai.RotatedRect) -> depthai.RotatedRect

        Transform a rotated rect from the source frame to the current frame.

        Parameter ``rect``:
            Rectangle to transform

        Returns:
            Transformed rectangle
        """

class InputQueue:
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def send(self, msg: ADatatype) -> None:
        """send(self: depthai.InputQueue, msg: depthai.ADatatype) -> None

        Send a message to the connected input

        Parameter ``msg:``:
            Message to send
        """

class Interpolation:
    __members__: ClassVar[dict] = ...  # read-only
    BICUBIC: ClassVar[Interpolation] = ...
    BILINEAR: ClassVar[Interpolation] = ...
    BYPASS: ClassVar[Interpolation] = ...
    DEFAULT: ClassVar[Interpolation] = ...
    DEFAULT_DISPARITY_DEPTH: ClassVar[Interpolation] = ...
    NEAREST_NEIGHBOR: ClassVar[Interpolation] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.Interpolation, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.Interpolation) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.Interpolation) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class LogLevel:
    __members__: ClassVar[dict] = ...  # read-only
    CRITICAL: ClassVar[LogLevel] = ...
    DEBUG: ClassVar[LogLevel] = ...
    ERR: ClassVar[LogLevel] = ...
    INFO: ClassVar[LogLevel] = ...
    OFF: ClassVar[LogLevel] = ...
    TRACE: ClassVar[LogLevel] = ...
    WARN: ClassVar[LogLevel] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.LogLevel, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.LogLevel) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.LogLevel) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class LogMessage:
    colorRangeEnd: int
    colorRangeStart: int
    level: LogLevel
    nodeIdName: str
    payload: str
    time: Timestamp
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class MedianFilter:
    __members__: ClassVar[dict] = ...  # read-only
    KERNEL_3x3: ClassVar[MedianFilter] = ...
    KERNEL_5x5: ClassVar[MedianFilter] = ...
    KERNEL_7x7: ClassVar[MedianFilter] = ...
    MEDIAN_OFF: ClassVar[MedianFilter] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.MedianFilter, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.MedianFilter) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.MedianFilter) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class MemoryInfo:
    remaining: int
    total: int
    used: int
    def __init__(self) -> None:
        """__init__(self: depthai.MemoryInfo) -> None"""

class MessageDemuxProperties:
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class MessageGroup(Buffer):
    def __init__(self) -> None:
        """__init__(self: depthai.MessageGroup) -> None"""
    def getIntervalNs(self) -> int:
        """getIntervalNs(self: depthai.MessageGroup) -> int

        Retrieves interval between the first and the last message in the group.
        """
    def getMessageNames(self) -> list[str]:
        """getMessageNames(self: depthai.MessageGroup) -> list[str]

        Gets the names of messages in the group
        """
    def getNumMessages(self) -> int:
        """getNumMessages(self: depthai.MessageGroup) -> int"""
    def getSequenceNum(self) -> int:
        """getSequenceNum(self: depthai.MessageGroup) -> int

        Retrieves image sequence number
        """
    def getTimestamp(self) -> datetime.timedelta:
        """getTimestamp(self: depthai.MessageGroup) -> datetime.timedelta

        Retrieves timestamp related to dai::Clock::now()
        """
    def getTimestampDevice(self) -> datetime.timedelta:
        """getTimestampDevice(self: depthai.MessageGroup) -> datetime.timedelta

        Retrieves timestamp directly captured from device's monotonic clock, not
        synchronized to host time. Used mostly for debugging
        """
    def isSynced(self, arg0: int) -> bool:
        """isSynced(self: depthai.MessageGroup, arg0: int) -> bool

        True if all messages in the group are in the interval

        Parameter ``thresholdNs``:
            Maximal interval between messages
        """
    def __getitem__(self, arg0: str) -> ADatatype:
        """__getitem__(self: depthai.MessageGroup, arg0: str) -> depthai.ADatatype"""
    def __iter__(self) -> Iterator[tuple[str, ADatatype]]:
        """__iter__(self: depthai.MessageGroup) -> Iterator[tuple[str, depthai.ADatatype]]"""
    def __setitem__(self, arg0: str, arg1: ADatatype) -> None:
        """__setitem__(self: depthai.MessageGroup, arg0: str, arg1: depthai.ADatatype) -> None"""

class MessageQueue:
    QueueException: ClassVar[type[MessageQueue.QueueException]] = ...
    @overload
    def __init__(self, name: str) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.MessageQueue, name: str) -> None

        2. __init__(self: depthai.MessageQueue, name: str = '', maxSize: int = 16, blocking: bool = True) -> None
        """
    @overload
    def __init__(self, name: str = ..., maxSize: int = ..., blocking: bool = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.MessageQueue, name: str) -> None

        2. __init__(self: depthai.MessageQueue, name: str = '', maxSize: int = 16, blocking: bool = True) -> None
        """
    def addCallback(self, callback: Callable) -> int:
        """addCallback(self: depthai.MessageQueue, callback: Callable) -> int

        Adds a callback on message received

        Parameter ``callback``:
            Callback function with queue name and message pointer

        Returns:
            Callback id
        """
    def close(self) -> None:
        """close(self: depthai.MessageQueue) -> None

        Closes the queue and unblocks any waiting consumers or producers
        """
    def front(self) -> ADatatype:
        """front(self: depthai.MessageQueue) -> depthai.ADatatype

        Gets first message in the queue.

        Returns:
            Message of type T or nullptr if no message available
        """
    @overload
    def get(self) -> ADatatype:
        """get(*args, **kwargs)
        Overloaded function.

        1. get(self: depthai.MessageQueue) -> depthai.ADatatype

        Block until a message is available.

        Returns:
            Message of type T or nullptr if no message available

        2. get(self: depthai.MessageQueue, timeout: datetime.timedelta) -> depthai.ADatatype

        Block until a message is available.

        Returns:
            Message of type T or nullptr if no message available
        """
    @overload
    def get(self, timeout: datetime.timedelta) -> ADatatype:
        """get(*args, **kwargs)
        Overloaded function.

        1. get(self: depthai.MessageQueue) -> depthai.ADatatype

        Block until a message is available.

        Returns:
            Message of type T or nullptr if no message available

        2. get(self: depthai.MessageQueue, timeout: datetime.timedelta) -> depthai.ADatatype

        Block until a message is available.

        Returns:
            Message of type T or nullptr if no message available
        """
    def getAll(self) -> list[ADatatype]:
        """getAll(self: depthai.MessageQueue) -> list[depthai.ADatatype]

        Block until at least one message in the queue. Then return all messages from the
        queue.

        Returns:
            Vector of messages which can either be of type T or nullptr
        """
    def getBlocking(self) -> bool:
        """getBlocking(self: depthai.MessageQueue) -> bool

        Gets current queue behavior when full (maxSize)

        Returns:
            True if blocking, false otherwise
        """
    def getMaxSize(self) -> int:
        """getMaxSize(self: depthai.MessageQueue) -> int

        Gets queue maximum size

        Returns:
            Maximum queue size
        """
    @overload
    def getName(self) -> str:
        """getName(*args, **kwargs)
        Overloaded function.

        1. getName(self: depthai.MessageQueue) -> str

        Get name of the queue

        2. getName(self: depthai.MessageQueue) -> str

        Get name of the queue
        """
    @overload
    def getName(self) -> str:
        """getName(*args, **kwargs)
        Overloaded function.

        1. getName(self: depthai.MessageQueue) -> str

        Get name of the queue

        2. getName(self: depthai.MessageQueue) -> str

        Get name of the queue
        """
    def getSize(self) -> int:
        """getSize(self: depthai.MessageQueue) -> int

        Gets queue current size

        Returns:
            Current queue size
        """
    def has(self) -> bool:
        """has(self: depthai.MessageQueue) -> bool

        Check whether front of the queue has message of type T

        Returns:
            True if queue isn't empty and the first element is of type T, false
            otherwise
        """
    def isClosed(self) -> bool:
        """isClosed(self: depthai.MessageQueue) -> bool

        Check whether queue is closed
        """
    def isFull(self) -> int:
        """isFull(self: depthai.MessageQueue) -> int

        Gets whether queue is full

        Returns:
            True if queue is full, false otherwise
        """
    def removeCallback(self, callbackId: int) -> bool:
        """removeCallback(self: depthai.MessageQueue, callbackId: int) -> bool

        Removes a callback

        Parameter ``callbackId``:
            Id of callback to be removed

        Returns:
            True if callback was removed, false otherwise
        """
    @overload
    def send(self, msg: ADatatype) -> None:
        """send(*args, **kwargs)
        Overloaded function.

        1. send(self: depthai.MessageQueue, msg: depthai.ADatatype) -> None

        Adds a message to the queue, which will be picked up and sent to the device. Can
        either block if 'blocking' behavior is true or overwrite oldest

        Parameter ``msg``:
            Message to add to the queue

        2. send(self: depthai.MessageQueue, msg: depthai.ADatatype, timeout: datetime.timedelta) -> bool

        Adds a message to the queue, which will be picked up and sent to the device. Can
        either block if 'blocking' behavior is true or overwrite oldest

        Parameter ``msg``:
            Message to add to the queue
        """
    @overload
    def send(self, msg: ADatatype, timeout: datetime.timedelta) -> bool:
        """send(*args, **kwargs)
        Overloaded function.

        1. send(self: depthai.MessageQueue, msg: depthai.ADatatype) -> None

        Adds a message to the queue, which will be picked up and sent to the device. Can
        either block if 'blocking' behavior is true or overwrite oldest

        Parameter ``msg``:
            Message to add to the queue

        2. send(self: depthai.MessageQueue, msg: depthai.ADatatype, timeout: datetime.timedelta) -> bool

        Adds a message to the queue, which will be picked up and sent to the device. Can
        either block if 'blocking' behavior is true or overwrite oldest

        Parameter ``msg``:
            Message to add to the queue
        """
    def setBlocking(self, blocking: bool) -> None:
        """setBlocking(self: depthai.MessageQueue, blocking: bool) -> None

        Sets queue behavior when full (maxSize)

        Parameter ``blocking``:
            Specifies if block or overwrite the oldest message in the queue
        """
    def setMaxSize(self, maxSize: int) -> None:
        """setMaxSize(self: depthai.MessageQueue, maxSize: int) -> None

        Sets queue maximum size

        Parameter ``maxSize``:
            Specifies maximum number of messages in the queue @note If maxSize is
            smaller than size, queue will not be truncated immediately, only after
            messages are popped
        """
    def setName(self, name: str) -> None:
        """setName(self: depthai.MessageQueue, name: str) -> None

        Set the name of the queue
        """
    def tryGet(self) -> ADatatype:
        """tryGet(self: depthai.MessageQueue) -> depthai.ADatatype

        Try to retrieve message T from queue. If message isn't of type T it returns
        nullptr

        Returns:
            Message of type T or nullptr if no message available
        """
    def tryGetAll(self) -> list[ADatatype]:
        """tryGetAll(self: depthai.MessageQueue) -> list[depthai.ADatatype]

        Try to retrieve all messages in the queue.

        Returns:
            Vector of messages which can either be of type T or nullptr
        """
    def trySend(self, msg: ADatatype) -> bool:
        """trySend(self: depthai.MessageQueue, msg: depthai.ADatatype) -> bool

        Tries sending a message

        Parameter ``msg``:
            message to send
        """

class ModelType:
    __members__: ClassVar[dict] = ...  # read-only
    BLOB: ClassVar[ModelType] = ...
    DLC: ClassVar[ModelType] = ...
    NNARCHIVE: ClassVar[ModelType] = ...
    OTHER: ClassVar[ModelType] = ...
    SUPERBLOB: ClassVar[ModelType] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.ModelType, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.ModelType) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.ModelType) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class MonoCameraProperties:
    class SensorResolution:
        __members__: ClassVar[dict] = ...  # read-only
        THE_1200_P: ClassVar[MonoCameraProperties.SensorResolution] = ...
        THE_4000X3000: ClassVar[MonoCameraProperties.SensorResolution] = ...
        THE_400_P: ClassVar[MonoCameraProperties.SensorResolution] = ...
        THE_4224X3136: ClassVar[MonoCameraProperties.SensorResolution] = ...
        THE_480_P: ClassVar[MonoCameraProperties.SensorResolution] = ...
        THE_720_P: ClassVar[MonoCameraProperties.SensorResolution] = ...
        THE_800_P: ClassVar[MonoCameraProperties.SensorResolution] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.MonoCameraProperties.SensorResolution, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.MonoCameraProperties.SensorResolution) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.MonoCameraProperties.SensorResolution) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    boardSocket: CameraBoardSocket
    eventFilter: list[FrameEvent]
    fps: float
    initialControl: CameraControl
    isp3aFps: int
    numFramesPool: int
    numFramesPoolRaw: int
    resolution: MonoCameraProperties.SensorResolution
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class NNArchive:
    @overload
    def __init__(self, archivePath: str, compression: NNArchiveEntry.Compression = ..., extractFolder: str = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.NNArchive, archivePath: str, compression: depthai.NNArchiveEntry.Compression = <Compression.???: 0>, extractFolder: str = '/tmp/') -> None

        Construct a new NNArchive object - a container holding a model and its
        configuration

        Parameter ``archivePath:``:
            Path to the archive file

        Parameter ``options:``:
            Archive options such as compression, number of shaves, etc. See
            NNArchiveOptions.

        2. __init__(self: depthai.NNArchive, archivePath: str, options: depthai.NNArchiveOptions = <depthai.NNArchiveOptions object at 0x7fff416c4670>) -> None

        Construct a new NNArchive object - a container holding a model and its
        configuration

        Parameter ``archivePath:``:
            Path to the archive file

        Parameter ``options:``:
            Archive options such as compression, number of shaves, etc. See
            NNArchiveOptions.
        """
    @overload
    def __init__(self, archivePath: str, options: NNArchiveOptions = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.NNArchive, archivePath: str, compression: depthai.NNArchiveEntry.Compression = <Compression.???: 0>, extractFolder: str = '/tmp/') -> None

        Construct a new NNArchive object - a container holding a model and its
        configuration

        Parameter ``archivePath:``:
            Path to the archive file

        Parameter ``options:``:
            Archive options such as compression, number of shaves, etc. See
            NNArchiveOptions.

        2. __init__(self: depthai.NNArchive, archivePath: str, options: depthai.NNArchiveOptions = <depthai.NNArchiveOptions object at 0x7fff416c4670>) -> None

        Construct a new NNArchive object - a container holding a model and its
        configuration

        Parameter ``archivePath:``:
            Path to the archive file

        Parameter ``options:``:
            Archive options such as compression, number of shaves, etc. See
            NNArchiveOptions.
        """
    def getBlob(self) -> OpenVINO.Blob | None:
        """getBlob(self: depthai.NNArchive) -> Optional[depthai.OpenVINO.Blob]

        Return a SuperVINO::Blob from the archive if getModelType() returns BLOB,
        nothing otherwise

        Returns:
            std::optional<OpenVINO::Blob>: Model blob
        """
    def getConfig(self) -> nn_archive.v1.Config:
        """getConfig(self: depthai.NNArchive) -> Union[depthai.nn_archive.v1.Config]

        Get NNArchive config.

        Template parameter ``T:``:
            Type of config to get

        Returns:
            const T&: Config
        """
    def getConfigV1(self) -> nn_archive.v1.Config:
        """getConfigV1(self: depthai.NNArchive) -> depthai.nn_archive.v1.Config

        Get NNArchive config.

        Template parameter ``T:``:
            Type of config to get

        Returns:
            const T&: Config
        """
    def getInputHeight(self, index: int = ...) -> int | None:
        """getInputHeight(self: depthai.NNArchive, index: int = 0) -> Optional[int]

        Get inputHeight of the model

        Parameter ``index:``:
            Index of input

        Returns:
            int: inputHeight
        """
    def getInputSize(self, index: int = ...) -> tuple[int, int] | None:
        """getInputSize(self: depthai.NNArchive, index: int = 0) -> Optional[tuple[int, int]]

        Get inputSize of the model

        Parameter ``index:``:
            Index of input @note this function is only valid for models with NCHW and
            NHWC input formats

        Returns:
            std::vector<std::pair<int, int>>: inputSize
        """
    def getInputWidth(self, index: int = ...) -> int | None:
        """getInputWidth(self: depthai.NNArchive, index: int = 0) -> Optional[int]

        Get inputWidth of the model

        Parameter ``index:``:
            Index of input

        Returns:
            int: inputWidth
        """
    def getModelPath(self) -> str | None:
        """getModelPath(self: depthai.NNArchive) -> Optional[str]

        Return a path to the model inside the archive if getModelType() returns OTHER or
        DLC, nothing otherwise

        Returns:
            std::optional<std::string>: Model path
        """
    def getModelType(self) -> ModelType:
        """getModelType(self: depthai.NNArchive) -> depthai.ModelType

        Get type of model contained in NNArchive

        Returns:
            model::ModelType: type of model in archive
        """
    def getSuperBlob(self) -> OpenVINO.SuperBlob | None:
        """getSuperBlob(self: depthai.NNArchive) -> Optional[depthai.OpenVINO.SuperBlob]

        Return a SuperVINO::Blob from the archive if getModelType() returns BLOB,
        nothing otherwise

        Returns:
            std::optional<OpenVINO::Blob>: Model blob
        """
    def getSupportedPlatforms(self) -> list[Platform]:
        """getSupportedPlatforms(self: depthai.NNArchive) -> list[depthai.Platform]

        Get supported platforms

        Returns:
            std::vector<dai::Platform>: Supported platforms
        """

class NNArchiveConfigVersion:
    __members__: ClassVar[dict] = ...  # read-only
    V1: ClassVar[NNArchiveConfigVersion] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.NNArchiveConfigVersion, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.NNArchiveConfigVersion) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.NNArchiveConfigVersion) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class NNArchiveEntry:
    class Compression:
        __members__: ClassVar[dict] = ...  # read-only
        AUTO: ClassVar[NNArchiveEntry.Compression] = ...
        RAW_FS: ClassVar[NNArchiveEntry.Compression] = ...
        TAR: ClassVar[NNArchiveEntry.Compression] = ...
        TAR_GZ: ClassVar[NNArchiveEntry.Compression] = ...
        TAR_XZ: ClassVar[NNArchiveEntry.Compression] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.NNArchiveEntry.Compression, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.NNArchiveEntry.Compression) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.NNArchiveEntry.Compression) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class Seek:
        __members__: ClassVar[dict] = ...  # read-only
        CUR: ClassVar[NNArchiveEntry.Seek] = ...
        END: ClassVar[NNArchiveEntry.Seek] = ...
        SET: ClassVar[NNArchiveEntry.Seek] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.NNArchiveEntry.Seek, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.NNArchiveEntry.Seek) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.NNArchiveEntry.Seek) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class NNArchiveOptions:
    compression: NNArchiveEntry.Compression
    extractFolder: str
    def __init__(self) -> None:
        """__init__(self: depthai.NNArchiveOptions) -> None"""

class NNArchiveVersionedConfig:
    @overload
    def __init__(self, path: Path, compression: NNArchiveEntry.Compression = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.NNArchiveVersionedConfig, path: Path, compression: depthai.NNArchiveEntry.Compression = <Compression.???: 0>) -> None

        @data Should point to a whole compressed NNArchive read to memory if compression
        is not set to RAW_FS. If compression is set to RAW_FS, then this should point to
        just the config.json file read to memory.

        2. __init__(self: depthai.NNArchiveVersionedConfig, data: std::vector<unsigned char, std::allocator<unsigned char> >, compression: depthai.NNArchiveEntry.Compression = <Compression.???: 0>) -> None

        @data Should point to a whole compressed NNArchive read to memory if compression
        is not set to RAW_FS. If compression is set to RAW_FS, then this should point to
        just the config.json file read to memory.

        3. __init__(self: depthai.NNArchiveVersionedConfig, arg0: Callable[[], int], arg1: Callable[[], std::vector<unsigned char, std::allocator<unsigned char> >], arg2: Callable[[int, depthai.NNArchiveEntry.Seek], int], arg3: Callable[[int], int], arg4: Callable[[], int], arg5: depthai.NNArchiveEntry.Compression) -> None
        """
    @overload
    def __init__(self, data, std, compression: NNArchiveEntry.Compression = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.NNArchiveVersionedConfig, path: Path, compression: depthai.NNArchiveEntry.Compression = <Compression.???: 0>) -> None

        @data Should point to a whole compressed NNArchive read to memory if compression
        is not set to RAW_FS. If compression is set to RAW_FS, then this should point to
        just the config.json file read to memory.

        2. __init__(self: depthai.NNArchiveVersionedConfig, data: std::vector<unsigned char, std::allocator<unsigned char> >, compression: depthai.NNArchiveEntry.Compression = <Compression.???: 0>) -> None

        @data Should point to a whole compressed NNArchive read to memory if compression
        is not set to RAW_FS. If compression is set to RAW_FS, then this should point to
        just the config.json file read to memory.

        3. __init__(self: depthai.NNArchiveVersionedConfig, arg0: Callable[[], int], arg1: Callable[[], std::vector<unsigned char, std::allocator<unsigned char> >], arg2: Callable[[int, depthai.NNArchiveEntry.Seek], int], arg3: Callable[[int], int], arg4: Callable[[], int], arg5: depthai.NNArchiveEntry.Compression) -> None
        """
    @overload
    def __init__(self, arg0: Callable[[], int], arg1, arg2: Callable[[int, NNArchiveEntry.Seek], int], arg3: Callable[[int], int], arg4: Callable[[], int], arg5: NNArchiveEntry.Compression) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.NNArchiveVersionedConfig, path: Path, compression: depthai.NNArchiveEntry.Compression = <Compression.???: 0>) -> None

        @data Should point to a whole compressed NNArchive read to memory if compression
        is not set to RAW_FS. If compression is set to RAW_FS, then this should point to
        just the config.json file read to memory.

        2. __init__(self: depthai.NNArchiveVersionedConfig, data: std::vector<unsigned char, std::allocator<unsigned char> >, compression: depthai.NNArchiveEntry.Compression = <Compression.???: 0>) -> None

        @data Should point to a whole compressed NNArchive read to memory if compression
        is not set to RAW_FS. If compression is set to RAW_FS, then this should point to
        just the config.json file read to memory.

        3. __init__(self: depthai.NNArchiveVersionedConfig, arg0: Callable[[], int], arg1: Callable[[], std::vector<unsigned char, std::allocator<unsigned char> >], arg2: Callable[[int, depthai.NNArchiveEntry.Seek], int], arg3: Callable[[int], int], arg4: Callable[[], int], arg5: depthai.NNArchiveEntry.Compression) -> None
        """
    def getConfig(self) -> nn_archive.v1.Config:
        """getConfig(self: depthai.NNArchiveVersionedConfig) -> Union[depthai.nn_archive.v1.Config]

        Get stored config cast to a specific version.

        Template parameter ``T:``:
            Config type to cast to.
        """
    def getConfigV1(self) -> nn_archive.v1.Config:
        """getConfigV1(self: depthai.NNArchiveVersionedConfig) -> depthai.nn_archive.v1.Config

        Get stored config cast to a specific version.

        Template parameter ``T:``:
            Config type to cast to.
        """
    def getVersion(self) -> NNArchiveConfigVersion:
        """getVersion(self: depthai.NNArchiveVersionedConfig) -> depthai.NNArchiveConfigVersion

        Get version of the underlying config.
        """

class NNData(Buffer):
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.NNData) -> None

        Construct NNData message.

        2. __init__(self: depthai.NNData, arg0: int) -> None
        """
    @overload
    def __init__(self, arg0: int) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.NNData) -> None

        Construct NNData message.

        2. __init__(self: depthai.NNData, arg0: int) -> None
        """
    @overload
    def addTensor(self, name: str, tensor: list[int], storageOrder: TensorInfo.StorageOrder) -> NNData:
        """addTensor(*args, **kwargs)
        Overloaded function.

        1. addTensor(self: depthai.NNData, name: str, tensor: list[int], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        2. addTensor(self: depthai.NNData, name: str, tensor: list[float], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        3. addTensor(self: depthai.NNData, name: str, tensor: list[float], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        4. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.int32], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        5. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.float32], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        6. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.float64], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        7. addTensor(self: depthai.NNData, name: str, tensor: object, dataType: depthai.TensorInfo.DataType) -> None

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        8. addTensor(self: depthai.NNData, name: str, tensor: object) -> None
        """
    @overload
    def addTensor(self, name: str, tensor: list[float], storageOrder: TensorInfo.StorageOrder) -> NNData:
        """addTensor(*args, **kwargs)
        Overloaded function.

        1. addTensor(self: depthai.NNData, name: str, tensor: list[int], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        2. addTensor(self: depthai.NNData, name: str, tensor: list[float], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        3. addTensor(self: depthai.NNData, name: str, tensor: list[float], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        4. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.int32], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        5. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.float32], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        6. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.float64], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        7. addTensor(self: depthai.NNData, name: str, tensor: object, dataType: depthai.TensorInfo.DataType) -> None

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        8. addTensor(self: depthai.NNData, name: str, tensor: object) -> None
        """
    @overload
    def addTensor(self, name: str, tensor: list[float], storageOrder: TensorInfo.StorageOrder) -> NNData:
        """addTensor(*args, **kwargs)
        Overloaded function.

        1. addTensor(self: depthai.NNData, name: str, tensor: list[int], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        2. addTensor(self: depthai.NNData, name: str, tensor: list[float], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        3. addTensor(self: depthai.NNData, name: str, tensor: list[float], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        4. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.int32], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        5. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.float32], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        6. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.float64], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        7. addTensor(self: depthai.NNData, name: str, tensor: object, dataType: depthai.TensorInfo.DataType) -> None

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        8. addTensor(self: depthai.NNData, name: str, tensor: object) -> None
        """
    @overload
    def addTensor(self, name: str, tensor: numpy.ndarray[numpy.int32], storageOrder: TensorInfo.StorageOrder) -> NNData:
        """addTensor(*args, **kwargs)
        Overloaded function.

        1. addTensor(self: depthai.NNData, name: str, tensor: list[int], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        2. addTensor(self: depthai.NNData, name: str, tensor: list[float], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        3. addTensor(self: depthai.NNData, name: str, tensor: list[float], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        4. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.int32], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        5. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.float32], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        6. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.float64], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        7. addTensor(self: depthai.NNData, name: str, tensor: object, dataType: depthai.TensorInfo.DataType) -> None

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        8. addTensor(self: depthai.NNData, name: str, tensor: object) -> None
        """
    @overload
    def addTensor(self, name: str, tensor: numpy.ndarray[numpy.float32], storageOrder: TensorInfo.StorageOrder) -> NNData:
        """addTensor(*args, **kwargs)
        Overloaded function.

        1. addTensor(self: depthai.NNData, name: str, tensor: list[int], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        2. addTensor(self: depthai.NNData, name: str, tensor: list[float], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        3. addTensor(self: depthai.NNData, name: str, tensor: list[float], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        4. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.int32], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        5. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.float32], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        6. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.float64], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        7. addTensor(self: depthai.NNData, name: str, tensor: object, dataType: depthai.TensorInfo.DataType) -> None

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        8. addTensor(self: depthai.NNData, name: str, tensor: object) -> None
        """
    @overload
    def addTensor(self, name: str, tensor: numpy.ndarray[numpy.float64], storageOrder: TensorInfo.StorageOrder) -> NNData:
        """addTensor(*args, **kwargs)
        Overloaded function.

        1. addTensor(self: depthai.NNData, name: str, tensor: list[int], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        2. addTensor(self: depthai.NNData, name: str, tensor: list[float], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        3. addTensor(self: depthai.NNData, name: str, tensor: list[float], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        4. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.int32], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        5. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.float32], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        6. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.float64], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        7. addTensor(self: depthai.NNData, name: str, tensor: object, dataType: depthai.TensorInfo.DataType) -> None

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        8. addTensor(self: depthai.NNData, name: str, tensor: object) -> None
        """
    @overload
    def addTensor(self, name: str, tensor: object, dataType: TensorInfo.DataType) -> None:
        """addTensor(*args, **kwargs)
        Overloaded function.

        1. addTensor(self: depthai.NNData, name: str, tensor: list[int], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        2. addTensor(self: depthai.NNData, name: str, tensor: list[float], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        3. addTensor(self: depthai.NNData, name: str, tensor: list[float], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        4. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.int32], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        5. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.float32], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        6. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.float64], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        7. addTensor(self: depthai.NNData, name: str, tensor: object, dataType: depthai.TensorInfo.DataType) -> None

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        8. addTensor(self: depthai.NNData, name: str, tensor: object) -> None
        """
    @overload
    def addTensor(self, name: str, tensor: object) -> None:
        """addTensor(*args, **kwargs)
        Overloaded function.

        1. addTensor(self: depthai.NNData, name: str, tensor: list[int], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        2. addTensor(self: depthai.NNData, name: str, tensor: list[float], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        3. addTensor(self: depthai.NNData, name: str, tensor: list[float], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        4. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.int32], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        5. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.float32], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        6. addTensor(self: depthai.NNData, name: str, tensor: numpy.ndarray[numpy.float64], storageOrder: depthai.TensorInfo.StorageOrder) -> depthai.NNData

        7. addTensor(self: depthai.NNData, name: str, tensor: object, dataType: depthai.TensorInfo.DataType) -> None

        Add a tensor to this NNData object. The provided array is stored as a 1xN tensor
        where N is the length of the array.

        Parameter ``name:``:
            Name of the tensor

        Parameter ``data:``:
            array

        Returns:
            NNData&: reference to this object

        8. addTensor(self: depthai.NNData, name: str, tensor: object) -> None
        """
    def getAllLayerNames(self) -> list[str]:
        """getAllLayerNames(self: depthai.NNData) -> list[str]

        Returns:
            Names of all layers added
        """
    def getAllLayers(self) -> list[TensorInfo]:
        """getAllLayers(self: depthai.NNData) -> list[depthai.TensorInfo]

        Returns:
            All layers and their information
        """
    @overload
    def getFirstTensor(self, dequantize: bool = ...) -> object:
        """getFirstTensor(*args, **kwargs)
        Overloaded function.

        1. getFirstTensor(self: depthai.NNData, dequantize: bool = False) -> object

        Convenience function to retrieve values from the first tensor

        Returns:
            xt::xarray<_Ty> tensor

        2. getFirstTensor(self: depthai.NNData, storageOrder: depthai.TensorInfo.StorageOrder, dequantize: bool = False) -> object

        Convenience function to retrieve values from the first tensor

        Returns:
            xt::xarray<_Ty> tensor
        """
    @overload
    def getFirstTensor(self, storageOrder: TensorInfo.StorageOrder, dequantize: bool = ...) -> object:
        """getFirstTensor(*args, **kwargs)
        Overloaded function.

        1. getFirstTensor(self: depthai.NNData, dequantize: bool = False) -> object

        Convenience function to retrieve values from the first tensor

        Returns:
            xt::xarray<_Ty> tensor

        2. getFirstTensor(self: depthai.NNData, storageOrder: depthai.TensorInfo.StorageOrder, dequantize: bool = False) -> object

        Convenience function to retrieve values from the first tensor

        Returns:
            xt::xarray<_Ty> tensor
        """
    def getLayerDatatype(self, name: str, datatype: TensorInfo.DataType) -> bool:
        """getLayerDatatype(self: depthai.NNData, name: str, datatype: depthai.TensorInfo.DataType) -> bool

        Retrieve datatype of a layers tensor

        Parameter ``name``:
            Name of the layer

        Parameter ``datatype``:
            Datatype of layers tensor

        Returns:
            True if layer exists, false otherwise
        """
    def getSequenceNum(self) -> int:
        """getSequenceNum(self: depthai.NNData) -> int

        Retrieves image sequence number
        """
    @overload
    def getTensor(self, name: str, dequantize: bool = ...) -> object:
        """getTensor(*args, **kwargs)
        Overloaded function.

        1. getTensor(self: depthai.NNData, name: str, dequantize: bool = False) -> object

        Convenience function to retrieve values from a tensor

        Returns:
            xt::xarray<_Ty> tensor

        2. getTensor(self: depthai.NNData, name: str, storageOrder: depthai.TensorInfo.StorageOrder, dequantize: bool = False) -> object

        Convenience function to retrieve values from a tensor

        Returns:
            xt::xarray<_Ty> tensor
        """
    @overload
    def getTensor(self, name: str, storageOrder: TensorInfo.StorageOrder, dequantize: bool = ...) -> object:
        """getTensor(*args, **kwargs)
        Overloaded function.

        1. getTensor(self: depthai.NNData, name: str, dequantize: bool = False) -> object

        Convenience function to retrieve values from a tensor

        Returns:
            xt::xarray<_Ty> tensor

        2. getTensor(self: depthai.NNData, name: str, storageOrder: depthai.TensorInfo.StorageOrder, dequantize: bool = False) -> object

        Convenience function to retrieve values from a tensor

        Returns:
            xt::xarray<_Ty> tensor
        """
    def getTensorDatatype(self, name: str) -> TensorInfo.DataType:
        """getTensorDatatype(self: depthai.NNData, name: str) -> depthai.TensorInfo.DataType

        Get the datatype of a given tensor

        Returns:
            TensorInfo::DataType tensor datatype
        """
    def getTensorInfo(self, name: str) -> TensorInfo | None:
        """getTensorInfo(self: depthai.NNData, name: str) -> Optional[depthai.TensorInfo]

        Retrieve tensor information

        Parameter ``name``:
            Name of the tensor

        Returns:
            Tensor information
        """
    def getTimestamp(self) -> datetime.timedelta:
        """getTimestamp(self: depthai.NNData) -> datetime.timedelta

        Retrieves timestamp related to dai::Clock::now()
        """
    def getTimestampDevice(self) -> datetime.timedelta:
        """getTimestampDevice(self: depthai.NNData) -> datetime.timedelta

        Retrieves timestamp directly captured from device's monotonic clock, not
        synchronized to host time. Used mostly for debugging
        """
    def getTransformation(self) -> ImgTransformation | None:
        """getTransformation(self: depthai.NNData) -> Optional[depthai.ImgTransformation]"""
    def hasLayer(self, name: str) -> bool:
        """hasLayer(self: depthai.NNData, name: str) -> bool

        Checks if given layer exists

        Parameter ``name``:
            Name of the layer

        Returns:
            True if layer exists, false otherwise
        """
    def setTransformation(self, arg0: ImgTransformation | None) -> None:
        """setTransformation(self: depthai.NNData, arg0: Optional[depthai.ImgTransformation]) -> None"""

class NNModelDescription:
    compressionLevel: str
    model: str
    modelPrecisionType: str
    optimizationLevel: str
    platform: str
    snpeVersion: str
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.NNModelDescription) -> None

        2. __init__(self: depthai.NNModelDescription, model: str, platform: str = '', optimizationLevel: str = '', compressionLevel: str = '', snpeVersion: str = '', modelPrecisionType: str = '') -> None

        3. __init__(self: depthai.NNModelDescription, modelSlug: str, platform: str = '', modelVersionSlug: str = '', modelInstanceHash: str = '', optimizationLevel: str = '', compressionLevel: str = '', teamName: str = '', snpeVersion: str = '', modelPrecisionType: str = '') -> None

        4. __init__(self: depthai.NNModelDescription, model: str) -> None
        """
    @overload
    def __init__(self, model: str, platform: str = ..., optimizationLevel: str = ..., compressionLevel: str = ..., snpeVersion: str = ..., modelPrecisionType: str = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.NNModelDescription) -> None

        2. __init__(self: depthai.NNModelDescription, model: str, platform: str = '', optimizationLevel: str = '', compressionLevel: str = '', snpeVersion: str = '', modelPrecisionType: str = '') -> None

        3. __init__(self: depthai.NNModelDescription, modelSlug: str, platform: str = '', modelVersionSlug: str = '', modelInstanceHash: str = '', optimizationLevel: str = '', compressionLevel: str = '', teamName: str = '', snpeVersion: str = '', modelPrecisionType: str = '') -> None

        4. __init__(self: depthai.NNModelDescription, model: str) -> None
        """
    @overload
    def __init__(self, modelSlug: str, platform: str = ..., modelVersionSlug: str = ..., modelInstanceHash: str = ..., optimizationLevel: str = ..., compressionLevel: str = ..., teamName: str = ..., snpeVersion: str = ..., modelPrecisionType: str = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.NNModelDescription) -> None

        2. __init__(self: depthai.NNModelDescription, model: str, platform: str = '', optimizationLevel: str = '', compressionLevel: str = '', snpeVersion: str = '', modelPrecisionType: str = '') -> None

        3. __init__(self: depthai.NNModelDescription, modelSlug: str, platform: str = '', modelVersionSlug: str = '', modelInstanceHash: str = '', optimizationLevel: str = '', compressionLevel: str = '', teamName: str = '', snpeVersion: str = '', modelPrecisionType: str = '') -> None

        4. __init__(self: depthai.NNModelDescription, model: str) -> None
        """
    @overload
    def __init__(self, model: str) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.NNModelDescription) -> None

        2. __init__(self: depthai.NNModelDescription, model: str, platform: str = '', optimizationLevel: str = '', compressionLevel: str = '', snpeVersion: str = '', modelPrecisionType: str = '') -> None

        3. __init__(self: depthai.NNModelDescription, modelSlug: str, platform: str = '', modelVersionSlug: str = '', modelInstanceHash: str = '', optimizationLevel: str = '', compressionLevel: str = '', teamName: str = '', snpeVersion: str = '', modelPrecisionType: str = '') -> None

        4. __init__(self: depthai.NNModelDescription, model: str) -> None
        """
    @staticmethod
    def fromYamlFile(yamlPath: str) -> NNModelDescription:
        """fromYamlFile(yamlPath: str) -> depthai.NNModelDescription

        Initialize NNModelDescription from yaml file

        Parameter ``yamlPath:``:
            Path to yaml file

        Returns:
            NNModelDescription
        """
    def saveToYamlFile(self, yamlPath: str) -> None:
        """saveToYamlFile(self: depthai.NNModelDescription, yamlPath: str) -> None

        Save NNModelDescription to yaml file

        Parameter ``yamlPath:``:
            Path to yaml file
        """
    def toString(self) -> str:
        """toString(self: depthai.NNModelDescription) -> str

        Convert NNModelDescription to string for printing purposes. This can be used for
        debugging.

        Returns:
            std::string: String representation
        """

class NeuralNetworkProperties:
    blobSize: int | None
    blobUri: str
    numFrames: int
    numNCEPerThread: int
    numThreads: int
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class Node:
    class Connection:
        inputGroup: str
        inputId: int
        inputName: str
        outputGroup: str
        outputId: int
        outputName: str
        def __init__(self, *args, **kwargs) -> None:
            """Initialize self.  See help(type(self)) for accurate signature."""

    class DatatypeHierarchy:
        datatype: DatatypeEnum
        descendants: bool
        def __init__(self, arg0: DatatypeEnum, arg1: bool) -> None:
            """__init__(self: depthai.Node.DatatypeHierarchy, arg0: depthai.DatatypeEnum, arg1: bool) -> None"""

    class Id:
        def __init__(self, *args, **kwargs) -> None:
            """Initialize self.  See help(type(self)) for accurate signature."""

    class Input(MessageQueue):
        class Type:
            __members__: ClassVar[dict] = ...  # read-only
            MReceiver: ClassVar[Node.Input.Type] = ...
            SReceiver: ClassVar[Node.Input.Type] = ...
            __entries: ClassVar[dict] = ...
            def __init__(self, value: int) -> None:
                """__init__(self: depthai.Node.Input.Type, value: int) -> None"""
            def __eq__(self, other: object) -> bool:
                """__eq__(self: object, other: object) -> bool"""
            def __hash__(self) -> int:
                """__hash__(self: object) -> int"""
            def __index__(self) -> int:
                """__index__(self: depthai.Node.Input.Type) -> int"""
            def __int__(self) -> int:
                """__int__(self: depthai.Node.Input.Type) -> int"""
            def __ne__(self, other: object) -> bool:
                """__ne__(self: object, other: object) -> bool"""
            @property
            def name(self) -> str: ...
            @property
            def value(self) -> int: ...
        possibleDatatypes: list[Node.DatatypeHierarchy]
        def __init__(self, parent: Node, name: str = ..., group: str = ..., blocking: bool = ..., queueSize: int = ..., types: list[Node.DatatypeHierarchy] = ..., waitForMessage: bool = ...) -> None:
            """__init__(self: depthai.Node.Input, parent: depthai.Node, name: str = '', group: str = '', blocking: bool = True, queueSize: int = 3, types: list[depthai.Node.DatatypeHierarchy] = [<depthai.Node.DatatypeHierarchy object at 0x7fff41591770>], waitForMessage: bool = False) -> None"""
        def createInputQueue(self, maxSize: int = ..., blocking: bool = ...) -> InputQueue:
            """createInputQueue(self: depthai.Node.Input, maxSize: int = 16, blocking: bool = False) -> depthai.InputQueue

            Create an shared pointer to an input queue that can be used to send messages to
            this input from onhost

            Parameter ``maxSize:``:
                Maximum size of the input queue

            Parameter ``blocking:``:
                Whether the input queue should block when full

            Returns:
                std::shared_ptr<InputQueue>: shared pointer to an input queue
            """
        @overload
        def getParent(self) -> Node:
            """getParent(*args, **kwargs)
            Overloaded function.

            1. getParent(self: depthai.Node.Input) -> depthai.Node

            Get the parent node

            2. getParent(self: depthai.Node.Input) -> depthai.Node

            Get the parent node
            """
        @overload
        def getParent(self) -> Node:
            """getParent(*args, **kwargs)
            Overloaded function.

            1. getParent(self: depthai.Node.Input) -> depthai.Node

            Get the parent node

            2. getParent(self: depthai.Node.Input) -> depthai.Node

            Get the parent node
            """
        def getPossibleDatatypes(self) -> list[Node.DatatypeHierarchy]:
            """getPossibleDatatypes(self: depthai.Node.Input) -> list[depthai.Node.DatatypeHierarchy]

            Get possible datatypes that can be received
            """
        def getReusePreviousMessage(self) -> bool:
            """getReusePreviousMessage(self: depthai.Node.Input) -> bool

            Equivalent to getWaitForMessage but with inverted logic.
            """
        def getWaitForMessage(self) -> bool:
            """getWaitForMessage(self: depthai.Node.Input) -> bool

            Get behavior whether to wait for this input when a Node processes certain data
            or not

            Returns:
                Whether to wait for message to arrive to this input or not
            """
        @overload
        def setPossibleDatatypes(self, types: list[Node.DatatypeHierarchy]) -> None:
            """setPossibleDatatypes(*args, **kwargs)
            Overloaded function.

            1. setPossibleDatatypes(self: depthai.Node.Input, types: list[depthai.Node.DatatypeHierarchy]) -> None

            Set possible datatypes that can be received

            2. setPossibleDatatypes(self: depthai.Node.Input, types: list[tuple[depthai.DatatypeEnum, bool]]) -> None

            Set possible datatypes that can be received
            """
        @overload
        def setPossibleDatatypes(self, types: list[tuple[DatatypeEnum, bool]]) -> None:
            """setPossibleDatatypes(*args, **kwargs)
            Overloaded function.

            1. setPossibleDatatypes(self: depthai.Node.Input, types: list[depthai.Node.DatatypeHierarchy]) -> None

            Set possible datatypes that can be received

            2. setPossibleDatatypes(self: depthai.Node.Input, types: list[tuple[depthai.DatatypeEnum, bool]]) -> None

            Set possible datatypes that can be received
            """
        def setReusePreviousMessage(self, reusePreviousMessage: bool) -> None:
            """setReusePreviousMessage(self: depthai.Node.Input, reusePreviousMessage: bool) -> None

            Equivalent to setWaitForMessage but with inverted logic.
            """
        def setWaitForMessage(self, waitForMessage: bool) -> None:
            """setWaitForMessage(self: depthai.Node.Input, waitForMessage: bool) -> None

            Overrides default wait for message behavior. Applicable for nodes with multiple
            inputs. Specifies behavior whether to wait for this input when a Node processes
            certain data or not.

            Parameter ``waitForMessage``:
                Whether to wait for message to arrive to this input or not
            """

    class InputMap:
        def __init__(self, *args, **kwargs) -> None:
            """Initialize self.  See help(type(self)) for accurate signature."""
        def items(self) -> Iterator[tuple[tuple[str, str], Node.Input]]:
            """items(self: depthai.Node.InputMap) -> Iterator[tuple[tuple[str, str], depthai.Node.Input]]"""
        def __bool__(self) -> bool:
            """__bool__(self: depthai.Node.InputMap) -> bool

            Check whether the map is nonempty
            """
        @overload
        def __contains__(self, arg0: str) -> bool:
            """__contains__(*args, **kwargs)
            Overloaded function.

            1. __contains__(self: depthai.Node.InputMap, arg0: str) -> bool

            2. __contains__(self: depthai.Node.InputMap, arg0: tuple[str, str]) -> bool
            """
        @overload
        def __contains__(self, arg0: tuple[str, str]) -> bool:
            """__contains__(*args, **kwargs)
            Overloaded function.

            1. __contains__(self: depthai.Node.InputMap, arg0: str) -> bool

            2. __contains__(self: depthai.Node.InputMap, arg0: tuple[str, str]) -> bool
            """
        @overload
        def __delitem__(self, arg0: str) -> None:
            """__delitem__(*args, **kwargs)
            Overloaded function.

            1. __delitem__(self: depthai.Node.InputMap, arg0: str) -> None

            2. __delitem__(self: depthai.Node.InputMap, arg0: tuple[str, str]) -> None
            """
        @overload
        def __delitem__(self, arg0: tuple[str, str]) -> None:
            """__delitem__(*args, **kwargs)
            Overloaded function.

            1. __delitem__(self: depthai.Node.InputMap, arg0: str) -> None

            2. __delitem__(self: depthai.Node.InputMap, arg0: tuple[str, str]) -> None
            """
        @overload
        def __getitem__(self, arg0: str) -> Node.Input:
            """__getitem__(*args, **kwargs)
            Overloaded function.

            1. __getitem__(self: depthai.Node.InputMap, arg0: str) -> depthai.Node.Input

            2. __getitem__(self: depthai.Node.InputMap, arg0: tuple[str, str]) -> depthai.Node.Input
            """
        @overload
        def __getitem__(self, arg0: tuple[str, str]) -> Node.Input:
            """__getitem__(*args, **kwargs)
            Overloaded function.

            1. __getitem__(self: depthai.Node.InputMap, arg0: str) -> depthai.Node.Input

            2. __getitem__(self: depthai.Node.InputMap, arg0: tuple[str, str]) -> depthai.Node.Input
            """
        def __iter__(self) -> Iterator[tuple[str, str]]:
            """__iter__(self: depthai.Node.InputMap) -> Iterator[tuple[str, str]]"""
        def __len__(self) -> int:
            """__len__(self: dict[tuple[str, str], depthai.Node.Input]) -> int"""
        def __setitem__(self, arg0: tuple[str, str], arg1: Node.Input) -> None:
            """__setitem__(self: depthai.Node.InputMap, arg0: tuple[str, str], arg1: depthai.Node.Input) -> None"""

    class Output:
        class Type:
            __members__: ClassVar[dict] = ...  # read-only
            MSender: ClassVar[Node.Output.Type] = ...
            SSender: ClassVar[Node.Output.Type] = ...
            __entries: ClassVar[dict] = ...
            def __init__(self, value: int) -> None:
                """__init__(self: depthai.Node.Output.Type, value: int) -> None"""
            def __eq__(self, other: object) -> bool:
                """__eq__(self: object, other: object) -> bool"""
            def __hash__(self) -> int:
                """__hash__(self: object) -> int"""
            def __index__(self) -> int:
                """__index__(self: depthai.Node.Output.Type) -> int"""
            def __int__(self) -> int:
                """__int__(self: depthai.Node.Output.Type) -> int"""
            def __ne__(self, other: object) -> bool:
                """__ne__(self: object, other: object) -> bool"""
            @property
            def name(self) -> str: ...
            @property
            def value(self) -> int: ...
        def __init__(self, parent: Node, name: str = ..., group: str = ..., possibleDatatypes: list[Node.DatatypeHierarchy] = ...) -> None:
            """__init__(self: depthai.Node.Output, parent: depthai.Node, name: str = '', group: str = '', possibleDatatypes: list[depthai.Node.DatatypeHierarchy] = [<depthai.Node.DatatypeHierarchy object at 0x7fff4169db30>]) -> None"""
        def canConnect(self, input: Node.Input) -> bool:
            """canConnect(self: depthai.Node.Output, input: depthai.Node.Input) -> bool

            Check if connection is possible

            Parameter ``in``:
                Input to connect to

            Returns:
                True if connection is possible, false otherwise
            """
        def createOutputQueue(self, maxSize: int = ..., blocking: bool = ...) -> MessageQueue:
            """createOutputQueue(self: depthai.Node.Output, maxSize: int = 16, blocking: bool = False) -> depthai.MessageQueue

            Construct and return a shared pointer to an output message queue

            Parameter ``maxSize:``:
                Maximum size of the output queue

            Parameter ``blocking:``:
                Whether the output queue should block when full

            Returns:
                std::shared_ptr<dai::MessageQueue>: shared pointer to an output queue
            """
        @overload
        def getParent(self) -> Node:
            """getParent(*args, **kwargs)
            Overloaded function.

            1. getParent(self: depthai.Node.Output) -> depthai.Node

            2. getParent(self: depthai.Node.Output) -> depthai.Node
            """
        @overload
        def getParent(self) -> Node:
            """getParent(*args, **kwargs)
            Overloaded function.

            1. getParent(self: depthai.Node.Output) -> depthai.Node

            2. getParent(self: depthai.Node.Output) -> depthai.Node
            """
        def getPossibleDatatypes(self) -> list[Node.DatatypeHierarchy]:
            """getPossibleDatatypes(self: depthai.Node.Output) -> list[depthai.Node.DatatypeHierarchy]

            Get possible datatypes that can be sent
            """
        def isSamePipeline(self, input: Node.Input) -> bool:
            """isSamePipeline(self: depthai.Node.Output, input: depthai.Node.Input) -> bool

            Check if this output and given input are on the same pipeline.

            See also:
                canConnect for checking if connection is possible

            Returns:
                True if output and input are on the same pipeline
            """
        def link(self, input: Node.Input) -> None:
            """link(self: depthai.Node.Output, input: depthai.Node.Input) -> None"""
        def send(self, msg: ADatatype) -> None:
            """send(self: depthai.Node.Output, msg: depthai.ADatatype) -> None

            Sends a Message to all connected inputs

            Parameter ``msg``:
                Message to send to all connected inputs
            """
        @overload
        def setPossibleDatatypes(self, types: list[Node.DatatypeHierarchy]) -> None:
            """setPossibleDatatypes(*args, **kwargs)
            Overloaded function.

            1. setPossibleDatatypes(self: depthai.Node.Output, types: list[depthai.Node.DatatypeHierarchy]) -> None

            Set possible datatypes that can be sent

            2. setPossibleDatatypes(self: depthai.Node.Output, types: list[tuple[depthai.DatatypeEnum, bool]]) -> None

            Set possible datatypes that can be sent
            """
        @overload
        def setPossibleDatatypes(self, types: list[tuple[DatatypeEnum, bool]]) -> None:
            """setPossibleDatatypes(*args, **kwargs)
            Overloaded function.

            1. setPossibleDatatypes(self: depthai.Node.Output, types: list[depthai.Node.DatatypeHierarchy]) -> None

            Set possible datatypes that can be sent

            2. setPossibleDatatypes(self: depthai.Node.Output, types: list[tuple[depthai.DatatypeEnum, bool]]) -> None

            Set possible datatypes that can be sent
            """
        def trySend(self, msg: ADatatype) -> bool:
            """trySend(self: depthai.Node.Output, msg: depthai.ADatatype) -> bool

            Try sending a message to all connected inputs

            Parameter ``msg``:
                Message to send to all connected inputs

            Returns:
                True if ALL connected inputs got the message, false otherwise
            """
        def unlink(self, input: Node.Input) -> None:
            """unlink(self: depthai.Node.Output, input: depthai.Node.Input) -> None"""

    class OutputMap:
        def __init__(self, *args, **kwargs) -> None:
            """Initialize self.  See help(type(self)) for accurate signature."""
        def items(self) -> Iterator[tuple[tuple[str, str], Node.Output]]:
            """items(self: depthai.Node.OutputMap) -> Iterator[tuple[tuple[str, str], depthai.Node.Output]]"""
        def __bool__(self) -> bool:
            """__bool__(self: depthai.Node.OutputMap) -> bool

            Check whether the map is nonempty
            """
        @overload
        def __contains__(self, arg0: str) -> bool:
            """__contains__(*args, **kwargs)
            Overloaded function.

            1. __contains__(self: depthai.Node.OutputMap, arg0: str) -> bool

            2. __contains__(self: depthai.Node.OutputMap, arg0: tuple[str, str]) -> bool
            """
        @overload
        def __contains__(self, arg0: tuple[str, str]) -> bool:
            """__contains__(*args, **kwargs)
            Overloaded function.

            1. __contains__(self: depthai.Node.OutputMap, arg0: str) -> bool

            2. __contains__(self: depthai.Node.OutputMap, arg0: tuple[str, str]) -> bool
            """
        @overload
        def __delitem__(self, arg0: str) -> None:
            """__delitem__(*args, **kwargs)
            Overloaded function.

            1. __delitem__(self: depthai.Node.OutputMap, arg0: str) -> None

            2. __delitem__(self: depthai.Node.OutputMap, arg0: tuple[str, str]) -> None
            """
        @overload
        def __delitem__(self, arg0: tuple[str, str]) -> None:
            """__delitem__(*args, **kwargs)
            Overloaded function.

            1. __delitem__(self: depthai.Node.OutputMap, arg0: str) -> None

            2. __delitem__(self: depthai.Node.OutputMap, arg0: tuple[str, str]) -> None
            """
        @overload
        def __getitem__(self, arg0: str) -> Node.Output:
            """__getitem__(*args, **kwargs)
            Overloaded function.

            1. __getitem__(self: depthai.Node.OutputMap, arg0: str) -> depthai.Node.Output

            2. __getitem__(self: depthai.Node.OutputMap, arg0: tuple[str, str]) -> depthai.Node.Output
            """
        @overload
        def __getitem__(self, arg0: tuple[str, str]) -> Node.Output:
            """__getitem__(*args, **kwargs)
            Overloaded function.

            1. __getitem__(self: depthai.Node.OutputMap, arg0: str) -> depthai.Node.Output

            2. __getitem__(self: depthai.Node.OutputMap, arg0: tuple[str, str]) -> depthai.Node.Output
            """
        def __iter__(self) -> Iterator[tuple[str, str]]:
            """__iter__(self: depthai.Node.OutputMap) -> Iterator[tuple[str, str]]"""
        def __len__(self) -> int:
            """__len__(self: dict[tuple[str, str], depthai.Node.Output]) -> int"""
        def __setitem__(self, arg0: tuple[str, str], arg1: Node.Output) -> None:
            """__setitem__(self: depthai.Node.OutputMap, arg0: tuple[str, str], arg1: depthai.Node.Output) -> None"""
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    @overload
    def getAssetManager(self) -> AssetManager:
        """getAssetManager(*args, **kwargs)
        Overloaded function.

        1. getAssetManager(self: depthai.Node) -> depthai.AssetManager

        Get node AssetManager as a const reference

        2. getAssetManager(self: depthai.Node) -> depthai.AssetManager

        Get node AssetManager as a const reference
        """
    @overload
    def getAssetManager(self) -> AssetManager:
        """getAssetManager(*args, **kwargs)
        Overloaded function.

        1. getAssetManager(self: depthai.Node) -> depthai.AssetManager

        Get node AssetManager as a const reference

        2. getAssetManager(self: depthai.Node) -> depthai.AssetManager

        Get node AssetManager as a const reference
        """
    def getInputMapRefs(self) -> list[Node.InputMap]:
        """getInputMapRefs(self: depthai.Node) -> list[depthai.Node.InputMap]

        Retrieves reference to node inputs
        """
    @overload
    def getInputRefs(self) -> list[Node.Input]:
        """getInputRefs(*args, **kwargs)
        Overloaded function.

        1. getInputRefs(self: depthai.Node) -> list[depthai.Node.Input]

        Retrieves reference to node inputs

        2. getInputRefs(self: depthai.Node) -> list[depthai.Node.Input]

        Retrieves reference to node inputs
        """
    @overload
    def getInputRefs(self) -> list[Node.Input]:
        """getInputRefs(*args, **kwargs)
        Overloaded function.

        1. getInputRefs(self: depthai.Node) -> list[depthai.Node.Input]

        Retrieves reference to node inputs

        2. getInputRefs(self: depthai.Node) -> list[depthai.Node.Input]

        Retrieves reference to node inputs
        """
    def getInputs(self) -> list[Node.Input]:
        """getInputs(self: depthai.Node) -> list[depthai.Node.Input]

        Retrieves all nodes inputs
        """
    def getName(self) -> str:
        """getName(self: depthai.Node) -> str

        Retrieves nodes name
        """
    def getOutputMapRefs(self) -> list[Node.OutputMap]:
        """getOutputMapRefs(self: depthai.Node) -> list[depthai.Node.OutputMap]

        Retrieves reference to node outputs
        """
    @overload
    def getOutputRefs(self) -> list[Node.Output]:
        """getOutputRefs(*args, **kwargs)
        Overloaded function.

        1. getOutputRefs(self: depthai.Node) -> list[depthai.Node.Output]

        Retrieves reference to node outputs

        2. getOutputRefs(self: depthai.Node) -> list[depthai.Node.Output]

        Retrieves reference to node outputs
        """
    @overload
    def getOutputRefs(self) -> list[Node.Output]:
        """getOutputRefs(*args, **kwargs)
        Overloaded function.

        1. getOutputRefs(self: depthai.Node) -> list[depthai.Node.Output]

        Retrieves reference to node outputs

        2. getOutputRefs(self: depthai.Node) -> list[depthai.Node.Output]

        Retrieves reference to node outputs
        """
    def getOutputs(self) -> list[Node.Output]:
        """getOutputs(self: depthai.Node) -> list[depthai.Node.Output]

        Retrieves all nodes outputs
        """
    @overload
    def getParentPipeline(self) -> Pipeline:
        """getParentPipeline(*args, **kwargs)
        Overloaded function.

        1. getParentPipeline(self: depthai.Node) -> depthai.Pipeline

        2. getParentPipeline(self: depthai.Node) -> depthai.Pipeline
        """
    @overload
    def getParentPipeline(self) -> Pipeline:
        """getParentPipeline(*args, **kwargs)
        Overloaded function.

        1. getParentPipeline(self: depthai.Node) -> depthai.Pipeline

        2. getParentPipeline(self: depthai.Node) -> depthai.Pipeline
        """
    def stopPipeline(self) -> None:
        """stopPipeline(self: depthai.Node) -> None"""
    @property
    def id(self) -> int: ...

class NodeGroup(Node):
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class ObjectTrackerProperties:
    detectionLabelsToTrack: list[int]
    maxObjectsToTrack: int
    trackerIdAssignmentPolicy: TrackerIdAssignmentPolicy
    trackerThreshold: float
    trackerType: TrackerType
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class OpenVINO:
    class Blob:
        data: list[int]
        device: OpenVINO.Device
        networkInputs: dict[str, TensorInfo]
        networkOutputs: dict[str, TensorInfo]
        numShaves: int
        numSlices: int
        stageCount: int
        version: OpenVINO.Version
        @overload
        def __init__(self, arg0: list[int]) -> None:
            """__init__(*args, **kwargs)
            Overloaded function.

            1. __init__(self: depthai.OpenVINO.Blob, arg0: list[int]) -> None

            Construct a new Blob from data in memory

            Parameter ``data``:
                In memory blob

            2. __init__(self: depthai.OpenVINO.Blob, arg0: Path) -> None

            Construct a new Blob by loading from a filesystem path

            Parameter ``path``:
                Filesystem path to the blob
            """
        @overload
        def __init__(self, arg0: Path) -> None:
            """__init__(*args, **kwargs)
            Overloaded function.

            1. __init__(self: depthai.OpenVINO.Blob, arg0: list[int]) -> None

            Construct a new Blob from data in memory

            Parameter ``data``:
                In memory blob

            2. __init__(self: depthai.OpenVINO.Blob, arg0: Path) -> None

            Construct a new Blob by loading from a filesystem path

            Parameter ``path``:
                Filesystem path to the blob
            """

    class Device:
        __members__: ClassVar[dict] = ...  # read-only
        VPU: ClassVar[OpenVINO.Device] = ...
        VPUX: ClassVar[OpenVINO.Device] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.OpenVINO.Device, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.OpenVINO.Device) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.OpenVINO.Device) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class SuperBlob:
        NUMBER_OF_PATCHES: ClassVar[int] = ...  # read-only
        @overload
        def __init__(self, superblobBytes: list[int]) -> None:
            """__init__(*args, **kwargs)
            Overloaded function.

            1. __init__(self: depthai.OpenVINO.SuperBlob, superblobBytes: list[int]) -> None

            Construct a new SuperBlob object

            Parameter ``data:``:
                In memory superblob data

            2. __init__(self: depthai.OpenVINO.SuperBlob, pathToSuperBlobFile: str) -> None

            Construct a new SuperBlob object

            Parameter ``data:``:
                In memory superblob data
            """
        @overload
        def __init__(self, pathToSuperBlobFile: str) -> None:
            """__init__(*args, **kwargs)
            Overloaded function.

            1. __init__(self: depthai.OpenVINO.SuperBlob, superblobBytes: list[int]) -> None

            Construct a new SuperBlob object

            Parameter ``data:``:
                In memory superblob data

            2. __init__(self: depthai.OpenVINO.SuperBlob, pathToSuperBlobFile: str) -> None

            Construct a new SuperBlob object

            Parameter ``data:``:
                In memory superblob data
            """
        def getBlobWithNumShaves(self, numShaves: int) -> OpenVINO.Blob:
            """getBlobWithNumShaves(self: depthai.OpenVINO.SuperBlob, numShaves: int) -> depthai.OpenVINO.Blob

            Generate a blob with a specific number of shaves

            Parameter ``numShaves:``:
                Number of shaves to generate the blob for. Must be between 1 and
                NUMBER_OF_PATCHES.

            Returns:
                dai::OpenVINO::Blob: Blob compiled for the specified number of shaves
            """

    class Version:
        __members__: ClassVar[dict] = ...  # read-only
        VERSION_2020_3: ClassVar[OpenVINO.Version] = ...
        VERSION_2020_4: ClassVar[OpenVINO.Version] = ...
        VERSION_2021_1: ClassVar[OpenVINO.Version] = ...
        VERSION_2021_2: ClassVar[OpenVINO.Version] = ...
        VERSION_2021_3: ClassVar[OpenVINO.Version] = ...
        VERSION_2021_4: ClassVar[OpenVINO.Version] = ...
        VERSION_2022_1: ClassVar[OpenVINO.Version] = ...
        VERSION_UNIVERSAL: ClassVar[OpenVINO.Version] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.OpenVINO.Version, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.OpenVINO.Version) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.OpenVINO.Version) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    DEFAULT_VERSION: ClassVar[OpenVINO.Version] = ...
    VERSION_2020_3: ClassVar[OpenVINO.Version] = ...
    VERSION_2020_4: ClassVar[OpenVINO.Version] = ...
    VERSION_2021_1: ClassVar[OpenVINO.Version] = ...
    VERSION_2021_2: ClassVar[OpenVINO.Version] = ...
    VERSION_2021_3: ClassVar[OpenVINO.Version] = ...
    VERSION_2021_4: ClassVar[OpenVINO.Version] = ...
    VERSION_2022_1: ClassVar[OpenVINO.Version] = ...
    VERSION_UNIVERSAL: ClassVar[OpenVINO.Version] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    @staticmethod
    def areVersionsBlobCompatible(v1: OpenVINO.Version, v2: OpenVINO.Version) -> bool:
        """areVersionsBlobCompatible(v1: depthai.OpenVINO.Version, v2: depthai.OpenVINO.Version) -> bool

        Checks whether two blob versions are compatible
        """
    @staticmethod
    def getBlobLatestSupportedVersion(*args, **kwargs):
        """getBlobLatestSupportedVersion(majorVersion: int, majorVersion: int) -> depthai.OpenVINO.Version

        Returns latest potentially supported version by a given blob version.

        Parameter ``majorVersion``:
            Major version from OpenVINO blob

        Parameter ``minorVersion``:
            Minor version from OpenVINO blob

        Returns:
            Latest potentially supported version
        """
    @staticmethod
    def getBlobSupportedVersions(*args, **kwargs):
        """getBlobSupportedVersions(majorVersion: int, majorVersion: int) -> list[depthai.OpenVINO.Version]

        Returns a list of potentially supported versions for a specified blob major and
        minor versions.

        Parameter ``majorVersion``:
            Major version from OpenVINO blob

        Parameter ``minorVersion``:
            Minor version from OpenVINO blob

        Returns:
            Vector of potentially supported versions
        """
    @staticmethod
    def getVersionName(version: OpenVINO.Version) -> str:
        """getVersionName(version: depthai.OpenVINO.Version) -> str

        Returns string representation of a given version

        Parameter ``version``:
            OpenVINO version

        Returns:
            Name of a given version
        """
    @staticmethod
    def getVersions() -> list[OpenVINO.Version]:
        """getVersions() -> list[depthai.OpenVINO.Version]

        Returns:
            Supported versions
        """
    @staticmethod
    def parseVersionName(versionString: str) -> OpenVINO.Version:
        """parseVersionName(versionString: str) -> depthai.OpenVINO.Version

        Creates Version from string representation. Throws if not possible.

        Parameter ``versionString``:
            Version as string

        Returns:
            Version object if successful
        """

class Pipeline:
    @overload
    def __init__(self, createImplicitDevice: bool = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Pipeline, createImplicitDevice: bool = True) -> None

        Creates a pipeline

        Parameter ``createImplicitDevice``:
            If true, creates a default device (default = true)

        2. __init__(self: depthai.Pipeline, defaultDevice: depthai.Device) -> None

        Creates a pipeline

        Parameter ``createImplicitDevice``:
            If true, creates a default device (default = true)
        """
    @overload
    def __init__(self, defaultDevice: Device) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Pipeline, createImplicitDevice: bool = True) -> None

        Creates a pipeline

        Parameter ``createImplicitDevice``:
            If true, creates a default device (default = true)

        2. __init__(self: depthai.Pipeline, defaultDevice: depthai.Device) -> None

        Creates a pipeline

        Parameter ``createImplicitDevice``:
            If true, creates a default device (default = true)
        """
    def add(self, arg0: Node) -> Node:
        """add(self: depthai.Pipeline, arg0: depthai.Node) -> depthai.Node"""
    def build(self) -> None:
        """build(self: depthai.Pipeline) -> None"""
    def create(self, arg0: Type[T], *args, **kwargs) -> T:
        """create(self: depthai.Pipeline, arg0: object, *args, **kwargs) -> depthai.Node"""
    def createAprilTag(self) -> node.AprilTag:
        """createAprilTag(self: depthai.Pipeline) -> depthai.node.AprilTag"""
    def createCamera(self) -> node.Camera:
        """createCamera(self: depthai.Pipeline) -> depthai.node.Camera"""
    def createColorCamera(self) -> node.ColorCamera:
        """createColorCamera(self: depthai.Pipeline) -> depthai.node.ColorCamera"""
    def createDetectionParser(self) -> node.DetectionParser:
        """createDetectionParser(self: depthai.Pipeline) -> depthai.node.DetectionParser"""
    def createEdgeDetector(self) -> node.EdgeDetector:
        """createEdgeDetector(self: depthai.Pipeline) -> depthai.node.EdgeDetector"""
    def createFeatureTracker(self) -> node.FeatureTracker:
        """createFeatureTracker(self: depthai.Pipeline) -> depthai.node.FeatureTracker"""
    def createIMU(self) -> node.IMU:
        """createIMU(self: depthai.Pipeline) -> depthai.node.IMU"""
    def createImageManip(self) -> node.ImageManip:
        """createImageManip(self: depthai.Pipeline) -> depthai.node.ImageManip"""
    def createMobileNetDetectionNetwork(self) -> node.MobileNetDetectionNetwork:
        """createMobileNetDetectionNetwork(self: depthai.Pipeline) -> depthai.node.MobileNetDetectionNetwork"""
    def createMobileNetSpatialDetectionNetwork(self) -> node.MobileNetSpatialDetectionNetwork:
        """createMobileNetSpatialDetectionNetwork(self: depthai.Pipeline) -> depthai.node.MobileNetSpatialDetectionNetwork"""
    def createMonoCamera(self) -> node.MonoCamera:
        """createMonoCamera(self: depthai.Pipeline) -> depthai.node.MonoCamera"""
    def createNeuralNetwork(self) -> node.NeuralNetwork:
        """createNeuralNetwork(self: depthai.Pipeline) -> depthai.node.NeuralNetwork"""
    def createObjectTracker(self) -> node.ObjectTracker:
        """createObjectTracker(self: depthai.Pipeline) -> depthai.node.ObjectTracker"""
    def createSPIIn(self) -> node.SPIIn:
        """createSPIIn(self: depthai.Pipeline) -> depthai.node.SPIIn"""
    def createSPIOut(self) -> node.SPIOut:
        """createSPIOut(self: depthai.Pipeline) -> depthai.node.SPIOut"""
    def createScript(self) -> node.Script:
        """createScript(self: depthai.Pipeline) -> depthai.node.Script"""
    def createSpatialLocationCalculator(self) -> node.SpatialLocationCalculator:
        """createSpatialLocationCalculator(self: depthai.Pipeline) -> depthai.node.SpatialLocationCalculator"""
    def createStereoDepth(self) -> node.StereoDepth:
        """createStereoDepth(self: depthai.Pipeline) -> depthai.node.StereoDepth"""
    def createSystemLogger(self) -> node.SystemLogger:
        """createSystemLogger(self: depthai.Pipeline) -> depthai.node.SystemLogger"""
    def createUVC(self) -> node.UVC:
        """createUVC(self: depthai.Pipeline) -> depthai.node.UVC"""
    def createVideoEncoder(self) -> node.VideoEncoder:
        """createVideoEncoder(self: depthai.Pipeline) -> depthai.node.VideoEncoder"""
    def createWarp(self) -> node.Warp:
        """createWarp(self: depthai.Pipeline) -> depthai.node.Warp"""
    def createXLinkIn(self) -> node.XLinkIn:
        """createXLinkIn(self: depthai.Pipeline) -> depthai.node.XLinkIn"""
    def createXLinkOut(self) -> node.XLinkOut:
        """createXLinkOut(self: depthai.Pipeline) -> depthai.node.XLinkOut"""
    def createYoloDetectionNetwork(self) -> node.YoloDetectionNetwork:
        """createYoloDetectionNetwork(self: depthai.Pipeline) -> depthai.node.YoloDetectionNetwork"""
    def createYoloSpatialDetectionNetwork(self) -> node.YoloSpatialDetectionNetwork:
        """createYoloSpatialDetectionNetwork(self: depthai.Pipeline) -> depthai.node.YoloSpatialDetectionNetwork"""
    def enableHolisticRecord(self, recordConfig: RecordConfig) -> None:
        """enableHolisticRecord(self: depthai.Pipeline, recordConfig: depthai.RecordConfig) -> None

        Record and Replay
        """
    def enableHolisticReplay(self, recordingPath: str) -> None:
        """enableHolisticReplay(self: depthai.Pipeline, recordingPath: str) -> None"""
    def getAllNodes(self) -> list[Node]:
        """getAllNodes(self: depthai.Pipeline) -> list[depthai.Node]

        Get a vector of all nodes
        """
    @overload
    def getAssetManager(self) -> AssetManager:
        """getAssetManager(*args, **kwargs)
        Overloaded function.

        1. getAssetManager(self: depthai.Pipeline) -> depthai.AssetManager

        Get pipelines AssetManager as reference

        2. getAssetManager(self: depthai.Pipeline) -> depthai.AssetManager

        Get pipelines AssetManager as reference
        """
    @overload
    def getAssetManager(self) -> AssetManager:
        """getAssetManager(*args, **kwargs)
        Overloaded function.

        1. getAssetManager(self: depthai.Pipeline) -> depthai.AssetManager

        Get pipelines AssetManager as reference

        2. getAssetManager(self: depthai.Pipeline) -> depthai.AssetManager

        Get pipelines AssetManager as reference
        """
    def getBoardConfig(self) -> BoardConfig:
        """getBoardConfig(self: depthai.Pipeline) -> depthai.BoardConfig

        Gets board configuration
        """
    def getCalibrationData(self) -> CalibrationHandler:
        """getCalibrationData(self: depthai.Pipeline) -> depthai.CalibrationHandler

        gets the calibration data which is set through pipeline

        Returns:
            the calibrationHandler with calib data in the pipeline
        """
    @overload
    def getDefaultDevice(self) -> Device:
        """getDefaultDevice(*args, **kwargs)
        Overloaded function.

        1. getDefaultDevice(self: depthai.Pipeline) -> depthai.Device

        2. getDefaultDevice(self: depthai.Pipeline) -> depthai.Device
        """
    @overload
    def getDefaultDevice(self) -> Device:
        """getDefaultDevice(*args, **kwargs)
        Overloaded function.

        1. getDefaultDevice(self: depthai.Pipeline) -> depthai.Device

        2. getDefaultDevice(self: depthai.Pipeline) -> depthai.Device
        """
    def getDeviceConfig(self) -> Device.Config:
        """getDeviceConfig(self: depthai.Pipeline) -> depthai.Device.Config

        Get device configuration needed for this pipeline
        """
    def getGlobalProperties(self) -> GlobalProperties:
        """getGlobalProperties(self: depthai.Pipeline) -> depthai.GlobalProperties

        Returns:
            Global properties of current pipeline
        """
    def getNode(self, arg0: int) -> Node:
        """getNode(self: depthai.Pipeline, arg0: int) -> depthai.Node

        Get node with id if it exists, nullptr otherwise
        """
    def getOpenVINOVersion(self) -> OpenVINO.Version:
        """getOpenVINOVersion(self: depthai.Pipeline) -> depthai.OpenVINO.Version

        Get possible OpenVINO version to run this pipeline
        """
    def getRequiredOpenVINOVersion(self) -> OpenVINO.Version | None:
        """getRequiredOpenVINOVersion(self: depthai.Pipeline) -> Optional[depthai.OpenVINO.Version]

        Get required OpenVINO version to run this pipeline. Can be none
        """
    def isBuilt(self) -> bool:
        """isBuilt(self: depthai.Pipeline) -> bool"""
    def isRunning(self) -> bool:
        """isRunning(self: depthai.Pipeline) -> bool"""
    def processTasks(self, waitForTasks: bool = ..., timeoutSeconds: float = ...) -> None:
        """processTasks(self: depthai.Pipeline, waitForTasks: bool = False, timeoutSeconds: float = -1.0) -> None"""
    def remove(self, node: Node) -> None:
        """remove(self: depthai.Pipeline, node: depthai.Node) -> None

        Removes a node from pipeline
        """
    def run(self) -> None:
        """run(self: depthai.Pipeline) -> None"""
    def serializeToJson(self) -> json:
        """serializeToJson(self: depthai.Pipeline) -> json

        Returns whole pipeline represented as JSON
        """
    def setBoardConfig(self, arg0: BoardConfig) -> None:
        """setBoardConfig(self: depthai.Pipeline, arg0: depthai.BoardConfig) -> None

        Sets board configuration
        """
    def setCalibrationData(self, calibrationDataHandler: CalibrationHandler) -> None:
        """setCalibrationData(self: depthai.Pipeline, calibrationDataHandler: depthai.CalibrationHandler) -> None

        Sets the calibration in pipeline which overrides the calibration data in eeprom

        Parameter ``calibrationDataHandler``:
            CalibrationHandler object which is loaded with calibration information.
        """
    def setCameraTuningBlobPath(self, path: Path) -> None:
        """setCameraTuningBlobPath(self: depthai.Pipeline, path: Path) -> None

        Set a camera IQ (Image Quality) tuning blob, used for all cameras
        """
    def setOpenVINOVersion(self, version: OpenVINO.Version) -> None:
        """setOpenVINOVersion(self: depthai.Pipeline, version: depthai.OpenVINO.Version) -> None

        Set a specific OpenVINO version to use with this pipeline
        """
    def setSippBufferSize(self, sizeBytes: int) -> None:
        """setSippBufferSize(self: depthai.Pipeline, sizeBytes: int) -> None

        SIPP (Signal Image Processing Pipeline) internal memory pool. SIPP is a
        framework used to schedule HW filters, e.g. ISP, Warp, Median filter etc.
        Changing the size of this pool is meant for advanced use cases, pushing the
        limits of the HW. By default memory is allocated in high speed CMX memory.
        Setting to 0 will allocate in DDR 256 kilobytes. Units are bytes.
        """
    def setSippDmaBufferSize(self, sizeBytes: int) -> None:
        """setSippDmaBufferSize(self: depthai.Pipeline, sizeBytes: int) -> None

        SIPP (Signal Image Processing Pipeline) internal DMA memory pool. SIPP is a
        framework used to schedule HW filters, e.g. ISP, Warp, Median filter etc.
        Changing the size of this pool is meant for advanced use cases, pushing the
        limits of the HW. Memory is allocated in high speed CMX memory Units are bytes.
        """
    def setXLinkChunkSize(self, sizeBytes: int) -> None:
        """setXLinkChunkSize(self: depthai.Pipeline, sizeBytes: int) -> None

        Set chunk size for splitting device-sent XLink packets, in bytes. A larger value
        could increase performance, with 0 disabling chunking. A negative value won't
        modify the device defaults - configured per protocol, currently 64*1024 for both
        USB and Ethernet.
        """
    def start(self) -> None:
        """start(self: depthai.Pipeline) -> None"""
    def stop(self) -> None:
        """stop(self: depthai.Pipeline) -> None"""
    def wait(self) -> None:
        """wait(self: depthai.Pipeline) -> None"""
    def __enter__(self) -> Pipeline:
        """__enter__(self: depthai.Pipeline) -> depthai.Pipeline"""
    def __exit__(self, arg0: object, arg1: object, arg2: object) -> None:
        """__exit__(self: depthai.Pipeline, arg0: object, arg1: object, arg2: object) -> None"""

class Platform:
    __members__: ClassVar[dict] = ...  # read-only
    RVC2: ClassVar[Platform] = ...
    RVC3: ClassVar[Platform] = ...
    RVC4: ClassVar[Platform] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.Platform, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.Platform) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.Platform) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class Point2f:
    x: float
    y: float
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Point2f) -> None

        2. __init__(self: depthai.Point2f, x: float, y: float) -> None

        3. __init__(self: depthai.Point2f, x: float, y: float, normalized: bool) -> None
        """
    @overload
    def __init__(self, x: float, y: float) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Point2f) -> None

        2. __init__(self: depthai.Point2f, x: float, y: float) -> None

        3. __init__(self: depthai.Point2f, x: float, y: float, normalized: bool) -> None
        """
    @overload
    def __init__(self, x: float, y: float, normalized: bool) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Point2f) -> None

        2. __init__(self: depthai.Point2f, x: float, y: float) -> None

        3. __init__(self: depthai.Point2f, x: float, y: float, normalized: bool) -> None
        """
    def isNormalized(self) -> bool:
        """isNormalized(self: depthai.Point2f) -> bool"""

class Point3d:
    x: float
    y: float
    z: float
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Point3d) -> None

        2. __init__(self: depthai.Point3d, arg0: float, arg1: float, arg2: float) -> None
        """
    @overload
    def __init__(self, arg0: float, arg1: float, arg2: float) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Point3d) -> None

        2. __init__(self: depthai.Point3d, arg0: float, arg1: float, arg2: float) -> None
        """

class Point3f:
    x: float
    y: float
    z: float
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Point3f) -> None

        2. __init__(self: depthai.Point3f, arg0: float, arg1: float, arg2: float) -> None
        """
    @overload
    def __init__(self, arg0: float, arg1: float, arg2: float) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Point3f) -> None

        2. __init__(self: depthai.Point3f, arg0: float, arg1: float, arg2: float) -> None
        """

class Point3fRGB:
    b: int
    g: int
    r: int
    x: float
    y: float
    z: float
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Point3fRGB) -> None

        2. __init__(self: depthai.Point3fRGB, arg0: float, arg1: float, arg2: float, arg3: int, arg4: int, arg5: int) -> None
        """
    @overload
    def __init__(self, arg0: float, arg1: float, arg2: float, arg3: int, arg4: int, arg5: int) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Point3fRGB) -> None

        2. __init__(self: depthai.Point3fRGB, arg0: float, arg1: float, arg2: float, arg3: int, arg4: int, arg5: int) -> None
        """

class PointCloudConfig(Buffer):
    def __init__(self) -> None:
        """__init__(self: depthai.PointCloudConfig) -> None"""
    def getSparse(self) -> bool:
        """getSparse(self: depthai.PointCloudConfig) -> bool

        Retrieve sparse point cloud calculation status.

        Returns:
            true if sparse point cloud calculation is enabled, false otherwise
        """
    def getTransformationMatrix(self, *args, **kwargs):
        """getTransformationMatrix(self: depthai.PointCloudConfig) -> Annotated[list[Annotated[list[float], FixedSize(4)]], FixedSize(4)]

        Retrieve transformation matrix for point cloud calculation.

        Returns:
            4x4 transformation matrix
        """
    def setSparse(self, arg0: bool) -> PointCloudConfig:
        """setSparse(self: depthai.PointCloudConfig, arg0: bool) -> depthai.PointCloudConfig

        Enable or disable sparse point cloud calculation.

        Parameter ``enable``:
        """
    @overload
    def setTransformationMatrix(self, arg0) -> PointCloudConfig:
        """setTransformationMatrix(*args, **kwargs)
        Overloaded function.

        1. setTransformationMatrix(self: depthai.PointCloudConfig, arg0: Annotated[list[Annotated[list[float], FixedSize(3)]], FixedSize(3)]) -> depthai.PointCloudConfig

        Set 4x4 transformation matrix for point cloud calculation. Default is an
        identity matrix.

        Parameter ``transformationMatrix``:

        2. setTransformationMatrix(self: depthai.PointCloudConfig, arg0: Annotated[list[Annotated[list[float], FixedSize(4)]], FixedSize(4)]) -> depthai.PointCloudConfig

        Set 4x4 transformation matrix for point cloud calculation. Default is an
        identity matrix.

        Parameter ``transformationMatrix``:
        """
    @overload
    def setTransformationMatrix(self, arg0) -> PointCloudConfig:
        """setTransformationMatrix(*args, **kwargs)
        Overloaded function.

        1. setTransformationMatrix(self: depthai.PointCloudConfig, arg0: Annotated[list[Annotated[list[float], FixedSize(3)]], FixedSize(3)]) -> depthai.PointCloudConfig

        Set 4x4 transformation matrix for point cloud calculation. Default is an
        identity matrix.

        Parameter ``transformationMatrix``:

        2. setTransformationMatrix(self: depthai.PointCloudConfig, arg0: Annotated[list[Annotated[list[float], FixedSize(4)]], FixedSize(4)]) -> depthai.PointCloudConfig

        Set 4x4 transformation matrix for point cloud calculation. Default is an
        identity matrix.

        Parameter ``transformationMatrix``:
        """

class PointCloudData(Buffer):
    def __init__(self) -> None:
        """__init__(self: depthai.PointCloudData) -> None"""
    def getHeight(self) -> int:
        """getHeight(self: depthai.PointCloudData) -> int

        Retrieves the height in pixels - in case of a sparse point cloud, this
        represents the hight of the frame which was used to generate the point cloud
        """
    def getInstanceNum(self) -> int:
        """getInstanceNum(self: depthai.PointCloudData) -> int

        Retrieves instance number
        """
    def getMaxX(self) -> float:
        """getMaxX(self: depthai.PointCloudData) -> float

        Retrieves maximal x coordinate in depth units (millimeter by default)
        """
    def getMaxY(self) -> float:
        """getMaxY(self: depthai.PointCloudData) -> float

        Retrieves maximal y coordinate in depth units (millimeter by default)
        """
    def getMaxZ(self) -> float:
        """getMaxZ(self: depthai.PointCloudData) -> float

        Retrieves maximal z coordinate in depth units (millimeter by default)
        """
    def getMinX(self) -> float:
        """getMinX(self: depthai.PointCloudData) -> float

        Retrieves minimal x coordinate in depth units (millimeter by default)
        """
    def getMinY(self) -> float:
        """getMinY(self: depthai.PointCloudData) -> float

        Retrieves minimal y coordinate in depth units (millimeter by default)
        """
    def getMinZ(self) -> float:
        """getMinZ(self: depthai.PointCloudData) -> float

        Retrieves minimal z coordinate in depth units (millimeter by default)
        """
    def getPoints(self) -> numpy.ndarray[numpy.float32]:
        """getPoints(self: object) -> numpy.ndarray[numpy.float32]"""
    def getPointsRGB(self) -> tuple:
        """getPointsRGB(self: object) -> tuple"""
    def getSequenceNum(self) -> int:
        """getSequenceNum(self: depthai.PointCloudData) -> int

        Retrieves image sequence number
        """
    def getTimestamp(self) -> datetime.timedelta:
        """getTimestamp(self: depthai.PointCloudData) -> datetime.timedelta

        Retrieves timestamp related to dai::Clock::now()
        """
    def getTimestampDevice(self) -> datetime.timedelta:
        """getTimestampDevice(self: depthai.PointCloudData) -> datetime.timedelta

        Retrieves timestamp directly captured from device's monotonic clock, not
        synchronized to host time. Used mostly for debugging
        """
    def getWidth(self) -> int:
        """getWidth(self: depthai.PointCloudData) -> int

        Retrieves the height in pixels - in case of a sparse point cloud, this
        represents the hight of the frame which was used to generate the point cloud
        """
    def isColor(self) -> bool:
        """isColor(self: depthai.PointCloudData) -> bool

        Retrieves whether point cloud is color
        """
    def isSparse(self) -> bool:
        """isSparse(self: depthai.PointCloudData) -> bool

        Retrieves whether point cloud is sparse
        """
    def setHeight(self, arg0: int) -> PointCloudData:
        """setHeight(self: depthai.PointCloudData, arg0: int) -> depthai.PointCloudData

        Specifies frame height

        Parameter ``height``:
            frame height
        """
    def setInstanceNum(self, arg0: int) -> PointCloudData:
        """setInstanceNum(self: depthai.PointCloudData, arg0: int) -> depthai.PointCloudData

        Specifies instance number

        Parameter ``instanceNum``:
            instance number
        """
    def setMaxX(self, arg0: float) -> PointCloudData:
        """setMaxX(self: depthai.PointCloudData, arg0: float) -> depthai.PointCloudData

        Specifies maximal x coordinate in depth units (millimeter by default)

        Parameter ``val``:
            maximal x coordinate in depth units (millimeter by default)
        """
    def setMaxY(self, arg0: float) -> PointCloudData:
        """setMaxY(self: depthai.PointCloudData, arg0: float) -> depthai.PointCloudData

        Specifies maximal y coordinate in depth units (millimeter by default)

        Parameter ``val``:
            maximal y coordinate in depth units (millimeter by default)
        """
    def setMaxZ(self, arg0: float) -> PointCloudData:
        """setMaxZ(self: depthai.PointCloudData, arg0: float) -> depthai.PointCloudData

        Specifies maximal z coordinate in depth units (millimeter by default)

        Parameter ``val``:
            maximal z coordinate in depth units (millimeter by default)
        """
    def setMinX(self, arg0: float) -> PointCloudData:
        """setMinX(self: depthai.PointCloudData, arg0: float) -> depthai.PointCloudData

        Specifies minimal x coordinate in depth units (millimeter by default)

        Parameter ``val``:
            minimal x coordinate in depth units (millimeter by default)
        """
    def setMinY(self, arg0: float) -> PointCloudData:
        """setMinY(self: depthai.PointCloudData, arg0: float) -> depthai.PointCloudData

        Specifies minimal y coordinate in depth units (millimeter by default)

        Parameter ``val``:
            minimal y coordinate in depth units (millimeter by default)
        """
    def setMinZ(self, arg0: float) -> PointCloudData:
        """setMinZ(self: depthai.PointCloudData, arg0: float) -> depthai.PointCloudData

        Specifies minimal z coordinate in depth units (millimeter by default)

        Parameter ``val``:
            minimal z coordinate in depth units (millimeter by default)
        """
    @overload
    def setSize(self, width: int, height: int) -> PointCloudData:
        """setSize(*args, **kwargs)
        Overloaded function.

        1. setSize(self: depthai.PointCloudData, width: int, height: int) -> depthai.PointCloudData

        Specifies frame size

        Parameter ``height``:
            frame height

        Parameter ``width``:
            frame width

        2. setSize(self: depthai.PointCloudData, size: tuple[int, int]) -> depthai.PointCloudData

        Specifies frame size

        Parameter ``size``:
            frame size
        """
    @overload
    def setSize(self, size: tuple[int, int]) -> PointCloudData:
        """setSize(*args, **kwargs)
        Overloaded function.

        1. setSize(self: depthai.PointCloudData, width: int, height: int) -> depthai.PointCloudData

        Specifies frame size

        Parameter ``height``:
            frame height

        Parameter ``width``:
            frame width

        2. setSize(self: depthai.PointCloudData, size: tuple[int, int]) -> depthai.PointCloudData

        Specifies frame size

        Parameter ``size``:
            frame size
        """
    def setWidth(self, arg0: int) -> PointCloudData:
        """setWidth(self: depthai.PointCloudData, arg0: int) -> depthai.PointCloudData

        Specifies frame width

        Parameter ``width``:
            frame width
        """

class PointCloudProperties:
    initialConfig: PointCloudConfig
    numFramesPool: int
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class PointsAnnotation:
    fillColor: Color
    outlineColor: Color
    outlineColors: VectorColor
    points: VectorPoint2f
    thickness: float
    type: PointsAnnotationType
    def __init__(self) -> None:
        """__init__(self: depthai.PointsAnnotation) -> None"""

class PointsAnnotationType:
    __members__: ClassVar[dict] = ...  # read-only
    LINE_LIST: ClassVar[PointsAnnotationType] = ...
    LINE_LOOP: ClassVar[PointsAnnotationType] = ...
    LINE_STRIP: ClassVar[PointsAnnotationType] = ...
    POINTS: ClassVar[PointsAnnotationType] = ...
    UNKNOWN: ClassVar[PointsAnnotationType] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.PointsAnnotationType, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.PointsAnnotationType) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.PointsAnnotationType) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class ProcessorType:
    __members__: ClassVar[dict] = ...  # read-only
    LEON_CSS: ClassVar[ProcessorType] = ...
    LEON_MSS: ClassVar[ProcessorType] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.ProcessorType, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.ProcessorType) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.ProcessorType) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class ProfilingData:
    numBytesRead: int
    numBytesWritten: int
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class Properties:
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class Quaterniond:
    qw: float
    qx: float
    qy: float
    qz: float
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Quaterniond) -> None

        2. __init__(self: depthai.Quaterniond, arg0: float, arg1: float, arg2: float, arg3: float) -> None
        """
    @overload
    def __init__(self, arg0: float, arg1: float, arg2: float, arg3: float) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Quaterniond) -> None

        2. __init__(self: depthai.Quaterniond, arg0: float, arg1: float, arg2: float, arg3: float) -> None
        """

class RecordConfig:
    class VideoEncoding:
        bitrate: int
        enabled: bool
        lossless: bool
        profile: VideoEncoderProperties.Profile
        quality: int
        def __init__(self) -> None:
            """__init__(self: depthai.RecordConfig.VideoEncoding) -> None"""
    compressionLevel: Incomplete
    outputDir: str
    videoEncoding: RecordConfig.VideoEncoding
    def __init__(self) -> None:
        """__init__(self: depthai.RecordConfig) -> None"""

class Rect:
    height: float
    width: float
    x: float
    y: float
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Rect) -> None

        2. __init__(self: depthai.Rect, arg0: float, arg1: float, arg2: float, arg3: float) -> None

        3. __init__(self: depthai.Rect, arg0: float, arg1: float, arg2: float, arg3: float, arg4: bool) -> None

        4. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Point2f) -> None

        5. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Point2f, arg2: bool) -> None

        6. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Size2f) -> None

        7. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Size2f, arg2: bool) -> None
        """
    @overload
    def __init__(self, arg0: float, arg1: float, arg2: float, arg3: float) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Rect) -> None

        2. __init__(self: depthai.Rect, arg0: float, arg1: float, arg2: float, arg3: float) -> None

        3. __init__(self: depthai.Rect, arg0: float, arg1: float, arg2: float, arg3: float, arg4: bool) -> None

        4. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Point2f) -> None

        5. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Point2f, arg2: bool) -> None

        6. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Size2f) -> None

        7. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Size2f, arg2: bool) -> None
        """
    @overload
    def __init__(self, arg0: float, arg1: float, arg2: float, arg3: float, arg4: bool) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Rect) -> None

        2. __init__(self: depthai.Rect, arg0: float, arg1: float, arg2: float, arg3: float) -> None

        3. __init__(self: depthai.Rect, arg0: float, arg1: float, arg2: float, arg3: float, arg4: bool) -> None

        4. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Point2f) -> None

        5. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Point2f, arg2: bool) -> None

        6. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Size2f) -> None

        7. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Size2f, arg2: bool) -> None
        """
    @overload
    def __init__(self, arg0: Point2f, arg1: Point2f) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Rect) -> None

        2. __init__(self: depthai.Rect, arg0: float, arg1: float, arg2: float, arg3: float) -> None

        3. __init__(self: depthai.Rect, arg0: float, arg1: float, arg2: float, arg3: float, arg4: bool) -> None

        4. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Point2f) -> None

        5. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Point2f, arg2: bool) -> None

        6. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Size2f) -> None

        7. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Size2f, arg2: bool) -> None
        """
    @overload
    def __init__(self, arg0: Point2f, arg1: Point2f, arg2: bool) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Rect) -> None

        2. __init__(self: depthai.Rect, arg0: float, arg1: float, arg2: float, arg3: float) -> None

        3. __init__(self: depthai.Rect, arg0: float, arg1: float, arg2: float, arg3: float, arg4: bool) -> None

        4. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Point2f) -> None

        5. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Point2f, arg2: bool) -> None

        6. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Size2f) -> None

        7. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Size2f, arg2: bool) -> None
        """
    @overload
    def __init__(self, arg0: Point2f, arg1: Size2f) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Rect) -> None

        2. __init__(self: depthai.Rect, arg0: float, arg1: float, arg2: float, arg3: float) -> None

        3. __init__(self: depthai.Rect, arg0: float, arg1: float, arg2: float, arg3: float, arg4: bool) -> None

        4. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Point2f) -> None

        5. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Point2f, arg2: bool) -> None

        6. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Size2f) -> None

        7. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Size2f, arg2: bool) -> None
        """
    @overload
    def __init__(self, arg0: Point2f, arg1: Size2f, arg2: bool) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Rect) -> None

        2. __init__(self: depthai.Rect, arg0: float, arg1: float, arg2: float, arg3: float) -> None

        3. __init__(self: depthai.Rect, arg0: float, arg1: float, arg2: float, arg3: float, arg4: bool) -> None

        4. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Point2f) -> None

        5. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Point2f, arg2: bool) -> None

        6. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Size2f) -> None

        7. __init__(self: depthai.Rect, arg0: depthai.Point2f, arg1: depthai.Size2f, arg2: bool) -> None
        """
    def area(self) -> float:
        """area(self: depthai.Rect) -> float

        Area (width*height) of the rectangle
        """
    def bottomRight(self) -> Point2f:
        """bottomRight(self: depthai.Rect) -> depthai.Point2f

        The bottom-right corner
        """
    def contains(self, arg0: Point2f) -> bool:
        """contains(self: depthai.Rect, arg0: depthai.Point2f) -> bool

        Checks whether the rectangle contains the point.
        """
    def denormalize(self, width: int, height: int) -> Rect:
        """denormalize(self: depthai.Rect, width: int, height: int) -> depthai.Rect

        Denormalize rectangle.

        Parameter ``destWidth``:
            Destination frame width.

        Parameter ``destHeight``:
            Destination frame height.
        """
    def empty(self) -> bool:
        """empty(self: depthai.Rect) -> bool

        True if rectangle is empty.
        """
    def isNormalized(self) -> bool:
        """isNormalized(self: depthai.Rect) -> bool

        Whether rectangle is normalized (coordinates in [0,1] range) or not.
        """
    def normalize(self, width: int, height: int) -> Rect:
        """normalize(self: depthai.Rect, width: int, height: int) -> depthai.Rect

        Normalize rectangle.

        Parameter ``srcWidth``:
            Source frame width.

        Parameter ``srcHeight``:
            Source frame height.
        """
    def size(self) -> Size2f:
        """size(self: depthai.Rect) -> depthai.Size2f

        Size (width, height) of the rectangle
        """
    def topLeft(self) -> Point2f:
        """topLeft(self: depthai.Rect) -> depthai.Point2f

        The top-left corner.
        """

class RemoteConnection:
    def __init__(self, address: str = ..., webSocketPort: int = ..., serveFrontend: bool = ..., httpPort: int = ...) -> None:
        """__init__(self: depthai.RemoteConnection, address: str = '0.0.0.0', webSocketPort: int = 8765, serveFrontend: bool = True, httpPort: int = 8080) -> None"""
    @overload
    def addTopic(self, topicName: str, output: Node.Output, group: str = ..., useVisualizationIfAvailable: bool = ...) -> None:
        """addTopic(*args, **kwargs)
        Overloaded function.

        1. addTopic(self: depthai.RemoteConnection, topicName: str, output: depthai.Node.Output, group: str = '', useVisualizationIfAvailable: bool = True) -> None

        2. addTopic(self: depthai.RemoteConnection, topicName: str, group: str = '', maxSize: int = 16, blocking: bool = False, useVisualizationIfAvailable: bool = True) -> depthai.MessageQueue
        """
    @overload
    def addTopic(self, topicName: str, group: str = ..., maxSize: int = ..., blocking: bool = ..., useVisualizationIfAvailable: bool = ...) -> MessageQueue:
        """addTopic(*args, **kwargs)
        Overloaded function.

        1. addTopic(self: depthai.RemoteConnection, topicName: str, output: depthai.Node.Output, group: str = '', useVisualizationIfAvailable: bool = True) -> None

        2. addTopic(self: depthai.RemoteConnection, topicName: str, group: str = '', maxSize: int = 16, blocking: bool = False, useVisualizationIfAvailable: bool = True) -> depthai.MessageQueue
        """
    def registerPipeline(self, pipeline: Pipeline) -> None:
        """registerPipeline(self: depthai.RemoteConnection, pipeline: depthai.Pipeline) -> None"""
    def registerService(self, serviceName: str, callback: Callable[[json], json]) -> None:
        """registerService(self: depthai.RemoteConnection, serviceName: str, callback: Callable[[json], json]) -> None"""
    def waitKey(self, delay: int) -> int:
        """waitKey(self: depthai.RemoteConnection, delay: int) -> int"""

class RotatedRect:
    angle: float
    center: Point2f
    size: Size2f
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.RotatedRect) -> None

        2. __init__(self: depthai.RotatedRect, arg0: depthai.Point2f, arg1: depthai.Size2f, arg2: float) -> None

        3. __init__(self: depthai.RotatedRect, arg0: depthai.Rect, arg1: float) -> None
        """
    @overload
    def __init__(self, arg0: Point2f, arg1: Size2f, arg2: float) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.RotatedRect) -> None

        2. __init__(self: depthai.RotatedRect, arg0: depthai.Point2f, arg1: depthai.Size2f, arg2: float) -> None

        3. __init__(self: depthai.RotatedRect, arg0: depthai.Rect, arg1: float) -> None
        """
    @overload
    def __init__(self, arg0: Rect, arg1: float) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.RotatedRect) -> None

        2. __init__(self: depthai.RotatedRect, arg0: depthai.Point2f, arg1: depthai.Size2f, arg2: float) -> None

        3. __init__(self: depthai.RotatedRect, arg0: depthai.Rect, arg1: float) -> None
        """
    def denormalize(self, width: int, height: int) -> RotatedRect:
        """denormalize(self: depthai.RotatedRect, width: int, height: int) -> depthai.RotatedRect

        Denormalize the rotated rectangle. The denormalized rectangle will have center
        and size coordinates in range [0, width] and [0, height]

        Returns:
            Denormalized rotated rectangle
        """
    def getOuterRect(self, *args, **kwargs):
        """getOuterRect(self: depthai.RotatedRect) -> Annotated[list[float], FixedSize(4)]

        Returns the outer non-rotated rectangle

        Returns:
            [minx, miny, maxx, maxy]
        """
    def getPoints(self, *args, **kwargs):
        """getPoints(self: depthai.RotatedRect) -> Annotated[list[depthai.Point2f], FixedSize(4)]

        Get the 4 corner points of the rotated rectangle

        Returns:
            4 corner points
        """
    def isNormalized(self) -> bool:
        """isNormalized(self: depthai.RotatedRect) -> bool"""
    def normalize(self, width: int, height: int) -> RotatedRect:
        """normalize(self: depthai.RotatedRect, width: int, height: int) -> depthai.RotatedRect

        Normalize the rotated rectangle. The normalized rectangle will have center and
        size coordinates in range [0,1]

        Returns:
            Normalized rotated rectangle
        """

class SPIInProperties:
    busId: int
    maxDataSize: int
    numFrames: int
    streamName: str
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class SPIOutProperties:
    busId: int
    streamName: str
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class ScriptProperties:
    processor: ProcessorType
    scriptName: str
    scriptUri: str
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class SerializationType:
    __members__: ClassVar[dict] = ...  # read-only
    JSON: ClassVar[SerializationType] = ...
    JSON_MSGPACK: ClassVar[SerializationType] = ...
    LIBNOP: ClassVar[SerializationType] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.SerializationType, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.SerializationType) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.SerializationType) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class Size2f:
    height: float
    width: float
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Size2f) -> None

        2. __init__(self: depthai.Size2f, width: float, height: float) -> None

        3. __init__(self: depthai.Size2f, width: float, height: float, normalized: bool) -> None
        """
    @overload
    def __init__(self, width: float, height: float) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Size2f) -> None

        2. __init__(self: depthai.Size2f, width: float, height: float) -> None

        3. __init__(self: depthai.Size2f, width: float, height: float, normalized: bool) -> None
        """
    @overload
    def __init__(self, width: float, height: float, normalized: bool) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Size2f) -> None

        2. __init__(self: depthai.Size2f, width: float, height: float) -> None

        3. __init__(self: depthai.Size2f, width: float, height: float, normalized: bool) -> None
        """
    def isNormalized(self) -> bool:
        """isNormalized(self: depthai.Size2f) -> bool"""

class SlugComponents:
    modelRef: str
    modelSlug: str
    modelVariantSlug: str
    teamName: str
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.SlugComponents) -> None

        2. __init__(self: depthai.SlugComponents, teamName: str = '', modelSlug: str = '', modelVariantSlug: str = '', modelRef: str = '') -> None
        """
    @overload
    def __init__(self, teamName: str = ..., modelSlug: str = ..., modelVariantSlug: str = ..., modelRef: str = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.SlugComponents) -> None

        2. __init__(self: depthai.SlugComponents, teamName: str = '', modelSlug: str = '', modelVariantSlug: str = '', modelRef: str = '') -> None
        """
    def merge(self) -> str:
        """merge(self: depthai.SlugComponents) -> str"""
    @staticmethod
    def split(slug: str) -> SlugComponents:
        """split(slug: str) -> depthai.SlugComponents"""

class SpatialDetectionNetworkProperties:
    depthThresholds: SpatialLocationCalculatorConfigThresholds
    detectedBBScaleFactor: float
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class SpatialImgDetection(ImgDetection):
    boundingBoxMapping: SpatialLocationCalculatorConfigData
    spatialCoordinates: Point3f
    def __init__(self) -> None:
        """__init__(self: depthai.SpatialImgDetection) -> None"""

class SpatialImgDetections(Buffer):
    detections: list[SpatialImgDetection]
    def __init__(self) -> None:
        """__init__(self: depthai.SpatialImgDetections) -> None"""
    def getSequenceNum(self) -> int:
        """getSequenceNum(self: depthai.SpatialImgDetections) -> int

        Retrieves image sequence number
        """
    def getTimestamp(self) -> datetime.timedelta:
        """getTimestamp(self: depthai.SpatialImgDetections) -> datetime.timedelta

        Retrieves timestamp related to dai::Clock::now()
        """
    def getTimestampDevice(self) -> datetime.timedelta:
        """getTimestampDevice(self: depthai.SpatialImgDetections) -> datetime.timedelta

        Retrieves timestamp directly captured from device's monotonic clock, not
        synchronized to host time. Used mostly for debugging
        """
    def getTransformation(self) -> ImgTransformation | None:
        """getTransformation(self: depthai.SpatialImgDetections) -> Optional[depthai.ImgTransformation]"""
    def setTransformation(self, arg0: ImgTransformation | None) -> None:
        """setTransformation(self: depthai.SpatialImgDetections, arg0: Optional[depthai.ImgTransformation]) -> None"""

class SpatialLocationCalculatorAlgorithm:
    __members__: ClassVar[dict] = ...  # read-only
    AVERAGE: ClassVar[SpatialLocationCalculatorAlgorithm] = ...
    MAX: ClassVar[SpatialLocationCalculatorAlgorithm] = ...
    MEAN: ClassVar[SpatialLocationCalculatorAlgorithm] = ...
    MEDIAN: ClassVar[SpatialLocationCalculatorAlgorithm] = ...
    MIN: ClassVar[SpatialLocationCalculatorAlgorithm] = ...
    MODE: ClassVar[SpatialLocationCalculatorAlgorithm] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.SpatialLocationCalculatorAlgorithm, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.SpatialLocationCalculatorAlgorithm) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.SpatialLocationCalculatorAlgorithm) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class SpatialLocationCalculatorConfig(Buffer):
    def __init__(self) -> None:
        """__init__(self: depthai.SpatialLocationCalculatorConfig) -> None"""
    def addROI(self, ROI: SpatialLocationCalculatorConfigData) -> None:
        """addROI(self: depthai.SpatialLocationCalculatorConfig, ROI: depthai.SpatialLocationCalculatorConfigData) -> None

        Add a new ROI to configuration data.

        Parameter ``roi``:
            Configuration parameters for ROI (region of interest)
        """
    def getConfigData(self) -> list[SpatialLocationCalculatorConfigData]:
        """getConfigData(self: depthai.SpatialLocationCalculatorConfig) -> list[depthai.SpatialLocationCalculatorConfigData]

        Retrieve configuration data for SpatialLocationCalculator

        Returns:
            Vector of configuration parameters for ROIs (region of interests)
        """
    def setROIs(self, ROIs: list[SpatialLocationCalculatorConfigData]) -> None:
        """setROIs(self: depthai.SpatialLocationCalculatorConfig, ROIs: list[depthai.SpatialLocationCalculatorConfigData]) -> None

        Set a vector of ROIs as configuration data.

        Parameter ``ROIs``:
            Vector of configuration parameters for ROIs (region of interests)
        """

class SpatialLocationCalculatorConfigData:
    calculationAlgorithm: SpatialLocationCalculatorAlgorithm
    depthThresholds: SpatialLocationCalculatorConfigThresholds
    roi: Rect
    def __init__(self) -> None:
        """__init__(self: depthai.SpatialLocationCalculatorConfigData) -> None"""

class SpatialLocationCalculatorConfigThresholds:
    lowerThreshold: int
    upperThreshold: int
    def __init__(self) -> None:
        """__init__(self: depthai.SpatialLocationCalculatorConfigThresholds) -> None"""

class SpatialLocationCalculatorData(Buffer):
    spatialLocations: list[SpatialLocations]
    def __init__(self) -> None:
        """__init__(self: depthai.SpatialLocationCalculatorData) -> None"""
    def getSequenceNum(self) -> int:
        """getSequenceNum(self: depthai.SpatialLocationCalculatorData) -> int

        Retrieves image sequence number
        """
    def getSpatialLocations(self) -> list[SpatialLocations]:
        """getSpatialLocations(self: depthai.SpatialLocationCalculatorData) -> list[depthai.SpatialLocations]

        Retrieve configuration data for SpatialLocationCalculatorData.

        Returns:
            Vector of spatial location data, carrying spatial information (X,Y,Z)
        """
    def getTimestamp(self) -> datetime.timedelta:
        """getTimestamp(self: depthai.SpatialLocationCalculatorData) -> datetime.timedelta

        Retrieves timestamp related to dai::Clock::now()
        """
    def getTimestampDevice(self) -> datetime.timedelta:
        """getTimestampDevice(self: depthai.SpatialLocationCalculatorData) -> datetime.timedelta

        Retrieves timestamp directly captured from device's monotonic clock, not
        synchronized to host time. Used mostly for debugging
        """

class SpatialLocationCalculatorProperties:
    roiConfig: SpatialLocationCalculatorConfig
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class SpatialLocations:
    config: SpatialLocationCalculatorConfigData
    depthAverage: float
    depthAveragePixelCount: int
    depthMax: int
    depthMedian: float
    depthMin: int
    depthMode: float
    spatialCoordinates: Point3f
    def __init__(self) -> None:
        """__init__(self: depthai.SpatialLocations) -> None"""

class StereoDepthConfig(Buffer):
    class AlgorithmControl:
        class DepthAlign:
            __members__: ClassVar[dict] = ...  # read-only
            CENTER: ClassVar[StereoDepthConfig.AlgorithmControl.DepthAlign] = ...
            RECTIFIED_LEFT: ClassVar[StereoDepthConfig.AlgorithmControl.DepthAlign] = ...
            RECTIFIED_RIGHT: ClassVar[StereoDepthConfig.AlgorithmControl.DepthAlign] = ...
            __entries: ClassVar[dict] = ...
            def __init__(self, value: int) -> None:
                """__init__(self: depthai.StereoDepthConfig.AlgorithmControl.DepthAlign, value: int) -> None"""
            def __eq__(self, other: object) -> bool:
                """__eq__(self: object, other: object) -> bool"""
            def __hash__(self) -> int:
                """__hash__(self: object) -> int"""
            def __index__(self) -> int:
                """__index__(self: depthai.StereoDepthConfig.AlgorithmControl.DepthAlign) -> int"""
            def __int__(self) -> int:
                """__int__(self: depthai.StereoDepthConfig.AlgorithmControl.DepthAlign) -> int"""
            def __ne__(self, other: object) -> bool:
                """__ne__(self: object, other: object) -> bool"""
            @property
            def name(self) -> str: ...
            @property
            def value(self) -> int: ...

        class DepthUnit:
            __members__: ClassVar[dict] = ...  # read-only
            CENTIMETER: ClassVar[StereoDepthConfig.AlgorithmControl.DepthUnit] = ...
            CUSTOM: ClassVar[StereoDepthConfig.AlgorithmControl.DepthUnit] = ...
            FOOT: ClassVar[StereoDepthConfig.AlgorithmControl.DepthUnit] = ...
            INCH: ClassVar[StereoDepthConfig.AlgorithmControl.DepthUnit] = ...
            METER: ClassVar[StereoDepthConfig.AlgorithmControl.DepthUnit] = ...
            MILLIMETER: ClassVar[StereoDepthConfig.AlgorithmControl.DepthUnit] = ...
            __entries: ClassVar[dict] = ...
            def __init__(self, value: int) -> None:
                """__init__(self: depthai.StereoDepthConfig.AlgorithmControl.DepthUnit, value: int) -> None"""
            def __eq__(self, other: object) -> bool:
                """__eq__(self: object, other: object) -> bool"""
            def __hash__(self) -> int:
                """__hash__(self: object) -> int"""
            def __index__(self) -> int:
                """__index__(self: depthai.StereoDepthConfig.AlgorithmControl.DepthUnit) -> int"""
            def __int__(self) -> int:
                """__int__(self: depthai.StereoDepthConfig.AlgorithmControl.DepthUnit) -> int"""
            def __ne__(self, other: object) -> bool:
                """__ne__(self: object, other: object) -> bool"""
            @property
            def name(self) -> str: ...
            @property
            def value(self) -> int: ...
        centerAlignmentShiftFactor: float | None
        customDepthUnitMultiplier: float
        depthAlign: StereoDepthConfig.AlgorithmControl.DepthAlign
        depthUnit: StereoDepthConfig.AlgorithmControl.DepthUnit
        disparityShift: int
        enableExtended: bool
        enableLeftRightCheck: bool
        enableSubpixel: bool
        leftRightCheckThreshold: int
        numInvalidateEdgePixels: int
        subpixelFractionalBits: int
        def __init__(self) -> None:
            """__init__(self: depthai.StereoDepthConfig.AlgorithmControl) -> None"""

    class CensusTransform:
        class KernelSize:
            __members__: ClassVar[dict] = ...  # read-only
            AUTO: ClassVar[StereoDepthConfig.CensusTransform.KernelSize] = ...
            KERNEL_5x5: ClassVar[StereoDepthConfig.CensusTransform.KernelSize] = ...
            KERNEL_7x7: ClassVar[StereoDepthConfig.CensusTransform.KernelSize] = ...
            KERNEL_7x9: ClassVar[StereoDepthConfig.CensusTransform.KernelSize] = ...
            __entries: ClassVar[dict] = ...
            def __init__(self, value: int) -> None:
                """__init__(self: depthai.StereoDepthConfig.CensusTransform.KernelSize, value: int) -> None"""
            def __eq__(self, other: object) -> bool:
                """__eq__(self: object, other: object) -> bool"""
            def __hash__(self) -> int:
                """__hash__(self: object) -> int"""
            def __index__(self) -> int:
                """__index__(self: depthai.StereoDepthConfig.CensusTransform.KernelSize) -> int"""
            def __int__(self) -> int:
                """__int__(self: depthai.StereoDepthConfig.CensusTransform.KernelSize) -> int"""
            def __ne__(self, other: object) -> bool:
                """__ne__(self: object, other: object) -> bool"""
            @property
            def name(self) -> str: ...
            @property
            def value(self) -> int: ...
        enableMeanMode: bool
        kernelMask: int
        kernelSize: StereoDepthConfig.CensusTransform.KernelSize
        noiseThresholdOffset: int
        noiseThresholdScale: int
        threshold: int
        def __init__(self) -> None:
            """__init__(self: depthai.StereoDepthConfig.CensusTransform) -> None"""

    class ConfidenceMetrics:
        flatnessConfidenceThreshold: int
        flatnessConfidenceWeight: int
        flatnessOverride: bool
        motionVectorConfidenceThreshold: int
        motionVectorConfidenceWeight: int
        occlusionConfidenceWeight: int
        def __init__(self) -> None:
            """__init__(self: depthai.StereoDepthConfig.ConfidenceMetrics) -> None"""

    class CostAggregation:
        class P1Config:
            defaultValue: int
            edgeThreshold: int
            edgeValue: int
            enableAdaptive: bool
            smoothThreshold: int
            smoothValue: int
            def __init__(self) -> None:
                """__init__(self: depthai.StereoDepthConfig.CostAggregation.P1Config) -> None"""

        class P2Config:
            defaultValue: int
            edgeValue: int
            enableAdaptive: bool
            smoothValue: int
            def __init__(self) -> None:
                """__init__(self: depthai.StereoDepthConfig.CostAggregation.P2Config) -> None"""
        divisionFactor: int
        horizontalPenaltyCostP1: int
        horizontalPenaltyCostP2: int
        p1Config: StereoDepthConfig.CostAggregation.P1Config
        p2Config: StereoDepthConfig.CostAggregation.P2Config
        verticalPenaltyCostP1: int
        verticalPenaltyCostP2: int
        def __init__(self) -> None:
            """__init__(self: depthai.StereoDepthConfig.CostAggregation) -> None"""

    class CostMatching:
        class DisparityWidth:
            __members__: ClassVar[dict] = ...  # read-only
            DISPARITY_64: ClassVar[StereoDepthConfig.CostMatching.DisparityWidth] = ...
            DISPARITY_96: ClassVar[StereoDepthConfig.CostMatching.DisparityWidth] = ...
            __entries: ClassVar[dict] = ...
            def __init__(self, value: int) -> None:
                """__init__(self: depthai.StereoDepthConfig.CostMatching.DisparityWidth, value: int) -> None"""
            def __eq__(self, other: object) -> bool:
                """__eq__(self: object, other: object) -> bool"""
            def __hash__(self) -> int:
                """__hash__(self: object) -> int"""
            def __index__(self) -> int:
                """__index__(self: depthai.StereoDepthConfig.CostMatching.DisparityWidth) -> int"""
            def __int__(self) -> int:
                """__int__(self: depthai.StereoDepthConfig.CostMatching.DisparityWidth) -> int"""
            def __ne__(self, other: object) -> bool:
                """__ne__(self: object, other: object) -> bool"""
            @property
            def name(self) -> str: ...
            @property
            def value(self) -> int: ...

        class LinearEquationParameters:
            alpha: int
            beta: int
            threshold: int
            def __init__(self) -> None:
                """__init__(self: depthai.StereoDepthConfig.CostMatching.LinearEquationParameters) -> None"""
        confidenceThreshold: int
        disparityWidth: StereoDepthConfig.CostMatching.DisparityWidth
        enableCompanding: bool
        invalidDisparityValue: int
        linearEquationParameters: StereoDepthConfig.CostMatching.LinearEquationParameters
        def __init__(self) -> None:
            """__init__(self: depthai.StereoDepthConfig.CostMatching) -> None"""

    class MedianFilter:
        __members__: ClassVar[dict] = ...  # read-only
        KERNEL_3x3: ClassVar[MedianFilter] = ...
        KERNEL_5x5: ClassVar[MedianFilter] = ...
        KERNEL_7x7: ClassVar[MedianFilter] = ...
        MEDIAN_OFF: ClassVar[MedianFilter] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.MedianFilter, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.MedianFilter) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.MedianFilter) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class PostProcessing:
        class AdaptiveMedianFilter:
            confidenceThreshold: int
            enable: bool
            def __init__(self) -> None:
                """__init__(self: depthai.StereoDepthConfig.PostProcessing.AdaptiveMedianFilter) -> None"""

        class BrightnessFilter:
            maxBrightness: int
            minBrightness: int
            def __init__(self) -> None:
                """__init__(self: depthai.StereoDepthConfig.PostProcessing.BrightnessFilter) -> None"""

        class DecimationFilter:
            class DecimationMode:
                __members__: ClassVar[dict] = ...  # read-only
                NON_ZERO_MEAN: ClassVar[StereoDepthConfig.PostProcessing.DecimationFilter.DecimationMode] = ...
                NON_ZERO_MEDIAN: ClassVar[StereoDepthConfig.PostProcessing.DecimationFilter.DecimationMode] = ...
                PIXEL_SKIPPING: ClassVar[StereoDepthConfig.PostProcessing.DecimationFilter.DecimationMode] = ...
                __entries: ClassVar[dict] = ...
                def __init__(self, value: int) -> None:
                    """__init__(self: depthai.StereoDepthConfig.PostProcessing.DecimationFilter.DecimationMode, value: int) -> None"""
                def __eq__(self, other: object) -> bool:
                    """__eq__(self: object, other: object) -> bool"""
                def __hash__(self) -> int:
                    """__hash__(self: object) -> int"""
                def __index__(self) -> int:
                    """__index__(self: depthai.StereoDepthConfig.PostProcessing.DecimationFilter.DecimationMode) -> int"""
                def __int__(self) -> int:
                    """__int__(self: depthai.StereoDepthConfig.PostProcessing.DecimationFilter.DecimationMode) -> int"""
                def __ne__(self, other: object) -> bool:
                    """__ne__(self: object, other: object) -> bool"""
                @property
                def name(self) -> str: ...
                @property
                def value(self) -> int: ...
            decimationFactor: int
            decimationMode: StereoDepthConfig.PostProcessing.DecimationFilter.DecimationMode
            def __init__(self) -> None:
                """__init__(self: depthai.StereoDepthConfig.PostProcessing.DecimationFilter) -> None"""

        class HoleFilling:
            enable: bool
            fillConfidenceThreshold: int
            highConfidenceThreshold: int
            invalidateDisparities: bool
            minValidDisparity: int
            def __init__(self) -> None:
                """__init__(self: depthai.StereoDepthConfig.PostProcessing.HoleFilling) -> None"""

        class SpatialFilter:
            alpha: float
            delta: int
            enable: bool
            holeFillingRadius: int
            numIterations: int
            def __init__(self) -> None:
                """__init__(self: depthai.StereoDepthConfig.PostProcessing.SpatialFilter) -> None"""

        class SpeckleFilter:
            differenceThreshold: int
            enable: bool
            speckleRange: int
            def __init__(self) -> None:
                """__init__(self: depthai.StereoDepthConfig.PostProcessing.SpeckleFilter) -> None"""

        class TemporalFilter:
            class PersistencyMode:
                __members__: ClassVar[dict] = ...  # read-only
                PERSISTENCY_INDEFINITELY: ClassVar[StereoDepthConfig.PostProcessing.TemporalFilter.PersistencyMode] = ...
                PERSISTENCY_OFF: ClassVar[StereoDepthConfig.PostProcessing.TemporalFilter.PersistencyMode] = ...
                VALID_1_IN_LAST_2: ClassVar[StereoDepthConfig.PostProcessing.TemporalFilter.PersistencyMode] = ...
                VALID_1_IN_LAST_5: ClassVar[StereoDepthConfig.PostProcessing.TemporalFilter.PersistencyMode] = ...
                VALID_1_IN_LAST_8: ClassVar[StereoDepthConfig.PostProcessing.TemporalFilter.PersistencyMode] = ...
                VALID_2_IN_LAST_3: ClassVar[StereoDepthConfig.PostProcessing.TemporalFilter.PersistencyMode] = ...
                VALID_2_IN_LAST_4: ClassVar[StereoDepthConfig.PostProcessing.TemporalFilter.PersistencyMode] = ...
                VALID_2_OUT_OF_8: ClassVar[StereoDepthConfig.PostProcessing.TemporalFilter.PersistencyMode] = ...
                VALID_8_OUT_OF_8: ClassVar[StereoDepthConfig.PostProcessing.TemporalFilter.PersistencyMode] = ...
                __entries: ClassVar[dict] = ...
                def __init__(self, value: int) -> None:
                    """__init__(self: depthai.StereoDepthConfig.PostProcessing.TemporalFilter.PersistencyMode, value: int) -> None"""
                def __eq__(self, other: object) -> bool:
                    """__eq__(self: object, other: object) -> bool"""
                def __hash__(self) -> int:
                    """__hash__(self: object) -> int"""
                def __index__(self) -> int:
                    """__index__(self: depthai.StereoDepthConfig.PostProcessing.TemporalFilter.PersistencyMode) -> int"""
                def __int__(self) -> int:
                    """__int__(self: depthai.StereoDepthConfig.PostProcessing.TemporalFilter.PersistencyMode) -> int"""
                def __ne__(self, other: object) -> bool:
                    """__ne__(self: object, other: object) -> bool"""
                @property
                def name(self) -> str: ...
                @property
                def value(self) -> int: ...
            alpha: float
            delta: int
            enable: bool
            persistencyMode: StereoDepthConfig.PostProcessing.TemporalFilter.PersistencyMode
            def __init__(self) -> None:
                """__init__(self: depthai.StereoDepthConfig.PostProcessing.TemporalFilter) -> None"""

        class ThresholdFilter:
            maxRange: int
            minRange: int
            def __init__(self) -> None:
                """__init__(self: depthai.StereoDepthConfig.PostProcessing.ThresholdFilter) -> None"""
        adaptiveMedianFilter: StereoDepthConfig.PostProcessing.AdaptiveMedianFilter
        bilateralSigmaValue: int
        brightnessFilter: StereoDepthConfig.PostProcessing.BrightnessFilter
        decimationFilter: StereoDepthConfig.PostProcessing.DecimationFilter
        filteringOrder: Incomplete
        holeFilling: StereoDepthConfig.PostProcessing.HoleFilling
        median: MedianFilter
        spatialFilter: StereoDepthConfig.PostProcessing.SpatialFilter
        speckleFilter: StereoDepthConfig.PostProcessing.SpeckleFilter
        temporalFilter: StereoDepthConfig.PostProcessing.TemporalFilter
        thresholdFilter: StereoDepthConfig.PostProcessing.ThresholdFilter
        def __init__(self) -> None:
            """__init__(self: depthai.StereoDepthConfig.PostProcessing) -> None"""
    algorithmControl: StereoDepthConfig.AlgorithmControl
    censusTransform: StereoDepthConfig.CensusTransform
    confidenceMetrics: StereoDepthConfig.ConfidenceMetrics
    costAggregation: StereoDepthConfig.CostAggregation
    costMatching: StereoDepthConfig.CostMatching
    postProcessing: StereoDepthConfig.PostProcessing
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.StereoDepthConfig) -> None

        2. __init__(self: depthai.StereoDepthConfig) -> None
        """
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.StereoDepthConfig) -> None

        2. __init__(self: depthai.StereoDepthConfig) -> None
        """
    def getBilateralFilterSigma(self) -> int:
        """getBilateralFilterSigma(self: depthai.StereoDepthConfig) -> int

        Get sigma value for 5x5 bilateral filter
        """
    def getConfidenceThreshold(self) -> int:
        """getConfidenceThreshold(self: depthai.StereoDepthConfig) -> int

        Get confidence threshold for disparity calculation
        """
    def getDepthUnit(self) -> StereoDepthConfig.AlgorithmControl.DepthUnit:
        """getDepthUnit(self: depthai.StereoDepthConfig) -> depthai.StereoDepthConfig.AlgorithmControl.DepthUnit

        Get depth unit of depth map.
        """
    def getExtendedDisparity(self) -> bool:
        """getExtendedDisparity(self: depthai.StereoDepthConfig) -> bool

        Get extended disparity setting
        """
    def getLeftRightCheck(self) -> bool:
        """getLeftRightCheck(self: depthai.StereoDepthConfig) -> bool

        Get left-right check setting
        """
    def getLeftRightCheckThreshold(self) -> int:
        """getLeftRightCheckThreshold(self: depthai.StereoDepthConfig) -> int

        Get threshold for left-right check combine
        """
    def getMaxDisparity(self) -> float:
        """getMaxDisparity(self: depthai.StereoDepthConfig) -> float

        Useful for normalization of the disparity map.

        Returns:
            Maximum disparity value that the node can return
        """
    def getMedianFilter(self) -> MedianFilter:
        """getMedianFilter(self: depthai.StereoDepthConfig) -> depthai.MedianFilter

        Get median filter setting
        """
    def getSubpixel(self) -> bool:
        """getSubpixel(self: depthai.StereoDepthConfig) -> bool

        Get subpixel setting
        """
    def getSubpixelFractionalBits(self) -> int:
        """getSubpixelFractionalBits(self: depthai.StereoDepthConfig) -> int

        Get number of fractional bits for subpixel mode
        """
    def setBilateralFilterSigma(self, sigma: int) -> StereoDepthConfig:
        """setBilateralFilterSigma(self: depthai.StereoDepthConfig, sigma: int) -> depthai.StereoDepthConfig

        A larger value of the parameter means that farther colors within the pixel
        neighborhood will be mixed together, resulting in larger areas of semi-equal
        color.

        Parameter ``sigma``:
            Set sigma value for 5x5 bilateral filter. 0..65535
        """
    def setConfidenceThreshold(self, confThr: int) -> StereoDepthConfig:
        """setConfidenceThreshold(self: depthai.StereoDepthConfig, confThr: int) -> depthai.StereoDepthConfig

        Confidence threshold for disparity calculation

        Parameter ``confThr``:
            Confidence threshold value 0..255
        """
    def setDepthAlign(self, align: StereoDepthConfig.AlgorithmControl.DepthAlign) -> StereoDepthConfig:
        """setDepthAlign(self: depthai.StereoDepthConfig, align: depthai.StereoDepthConfig.AlgorithmControl.DepthAlign) -> depthai.StereoDepthConfig

        Parameter ``align``:
            Set the disparity/depth alignment: centered (between the 'left' and 'right'
            inputs), or from the perspective of a rectified output stream
        """
    def setDepthUnit(self, arg0: StereoDepthConfig.AlgorithmControl.DepthUnit) -> StereoDepthConfig:
        """setDepthUnit(self: depthai.StereoDepthConfig, arg0: depthai.StereoDepthConfig.AlgorithmControl.DepthUnit) -> depthai.StereoDepthConfig

        Set depth unit of depth map.

        Meter, centimeter, millimeter, inch, foot or custom unit is available.
        """
    def setDisparityShift(self, arg0: int) -> StereoDepthConfig:
        """setDisparityShift(self: depthai.StereoDepthConfig, arg0: int) -> depthai.StereoDepthConfig

        Shift input frame by a number of pixels to increase minimum depth. For example
        shifting by 48 will change effective disparity search range from (0,95] to
        [48,143]. An alternative approach to reducing the minZ. We normally only
        recommend doing this when it is known that there will be no objects farther away
        than MaxZ, such as having a depth camera mounted above a table pointing down at
        the table surface.
        """
    def setExtendedDisparity(self, enable: bool) -> StereoDepthConfig:
        """setExtendedDisparity(self: depthai.StereoDepthConfig, enable: bool) -> depthai.StereoDepthConfig

        Disparity range increased from 95 to 190, combined from full resolution and
        downscaled images. Suitable for short range objects
        """
    def setLeftRightCheck(self, enable: bool) -> StereoDepthConfig:
        """setLeftRightCheck(self: depthai.StereoDepthConfig, enable: bool) -> depthai.StereoDepthConfig

        Computes and combines disparities in both L-R and R-L directions, and combine
        them.

        For better occlusion handling, discarding invalid disparity values
        """
    def setLeftRightCheckThreshold(self, sigma: int) -> StereoDepthConfig:
        """setLeftRightCheckThreshold(self: depthai.StereoDepthConfig, sigma: int) -> depthai.StereoDepthConfig

        Parameter ``threshold``:
            Set threshold for left-right, right-left disparity map combine, 0..255
        """
    def setMedianFilter(self, median: MedianFilter) -> StereoDepthConfig:
        """setMedianFilter(self: depthai.StereoDepthConfig, median: depthai.MedianFilter) -> depthai.StereoDepthConfig

        Parameter ``median``:
            Set kernel size for disparity/depth median filtering, or disable
        """
    def setNumInvalidateEdgePixels(self, arg0: int) -> StereoDepthConfig:
        """setNumInvalidateEdgePixels(self: depthai.StereoDepthConfig, arg0: int) -> depthai.StereoDepthConfig

        Invalidate X amount of pixels at the edge of disparity frame. For right and
        center alignment X pixels will be invalidated from the right edge, for left
        alignment from the left edge.
        """
    def setSubpixel(self, enable: bool) -> StereoDepthConfig:
        """setSubpixel(self: depthai.StereoDepthConfig, enable: bool) -> depthai.StereoDepthConfig

        Computes disparity with sub-pixel interpolation (3 fractional bits by default).

        Suitable for long range. Currently incompatible with extended disparity
        """
    def setSubpixelFractionalBits(self, subpixelFractionalBits: int) -> StereoDepthConfig:
        """setSubpixelFractionalBits(self: depthai.StereoDepthConfig, subpixelFractionalBits: int) -> depthai.StereoDepthConfig

        Number of fractional bits for subpixel mode. Default value: 3. Valid values:
        3,4,5. Defines the number of fractional disparities: 2^x. Median filter
        postprocessing is supported only for 3 fractional bits.
        """

class StereoDepthProperties:
    class RectificationMesh:
        meshLeftUri: str
        meshRightUri: str
        meshSize: int | None
        stepHeight: int
        stepWidth: int
        def __init__(self, *args, **kwargs) -> None:
            """Initialize self.  See help(type(self)) for accurate signature."""
    alphaScaling: float | None
    baseline: float | None
    depthAlignCamera: CameraBoardSocket
    depthAlignmentUseSpecTranslation: bool | None
    disparityToDepthUseSpecTranslation: bool | None
    enableRectification: bool
    enableRuntimeStereoModeSwitch: bool
    focalLength: float | None
    focalLengthFromCalibration: bool
    height: int | None
    initialConfig: StereoDepthConfig
    mesh: StereoDepthProperties.RectificationMesh
    numFramesPool: int
    numPostProcessingMemorySlices: int
    numPostProcessingShaves: int
    outHeight: int | None
    outKeepAspectRatio: bool
    outWidth: int | None
    rectificationUseSpecTranslation: bool | None
    rectifyEdgeFillColor: int
    useHomographyRectification: bool | None
    width: int | None
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class StereoPair:
    baseline: float
    isVertical: bool
    left: CameraBoardSocket
    right: CameraBoardSocket
    def __init__(self) -> None:
        """__init__(self: depthai.StereoPair) -> None"""

class StereoRectification:
    leftCameraSocket: CameraBoardSocket
    rectifiedRotationLeft: list[list[float]]
    rectifiedRotationRight: list[list[float]]
    rightCameraSocket: CameraBoardSocket
    def __init__(self) -> None:
        """__init__(self: depthai.StereoRectification) -> None"""

class SyncProperties:
    syncAttempts: int
    syncThresholdNs: int
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class SystemInformation(Buffer):
    chipTemperature: ChipTemperature
    cmxMemoryUsage: MemoryInfo
    ddrMemoryUsage: MemoryInfo
    leonCssCpuUsage: CpuUsage
    leonCssMemoryUsage: MemoryInfo
    leonMssCpuUsage: CpuUsage
    leonMssMemoryUsage: MemoryInfo
    def __init__(self) -> None:
        """__init__(self: depthai.SystemInformation) -> None"""

class SystemInformationS3(Buffer):
    chipTemperature: ChipTemperatureS3
    cpuAvgUsage: CpuUsage
    cpuUsages: list[CpuUsage]
    ddrMemoryUsage: MemoryInfo
    def __init__(self) -> None:
        """__init__(self: depthai.SystemInformationS3) -> None"""

class SystemLoggerProperties:
    rateHz: float
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class TensorInfo:
    class DataType:
        __members__: ClassVar[dict] = ...  # read-only
        FP16: ClassVar[TensorInfo.DataType] = ...
        FP32: ClassVar[TensorInfo.DataType] = ...
        FP64: ClassVar[TensorInfo.DataType] = ...
        I8: ClassVar[TensorInfo.DataType] = ...
        INT: ClassVar[TensorInfo.DataType] = ...
        U8F: ClassVar[TensorInfo.DataType] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.TensorInfo.DataType, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.TensorInfo.DataType) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.TensorInfo.DataType) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class StorageOrder:
        __members__: ClassVar[dict] = ...  # read-only
        C: ClassVar[TensorInfo.StorageOrder] = ...
        CHW: ClassVar[TensorInfo.StorageOrder] = ...
        CN: ClassVar[TensorInfo.StorageOrder] = ...
        CWH: ClassVar[TensorInfo.StorageOrder] = ...
        H: ClassVar[TensorInfo.StorageOrder] = ...
        HCW: ClassVar[TensorInfo.StorageOrder] = ...
        HWC: ClassVar[TensorInfo.StorageOrder] = ...
        NC: ClassVar[TensorInfo.StorageOrder] = ...
        NCHW: ClassVar[TensorInfo.StorageOrder] = ...
        NHCW: ClassVar[TensorInfo.StorageOrder] = ...
        NHWC: ClassVar[TensorInfo.StorageOrder] = ...
        W: ClassVar[TensorInfo.StorageOrder] = ...
        WCH: ClassVar[TensorInfo.StorageOrder] = ...
        WHC: ClassVar[TensorInfo.StorageOrder] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.TensorInfo.StorageOrder, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.TensorInfo.StorageOrder) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.TensorInfo.StorageOrder) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    dataType: TensorInfo.DataType
    dims: list[int]
    name: str
    numDimensions: int
    offset: int
    order: TensorInfo.StorageOrder
    qpScale: float
    qpZp: float
    quantization: bool
    strides: list[int]
    def __init__(self) -> None:
        """__init__(self: depthai.TensorInfo) -> None"""
    def getTensorSize(self) -> int:
        """getTensorSize(self: depthai.TensorInfo) -> int"""

class TextAnnotation:
    backgroundColor: Color
    fontSize: float
    position: Point2f
    text: str
    textColor: Color
    def __init__(self) -> None:
        """__init__(self: depthai.TextAnnotation) -> None"""

class ThermalAmbientParams:
    atmosphericTemperature: int | None
    atmosphericTransmittance: int | None
    distance: int | None
    gainMode: ThermalGainMode | None
    reflectionTemperature: int | None
    targetEmissivity: int | None
    def __init__(self) -> None:
        """__init__(self: depthai.ThermalAmbientParams) -> None"""

class ThermalConfig(Buffer):
    ambientParams: ThermalAmbientParams
    ffcParams: ThermalFFCParams
    imageParams: ThermalImageParams
    def __init__(self) -> None:
        """__init__(self: depthai.ThermalConfig) -> None"""

class ThermalFFCParams:
    antiFallProtectionThresholdHighGainMode: int | None
    antiFallProtectionThresholdLowGainMode: int | None
    autoFFC: bool | None
    autoFFCTempThreshold: int | None
    closeManualShutter: bool | None
    fallProtection: bool | None
    maxFFCInterval: int | None
    minFFCInterval: int | None
    minShutterInterval: int | None
    def __init__(self) -> None:
        """__init__(self: depthai.ThermalFFCParams) -> None"""

class ThermalGainMode:
    __members__: ClassVar[dict] = ...  # read-only
    HIGH: ClassVar[ThermalGainMode] = ...
    LOW: ClassVar[ThermalGainMode] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.ThermalGainMode, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.ThermalGainMode) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.ThermalGainMode) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class ThermalImageParams:
    brightnessLevel: int | None
    contrastLevel: int | None
    digitalDetailEnhanceLevel: int | None
    orientation: Incomplete
    spatialNoiseFilterLevel: int | None
    timeNoiseFilterLevel: int | None
    def __init__(self) -> None:
        """__init__(self: depthai.ThermalImageParams) -> None"""

class ThermalProperties:
    boardSocket: CameraBoardSocket
    fps: float
    initialConfig: ThermalConfig
    numFramesPool: int
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class ThreadedNode(Node):
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def critical(self, arg0: str) -> None:
        """critical(self: depthai.ThreadedNode, arg0: str) -> None"""
    def debug(self, arg0: str) -> None:
        """debug(self: depthai.ThreadedNode, arg0: str) -> None"""
    def error(self, arg0: str) -> None:
        """error(self: depthai.ThreadedNode, arg0: str) -> None"""
    def getLogLevel(self) -> LogLevel:
        """getLogLevel(self: depthai.ThreadedNode) -> depthai.LogLevel

        Gets the logging severity level for this node.

        Returns:
            Logging severity level
        """
    def info(self, arg0: str) -> None:
        """info(self: depthai.ThreadedNode, arg0: str) -> None"""
    def isRunning(self) -> bool:
        """isRunning(self: depthai.ThreadedNode) -> bool"""
    def setLogLevel(self, arg0: LogLevel) -> None:
        """setLogLevel(self: depthai.ThreadedNode, arg0: depthai.LogLevel) -> None

        Sets the logging severity level for this node.

        Parameter ``level``:
            Logging severity level
        """
    def trace(self, arg0: str) -> None:
        """trace(self: depthai.ThreadedNode, arg0: str) -> None"""
    def warn(self, arg0: str) -> None:
        """warn(self: depthai.ThreadedNode, arg0: str) -> None"""

class Timestamp:
    nsec: int
    sec: int
    def __init__(self) -> None:
        """__init__(self: depthai.Timestamp) -> None"""
    def get(self) -> datetime.timedelta:
        """get(self: depthai.Timestamp) -> datetime.timedelta"""

class ToFConfig(Buffer):
    enableBurstMode: bool
    enableDistortionCorrection: bool
    enableFPPNCorrection: bool | None
    enableOpticalCorrection: bool | None
    enablePhaseShuffleTemporalFilter: bool
    enablePhaseUnwrapping: bool | None
    enableTemperatureCorrection: bool | None
    enableWiggleCorrection: bool | None
    median: Incomplete
    phaseUnwrapErrorThreshold: int
    phaseUnwrappingLevel: int
    def __init__(self) -> None:
        """__init__(self: depthai.ToFConfig) -> None"""
    def setMedianFilter(self, arg0) -> ToFConfig:
        """setMedianFilter(self: depthai.ToFConfig, arg0: dai::MedianFilter) -> depthai.ToFConfig

        Parameter ``median``:
            Set kernel size for median filtering, or disable
        """

class ToFProperties:
    initialConfig: ToFConfig
    numFramesPool: int
    numShaves: int
    warpHwIds: list[int]
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class TrackedFeature:
    age: int
    descriptor: Incomplete
    harrisScore: float
    id: int
    position: Point2f
    trackingError: float
    def __init__(self) -> None:
        """__init__(self: depthai.TrackedFeature) -> None"""

class TrackedFeatures(Buffer):
    trackedFeatures: list[TrackedFeature]
    def __init__(self) -> None:
        """__init__(self: depthai.TrackedFeatures) -> None"""
    def getSequenceNum(self) -> int:
        """getSequenceNum(self: depthai.TrackedFeatures) -> int

        Retrieves image sequence number
        """
    def getTimestamp(self) -> datetime.timedelta:
        """getTimestamp(self: depthai.TrackedFeatures) -> datetime.timedelta

        Retrieves timestamp related to dai::Clock::now()
        """
    def getTimestampDevice(self) -> datetime.timedelta:
        """getTimestampDevice(self: depthai.TrackedFeatures) -> datetime.timedelta

        Retrieves timestamp directly captured from device's monotonic clock, not
        synchronized to host time. Used mostly for debugging
        """

class TrackerIdAssignmentPolicy:
    __members__: ClassVar[dict] = ...  # read-only
    SMALLEST_ID: ClassVar[TrackerIdAssignmentPolicy] = ...
    UNIQUE_ID: ClassVar[TrackerIdAssignmentPolicy] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.TrackerIdAssignmentPolicy, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.TrackerIdAssignmentPolicy) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.TrackerIdAssignmentPolicy) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class TrackerType:
    __members__: ClassVar[dict] = ...  # read-only
    SHORT_TERM_IMAGELESS: ClassVar[TrackerType] = ...
    SHORT_TERM_KCF: ClassVar[TrackerType] = ...
    ZERO_TERM_COLOR_HISTOGRAM: ClassVar[TrackerType] = ...
    ZERO_TERM_IMAGELESS: ClassVar[TrackerType] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.TrackerType, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.TrackerType) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.TrackerType) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class Tracklet:
    class TrackingStatus:
        __members__: ClassVar[dict] = ...  # read-only
        LOST: ClassVar[Tracklet.TrackingStatus] = ...
        NEW: ClassVar[Tracklet.TrackingStatus] = ...
        REMOVED: ClassVar[Tracklet.TrackingStatus] = ...
        TRACKED: ClassVar[Tracklet.TrackingStatus] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.Tracklet.TrackingStatus, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.Tracklet.TrackingStatus) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.Tracklet.TrackingStatus) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    age: int
    id: int
    label: int
    roi: Rect
    spatialCoordinates: Point3f
    srcImgDetection: ImgDetection
    status: Tracklet.TrackingStatus
    def __init__(self) -> None:
        """__init__(self: depthai.Tracklet) -> None"""

class Tracklets(Buffer):
    tracklets: list[Tracklet]
    def __init__(self) -> None:
        """__init__(self: depthai.Tracklets) -> None"""
    def getSequenceNum(self) -> int:
        """getSequenceNum(self: depthai.Tracklets) -> int

        Retrieves image sequence number
        """
    def getTimestamp(self) -> datetime.timedelta:
        """getTimestamp(self: depthai.Tracklets) -> datetime.timedelta

        Retrieves timestamp related to dai::Clock::now()
        """
    def getTimestampDevice(self) -> datetime.timedelta:
        """getTimestampDevice(self: depthai.Tracklets) -> datetime.timedelta

        Retrieves timestamp directly captured from device's monotonic clock, not
        synchronized to host time. Used mostly for debugging
        """

class TransformData(Buffer):
    def __init__(self) -> None:
        """__init__(self: depthai.TransformData) -> None"""
    def getQuaternion(self) -> Quaterniond:
        """getQuaternion(self: depthai.TransformData) -> depthai.Quaterniond"""
    def getRotationEuler(self) -> Point3d:
        """getRotationEuler(self: depthai.TransformData) -> depthai.Point3d"""
    def getTranslation(self) -> Point3d:
        """getTranslation(self: depthai.TransformData) -> depthai.Point3d"""

class UVCProperties:
    gpioInit: dict[int, int]
    gpioStreamOff: dict[int, int]
    gpioStreamOn: dict[int, int]
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class UsbSpeed:
    __members__: ClassVar[dict] = ...  # read-only
    FULL: ClassVar[UsbSpeed] = ...
    HIGH: ClassVar[UsbSpeed] = ...
    LOW: ClassVar[UsbSpeed] = ...
    SUPER: ClassVar[UsbSpeed] = ...
    SUPER_PLUS: ClassVar[UsbSpeed] = ...
    UNKNOWN: ClassVar[UsbSpeed] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.UsbSpeed, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.UsbSpeed) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.UsbSpeed) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class VectorCircleAnnotation:
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.VectorCircleAnnotation) -> None

        2. __init__(self: depthai.VectorCircleAnnotation, arg0: depthai.VectorCircleAnnotation) -> None

        Copy constructor

        3. __init__(self: depthai.VectorCircleAnnotation, arg0: Iterable) -> None
        """
    @overload
    def __init__(self, arg0: VectorCircleAnnotation) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.VectorCircleAnnotation) -> None

        2. __init__(self: depthai.VectorCircleAnnotation, arg0: depthai.VectorCircleAnnotation) -> None

        Copy constructor

        3. __init__(self: depthai.VectorCircleAnnotation, arg0: Iterable) -> None
        """
    @overload
    def __init__(self, arg0: Iterable) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.VectorCircleAnnotation) -> None

        2. __init__(self: depthai.VectorCircleAnnotation, arg0: depthai.VectorCircleAnnotation) -> None

        Copy constructor

        3. __init__(self: depthai.VectorCircleAnnotation, arg0: Iterable) -> None
        """
    def append(self, x: CircleAnnotation) -> None:
        """append(self: depthai.VectorCircleAnnotation, x: depthai.CircleAnnotation) -> None

        Add an item to the end of the list
        """
    def clear(self) -> None:
        """clear(self: depthai.VectorCircleAnnotation) -> None

        Clear the contents
        """
    @overload
    def extend(self, L: VectorCircleAnnotation) -> None:
        """extend(*args, **kwargs)
        Overloaded function.

        1. extend(self: depthai.VectorCircleAnnotation, L: depthai.VectorCircleAnnotation) -> None

        Extend the list by appending all the items in the given list

        2. extend(self: depthai.VectorCircleAnnotation, L: Iterable) -> None

        Extend the list by appending all the items in the given list
        """
    @overload
    def extend(self, L: Iterable) -> None:
        """extend(*args, **kwargs)
        Overloaded function.

        1. extend(self: depthai.VectorCircleAnnotation, L: depthai.VectorCircleAnnotation) -> None

        Extend the list by appending all the items in the given list

        2. extend(self: depthai.VectorCircleAnnotation, L: Iterable) -> None

        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: CircleAnnotation) -> None:
        """insert(self: depthai.VectorCircleAnnotation, i: int, x: depthai.CircleAnnotation) -> None

        Insert an item at a given position.
        """
    @overload
    def pop(self) -> CircleAnnotation:
        """pop(*args, **kwargs)
        Overloaded function.

        1. pop(self: depthai.VectorCircleAnnotation) -> depthai.CircleAnnotation

        Remove and return the last item

        2. pop(self: depthai.VectorCircleAnnotation, i: int) -> depthai.CircleAnnotation

        Remove and return the item at index ``i``
        """
    @overload
    def pop(self, i: int) -> CircleAnnotation:
        """pop(*args, **kwargs)
        Overloaded function.

        1. pop(self: depthai.VectorCircleAnnotation) -> depthai.CircleAnnotation

        Remove and return the last item

        2. pop(self: depthai.VectorCircleAnnotation, i: int) -> depthai.CircleAnnotation

        Remove and return the item at index ``i``
        """
    def __bool__(self) -> bool:
        """__bool__(self: depthai.VectorCircleAnnotation) -> bool

        Check whether the list is nonempty
        """
    @overload
    def __delitem__(self, arg0: int) -> None:
        """__delitem__(*args, **kwargs)
        Overloaded function.

        1. __delitem__(self: depthai.VectorCircleAnnotation, arg0: int) -> None

        Delete the list elements at index ``i``

        2. __delitem__(self: depthai.VectorCircleAnnotation, arg0: slice) -> None

        Delete list elements using a slice object
        """
    @overload
    def __delitem__(self, arg0: slice) -> None:
        """__delitem__(*args, **kwargs)
        Overloaded function.

        1. __delitem__(self: depthai.VectorCircleAnnotation, arg0: int) -> None

        Delete the list elements at index ``i``

        2. __delitem__(self: depthai.VectorCircleAnnotation, arg0: slice) -> None

        Delete list elements using a slice object
        """
    @overload
    def __getitem__(self, s: slice) -> VectorCircleAnnotation:
        """__getitem__(*args, **kwargs)
        Overloaded function.

        1. __getitem__(self: depthai.VectorCircleAnnotation, s: slice) -> depthai.VectorCircleAnnotation

        Retrieve list elements using a slice object

        2. __getitem__(self: depthai.VectorCircleAnnotation, arg0: int) -> depthai.CircleAnnotation
        """
    @overload
    def __getitem__(self, arg0: int) -> CircleAnnotation:
        """__getitem__(*args, **kwargs)
        Overloaded function.

        1. __getitem__(self: depthai.VectorCircleAnnotation, s: slice) -> depthai.VectorCircleAnnotation

        Retrieve list elements using a slice object

        2. __getitem__(self: depthai.VectorCircleAnnotation, arg0: int) -> depthai.CircleAnnotation
        """
    def __iter__(self) -> Iterator[CircleAnnotation]:
        """__iter__(self: depthai.VectorCircleAnnotation) -> Iterator[depthai.CircleAnnotation]"""
    def __len__(self) -> int:
        """__len__(self: depthai.VectorCircleAnnotation) -> int"""
    @overload
    def __setitem__(self, arg0: int, arg1: CircleAnnotation) -> None:
        """__setitem__(*args, **kwargs)
        Overloaded function.

        1. __setitem__(self: depthai.VectorCircleAnnotation, arg0: int, arg1: depthai.CircleAnnotation) -> None

        2. __setitem__(self: depthai.VectorCircleAnnotation, arg0: slice, arg1: depthai.VectorCircleAnnotation) -> None

        Assign list elements using a slice object
        """
    @overload
    def __setitem__(self, arg0: slice, arg1: VectorCircleAnnotation) -> None:
        """__setitem__(*args, **kwargs)
        Overloaded function.

        1. __setitem__(self: depthai.VectorCircleAnnotation, arg0: int, arg1: depthai.CircleAnnotation) -> None

        2. __setitem__(self: depthai.VectorCircleAnnotation, arg0: slice, arg1: depthai.VectorCircleAnnotation) -> None

        Assign list elements using a slice object
        """

class VectorColor:
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.VectorColor) -> None

        2. __init__(self: depthai.VectorColor, arg0: depthai.VectorColor) -> None

        Copy constructor

        3. __init__(self: depthai.VectorColor, arg0: Iterable) -> None
        """
    @overload
    def __init__(self, arg0: VectorColor) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.VectorColor) -> None

        2. __init__(self: depthai.VectorColor, arg0: depthai.VectorColor) -> None

        Copy constructor

        3. __init__(self: depthai.VectorColor, arg0: Iterable) -> None
        """
    @overload
    def __init__(self, arg0: Iterable) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.VectorColor) -> None

        2. __init__(self: depthai.VectorColor, arg0: depthai.VectorColor) -> None

        Copy constructor

        3. __init__(self: depthai.VectorColor, arg0: Iterable) -> None
        """
    def append(self, x: Color) -> None:
        """append(self: depthai.VectorColor, x: depthai.Color) -> None

        Add an item to the end of the list
        """
    def clear(self) -> None:
        """clear(self: depthai.VectorColor) -> None

        Clear the contents
        """
    @overload
    def extend(self, L: VectorColor) -> None:
        """extend(*args, **kwargs)
        Overloaded function.

        1. extend(self: depthai.VectorColor, L: depthai.VectorColor) -> None

        Extend the list by appending all the items in the given list

        2. extend(self: depthai.VectorColor, L: Iterable) -> None

        Extend the list by appending all the items in the given list
        """
    @overload
    def extend(self, L: Iterable) -> None:
        """extend(*args, **kwargs)
        Overloaded function.

        1. extend(self: depthai.VectorColor, L: depthai.VectorColor) -> None

        Extend the list by appending all the items in the given list

        2. extend(self: depthai.VectorColor, L: Iterable) -> None

        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: Color) -> None:
        """insert(self: depthai.VectorColor, i: int, x: depthai.Color) -> None

        Insert an item at a given position.
        """
    @overload
    def pop(self) -> Color:
        """pop(*args, **kwargs)
        Overloaded function.

        1. pop(self: depthai.VectorColor) -> depthai.Color

        Remove and return the last item

        2. pop(self: depthai.VectorColor, i: int) -> depthai.Color

        Remove and return the item at index ``i``
        """
    @overload
    def pop(self, i: int) -> Color:
        """pop(*args, **kwargs)
        Overloaded function.

        1. pop(self: depthai.VectorColor) -> depthai.Color

        Remove and return the last item

        2. pop(self: depthai.VectorColor, i: int) -> depthai.Color

        Remove and return the item at index ``i``
        """
    def __bool__(self) -> bool:
        """__bool__(self: depthai.VectorColor) -> bool

        Check whether the list is nonempty
        """
    @overload
    def __delitem__(self, arg0: int) -> None:
        """__delitem__(*args, **kwargs)
        Overloaded function.

        1. __delitem__(self: depthai.VectorColor, arg0: int) -> None

        Delete the list elements at index ``i``

        2. __delitem__(self: depthai.VectorColor, arg0: slice) -> None

        Delete list elements using a slice object
        """
    @overload
    def __delitem__(self, arg0: slice) -> None:
        """__delitem__(*args, **kwargs)
        Overloaded function.

        1. __delitem__(self: depthai.VectorColor, arg0: int) -> None

        Delete the list elements at index ``i``

        2. __delitem__(self: depthai.VectorColor, arg0: slice) -> None

        Delete list elements using a slice object
        """
    @overload
    def __getitem__(self, s: slice) -> VectorColor:
        """__getitem__(*args, **kwargs)
        Overloaded function.

        1. __getitem__(self: depthai.VectorColor, s: slice) -> depthai.VectorColor

        Retrieve list elements using a slice object

        2. __getitem__(self: depthai.VectorColor, arg0: int) -> depthai.Color
        """
    @overload
    def __getitem__(self, arg0: int) -> Color:
        """__getitem__(*args, **kwargs)
        Overloaded function.

        1. __getitem__(self: depthai.VectorColor, s: slice) -> depthai.VectorColor

        Retrieve list elements using a slice object

        2. __getitem__(self: depthai.VectorColor, arg0: int) -> depthai.Color
        """
    def __iter__(self) -> Iterator[Color]:
        """__iter__(self: depthai.VectorColor) -> Iterator[depthai.Color]"""
    def __len__(self) -> int:
        """__len__(self: depthai.VectorColor) -> int"""
    @overload
    def __setitem__(self, arg0: int, arg1: Color) -> None:
        """__setitem__(*args, **kwargs)
        Overloaded function.

        1. __setitem__(self: depthai.VectorColor, arg0: int, arg1: depthai.Color) -> None

        2. __setitem__(self: depthai.VectorColor, arg0: slice, arg1: depthai.VectorColor) -> None

        Assign list elements using a slice object
        """
    @overload
    def __setitem__(self, arg0: slice, arg1: VectorColor) -> None:
        """__setitem__(*args, **kwargs)
        Overloaded function.

        1. __setitem__(self: depthai.VectorColor, arg0: int, arg1: depthai.Color) -> None

        2. __setitem__(self: depthai.VectorColor, arg0: slice, arg1: depthai.VectorColor) -> None

        Assign list elements using a slice object
        """

class VectorImgAnnotation:
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.VectorImgAnnotation) -> None

        2. __init__(self: depthai.VectorImgAnnotation, arg0: depthai.VectorImgAnnotation) -> None

        Copy constructor

        3. __init__(self: depthai.VectorImgAnnotation, arg0: Iterable) -> None
        """
    @overload
    def __init__(self, arg0: VectorImgAnnotation) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.VectorImgAnnotation) -> None

        2. __init__(self: depthai.VectorImgAnnotation, arg0: depthai.VectorImgAnnotation) -> None

        Copy constructor

        3. __init__(self: depthai.VectorImgAnnotation, arg0: Iterable) -> None
        """
    @overload
    def __init__(self, arg0: Iterable) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.VectorImgAnnotation) -> None

        2. __init__(self: depthai.VectorImgAnnotation, arg0: depthai.VectorImgAnnotation) -> None

        Copy constructor

        3. __init__(self: depthai.VectorImgAnnotation, arg0: Iterable) -> None
        """
    def append(self, x: ImgAnnotation) -> None:
        """append(self: depthai.VectorImgAnnotation, x: depthai.ImgAnnotation) -> None

        Add an item to the end of the list
        """
    def clear(self) -> None:
        """clear(self: depthai.VectorImgAnnotation) -> None

        Clear the contents
        """
    @overload
    def extend(self, L: VectorImgAnnotation) -> None:
        """extend(*args, **kwargs)
        Overloaded function.

        1. extend(self: depthai.VectorImgAnnotation, L: depthai.VectorImgAnnotation) -> None

        Extend the list by appending all the items in the given list

        2. extend(self: depthai.VectorImgAnnotation, L: Iterable) -> None

        Extend the list by appending all the items in the given list
        """
    @overload
    def extend(self, L: Iterable) -> None:
        """extend(*args, **kwargs)
        Overloaded function.

        1. extend(self: depthai.VectorImgAnnotation, L: depthai.VectorImgAnnotation) -> None

        Extend the list by appending all the items in the given list

        2. extend(self: depthai.VectorImgAnnotation, L: Iterable) -> None

        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: ImgAnnotation) -> None:
        """insert(self: depthai.VectorImgAnnotation, i: int, x: depthai.ImgAnnotation) -> None

        Insert an item at a given position.
        """
    @overload
    def pop(self) -> ImgAnnotation:
        """pop(*args, **kwargs)
        Overloaded function.

        1. pop(self: depthai.VectorImgAnnotation) -> depthai.ImgAnnotation

        Remove and return the last item

        2. pop(self: depthai.VectorImgAnnotation, i: int) -> depthai.ImgAnnotation

        Remove and return the item at index ``i``
        """
    @overload
    def pop(self, i: int) -> ImgAnnotation:
        """pop(*args, **kwargs)
        Overloaded function.

        1. pop(self: depthai.VectorImgAnnotation) -> depthai.ImgAnnotation

        Remove and return the last item

        2. pop(self: depthai.VectorImgAnnotation, i: int) -> depthai.ImgAnnotation

        Remove and return the item at index ``i``
        """
    def __bool__(self) -> bool:
        """__bool__(self: depthai.VectorImgAnnotation) -> bool

        Check whether the list is nonempty
        """
    @overload
    def __delitem__(self, arg0: int) -> None:
        """__delitem__(*args, **kwargs)
        Overloaded function.

        1. __delitem__(self: depthai.VectorImgAnnotation, arg0: int) -> None

        Delete the list elements at index ``i``

        2. __delitem__(self: depthai.VectorImgAnnotation, arg0: slice) -> None

        Delete list elements using a slice object
        """
    @overload
    def __delitem__(self, arg0: slice) -> None:
        """__delitem__(*args, **kwargs)
        Overloaded function.

        1. __delitem__(self: depthai.VectorImgAnnotation, arg0: int) -> None

        Delete the list elements at index ``i``

        2. __delitem__(self: depthai.VectorImgAnnotation, arg0: slice) -> None

        Delete list elements using a slice object
        """
    @overload
    def __getitem__(self, s: slice) -> VectorImgAnnotation:
        """__getitem__(*args, **kwargs)
        Overloaded function.

        1. __getitem__(self: depthai.VectorImgAnnotation, s: slice) -> depthai.VectorImgAnnotation

        Retrieve list elements using a slice object

        2. __getitem__(self: depthai.VectorImgAnnotation, arg0: int) -> depthai.ImgAnnotation
        """
    @overload
    def __getitem__(self, arg0: int) -> ImgAnnotation:
        """__getitem__(*args, **kwargs)
        Overloaded function.

        1. __getitem__(self: depthai.VectorImgAnnotation, s: slice) -> depthai.VectorImgAnnotation

        Retrieve list elements using a slice object

        2. __getitem__(self: depthai.VectorImgAnnotation, arg0: int) -> depthai.ImgAnnotation
        """
    def __iter__(self) -> Iterator[ImgAnnotation]:
        """__iter__(self: depthai.VectorImgAnnotation) -> Iterator[depthai.ImgAnnotation]"""
    def __len__(self) -> int:
        """__len__(self: depthai.VectorImgAnnotation) -> int"""
    @overload
    def __setitem__(self, arg0: int, arg1: ImgAnnotation) -> None:
        """__setitem__(*args, **kwargs)
        Overloaded function.

        1. __setitem__(self: depthai.VectorImgAnnotation, arg0: int, arg1: depthai.ImgAnnotation) -> None

        2. __setitem__(self: depthai.VectorImgAnnotation, arg0: slice, arg1: depthai.VectorImgAnnotation) -> None

        Assign list elements using a slice object
        """
    @overload
    def __setitem__(self, arg0: slice, arg1: VectorImgAnnotation) -> None:
        """__setitem__(*args, **kwargs)
        Overloaded function.

        1. __setitem__(self: depthai.VectorImgAnnotation, arg0: int, arg1: depthai.ImgAnnotation) -> None

        2. __setitem__(self: depthai.VectorImgAnnotation, arg0: slice, arg1: depthai.VectorImgAnnotation) -> None

        Assign list elements using a slice object
        """

class VectorPoint2f:
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.VectorPoint2f) -> None

        2. __init__(self: depthai.VectorPoint2f, arg0: depthai.VectorPoint2f) -> None

        Copy constructor

        3. __init__(self: depthai.VectorPoint2f, arg0: Iterable) -> None
        """
    @overload
    def __init__(self, arg0: VectorPoint2f) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.VectorPoint2f) -> None

        2. __init__(self: depthai.VectorPoint2f, arg0: depthai.VectorPoint2f) -> None

        Copy constructor

        3. __init__(self: depthai.VectorPoint2f, arg0: Iterable) -> None
        """
    @overload
    def __init__(self, arg0: Iterable) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.VectorPoint2f) -> None

        2. __init__(self: depthai.VectorPoint2f, arg0: depthai.VectorPoint2f) -> None

        Copy constructor

        3. __init__(self: depthai.VectorPoint2f, arg0: Iterable) -> None
        """
    def append(self, x: Point2f) -> None:
        """append(self: depthai.VectorPoint2f, x: depthai.Point2f) -> None

        Add an item to the end of the list
        """
    def clear(self) -> None:
        """clear(self: depthai.VectorPoint2f) -> None

        Clear the contents
        """
    @overload
    def extend(self, L: VectorPoint2f) -> None:
        """extend(*args, **kwargs)
        Overloaded function.

        1. extend(self: depthai.VectorPoint2f, L: depthai.VectorPoint2f) -> None

        Extend the list by appending all the items in the given list

        2. extend(self: depthai.VectorPoint2f, L: Iterable) -> None

        Extend the list by appending all the items in the given list
        """
    @overload
    def extend(self, L: Iterable) -> None:
        """extend(*args, **kwargs)
        Overloaded function.

        1. extend(self: depthai.VectorPoint2f, L: depthai.VectorPoint2f) -> None

        Extend the list by appending all the items in the given list

        2. extend(self: depthai.VectorPoint2f, L: Iterable) -> None

        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: Point2f) -> None:
        """insert(self: depthai.VectorPoint2f, i: int, x: depthai.Point2f) -> None

        Insert an item at a given position.
        """
    @overload
    def pop(self) -> Point2f:
        """pop(*args, **kwargs)
        Overloaded function.

        1. pop(self: depthai.VectorPoint2f) -> depthai.Point2f

        Remove and return the last item

        2. pop(self: depthai.VectorPoint2f, i: int) -> depthai.Point2f

        Remove and return the item at index ``i``
        """
    @overload
    def pop(self, i: int) -> Point2f:
        """pop(*args, **kwargs)
        Overloaded function.

        1. pop(self: depthai.VectorPoint2f) -> depthai.Point2f

        Remove and return the last item

        2. pop(self: depthai.VectorPoint2f, i: int) -> depthai.Point2f

        Remove and return the item at index ``i``
        """
    def __bool__(self) -> bool:
        """__bool__(self: depthai.VectorPoint2f) -> bool

        Check whether the list is nonempty
        """
    @overload
    def __delitem__(self, arg0: int) -> None:
        """__delitem__(*args, **kwargs)
        Overloaded function.

        1. __delitem__(self: depthai.VectorPoint2f, arg0: int) -> None

        Delete the list elements at index ``i``

        2. __delitem__(self: depthai.VectorPoint2f, arg0: slice) -> None

        Delete list elements using a slice object
        """
    @overload
    def __delitem__(self, arg0: slice) -> None:
        """__delitem__(*args, **kwargs)
        Overloaded function.

        1. __delitem__(self: depthai.VectorPoint2f, arg0: int) -> None

        Delete the list elements at index ``i``

        2. __delitem__(self: depthai.VectorPoint2f, arg0: slice) -> None

        Delete list elements using a slice object
        """
    @overload
    def __getitem__(self, s: slice) -> VectorPoint2f:
        """__getitem__(*args, **kwargs)
        Overloaded function.

        1. __getitem__(self: depthai.VectorPoint2f, s: slice) -> depthai.VectorPoint2f

        Retrieve list elements using a slice object

        2. __getitem__(self: depthai.VectorPoint2f, arg0: int) -> depthai.Point2f
        """
    @overload
    def __getitem__(self, arg0: int) -> Point2f:
        """__getitem__(*args, **kwargs)
        Overloaded function.

        1. __getitem__(self: depthai.VectorPoint2f, s: slice) -> depthai.VectorPoint2f

        Retrieve list elements using a slice object

        2. __getitem__(self: depthai.VectorPoint2f, arg0: int) -> depthai.Point2f
        """
    def __iter__(self) -> Iterator[Point2f]:
        """__iter__(self: depthai.VectorPoint2f) -> Iterator[depthai.Point2f]"""
    def __len__(self) -> int:
        """__len__(self: depthai.VectorPoint2f) -> int"""
    @overload
    def __setitem__(self, arg0: int, arg1: Point2f) -> None:
        """__setitem__(*args, **kwargs)
        Overloaded function.

        1. __setitem__(self: depthai.VectorPoint2f, arg0: int, arg1: depthai.Point2f) -> None

        2. __setitem__(self: depthai.VectorPoint2f, arg0: slice, arg1: depthai.VectorPoint2f) -> None

        Assign list elements using a slice object
        """
    @overload
    def __setitem__(self, arg0: slice, arg1: VectorPoint2f) -> None:
        """__setitem__(*args, **kwargs)
        Overloaded function.

        1. __setitem__(self: depthai.VectorPoint2f, arg0: int, arg1: depthai.Point2f) -> None

        2. __setitem__(self: depthai.VectorPoint2f, arg0: slice, arg1: depthai.VectorPoint2f) -> None

        Assign list elements using a slice object
        """

class VectorPointsAnnotation:
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.VectorPointsAnnotation) -> None

        2. __init__(self: depthai.VectorPointsAnnotation, arg0: depthai.VectorPointsAnnotation) -> None

        Copy constructor

        3. __init__(self: depthai.VectorPointsAnnotation, arg0: Iterable) -> None
        """
    @overload
    def __init__(self, arg0: VectorPointsAnnotation) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.VectorPointsAnnotation) -> None

        2. __init__(self: depthai.VectorPointsAnnotation, arg0: depthai.VectorPointsAnnotation) -> None

        Copy constructor

        3. __init__(self: depthai.VectorPointsAnnotation, arg0: Iterable) -> None
        """
    @overload
    def __init__(self, arg0: Iterable) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.VectorPointsAnnotation) -> None

        2. __init__(self: depthai.VectorPointsAnnotation, arg0: depthai.VectorPointsAnnotation) -> None

        Copy constructor

        3. __init__(self: depthai.VectorPointsAnnotation, arg0: Iterable) -> None
        """
    def append(self, x: PointsAnnotation) -> None:
        """append(self: depthai.VectorPointsAnnotation, x: depthai.PointsAnnotation) -> None

        Add an item to the end of the list
        """
    def clear(self) -> None:
        """clear(self: depthai.VectorPointsAnnotation) -> None

        Clear the contents
        """
    @overload
    def extend(self, L: VectorPointsAnnotation) -> None:
        """extend(*args, **kwargs)
        Overloaded function.

        1. extend(self: depthai.VectorPointsAnnotation, L: depthai.VectorPointsAnnotation) -> None

        Extend the list by appending all the items in the given list

        2. extend(self: depthai.VectorPointsAnnotation, L: Iterable) -> None

        Extend the list by appending all the items in the given list
        """
    @overload
    def extend(self, L: Iterable) -> None:
        """extend(*args, **kwargs)
        Overloaded function.

        1. extend(self: depthai.VectorPointsAnnotation, L: depthai.VectorPointsAnnotation) -> None

        Extend the list by appending all the items in the given list

        2. extend(self: depthai.VectorPointsAnnotation, L: Iterable) -> None

        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: PointsAnnotation) -> None:
        """insert(self: depthai.VectorPointsAnnotation, i: int, x: depthai.PointsAnnotation) -> None

        Insert an item at a given position.
        """
    @overload
    def pop(self) -> PointsAnnotation:
        """pop(*args, **kwargs)
        Overloaded function.

        1. pop(self: depthai.VectorPointsAnnotation) -> depthai.PointsAnnotation

        Remove and return the last item

        2. pop(self: depthai.VectorPointsAnnotation, i: int) -> depthai.PointsAnnotation

        Remove and return the item at index ``i``
        """
    @overload
    def pop(self, i: int) -> PointsAnnotation:
        """pop(*args, **kwargs)
        Overloaded function.

        1. pop(self: depthai.VectorPointsAnnotation) -> depthai.PointsAnnotation

        Remove and return the last item

        2. pop(self: depthai.VectorPointsAnnotation, i: int) -> depthai.PointsAnnotation

        Remove and return the item at index ``i``
        """
    def __bool__(self) -> bool:
        """__bool__(self: depthai.VectorPointsAnnotation) -> bool

        Check whether the list is nonempty
        """
    @overload
    def __delitem__(self, arg0: int) -> None:
        """__delitem__(*args, **kwargs)
        Overloaded function.

        1. __delitem__(self: depthai.VectorPointsAnnotation, arg0: int) -> None

        Delete the list elements at index ``i``

        2. __delitem__(self: depthai.VectorPointsAnnotation, arg0: slice) -> None

        Delete list elements using a slice object
        """
    @overload
    def __delitem__(self, arg0: slice) -> None:
        """__delitem__(*args, **kwargs)
        Overloaded function.

        1. __delitem__(self: depthai.VectorPointsAnnotation, arg0: int) -> None

        Delete the list elements at index ``i``

        2. __delitem__(self: depthai.VectorPointsAnnotation, arg0: slice) -> None

        Delete list elements using a slice object
        """
    @overload
    def __getitem__(self, s: slice) -> VectorPointsAnnotation:
        """__getitem__(*args, **kwargs)
        Overloaded function.

        1. __getitem__(self: depthai.VectorPointsAnnotation, s: slice) -> depthai.VectorPointsAnnotation

        Retrieve list elements using a slice object

        2. __getitem__(self: depthai.VectorPointsAnnotation, arg0: int) -> depthai.PointsAnnotation
        """
    @overload
    def __getitem__(self, arg0: int) -> PointsAnnotation:
        """__getitem__(*args, **kwargs)
        Overloaded function.

        1. __getitem__(self: depthai.VectorPointsAnnotation, s: slice) -> depthai.VectorPointsAnnotation

        Retrieve list elements using a slice object

        2. __getitem__(self: depthai.VectorPointsAnnotation, arg0: int) -> depthai.PointsAnnotation
        """
    def __iter__(self) -> Iterator[PointsAnnotation]:
        """__iter__(self: depthai.VectorPointsAnnotation) -> Iterator[depthai.PointsAnnotation]"""
    def __len__(self) -> int:
        """__len__(self: depthai.VectorPointsAnnotation) -> int"""
    @overload
    def __setitem__(self, arg0: int, arg1: PointsAnnotation) -> None:
        """__setitem__(*args, **kwargs)
        Overloaded function.

        1. __setitem__(self: depthai.VectorPointsAnnotation, arg0: int, arg1: depthai.PointsAnnotation) -> None

        2. __setitem__(self: depthai.VectorPointsAnnotation, arg0: slice, arg1: depthai.VectorPointsAnnotation) -> None

        Assign list elements using a slice object
        """
    @overload
    def __setitem__(self, arg0: slice, arg1: VectorPointsAnnotation) -> None:
        """__setitem__(*args, **kwargs)
        Overloaded function.

        1. __setitem__(self: depthai.VectorPointsAnnotation, arg0: int, arg1: depthai.PointsAnnotation) -> None

        2. __setitem__(self: depthai.VectorPointsAnnotation, arg0: slice, arg1: depthai.VectorPointsAnnotation) -> None

        Assign list elements using a slice object
        """

class VectorTextAnnotation:
    @overload
    def __init__(self) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.VectorTextAnnotation) -> None

        2. __init__(self: depthai.VectorTextAnnotation, arg0: depthai.VectorTextAnnotation) -> None

        Copy constructor

        3. __init__(self: depthai.VectorTextAnnotation, arg0: Iterable) -> None
        """
    @overload
    def __init__(self, arg0: VectorTextAnnotation) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.VectorTextAnnotation) -> None

        2. __init__(self: depthai.VectorTextAnnotation, arg0: depthai.VectorTextAnnotation) -> None

        Copy constructor

        3. __init__(self: depthai.VectorTextAnnotation, arg0: Iterable) -> None
        """
    @overload
    def __init__(self, arg0: Iterable) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.VectorTextAnnotation) -> None

        2. __init__(self: depthai.VectorTextAnnotation, arg0: depthai.VectorTextAnnotation) -> None

        Copy constructor

        3. __init__(self: depthai.VectorTextAnnotation, arg0: Iterable) -> None
        """
    def append(self, x: TextAnnotation) -> None:
        """append(self: depthai.VectorTextAnnotation, x: depthai.TextAnnotation) -> None

        Add an item to the end of the list
        """
    def clear(self) -> None:
        """clear(self: depthai.VectorTextAnnotation) -> None

        Clear the contents
        """
    @overload
    def extend(self, L: VectorTextAnnotation) -> None:
        """extend(*args, **kwargs)
        Overloaded function.

        1. extend(self: depthai.VectorTextAnnotation, L: depthai.VectorTextAnnotation) -> None

        Extend the list by appending all the items in the given list

        2. extend(self: depthai.VectorTextAnnotation, L: Iterable) -> None

        Extend the list by appending all the items in the given list
        """
    @overload
    def extend(self, L: Iterable) -> None:
        """extend(*args, **kwargs)
        Overloaded function.

        1. extend(self: depthai.VectorTextAnnotation, L: depthai.VectorTextAnnotation) -> None

        Extend the list by appending all the items in the given list

        2. extend(self: depthai.VectorTextAnnotation, L: Iterable) -> None

        Extend the list by appending all the items in the given list
        """
    def insert(self, i: int, x: TextAnnotation) -> None:
        """insert(self: depthai.VectorTextAnnotation, i: int, x: depthai.TextAnnotation) -> None

        Insert an item at a given position.
        """
    @overload
    def pop(self) -> TextAnnotation:
        """pop(*args, **kwargs)
        Overloaded function.

        1. pop(self: depthai.VectorTextAnnotation) -> depthai.TextAnnotation

        Remove and return the last item

        2. pop(self: depthai.VectorTextAnnotation, i: int) -> depthai.TextAnnotation

        Remove and return the item at index ``i``
        """
    @overload
    def pop(self, i: int) -> TextAnnotation:
        """pop(*args, **kwargs)
        Overloaded function.

        1. pop(self: depthai.VectorTextAnnotation) -> depthai.TextAnnotation

        Remove and return the last item

        2. pop(self: depthai.VectorTextAnnotation, i: int) -> depthai.TextAnnotation

        Remove and return the item at index ``i``
        """
    def __bool__(self) -> bool:
        """__bool__(self: depthai.VectorTextAnnotation) -> bool

        Check whether the list is nonempty
        """
    @overload
    def __delitem__(self, arg0: int) -> None:
        """__delitem__(*args, **kwargs)
        Overloaded function.

        1. __delitem__(self: depthai.VectorTextAnnotation, arg0: int) -> None

        Delete the list elements at index ``i``

        2. __delitem__(self: depthai.VectorTextAnnotation, arg0: slice) -> None

        Delete list elements using a slice object
        """
    @overload
    def __delitem__(self, arg0: slice) -> None:
        """__delitem__(*args, **kwargs)
        Overloaded function.

        1. __delitem__(self: depthai.VectorTextAnnotation, arg0: int) -> None

        Delete the list elements at index ``i``

        2. __delitem__(self: depthai.VectorTextAnnotation, arg0: slice) -> None

        Delete list elements using a slice object
        """
    @overload
    def __getitem__(self, s: slice) -> VectorTextAnnotation:
        """__getitem__(*args, **kwargs)
        Overloaded function.

        1. __getitem__(self: depthai.VectorTextAnnotation, s: slice) -> depthai.VectorTextAnnotation

        Retrieve list elements using a slice object

        2. __getitem__(self: depthai.VectorTextAnnotation, arg0: int) -> depthai.TextAnnotation
        """
    @overload
    def __getitem__(self, arg0: int) -> TextAnnotation:
        """__getitem__(*args, **kwargs)
        Overloaded function.

        1. __getitem__(self: depthai.VectorTextAnnotation, s: slice) -> depthai.VectorTextAnnotation

        Retrieve list elements using a slice object

        2. __getitem__(self: depthai.VectorTextAnnotation, arg0: int) -> depthai.TextAnnotation
        """
    def __iter__(self) -> Iterator[TextAnnotation]:
        """__iter__(self: depthai.VectorTextAnnotation) -> Iterator[depthai.TextAnnotation]"""
    def __len__(self) -> int:
        """__len__(self: depthai.VectorTextAnnotation) -> int"""
    @overload
    def __setitem__(self, arg0: int, arg1: TextAnnotation) -> None:
        """__setitem__(*args, **kwargs)
        Overloaded function.

        1. __setitem__(self: depthai.VectorTextAnnotation, arg0: int, arg1: depthai.TextAnnotation) -> None

        2. __setitem__(self: depthai.VectorTextAnnotation, arg0: slice, arg1: depthai.VectorTextAnnotation) -> None

        Assign list elements using a slice object
        """
    @overload
    def __setitem__(self, arg0: slice, arg1: VectorTextAnnotation) -> None:
        """__setitem__(*args, **kwargs)
        Overloaded function.

        1. __setitem__(self: depthai.VectorTextAnnotation, arg0: int, arg1: depthai.TextAnnotation) -> None

        2. __setitem__(self: depthai.VectorTextAnnotation, arg0: slice, arg1: depthai.VectorTextAnnotation) -> None

        Assign list elements using a slice object
        """

class Version:
    @overload
    def __init__(self, v: str) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Version, v: str) -> None

        Construct Version from string

        2. __init__(self: depthai.Version, major: int, minor: int, patch: int) -> None

        Construct Version major, minor, patch, and pre-release information
        """
    @overload
    def __init__(self, major: int, minor: int, patch: int) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.Version, v: str) -> None

        Construct Version from string

        2. __init__(self: depthai.Version, major: int, minor: int, patch: int) -> None

        Construct Version major, minor, patch, and pre-release information
        """
    def getBuildInfo(self) -> str:
        """getBuildInfo(self: depthai.Version) -> str

        Get build info
        """
    def toStringSemver(self) -> str:
        """toStringSemver(self: depthai.Version) -> str

        Convert Version to semver (no build information) string
        """
    def __eq__(self, arg0: Version) -> bool:
        """__eq__(self: depthai.Version, arg0: depthai.Version) -> bool"""
    def __gt__(self, arg0: Version) -> bool:
        """__gt__(self: depthai.Version, arg0: depthai.Version) -> bool"""
    def __lt__(self, arg0: Version) -> bool:
        """__lt__(self: depthai.Version, arg0: depthai.Version) -> bool"""

class VideoEncoderProperties:
    class Profile:
        __members__: ClassVar[dict] = ...  # read-only
        H264_BASELINE: ClassVar[VideoEncoderProperties.Profile] = ...
        H264_HIGH: ClassVar[VideoEncoderProperties.Profile] = ...
        H264_MAIN: ClassVar[VideoEncoderProperties.Profile] = ...
        H265_MAIN: ClassVar[VideoEncoderProperties.Profile] = ...
        MJPEG: ClassVar[VideoEncoderProperties.Profile] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.VideoEncoderProperties.Profile, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.VideoEncoderProperties.Profile) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.VideoEncoderProperties.Profile) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...

    class RateControlMode:
        __members__: ClassVar[dict] = ...  # read-only
        CBR: ClassVar[VideoEncoderProperties.RateControlMode] = ...
        VBR: ClassVar[VideoEncoderProperties.RateControlMode] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.VideoEncoderProperties.RateControlMode, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.VideoEncoderProperties.RateControlMode) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.VideoEncoderProperties.RateControlMode) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    bitrate: int
    keyframeFrequency: int
    maxBitrate: int
    numBFrames: int
    numFramesPool: int
    outputFrameSize: int
    profile: VideoEncoderProperties.Profile
    quality: int
    rateCtrlMode: VideoEncoderProperties.RateControlMode
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class VioConfig:
    mapper_bow_num_bits: int
    mapper_detection_num_points: int
    mapper_frames_to_match_threshold: float
    mapper_lm_lambda_max: float
    mapper_lm_lambda_min: float
    mapper_max_hamming_distance: float
    mapper_min_matches: float
    mapper_min_track_length: float
    mapper_min_triangulation_dist: float
    mapper_no_factor_weights: bool
    mapper_num_frames_to_match: float
    mapper_obs_huber_thresh: float
    mapper_obs_std_dev: float
    mapper_ransac_threshold: float
    mapper_second_best_test_ratio: float
    mapper_use_factors: bool
    mapper_use_lm: bool
    optical_flow_detection_grid_size: int
    optical_flow_detection_max_threshold: int
    optical_flow_detection_min_threshold: int
    optical_flow_detection_nonoverlap: bool
    optical_flow_detection_num_points_cell: int
    optical_flow_epipolar_error: float
    optical_flow_image_safe_radius: float
    optical_flow_levels: int
    optical_flow_matching_default_depth: float
    optical_flow_matching_guess_type: Incomplete
    optical_flow_max_iterations: int
    optical_flow_max_recovered_dist2: float
    optical_flow_pattern: int
    optical_flow_recall_all_cams: bool
    optical_flow_recall_enable: bool
    optical_flow_recall_max_patch_dist: float
    optical_flow_recall_max_patch_norms: list[float]
    optical_flow_recall_num_points_cell: bool
    optical_flow_recall_over_tracking: bool
    optical_flow_recall_update_patch_viewpoint: bool
    optical_flow_skip_frames: int
    optical_flow_type: str
    vio_debug: bool
    vio_enforce_realtime: bool
    vio_extended_logging: bool
    vio_fix_long_term_keyframes: bool
    vio_init_ba_weight: float
    vio_init_bg_weight: float
    vio_init_pose_weight: float
    vio_kf_marg_criteria: Incomplete
    vio_kf_marg_feature_ratio: float
    vio_linearization_type: Incomplete
    vio_lm_lambda_initial: float
    vio_lm_lambda_max: float
    vio_lm_lambda_min: float
    vio_marg_lost_landmarks: bool
    vio_max_iterations: int
    vio_max_kfs: int
    vio_max_states: int
    vio_min_frames_after_kf: int
    vio_min_triangulation_dist: float
    vio_new_kf_keypoints_thresh: float
    vio_obs_huber_thresh: float
    vio_obs_std_dev: float
    vio_scale_jacobian: bool
    vio_sqrt_marg: bool
    vio_use_lm: bool
    def __init__(self) -> None:
        """__init__(self: depthai.VioConfig) -> None"""

class WarpProperties:
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class XLinkConnection:
    @overload
    def __init__(self, arg0: DeviceInfo, arg1: list[int]) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.XLinkConnection, arg0: depthai.DeviceInfo, arg1: list[int]) -> None

        2. __init__(self: depthai.XLinkConnection, arg0: depthai.DeviceInfo, arg1: str) -> None

        3. __init__(self: depthai.XLinkConnection, arg0: depthai.DeviceInfo) -> None
        """
    @overload
    def __init__(self, arg0: DeviceInfo, arg1: str) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.XLinkConnection, arg0: depthai.DeviceInfo, arg1: list[int]) -> None

        2. __init__(self: depthai.XLinkConnection, arg0: depthai.DeviceInfo, arg1: str) -> None

        3. __init__(self: depthai.XLinkConnection, arg0: depthai.DeviceInfo) -> None
        """
    @overload
    def __init__(self, arg0: DeviceInfo) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.XLinkConnection, arg0: depthai.DeviceInfo, arg1: list[int]) -> None

        2. __init__(self: depthai.XLinkConnection, arg0: depthai.DeviceInfo, arg1: str) -> None

        3. __init__(self: depthai.XLinkConnection, arg0: depthai.DeviceInfo) -> None
        """
    @staticmethod
    def bootBootloader(devInfo: DeviceInfo) -> DeviceInfo:
        """bootBootloader(devInfo: depthai.DeviceInfo) -> depthai.DeviceInfo"""
    @staticmethod
    def getAllConnectedDevices(state: XLinkDeviceState = ..., skipInvalidDevices: bool = ..., timeoutMs: int = ...) -> list[DeviceInfo]:
        """getAllConnectedDevices(state: depthai.XLinkDeviceState = <XLinkDeviceState.X_LINK_ANY_STATE: 0>, skipInvalidDevices: bool = True, timeoutMs: int = 500) -> list[depthai.DeviceInfo]"""
    @staticmethod
    def getDeviceById(deviceId: str, state: XLinkDeviceState = ..., skipInvalidDevice: bool = ...) -> tuple[bool, DeviceInfo]:
        """getDeviceById(deviceId: str, state: depthai.XLinkDeviceState = <XLinkDeviceState.X_LINK_ANY_STATE: 0>, skipInvalidDevice: bool = True) -> tuple[bool, depthai.DeviceInfo]"""
    @staticmethod
    def getFirstDevice(state: XLinkDeviceState = ..., skipInvalidDevice: bool = ...) -> tuple[bool, DeviceInfo]:
        """getFirstDevice(state: depthai.XLinkDeviceState = <XLinkDeviceState.X_LINK_ANY_STATE: 0>, skipInvalidDevice: bool = True) -> tuple[bool, depthai.DeviceInfo]"""
    @staticmethod
    def getGlobalProfilingData() -> ProfilingData:
        """getGlobalProfilingData() -> depthai.ProfilingData

        Get current accumulated profiling data

        Returns:
            ProfilingData from the specific connection
        """

class XLinkDeviceState:
    __members__: ClassVar[dict] = ...  # read-only
    X_LINK_ANY_STATE: ClassVar[XLinkDeviceState] = ...
    X_LINK_BOOTED: ClassVar[XLinkDeviceState] = ...
    X_LINK_BOOTED_NON_EXCLUSIVE: ClassVar[XLinkDeviceState] = ...
    X_LINK_BOOTLOADER: ClassVar[XLinkDeviceState] = ...
    X_LINK_FLASH_BOOTED: ClassVar[XLinkDeviceState] = ...
    X_LINK_GATE: ClassVar[XLinkDeviceState] = ...
    X_LINK_GATE_BOOTED: ClassVar[XLinkDeviceState] = ...
    X_LINK_UNBOOTED: ClassVar[XLinkDeviceState] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.XLinkDeviceState, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.XLinkDeviceState) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.XLinkDeviceState) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class XLinkError(RuntimeError): ...

class XLinkError_t:
    __members__: ClassVar[dict] = ...  # read-only
    X_LINK_ALREADY_OPEN: ClassVar[XLinkError_t] = ...
    X_LINK_COMMUNICATION_FAIL: ClassVar[XLinkError_t] = ...
    X_LINK_COMMUNICATION_NOT_OPEN: ClassVar[XLinkError_t] = ...
    X_LINK_COMMUNICATION_UNKNOWN_ERROR: ClassVar[XLinkError_t] = ...
    X_LINK_DEVICE_ALREADY_IN_USE: ClassVar[XLinkError_t] = ...
    X_LINK_DEVICE_NOT_FOUND: ClassVar[XLinkError_t] = ...
    X_LINK_ERROR: ClassVar[XLinkError_t] = ...
    X_LINK_INIT_PCIE_ERROR: ClassVar[XLinkError_t] = ...
    X_LINK_INIT_TCP_IP_ERROR: ClassVar[XLinkError_t] = ...
    X_LINK_INIT_USB_ERROR: ClassVar[XLinkError_t] = ...
    X_LINK_INSUFFICIENT_PERMISSIONS: ClassVar[XLinkError_t] = ...
    X_LINK_NOT_IMPLEMENTED: ClassVar[XLinkError_t] = ...
    X_LINK_OUT_OF_MEMORY: ClassVar[XLinkError_t] = ...
    X_LINK_SUCCESS: ClassVar[XLinkError_t] = ...
    X_LINK_TIMEOUT: ClassVar[XLinkError_t] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.XLinkError_t, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.XLinkError_t) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.XLinkError_t) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class XLinkInProperties:
    maxDataSize: int
    numFrames: int
    streamName: str
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class XLinkOutProperties:
    maxFpsLimit: float
    metadataOnly: bool
    streamName: str
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class XLinkPlatform:
    __members__: ClassVar[dict] = ...  # read-only
    X_LINK_ANY_PLATFORM: ClassVar[XLinkPlatform] = ...
    X_LINK_MYRIAD_2: ClassVar[XLinkPlatform] = ...
    X_LINK_MYRIAD_X: ClassVar[XLinkPlatform] = ...
    X_LINK_RVC3: ClassVar[XLinkPlatform] = ...
    X_LINK_RVC4: ClassVar[XLinkPlatform] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.XLinkPlatform, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.XLinkPlatform) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.XLinkPlatform) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class XLinkProtocol:
    __members__: ClassVar[dict] = ...  # read-only
    X_LINK_ANY_PROTOCOL: ClassVar[XLinkProtocol] = ...
    X_LINK_IPC: ClassVar[XLinkProtocol] = ...
    X_LINK_NMB_OF_PROTOCOLS: ClassVar[XLinkProtocol] = ...
    X_LINK_PCIE: ClassVar[XLinkProtocol] = ...
    X_LINK_TCP_IP: ClassVar[XLinkProtocol] = ...
    X_LINK_USB_CDC: ClassVar[XLinkProtocol] = ...
    X_LINK_USB_VSC: ClassVar[XLinkProtocol] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.XLinkProtocol, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.XLinkProtocol) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.XLinkProtocol) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class XLinkReadError(XLinkError): ...

class XLinkWriteError(XLinkError): ...

class connectionInterface:
    __members__: ClassVar[dict] = ...  # read-only
    ETHERNET: ClassVar[connectionInterface] = ...
    USB: ClassVar[connectionInterface] = ...
    WIFI: ClassVar[connectionInterface] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None:
        """__init__(self: depthai.connectionInterface, value: int) -> None"""
    def __eq__(self, other: object) -> bool:
        """__eq__(self: object, other: object) -> bool"""
    def __hash__(self) -> int:
        """__hash__(self: object) -> int"""
    def __index__(self) -> int:
        """__index__(self: depthai.connectionInterface) -> int"""
    def __int__(self) -> int:
        """__int__(self: depthai.connectionInterface) -> int"""
    def __ne__(self, other: object) -> bool:
        """__ne__(self: object, other: object) -> bool"""
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

def downloadModelsFromZoo(path: str, cacheDirectory: str = ..., apiKey: str = ...) -> None:
    """downloadModelsFromZoo(path: str, cacheDirectory: str = '.depthai_cached_models', apiKey: str = '') -> None

    Helper function allowing one to download all models specified in yaml files in
    the given path and store them in the cache directory

    Parameter ``path:``:
        Path to the directory containing yaml files

    Parameter ``cacheDirectory:``:
        Cache directory where the cached models are stored, default is
        MODEL_ZOO_DEFAULT_CACHE_DIRECTORY

    Parameter ``verbose:``:
        Print verbose output, default is false
    """
def getModelFromZoo(modelDescription: NNModelDescription, useCached: bool = ..., cacheDirectory: str = ..., apiKey: str = ...) -> str:
    """getModelFromZoo(modelDescription: depthai.NNModelDescription, useCached: bool = True, cacheDirectory: str = '.depthai_cached_models', apiKey: str = '') -> str

    Get model from model zoo

    Parameter ``modelDescription:``:
        Model description

    Parameter ``useCached:``:
        Use cached model if present, default is true

    Parameter ``cacheDirectory:``:
        Cache directory where the cached models are stored, default is
        MODEL_ZOO_DEFAULT_CACHE_DIRECTORY

    Returns:
        std::string: Path to the model in cache
    """
def isDatatypeSubclassOf(arg0: DatatypeEnum, arg1: DatatypeEnum) -> bool:
    """isDatatypeSubclassOf(arg0: depthai.DatatypeEnum, arg1: depthai.DatatypeEnum) -> bool"""
def platform2string(arg0: Platform) -> str:
    """platform2string(arg0: depthai.Platform) -> str

    Convert Platform enum to string

    Parameter ``platform``:
        Platform enum

    Returns:
        std::string String representation of Platform
    """
def readModelType(modelPath: str) -> ModelType:
    """readModelType(modelPath: str) -> depthai.ModelType

    Read model type from model path

    Parameter ``modelPath``:
        Path to model

    Returns:
        ModelType
    """
def string2platform(arg0: str) -> Platform:
    """string2platform(arg0: str) -> depthai.Platform

    Convert string to Platform enum

    Parameter ``platform``:
        String representation of Platform

    Returns:
        Platform Platform enum
    """


from pathlib import Path
from typing import Set
import datetime
import depthai
import os
from typing import Any, Callable, ClassVar, overload

class AprilTag(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.AprilTagProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getNumThreads(self) -> int:
        """getNumThreads(self: depthai.node.AprilTag) -> int

        Get number of threads to use for AprilTag detection.

        Returns:
            Number of threads to use.
        """
    def getWaitForConfigInput(self) -> bool:
        """getWaitForConfigInput(self: depthai.node.AprilTag) -> bool

        Get whether or not wait until configuration message arrives to inputConfig
        Input.
        """
    def runOnHost(self) -> bool:
        """runOnHost(self: depthai.node.AprilTag) -> bool

        Check if the node is set to run on host
        """
    def setNumThreads(self, numThreads: int) -> None:
        """setNumThreads(self: depthai.node.AprilTag, numThreads: int) -> None

        Set number of threads to use for AprilTag detection.

        Parameter ``numThreads``:
            Number of threads to use.
        """
    def setRunOnHost(self, arg0: bool) -> None:
        """setRunOnHost(self: depthai.node.AprilTag, arg0: bool) -> None

        Specify whether to run on host or device By default, the node will run on
        device.
        """
    def setWaitForConfigInput(self, wait: bool) -> None:
        """setWaitForConfigInput(self: depthai.node.AprilTag, wait: bool) -> None

        Specify whether or not wait until configuration message arrives to inputConfig
        Input.

        Parameter ``wait``:
            True to wait for configuration message, false otherwise.
        """
    @property
    def initialConfig(self) -> depthai.AprilTagConfig: ...
    @property
    def inputConfig(self) -> depthai.Node.Input: ...
    @property
    def inputImage(self) -> depthai.Node.Input: ...
    @property
    def out(self) -> depthai.Node.Output: ...
    @property
    def passthroughInputImage(self) -> depthai.Node.Output: ...

class BasaltVIO(ThreadedHostNode):
    vioConfig: depthai.VioConfig
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def setConfigPath(self, path: str) -> None:
        """setConfigPath(self: depthai.node.BasaltVIO, path: str) -> None"""
    def setImuUpdateRate(self, rate: int) -> None:
        """setImuUpdateRate(self: depthai.node.BasaltVIO, rate: int) -> None"""
    def setLocalTransform(self, transform: depthai.TransformData) -> None:
        """setLocalTransform(self: depthai.node.BasaltVIO, transform: depthai.TransformData) -> None"""
    @property
    def imu(self) -> depthai.Node.Input: ...
    @property
    def left(self) -> depthai.Node.Input: ...
    @property
    def passthrough(self) -> depthai.Node.Output: ...
    @property
    def right(self) -> depthai.Node.Input: ...
    @property
    def transform(self) -> depthai.Node.Output: ...

class BenchmarkIn(depthai.DeviceNode):
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def logReportsAsWarnings(self, logReportsAsWarnings: bool) -> None:
        """logReportsAsWarnings(self: depthai.node.BenchmarkIn, logReportsAsWarnings: bool) -> None

        Log the reports as warnings
        """
    def measureIndividualLatencies(self, attachLatencies: bool) -> None:
        """measureIndividualLatencies(self: depthai.node.BenchmarkIn, attachLatencies: bool) -> None

        Attach latencies to the report
        """
    def sendReportEveryNMessages(self, num: int) -> None:
        """sendReportEveryNMessages(self: depthai.node.BenchmarkIn, num: int) -> None

        Specify how many messages to measure for each report
        """
    def setRunOnHost(self, runOnHost: bool) -> None:
        """setRunOnHost(self: depthai.node.BenchmarkIn, runOnHost: bool) -> None

        Specify whether to run on host or device By default, the node will run on
        device.
        """
    @property
    def input(self) -> depthai.Node.Input: ...
    @property
    def passthrough(self) -> depthai.Node.Output: ...
    @property
    def report(self) -> depthai.Node.Output: ...

class BenchmarkOut(depthai.DeviceNode):
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def setFps(self, fps: float) -> None:
        """setFps(self: depthai.node.BenchmarkOut, fps: float) -> None

        Set FPS at which the node is sending out messages. 0 means as fast as possible
        """
    def setNumMessagesToSend(self, num: int) -> None:
        """setNumMessagesToSend(self: depthai.node.BenchmarkOut, num: int) -> None

        Sets number of messages to send, by default send messages indefinitely

        Parameter ``num``:
            number of messages to send
        """
    def setRunOnHost(self, runOnHost: bool) -> None:
        """setRunOnHost(self: depthai.node.BenchmarkOut, runOnHost: bool) -> None

        Specify whether to run on host or device By default, the node will run on
        device.
        """
    @property
    def input(self) -> depthai.Node.Input: ...
    @property
    def out(self) -> depthai.Node.Output: ...

class Camera(depthai.DeviceNode):
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    @overload
    def build(self, boardSocket: depthai.CameraBoardSocket = ...) -> Camera:
        """build(*args, **kwargs)
        Overloaded function.

        1. build(self: depthai.node.Camera, boardSocket: depthai.CameraBoardSocket = <CameraBoardSocket.???: -1>) -> depthai.node.Camera

        Build with a specific board socket

        2. build(self: depthai.node.Camera, boardSocket: depthai.CameraBoardSocket, replayNode: depthai.node.ReplayVideo) -> depthai.node.Camera

        Build with a specific board socket

        3. build(self: depthai.node.Camera, replayNode: depthai.node.ReplayVideo) -> depthai.node.Camera

        Build with a specific board socket
        """
    @overload
    def build(self, boardSocket: depthai.CameraBoardSocket, replayNode: ReplayVideo) -> Camera:
        """build(*args, **kwargs)
        Overloaded function.

        1. build(self: depthai.node.Camera, boardSocket: depthai.CameraBoardSocket = <CameraBoardSocket.???: -1>) -> depthai.node.Camera

        Build with a specific board socket

        2. build(self: depthai.node.Camera, boardSocket: depthai.CameraBoardSocket, replayNode: depthai.node.ReplayVideo) -> depthai.node.Camera

        Build with a specific board socket

        3. build(self: depthai.node.Camera, replayNode: depthai.node.ReplayVideo) -> depthai.node.Camera

        Build with a specific board socket
        """
    @overload
    def build(self, replayNode: ReplayVideo) -> Camera:
        """build(*args, **kwargs)
        Overloaded function.

        1. build(self: depthai.node.Camera, boardSocket: depthai.CameraBoardSocket = <CameraBoardSocket.???: -1>) -> depthai.node.Camera

        Build with a specific board socket

        2. build(self: depthai.node.Camera, boardSocket: depthai.CameraBoardSocket, replayNode: depthai.node.ReplayVideo) -> depthai.node.Camera

        Build with a specific board socket

        3. build(self: depthai.node.Camera, replayNode: depthai.node.ReplayVideo) -> depthai.node.Camera

        Build with a specific board socket
        """
    def getBoardSocket(self) -> depthai.CameraBoardSocket:
        """getBoardSocket(self: depthai.node.Camera) -> depthai.CameraBoardSocket

        Retrieves which board socket to use

        Returns:
            Board socket to use
        """
    def requestFullResolutionOutput(self, type: depthai.ImgFrame.Type = ..., fps: float = ...) -> depthai.Node.Output:
        """requestFullResolutionOutput(self: depthai.node.Camera, type: depthai.ImgFrame.Type = <Type.???: 22>, fps: float = 30) -> depthai.Node.Output

        Get full resolution output
        """
    @overload
    def requestOutput(self, size: tuple[int, int], type: depthai.ImgFrame.Type | None = ..., resizeMode: depthai.ImgResizeMode = ..., fps: float = ..., enableUndistortion: bool | None = ...) -> depthai.Node.Output:
        """requestOutput(*args, **kwargs)
        Overloaded function.

        1. requestOutput(self: depthai.node.Camera, size: tuple[int, int], type: Optional[depthai.ImgFrame.Type] = None, resizeMode: depthai.ImgResizeMode = <ImgResizeMode.???: 0>, fps: float = 30, enableUndistortion: Optional[bool] = None) -> depthai.Node.Output

        Get video output with specified size.

        2. requestOutput(self: depthai.node.Camera, capability: depthai.Capability, onHost: bool) -> depthai.Node.Output

        Request output with advanced controls. Mainly to be used by custom node writers.
        """
    @overload
    def requestOutput(self, capability: depthai.Capability, onHost: bool) -> depthai.Node.Output:
        """requestOutput(*args, **kwargs)
        Overloaded function.

        1. requestOutput(self: depthai.node.Camera, size: tuple[int, int], type: Optional[depthai.ImgFrame.Type] = None, resizeMode: depthai.ImgResizeMode = <ImgResizeMode.???: 0>, fps: float = 30, enableUndistortion: Optional[bool] = None) -> depthai.Node.Output

        Get video output with specified size.

        2. requestOutput(self: depthai.node.Camera, capability: depthai.Capability, onHost: bool) -> depthai.Node.Output

        Request output with advanced controls. Mainly to be used by custom node writers.
        """
    def setMockIsp(self, mockIsp: ReplayVideo) -> Camera:
        """setMockIsp(self: depthai.node.Camera, mockIsp: depthai.node.ReplayVideo) -> depthai.node.Camera

        Set mock ISP for Camera node. Automatically sets mockIsp size.

        Parameter ``replay``:
            ReplayVideo node to use as mock ISP
        """
    @property
    def initialControl(self) -> depthai.CameraControl: ...
    @property
    def inputControl(self) -> depthai.Node.Input: ...
    @property
    def mockIsp(self) -> depthai.Node.Input: ...

class ColorCamera(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.ColorCameraProperties]] = ...
    def __init__(self) -> None:
        """__init__(self: depthai.node.ColorCamera) -> None"""
    def getBoardSocket(self) -> depthai.CameraBoardSocket:
        """getBoardSocket(self: depthai.node.ColorCamera) -> depthai.CameraBoardSocket

        Retrieves which board socket to use

        Returns:
            Board socket to use
        """
    def getCalibrationAlpha(self) -> float:
        """getCalibrationAlpha(self: depthai.node.ColorCamera) -> float

        Get calibration alpha parameter that determines FOV of undistorted frames
        """
    def getCamId(self) -> int:
        """getCamId(self: depthai.node.ColorCamera) -> int"""
    def getCamera(self) -> str:
        """getCamera(self: depthai.node.ColorCamera) -> str

        Retrieves which camera to use by name

        Returns:
            Name of the camera to use
        """
    def getColorOrder(self) -> depthai.ColorCameraProperties.ColorOrder:
        """getColorOrder(self: depthai.node.ColorCamera) -> depthai.ColorCameraProperties.ColorOrder

        Get color order of preview output frames. RGB or BGR
        """
    def getFp16(self) -> bool:
        """getFp16(self: depthai.node.ColorCamera) -> bool

        Get fp16 (0..255) data of preview output frames
        """
    def getFps(self) -> float:
        """getFps(self: depthai.node.ColorCamera) -> float

        Get rate at which camera should produce frames

        Returns:
            Rate in frames per second
        """
    def getFrameEventFilter(self) -> list[depthai.FrameEvent]:
        """getFrameEventFilter(self: depthai.node.ColorCamera) -> list[depthai.FrameEvent]"""
    def getImageOrientation(self) -> depthai.CameraImageOrientation:
        """getImageOrientation(self: depthai.node.ColorCamera) -> depthai.CameraImageOrientation

        Get camera image orientation
        """
    def getInterleaved(self) -> bool:
        """getInterleaved(self: depthai.node.ColorCamera) -> bool

        Get planar or interleaved data of preview output frames
        """
    def getIspHeight(self) -> int:
        """getIspHeight(self: depthai.node.ColorCamera) -> int

        Get 'isp' output height
        """
    def getIspNumFramesPool(self) -> int:
        """getIspNumFramesPool(self: depthai.node.ColorCamera) -> int

        Get number of frames in isp pool
        """
    def getIspSize(self) -> tuple[int, int]:
        """getIspSize(self: depthai.node.ColorCamera) -> tuple[int, int]

        Get 'isp' output resolution as size, after scaling
        """
    def getIspWidth(self) -> int:
        """getIspWidth(self: depthai.node.ColorCamera) -> int

        Get 'isp' output width
        """
    def getMeshSize(self) -> tuple[int, int]:
        """getMeshSize(self: depthai.node.ColorCamera) -> tuple[int, int]

        Gets the mesh size
        """
    def getMeshSource(self) -> depthai.ColorCameraProperties.WarpMeshSource:
        """getMeshSource(self: depthai.node.ColorCamera) -> depthai.ColorCameraProperties.WarpMeshSource

        Gets the source of the warp mesh
        """
    def getMeshStep(self) -> tuple[int, int]:
        """getMeshStep(self: depthai.node.ColorCamera) -> tuple[int, int]

        Gets the distance between mesh points
        """
    def getPreviewHeight(self) -> int:
        """getPreviewHeight(self: depthai.node.ColorCamera) -> int

        Get preview height
        """
    def getPreviewKeepAspectRatio(self) -> bool:
        """getPreviewKeepAspectRatio(self: depthai.node.ColorCamera) -> bool

        See also:
            setPreviewKeepAspectRatio

        Returns:
            Preview keep aspect ratio option
        """
    def getPreviewNumFramesPool(self) -> int:
        """getPreviewNumFramesPool(self: depthai.node.ColorCamera) -> int

        Get number of frames in preview pool
        """
    def getPreviewSize(self) -> tuple[int, int]:
        """getPreviewSize(self: depthai.node.ColorCamera) -> tuple[int, int]

        Get preview size as tuple
        """
    def getPreviewWidth(self) -> int:
        """getPreviewWidth(self: depthai.node.ColorCamera) -> int

        Get preview width
        """
    def getRawNumFramesPool(self) -> int:
        """getRawNumFramesPool(self: depthai.node.ColorCamera) -> int

        Get number of frames in raw pool
        """
    def getResolution(self) -> depthai.ColorCameraProperties.SensorResolution:
        """getResolution(self: depthai.node.ColorCamera) -> depthai.ColorCameraProperties.SensorResolution

        Get sensor resolution
        """
    def getResolutionHeight(self) -> int:
        """getResolutionHeight(self: depthai.node.ColorCamera) -> int

        Get sensor resolution height
        """
    def getResolutionSize(self) -> tuple[int, int]:
        """getResolutionSize(self: depthai.node.ColorCamera) -> tuple[int, int]

        Get sensor resolution as size
        """
    def getResolutionWidth(self) -> int:
        """getResolutionWidth(self: depthai.node.ColorCamera) -> int

        Get sensor resolution width
        """
    def getSensorCrop(self) -> tuple[float, float]:
        """getSensorCrop(self: depthai.node.ColorCamera) -> tuple[float, float]

        Returns:
            Sensor top left crop coordinates
        """
    def getSensorCropX(self) -> float:
        """getSensorCropX(self: depthai.node.ColorCamera) -> float

        Get sensor top left x crop coordinate
        """
    def getSensorCropY(self) -> float:
        """getSensorCropY(self: depthai.node.ColorCamera) -> float

        Get sensor top left y crop coordinate
        """
    def getStillHeight(self) -> int:
        """getStillHeight(self: depthai.node.ColorCamera) -> int

        Get still height
        """
    def getStillNumFramesPool(self) -> int:
        """getStillNumFramesPool(self: depthai.node.ColorCamera) -> int

        Get number of frames in still pool
        """
    def getStillSize(self) -> tuple[int, int]:
        """getStillSize(self: depthai.node.ColorCamera) -> tuple[int, int]

        Get still size as tuple
        """
    def getStillWidth(self) -> int:
        """getStillWidth(self: depthai.node.ColorCamera) -> int

        Get still width
        """
    def getVideoHeight(self) -> int:
        """getVideoHeight(self: depthai.node.ColorCamera) -> int

        Get video height
        """
    def getVideoNumFramesPool(self) -> int:
        """getVideoNumFramesPool(self: depthai.node.ColorCamera) -> int

        Get number of frames in video pool
        """
    def getVideoSize(self) -> tuple[int, int]:
        """getVideoSize(self: depthai.node.ColorCamera) -> tuple[int, int]

        Get video size as tuple
        """
    def getVideoWidth(self) -> int:
        """getVideoWidth(self: depthai.node.ColorCamera) -> int

        Get video width
        """
    def getWaitForConfigInput(self) -> bool:
        """getWaitForConfigInput(self: depthai.node.ColorCamera) -> bool

        See also:
            setWaitForConfigInput

        Returns:
            True if wait for inputConfig message, false otherwise
        """
    def loadMeshData(self, warpMesh: list[int]) -> None:
        """loadMeshData(self: depthai.node.ColorCamera, warpMesh: list[int]) -> None

        Specify mesh calibration data for undistortion See `loadMeshFiles` for the
        expected data format
        """
    def sensorCenterCrop(self) -> None:
        """sensorCenterCrop(self: depthai.node.ColorCamera) -> None

        Specify sensor center crop. Resolution size / video size
        """
    def setBoardSocket(self, boardSocket: depthai.CameraBoardSocket) -> None:
        """setBoardSocket(self: depthai.node.ColorCamera, boardSocket: depthai.CameraBoardSocket) -> None

        Specify which board socket to use

        Parameter ``boardSocket``:
            Board socket to use
        """
    def setCalibrationAlpha(self, alpha: float) -> None:
        """setCalibrationAlpha(self: depthai.node.ColorCamera, alpha: float) -> None

        Set calibration alpha parameter that determines FOV of undistorted frames
        """
    def setCamId(self, arg0: int) -> None:
        """setCamId(self: depthai.node.ColorCamera, arg0: int) -> None"""
    def setCamera(self, name: str) -> None:
        """setCamera(self: depthai.node.ColorCamera, name: str) -> None

        Specify which camera to use by name

        Parameter ``name``:
            Name of the camera to use
        """
    def setColorOrder(self, colorOrder: depthai.ColorCameraProperties.ColorOrder) -> None:
        """setColorOrder(self: depthai.node.ColorCamera, colorOrder: depthai.ColorCameraProperties.ColorOrder) -> None

        Set color order of preview output images. RGB or BGR
        """
    def setFp16(self, fp16: bool) -> None:
        """setFp16(self: depthai.node.ColorCamera, fp16: bool) -> None

        Set fp16 (0..255) data type of preview output frames
        """
    def setFps(self, fps: float) -> None:
        """setFps(self: depthai.node.ColorCamera, fps: float) -> None

        Set rate at which camera should produce frames

        Parameter ``fps``:
            Rate in frames per second
        """
    def setFrameEventFilter(self, events: list[depthai.FrameEvent]) -> None:
        """setFrameEventFilter(self: depthai.node.ColorCamera, events: list[depthai.FrameEvent]) -> None"""
    def setImageOrientation(self, imageOrientation: depthai.CameraImageOrientation) -> None:
        """setImageOrientation(self: depthai.node.ColorCamera, imageOrientation: depthai.CameraImageOrientation) -> None

        Set camera image orientation
        """
    def setInterleaved(self, interleaved: bool) -> None:
        """setInterleaved(self: depthai.node.ColorCamera, interleaved: bool) -> None

        Set planar or interleaved data of preview output frames
        """
    def setIsp3aFps(self, arg0: int) -> None:
        """setIsp3aFps(self: depthai.node.ColorCamera, arg0: int) -> None

        Isp 3A rate (auto focus, auto exposure, auto white balance, camera controls
        etc.). Default (0) matches the camera FPS, meaning that 3A is running on each
        frame. Reducing the rate of 3A reduces the CPU usage on CSS, but also increases
        the convergence rate of 3A. Note that camera controls will be processed at this
        rate. E.g. if camera is running at 30 fps, and camera control is sent at every
        frame, but 3A fps is set to 15, the camera control messages will be processed at
        15 fps rate, which will lead to queueing.
        """
    def setIspNumFramesPool(self, arg0: int) -> None:
        """setIspNumFramesPool(self: depthai.node.ColorCamera, arg0: int) -> None

        Set number of frames in isp pool
        """
    @overload
    def setIspScale(self, numerator: int, denominator: int) -> None:
        """setIspScale(*args, **kwargs)
        Overloaded function.

        1. setIspScale(self: depthai.node.ColorCamera, numerator: int, denominator: int) -> None

        Set 'isp' output scaling (numerator/denominator), preserving the aspect ratio.
        The fraction numerator/denominator is simplified first to a irreducible form,
        then a set of hardware scaler constraints applies: max numerator = 16, max
        denominator = 63

        2. setIspScale(self: depthai.node.ColorCamera, scale: tuple[int, int]) -> None

        Set 'isp' output scaling, as a tuple <numerator, denominator>

        3. setIspScale(self: depthai.node.ColorCamera, horizNum: int, horizDenom: int, vertNum: int, vertDenom: int) -> None

        Set 'isp' output scaling, per each direction. If the horizontal scaling factor
        (horizNum/horizDen) is different than the vertical scaling factor
        (vertNum/vertDen), a distorted (stretched or squished) image is generated

        4. setIspScale(self: depthai.node.ColorCamera, horizScale: tuple[int, int], vertScale: tuple[int, int]) -> None

        Set 'isp' output scaling, per each direction, as <numerator, denominator> tuples
        """
    @overload
    def setIspScale(self, scale: tuple[int, int]) -> None:
        """setIspScale(*args, **kwargs)
        Overloaded function.

        1. setIspScale(self: depthai.node.ColorCamera, numerator: int, denominator: int) -> None

        Set 'isp' output scaling (numerator/denominator), preserving the aspect ratio.
        The fraction numerator/denominator is simplified first to a irreducible form,
        then a set of hardware scaler constraints applies: max numerator = 16, max
        denominator = 63

        2. setIspScale(self: depthai.node.ColorCamera, scale: tuple[int, int]) -> None

        Set 'isp' output scaling, as a tuple <numerator, denominator>

        3. setIspScale(self: depthai.node.ColorCamera, horizNum: int, horizDenom: int, vertNum: int, vertDenom: int) -> None

        Set 'isp' output scaling, per each direction. If the horizontal scaling factor
        (horizNum/horizDen) is different than the vertical scaling factor
        (vertNum/vertDen), a distorted (stretched or squished) image is generated

        4. setIspScale(self: depthai.node.ColorCamera, horizScale: tuple[int, int], vertScale: tuple[int, int]) -> None

        Set 'isp' output scaling, per each direction, as <numerator, denominator> tuples
        """
    @overload
    def setIspScale(self, horizNum: int, horizDenom: int, vertNum: int, vertDenom: int) -> None:
        """setIspScale(*args, **kwargs)
        Overloaded function.

        1. setIspScale(self: depthai.node.ColorCamera, numerator: int, denominator: int) -> None

        Set 'isp' output scaling (numerator/denominator), preserving the aspect ratio.
        The fraction numerator/denominator is simplified first to a irreducible form,
        then a set of hardware scaler constraints applies: max numerator = 16, max
        denominator = 63

        2. setIspScale(self: depthai.node.ColorCamera, scale: tuple[int, int]) -> None

        Set 'isp' output scaling, as a tuple <numerator, denominator>

        3. setIspScale(self: depthai.node.ColorCamera, horizNum: int, horizDenom: int, vertNum: int, vertDenom: int) -> None

        Set 'isp' output scaling, per each direction. If the horizontal scaling factor
        (horizNum/horizDen) is different than the vertical scaling factor
        (vertNum/vertDen), a distorted (stretched or squished) image is generated

        4. setIspScale(self: depthai.node.ColorCamera, horizScale: tuple[int, int], vertScale: tuple[int, int]) -> None

        Set 'isp' output scaling, per each direction, as <numerator, denominator> tuples
        """
    @overload
    def setIspScale(self, horizScale: tuple[int, int], vertScale: tuple[int, int]) -> None:
        """setIspScale(*args, **kwargs)
        Overloaded function.

        1. setIspScale(self: depthai.node.ColorCamera, numerator: int, denominator: int) -> None

        Set 'isp' output scaling (numerator/denominator), preserving the aspect ratio.
        The fraction numerator/denominator is simplified first to a irreducible form,
        then a set of hardware scaler constraints applies: max numerator = 16, max
        denominator = 63

        2. setIspScale(self: depthai.node.ColorCamera, scale: tuple[int, int]) -> None

        Set 'isp' output scaling, as a tuple <numerator, denominator>

        3. setIspScale(self: depthai.node.ColorCamera, horizNum: int, horizDenom: int, vertNum: int, vertDenom: int) -> None

        Set 'isp' output scaling, per each direction. If the horizontal scaling factor
        (horizNum/horizDen) is different than the vertical scaling factor
        (vertNum/vertDen), a distorted (stretched or squished) image is generated

        4. setIspScale(self: depthai.node.ColorCamera, horizScale: tuple[int, int], vertScale: tuple[int, int]) -> None

        Set 'isp' output scaling, per each direction, as <numerator, denominator> tuples
        """
    def setMeshSize(self, width: int, height: int) -> None:
        """setMeshSize(self: depthai.node.ColorCamera, width: int, height: int) -> None

        Set mesh size
        """
    def setMeshSource(self, source: depthai.ColorCameraProperties.WarpMeshSource) -> None:
        """setMeshSource(self: depthai.node.ColorCamera, source: depthai.ColorCameraProperties.WarpMeshSource) -> None

        Set the source of the warp mesh or disable
        """
    def setMeshStep(self, width: int, height: int) -> None:
        """setMeshStep(self: depthai.node.ColorCamera, width: int, height: int) -> None

        Set the distance between mesh points. Default: (32, 32)
        """
    def setNumFramesPool(self, raw: int, isp: int, preview: int, video: int, still: int) -> None:
        """setNumFramesPool(self: depthai.node.ColorCamera, raw: int, isp: int, preview: int, video: int, still: int) -> None

        Set number of frames in all pools
        """
    def setPreviewKeepAspectRatio(self, keep: bool) -> None:
        """setPreviewKeepAspectRatio(self: depthai.node.ColorCamera, keep: bool) -> None

        Specifies whether preview output should preserve aspect ratio, after downscaling
        from video size or not.

        Parameter ``keep``:
            If true, a larger crop region will be considered to still be able to create
            the final image in the specified aspect ratio. Otherwise video size is
            resized to fit preview size
        """
    def setPreviewNumFramesPool(self, arg0: int) -> None:
        """setPreviewNumFramesPool(self: depthai.node.ColorCamera, arg0: int) -> None

        Set number of frames in preview pool
        """
    @overload
    def setPreviewSize(self, width: int, height: int) -> None:
        """setPreviewSize(*args, **kwargs)
        Overloaded function.

        1. setPreviewSize(self: depthai.node.ColorCamera, width: int, height: int) -> None

        Set preview output size

        2. setPreviewSize(self: depthai.node.ColorCamera, size: tuple[int, int]) -> None

        Set preview output size, as a tuple <width, height>
        """
    @overload
    def setPreviewSize(self, size: tuple[int, int]) -> None:
        """setPreviewSize(*args, **kwargs)
        Overloaded function.

        1. setPreviewSize(self: depthai.node.ColorCamera, width: int, height: int) -> None

        Set preview output size

        2. setPreviewSize(self: depthai.node.ColorCamera, size: tuple[int, int]) -> None

        Set preview output size, as a tuple <width, height>
        """
    def setRawNumFramesPool(self, arg0: int) -> None:
        """setRawNumFramesPool(self: depthai.node.ColorCamera, arg0: int) -> None

        Set number of frames in raw pool
        """
    def setRawOutputPacked(self, packed: bool) -> None:
        """setRawOutputPacked(self: depthai.node.ColorCamera, packed: bool) -> None

        Configures whether the camera `raw` frames are saved as MIPI-packed to memory.
        The packed format is more efficient, consuming less memory on device, and less
        data to send to host: RAW10: 4 pixels saved on 5 bytes, RAW12: 2 pixels saved on
        3 bytes. When packing is disabled (`false`), data is saved lsb-aligned, e.g. a
        RAW10 pixel will be stored as uint16, on bits 9..0: 0b0000'00pp'pppp'pppp.
        Default is auto: enabled for standard color/monochrome cameras where ISP can
        work with both packed/unpacked, but disabled for other cameras like ToF.
        """
    def setResolution(self, resolution: depthai.ColorCameraProperties.SensorResolution) -> None:
        """setResolution(self: depthai.node.ColorCamera, resolution: depthai.ColorCameraProperties.SensorResolution) -> None

        Set sensor resolution
        """
    def setSensorCrop(self, x: float, y: float) -> None:
        """setSensorCrop(self: depthai.node.ColorCamera, x: float, y: float) -> None

        Specifies the cropping that happens when converting ISP to video output. By
        default, video will be center cropped from the ISP output. Note that this
        doesn't actually do on-sensor cropping (and MIPI-stream only that region), but
        it does postprocessing on the ISP (on RVC).

        Parameter ``x``:
            Top left X coordinate

        Parameter ``y``:
            Top left Y coordinate
        """
    def setStillNumFramesPool(self, arg0: int) -> None:
        """setStillNumFramesPool(self: depthai.node.ColorCamera, arg0: int) -> None

        Set number of frames in preview pool
        """
    @overload
    def setStillSize(self, width: int, height: int) -> None:
        """setStillSize(*args, **kwargs)
        Overloaded function.

        1. setStillSize(self: depthai.node.ColorCamera, width: int, height: int) -> None

        Set still output size

        2. setStillSize(self: depthai.node.ColorCamera, size: tuple[int, int]) -> None

        Set still output size, as a tuple <width, height>
        """
    @overload
    def setStillSize(self, size: tuple[int, int]) -> None:
        """setStillSize(*args, **kwargs)
        Overloaded function.

        1. setStillSize(self: depthai.node.ColorCamera, width: int, height: int) -> None

        Set still output size

        2. setStillSize(self: depthai.node.ColorCamera, size: tuple[int, int]) -> None

        Set still output size, as a tuple <width, height>
        """
    def setVideoNumFramesPool(self, arg0: int) -> None:
        """setVideoNumFramesPool(self: depthai.node.ColorCamera, arg0: int) -> None

        Set number of frames in preview pool
        """
    @overload
    def setVideoSize(self, width: int, height: int) -> None:
        """setVideoSize(*args, **kwargs)
        Overloaded function.

        1. setVideoSize(self: depthai.node.ColorCamera, width: int, height: int) -> None

        Set video output size

        2. setVideoSize(self: depthai.node.ColorCamera, size: tuple[int, int]) -> None

        Set video output size, as a tuple <width, height>
        """
    @overload
    def setVideoSize(self, size: tuple[int, int]) -> None:
        """setVideoSize(*args, **kwargs)
        Overloaded function.

        1. setVideoSize(self: depthai.node.ColorCamera, width: int, height: int) -> None

        Set video output size

        2. setVideoSize(self: depthai.node.ColorCamera, size: tuple[int, int]) -> None

        Set video output size, as a tuple <width, height>
        """
    def setWaitForConfigInput(self, wait: bool) -> None:
        """setWaitForConfigInput(self: depthai.node.ColorCamera, wait: bool) -> None

        Specify to wait until inputConfig receives a configuration message, before
        sending out a frame.

        Parameter ``wait``:
            True to wait for inputConfig message, false otherwise
        """
    @property
    def frameEvent(self) -> depthai.Node.Output: ...
    @property
    def initialControl(self) -> depthai.CameraControl: ...
    @property
    def inputConfig(self) -> depthai.Node.Input: ...
    @property
    def inputControl(self) -> depthai.Node.Input: ...
    @property
    def isp(self) -> depthai.Node.Output: ...
    @property
    def preview(self) -> depthai.Node.Output: ...
    @property
    def raw(self) -> depthai.Node.Output: ...
    @property
    def still(self) -> depthai.Node.Output: ...
    @property
    def video(self) -> depthai.Node.Output: ...

class DetectionNetwork(depthai.DeviceNodeGroup):
    def __init__(self, input: depthai.Node.Output, nnArchive: depthai.NNArchive, confidenceThreshold: float = ...) -> None:
        """__init__(self: depthai.node.DetectionNetwork, input: depthai.Node.Output, nnArchive: depthai.NNArchive, confidenceThreshold: float = 0.5) -> None"""
    @overload
    def build(self, input: depthai.Node.Output, nnArchive: depthai.NNArchive, confidenceThreshold: float = ...) -> DetectionNetwork:
        """build(*args, **kwargs)
        Overloaded function.

        1. build(self: depthai.node.DetectionNetwork, input: depthai.Node.Output, nnArchive: depthai.NNArchive, confidenceThreshold: float = 0.5) -> depthai.node.DetectionNetwork

        2. build(self: depthai.node.DetectionNetwork, input: depthai.node.Camera, model: depthai.NNModelDescription, fps: float = 30.0) -> depthai.node.DetectionNetwork

        3. build(self: depthai.node.DetectionNetwork, input: depthai.node.Camera, model: str, fps: float = 30.0) -> depthai.node.DetectionNetwork

        4. build(self: depthai.node.DetectionNetwork, input: depthai.node.Camera, nnArchive: depthai.NNArchive, fps: float = 30.0) -> depthai.node.DetectionNetwork

        5. build(self: depthai.node.DetectionNetwork, input: depthai.node.ReplayVideo, model: depthai.NNModelDescription, fps: float = 30.0) -> depthai.node.DetectionNetwork

        6. build(self: depthai.node.DetectionNetwork, input: depthai.node.ReplayVideo, nnArchive: depthai.NNArchive, fps: float = 30.0) -> depthai.node.DetectionNetwork
        """
    @overload
    def build(self, input: Camera, model: depthai.NNModelDescription, fps: float = ...) -> DetectionNetwork:
        """build(*args, **kwargs)
        Overloaded function.

        1. build(self: depthai.node.DetectionNetwork, input: depthai.Node.Output, nnArchive: depthai.NNArchive, confidenceThreshold: float = 0.5) -> depthai.node.DetectionNetwork

        2. build(self: depthai.node.DetectionNetwork, input: depthai.node.Camera, model: depthai.NNModelDescription, fps: float = 30.0) -> depthai.node.DetectionNetwork

        3. build(self: depthai.node.DetectionNetwork, input: depthai.node.Camera, model: str, fps: float = 30.0) -> depthai.node.DetectionNetwork

        4. build(self: depthai.node.DetectionNetwork, input: depthai.node.Camera, nnArchive: depthai.NNArchive, fps: float = 30.0) -> depthai.node.DetectionNetwork

        5. build(self: depthai.node.DetectionNetwork, input: depthai.node.ReplayVideo, model: depthai.NNModelDescription, fps: float = 30.0) -> depthai.node.DetectionNetwork

        6. build(self: depthai.node.DetectionNetwork, input: depthai.node.ReplayVideo, nnArchive: depthai.NNArchive, fps: float = 30.0) -> depthai.node.DetectionNetwork
        """
    @overload
    def build(self, input: Camera, model: str, fps: float = ...) -> DetectionNetwork:
        """build(*args, **kwargs)
        Overloaded function.

        1. build(self: depthai.node.DetectionNetwork, input: depthai.Node.Output, nnArchive: depthai.NNArchive, confidenceThreshold: float = 0.5) -> depthai.node.DetectionNetwork

        2. build(self: depthai.node.DetectionNetwork, input: depthai.node.Camera, model: depthai.NNModelDescription, fps: float = 30.0) -> depthai.node.DetectionNetwork

        3. build(self: depthai.node.DetectionNetwork, input: depthai.node.Camera, model: str, fps: float = 30.0) -> depthai.node.DetectionNetwork

        4. build(self: depthai.node.DetectionNetwork, input: depthai.node.Camera, nnArchive: depthai.NNArchive, fps: float = 30.0) -> depthai.node.DetectionNetwork

        5. build(self: depthai.node.DetectionNetwork, input: depthai.node.ReplayVideo, model: depthai.NNModelDescription, fps: float = 30.0) -> depthai.node.DetectionNetwork

        6. build(self: depthai.node.DetectionNetwork, input: depthai.node.ReplayVideo, nnArchive: depthai.NNArchive, fps: float = 30.0) -> depthai.node.DetectionNetwork
        """
    @overload
    def build(self, input: Camera, nnArchive: depthai.NNArchive, fps: float = ...) -> DetectionNetwork:
        """build(*args, **kwargs)
        Overloaded function.

        1. build(self: depthai.node.DetectionNetwork, input: depthai.Node.Output, nnArchive: depthai.NNArchive, confidenceThreshold: float = 0.5) -> depthai.node.DetectionNetwork

        2. build(self: depthai.node.DetectionNetwork, input: depthai.node.Camera, model: depthai.NNModelDescription, fps: float = 30.0) -> depthai.node.DetectionNetwork

        3. build(self: depthai.node.DetectionNetwork, input: depthai.node.Camera, model: str, fps: float = 30.0) -> depthai.node.DetectionNetwork

        4. build(self: depthai.node.DetectionNetwork, input: depthai.node.Camera, nnArchive: depthai.NNArchive, fps: float = 30.0) -> depthai.node.DetectionNetwork

        5. build(self: depthai.node.DetectionNetwork, input: depthai.node.ReplayVideo, model: depthai.NNModelDescription, fps: float = 30.0) -> depthai.node.DetectionNetwork

        6. build(self: depthai.node.DetectionNetwork, input: depthai.node.ReplayVideo, nnArchive: depthai.NNArchive, fps: float = 30.0) -> depthai.node.DetectionNetwork
        """
    @overload
    def build(self, input: ReplayVideo, model: depthai.NNModelDescription, fps: float = ...) -> DetectionNetwork:
        """build(*args, **kwargs)
        Overloaded function.

        1. build(self: depthai.node.DetectionNetwork, input: depthai.Node.Output, nnArchive: depthai.NNArchive, confidenceThreshold: float = 0.5) -> depthai.node.DetectionNetwork

        2. build(self: depthai.node.DetectionNetwork, input: depthai.node.Camera, model: depthai.NNModelDescription, fps: float = 30.0) -> depthai.node.DetectionNetwork

        3. build(self: depthai.node.DetectionNetwork, input: depthai.node.Camera, model: str, fps: float = 30.0) -> depthai.node.DetectionNetwork

        4. build(self: depthai.node.DetectionNetwork, input: depthai.node.Camera, nnArchive: depthai.NNArchive, fps: float = 30.0) -> depthai.node.DetectionNetwork

        5. build(self: depthai.node.DetectionNetwork, input: depthai.node.ReplayVideo, model: depthai.NNModelDescription, fps: float = 30.0) -> depthai.node.DetectionNetwork

        6. build(self: depthai.node.DetectionNetwork, input: depthai.node.ReplayVideo, nnArchive: depthai.NNArchive, fps: float = 30.0) -> depthai.node.DetectionNetwork
        """
    @overload
    def build(self, input: ReplayVideo, nnArchive: depthai.NNArchive, fps: float = ...) -> DetectionNetwork:
        """build(*args, **kwargs)
        Overloaded function.

        1. build(self: depthai.node.DetectionNetwork, input: depthai.Node.Output, nnArchive: depthai.NNArchive, confidenceThreshold: float = 0.5) -> depthai.node.DetectionNetwork

        2. build(self: depthai.node.DetectionNetwork, input: depthai.node.Camera, model: depthai.NNModelDescription, fps: float = 30.0) -> depthai.node.DetectionNetwork

        3. build(self: depthai.node.DetectionNetwork, input: depthai.node.Camera, model: str, fps: float = 30.0) -> depthai.node.DetectionNetwork

        4. build(self: depthai.node.DetectionNetwork, input: depthai.node.Camera, nnArchive: depthai.NNArchive, fps: float = 30.0) -> depthai.node.DetectionNetwork

        5. build(self: depthai.node.DetectionNetwork, input: depthai.node.ReplayVideo, model: depthai.NNModelDescription, fps: float = 30.0) -> depthai.node.DetectionNetwork

        6. build(self: depthai.node.DetectionNetwork, input: depthai.node.ReplayVideo, nnArchive: depthai.NNArchive, fps: float = 30.0) -> depthai.node.DetectionNetwork
        """
    def getClasses(self) -> list[str] | None:
        """getClasses(self: depthai.node.DetectionNetwork) -> Optional[list[str]]"""
    def getConfidenceThreshold(self) -> float:
        """getConfidenceThreshold(self: depthai.node.DetectionNetwork) -> float

        Retrieves threshold at which to filter the rest of the detections.

        Returns:
            Detection confidence
        """
    def getNumInferenceThreads(self) -> int:
        """getNumInferenceThreads(self: depthai.node.DetectionNetwork) -> int

        How many inference threads will be used to run the network

        Returns:
            Number of threads, 0, 1 or 2. Zero means AUTO
        """
    def setBackend(self, setBackend: str) -> None:
        """setBackend(self: depthai.node.DetectionNetwork, setBackend: str) -> None

        Specifies backend to use

        Parameter ``backend``:
            String specifying backend to use
        """
    def setBackendProperties(self, setBackendProperties: dict[str, str]) -> None:
        """setBackendProperties(self: depthai.node.DetectionNetwork, setBackendProperties: dict[str, str]) -> None

        Set backend properties

        Parameter ``backendProperties``:
            backend properties map
        """
    @overload
    def setBlob(self, blob: depthai.OpenVINO.Blob) -> None:
        """setBlob(*args, **kwargs)
        Overloaded function.

        1. setBlob(self: depthai.node.DetectionNetwork, blob: depthai.OpenVINO.Blob) -> None

        Load network blob into assets and use once pipeline is started.

        Parameter ``blob``:
            Network blob

        2. setBlob(self: depthai.node.DetectionNetwork, path: Path) -> None

        Same functionality as the setBlobPath(). Load network blob into assets and use
        once pipeline is started.

        Throws:
            Error if file doesn't exist or isn't a valid network blob.

        Parameter ``path``:
            Path to network blob
        """
    @overload
    def setBlob(self, path: Path) -> None:
        """setBlob(*args, **kwargs)
        Overloaded function.

        1. setBlob(self: depthai.node.DetectionNetwork, blob: depthai.OpenVINO.Blob) -> None

        Load network blob into assets and use once pipeline is started.

        Parameter ``blob``:
            Network blob

        2. setBlob(self: depthai.node.DetectionNetwork, path: Path) -> None

        Same functionality as the setBlobPath(). Load network blob into assets and use
        once pipeline is started.

        Throws:
            Error if file doesn't exist or isn't a valid network blob.

        Parameter ``path``:
            Path to network blob
        """
    def setBlobPath(self, path: Path) -> None:
        """setBlobPath(self: depthai.node.DetectionNetwork, path: Path) -> None

        Load network blob into assets and use once pipeline is started.

        Throws:
            Error if file doesn't exist or isn't a valid network blob.

        Parameter ``path``:
            Path to network blob
        """
    def setConfidenceThreshold(self, thresh: float) -> None:
        """setConfidenceThreshold(self: depthai.node.DetectionNetwork, thresh: float) -> None

        Specifies confidence threshold at which to filter the rest of the detections.

        Parameter ``thresh``:
            Detection confidence must be greater than specified threshold to be added to
            the list
        """
    def setFromModelZoo(self, description: depthai.NNModelDescription, useCached: bool = ...) -> None:
        """setFromModelZoo(self: depthai.node.DetectionNetwork, description: depthai.NNModelDescription, useCached: bool = False) -> None

        Download model from zoo and set it for this Node

        Parameter ``description:``:
            Model description to download

        Parameter ``useCached:``:
            Use cached model if available
        """
    def setModelPath(self, modelPath: Path) -> None:
        """setModelPath(self: depthai.node.DetectionNetwork, modelPath: Path) -> None

        Load network model into assets.

        Parameter ``modelPath``:
            Path to the model file.
        """
    def setNNArchive(self, archive: depthai.NNArchive) -> None:
        """setNNArchive(*args, **kwargs)
        Overloaded function.

        1. setNNArchive(self: depthai.node.DetectionNetwork, archive: depthai.NNArchive) -> None

        Set NNArchive for this Node. If the archive's type is SUPERBLOB, use default
        number of shaves.

        Parameter ``nnArchive:``:
            NNArchive to set

        2. setNNArchive(self: depthai.node.DetectionNetwork, archive: depthai.NNArchive, numShaves: int) -> None

        Set NNArchive for this Node. If the archive's type is SUPERBLOB, use default
        number of shaves.

        Parameter ``nnArchive:``:
            NNArchive to set
        """
    def setNumInferenceThreads(self, numThreads: int) -> None:
        """setNumInferenceThreads(self: depthai.node.DetectionNetwork, numThreads: int) -> None

        How many threads should the node use to run the network.

        Parameter ``numThreads``:
            Number of threads to dedicate to this node
        """
    def setNumNCEPerInferenceThread(self, numNCEPerThread: int) -> None:
        """setNumNCEPerInferenceThread(self: depthai.node.DetectionNetwork, numNCEPerThread: int) -> None

        How many Neural Compute Engines should a single thread use for inference

        Parameter ``numNCEPerThread``:
            Number of NCE per thread
        """
    def setNumPoolFrames(self, numFrames: int) -> None:
        """setNumPoolFrames(self: depthai.node.DetectionNetwork, numFrames: int) -> None

        Specifies how many frames will be available in the pool

        Parameter ``numFrames``:
            How many frames will pool have
        """
    def setNumShavesPerInferenceThread(self, numShavesPerInferenceThread: int) -> None:
        """setNumShavesPerInferenceThread(self: depthai.node.DetectionNetwork, numShavesPerInferenceThread: int) -> None

        How many Shaves should a single thread use for inference

        Parameter ``numShavesPerThread``:
            Number of shaves per thread
        """
    @property
    def input(self) -> depthai.Node.Input: ...
    @property
    def out(self) -> depthai.Node.Output: ...
    @property
    def outNetwork(self) -> depthai.Node.Output: ...
    @property
    def passthrough(self) -> depthai.Node.Output: ...

class DetectionParser(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.DetectionParserProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def build(self, arg0: depthai.Node.Output, arg1: depthai.NNArchive) -> DetectionParser:
        """build(self: depthai.node.DetectionParser, arg0: depthai.Node.Output, arg1: depthai.NNArchive) -> depthai.node.DetectionParser

        Build DetectionParser node. Connect output to this node's input. Also call
        setNNArchive() with provided NNArchive.

        Parameter ``nnInput:``:
            Output to link

        Parameter ``nnArchive:``:
            Neural network archive
        """
    def getAnchorMasks(self) -> dict[str, list[int]]:
        """getAnchorMasks(self: depthai.node.DetectionParser) -> dict[str, list[int]]

        Get anchor masks
        """
    def getAnchors(self) -> list[float]:
        """getAnchors(self: depthai.node.DetectionParser) -> list[float]

        Get anchors
        """
    def getConfidenceThreshold(self) -> float:
        """getConfidenceThreshold(self: depthai.node.DetectionParser) -> float

        Retrieves threshold at which to filter the rest of the detections.

        Returns:
            Detection confidence
        """
    def getCoordinateSize(self) -> int:
        """getCoordinateSize(self: depthai.node.DetectionParser) -> int

        Get coordianate size
        """
    def getIouThreshold(self) -> float:
        """getIouThreshold(self: depthai.node.DetectionParser) -> float

        Get Iou threshold
        """
    def getNNFamily(self) -> depthai.DetectionNetworkType:
        """getNNFamily(self: depthai.node.DetectionParser) -> depthai.DetectionNetworkType

        Gets NN Family to parse
        """
    def getNumClasses(self) -> int:
        """getNumClasses(self: depthai.node.DetectionParser) -> int

        Get num classes
        """
    def getNumFramesPool(self) -> int:
        """getNumFramesPool(self: depthai.node.DetectionParser) -> int

        Returns number of frames in pool
        """
    def setAnchorMasks(self, anchorMasks: dict[str, list[int]]) -> None:
        """setAnchorMasks(self: depthai.node.DetectionParser, anchorMasks: dict[str, list[int]]) -> None

        Set anchor masks
        """
    @overload
    def setAnchors(self, anchors: list[list[list[float]]]) -> None:
        """setAnchors(*args, **kwargs)
        Overloaded function.

        1. setAnchors(self: depthai.node.DetectionParser, anchors: list[list[list[float]]]) -> None

        Set anchors

        2. setAnchors(self: depthai.node.DetectionParser, anchors: list[float]) -> None

        Set anchors with masks
        """
    @overload
    def setAnchors(self, anchors: list[float]) -> None:
        """setAnchors(*args, **kwargs)
        Overloaded function.

        1. setAnchors(self: depthai.node.DetectionParser, anchors: list[list[list[float]]]) -> None

        Set anchors

        2. setAnchors(self: depthai.node.DetectionParser, anchors: list[float]) -> None

        Set anchors with masks
        """
    @overload
    def setBlob(self, blob: depthai.OpenVINO.Blob) -> None:
        """setBlob(*args, **kwargs)
        Overloaded function.

        1. setBlob(self: depthai.node.DetectionParser, blob: depthai.OpenVINO.Blob) -> None

        Retrieves some input tensor information from the blob

        Parameter ``blob``:
            OpenVINO blob to retrieve the information from

        2. setBlob(self: depthai.node.DetectionParser, path: Path) -> None

        Same functionality as the setBlobPath(). Load network blob into assets and use
        once pipeline is started.

        Throws:
            Error if file doesn't exist or isn't a valid network blob.

        Parameter ``path``:
            Path to network blob
        """
    @overload
    def setBlob(self, path: Path) -> None:
        """setBlob(*args, **kwargs)
        Overloaded function.

        1. setBlob(self: depthai.node.DetectionParser, blob: depthai.OpenVINO.Blob) -> None

        Retrieves some input tensor information from the blob

        Parameter ``blob``:
            OpenVINO blob to retrieve the information from

        2. setBlob(self: depthai.node.DetectionParser, path: Path) -> None

        Same functionality as the setBlobPath(). Load network blob into assets and use
        once pipeline is started.

        Throws:
            Error if file doesn't exist or isn't a valid network blob.

        Parameter ``path``:
            Path to network blob
        """
    def setBlobPath(self, path: Path) -> None:
        """setBlobPath(self: depthai.node.DetectionParser, path: Path) -> None

        Load network blob into assets and use once pipeline is started.

        Throws:
            Error if file doesn't exist or isn't a valid network blob.

        Parameter ``path``:
            Path to network blob
        """
    def setConfidenceThreshold(self, thresh: float) -> None:
        """setConfidenceThreshold(self: depthai.node.DetectionParser, thresh: float) -> None

        Specifies confidence threshold at which to filter the rest of the detections.

        Parameter ``thresh``:
            Detection confidence must be greater than specified threshold to be added to
            the list
        """
    def setCoordinateSize(self, coordinates: int) -> None:
        """setCoordinateSize(self: depthai.node.DetectionParser, coordinates: int) -> None

        Set coordianate size
        """
    @overload
    def setInputImageSize(self, width: int, height: int) -> None:
        """setInputImageSize(*args, **kwargs)
        Overloaded function.

        1. setInputImageSize(self: depthai.node.DetectionParser, width: int, height: int) -> None

        Set input image size

        This should only be used instead of setBlob, not besides it

        2. setInputImageSize(self: depthai.node.DetectionParser, size: tuple[int, int]) -> None
        """
    @overload
    def setInputImageSize(self, size: tuple[int, int]) -> None:
        """setInputImageSize(*args, **kwargs)
        Overloaded function.

        1. setInputImageSize(self: depthai.node.DetectionParser, width: int, height: int) -> None

        Set input image size

        This should only be used instead of setBlob, not besides it

        2. setInputImageSize(self: depthai.node.DetectionParser, size: tuple[int, int]) -> None
        """
    def setIouThreshold(self, thresh: float) -> None:
        """setIouThreshold(self: depthai.node.DetectionParser, thresh: float) -> None

        Set Iou threshold
        """
    def setNNArchive(self, nnArchive: depthai.NNArchive) -> None:
        """setNNArchive(self: depthai.node.DetectionParser, nnArchive: depthai.NNArchive) -> None

        Set NNArchive for this Node. If the archive's type is SUPERBLOB, use default
        number of shaves.

        Parameter ``nnArchive:``:
            NNArchive to set
        """
    def setNNFamily(self, type: depthai.DetectionNetworkType) -> None:
        """setNNFamily(self: depthai.node.DetectionParser, type: depthai.DetectionNetworkType) -> None

        Sets NN Family to parse
        """
    def setNumClasses(self, numClasses: int) -> None:
        """setNumClasses(self: depthai.node.DetectionParser, numClasses: int) -> None

        Set num classes
        """
    def setNumFramesPool(self, numFramesPool: int) -> None:
        """setNumFramesPool(self: depthai.node.DetectionParser, numFramesPool: int) -> None

        Specify number of frames in pool.

        Parameter ``numFramesPool``:
            How many frames should the pool have
        """
    @property
    def input(self) -> depthai.Node.Input: ...
    @property
    def out(self) -> depthai.Node.Output: ...

class EdgeDetector(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.EdgeDetectorProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getWaitForConfigInput(self) -> bool:
        """getWaitForConfigInput(self: depthai.node.EdgeDetector) -> bool

        See also:
            setWaitForConfigInput

        Returns:
            True if wait for inputConfig message, false otherwise
        """
    def setMaxOutputFrameSize(self, arg0: int) -> None:
        """setMaxOutputFrameSize(self: depthai.node.EdgeDetector, arg0: int) -> None

        Specify maximum size of output image.

        Parameter ``maxFrameSize``:
            Maximum frame size in bytes
        """
    def setNumFramesPool(self, arg0: int) -> None:
        """setNumFramesPool(self: depthai.node.EdgeDetector, arg0: int) -> None

        Specify number of frames in pool.

        Parameter ``numFramesPool``:
            How many frames should the pool have
        """
    def setWaitForConfigInput(self, wait: bool) -> None:
        """setWaitForConfigInput(self: depthai.node.EdgeDetector, wait: bool) -> None

        Specify whether or not wait until configuration message arrives to inputConfig
        Input.

        Parameter ``wait``:
            True to wait for configuration message, false otherwise.
        """
    @property
    def initialConfig(self) -> depthai.EdgeDetectorConfig: ...
    @property
    def inputConfig(self) -> depthai.Node.Input: ...
    @property
    def inputImage(self) -> depthai.Node.Input: ...
    @property
    def outputImage(self) -> depthai.Node.Output: ...

class FeatureTracker(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.FeatureTrackerProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getWaitForConfigInput(self) -> bool:
        """getWaitForConfigInput(self: depthai.node.FeatureTracker) -> bool

        See also:
            setWaitForConfigInput

        Returns:
            True if wait for inputConfig message, false otherwise
        """
    def setHardwareResources(self, numShaves: int, numMemorySlices: int) -> None:
        """setHardwareResources(self: depthai.node.FeatureTracker, numShaves: int, numMemorySlices: int) -> None

        Specify allocated hardware resources for feature tracking. 2 shaves/memory
        slices are required for optical flow, 1 for corner detection only.

        Parameter ``numShaves``:
            Number of shaves. Maximum 2.

        Parameter ``numMemorySlices``:
            Number of memory slices. Maximum 2.
        """
    def setWaitForConfigInput(self, wait: bool) -> None:
        """setWaitForConfigInput(self: depthai.node.FeatureTracker, wait: bool) -> None

        Specify whether or not wait until configuration message arrives to inputConfig
        Input.

        Parameter ``wait``:
            True to wait for configuration message, false otherwise.
        """
    @property
    def initialConfig(self) -> depthai.FeatureTrackerConfig: ...
    @property
    def inputConfig(self) -> depthai.Node.Input: ...
    @property
    def inputImage(self) -> depthai.Node.Input: ...
    @property
    def outputFeatures(self) -> depthai.Node.Output: ...
    @property
    def passthroughInputImage(self) -> depthai.Node.Output: ...

class HostNode(ThreadedHostNode):
    def link_args(self, *args) -> None: ...
    def __init__(self, *args) -> None: ...
    createSubnode: ClassVar[Callable] = ...
    __init_subclass__: ClassVar[method] = ...
    def __init__(self) -> None:
        """__init__(self: depthai.node.HostNode) -> None"""
    def onStart(self) -> None:
        """onStart(self: depthai.node.HostNode) -> None"""
    def onStop(self) -> None:
        """onStop(self: depthai.node.HostNode) -> None"""
    def processGroup(self, arg0: depthai.MessageGroup) -> depthai.Buffer:
        """processGroup(self: depthai.node.HostNode, arg0: depthai.MessageGroup) -> depthai.Buffer"""
    def runSyncingOnDevice(self) -> None:
        """runSyncingOnDevice(self: depthai.node.HostNode) -> None"""
    def runSyncingOnHost(self) -> None:
        """runSyncingOnHost(self: depthai.node.HostNode) -> None"""
    def sendProcessingToPipeline(self, arg0: bool) -> None:
        """sendProcessingToPipeline(self: depthai.node.HostNode, arg0: bool) -> None"""
    @property
    def inputs(self) -> depthai.Node.InputMap: ...
    @property
    def out(self) -> depthai.Node.Output: ...

class IMU(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.IMUProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def enableFirmwareUpdate(self, arg0: bool) -> None:
        """enableFirmwareUpdate(self: depthai.node.IMU, arg0: bool) -> None"""
    @overload
    def enableIMUSensor(self, sensorConfig: depthai.IMUSensorConfig) -> None:
        """enableIMUSensor(*args, **kwargs)
        Overloaded function.

        1. enableIMUSensor(self: depthai.node.IMU, sensorConfig: depthai.IMUSensorConfig) -> None

        Enable a new IMU sensor with explicit configuration

        2. enableIMUSensor(self: depthai.node.IMU, sensorConfigs: list[depthai.IMUSensorConfig]) -> None

        Enable a list of IMU sensors with explicit configuration

        3. enableIMUSensor(self: depthai.node.IMU, sensor: depthai.IMUSensor, reportRate: int) -> None

        Enable a new IMU sensor with default configuration

        4. enableIMUSensor(self: depthai.node.IMU, sensors: list[depthai.IMUSensor], reportRate: int) -> None

        Enable a list of IMU sensors with default configuration
        """
    @overload
    def enableIMUSensor(self, sensorConfigs: list[depthai.IMUSensorConfig]) -> None:
        """enableIMUSensor(*args, **kwargs)
        Overloaded function.

        1. enableIMUSensor(self: depthai.node.IMU, sensorConfig: depthai.IMUSensorConfig) -> None

        Enable a new IMU sensor with explicit configuration

        2. enableIMUSensor(self: depthai.node.IMU, sensorConfigs: list[depthai.IMUSensorConfig]) -> None

        Enable a list of IMU sensors with explicit configuration

        3. enableIMUSensor(self: depthai.node.IMU, sensor: depthai.IMUSensor, reportRate: int) -> None

        Enable a new IMU sensor with default configuration

        4. enableIMUSensor(self: depthai.node.IMU, sensors: list[depthai.IMUSensor], reportRate: int) -> None

        Enable a list of IMU sensors with default configuration
        """
    @overload
    def enableIMUSensor(self, sensor: depthai.IMUSensor, reportRate: int) -> None:
        """enableIMUSensor(*args, **kwargs)
        Overloaded function.

        1. enableIMUSensor(self: depthai.node.IMU, sensorConfig: depthai.IMUSensorConfig) -> None

        Enable a new IMU sensor with explicit configuration

        2. enableIMUSensor(self: depthai.node.IMU, sensorConfigs: list[depthai.IMUSensorConfig]) -> None

        Enable a list of IMU sensors with explicit configuration

        3. enableIMUSensor(self: depthai.node.IMU, sensor: depthai.IMUSensor, reportRate: int) -> None

        Enable a new IMU sensor with default configuration

        4. enableIMUSensor(self: depthai.node.IMU, sensors: list[depthai.IMUSensor], reportRate: int) -> None

        Enable a list of IMU sensors with default configuration
        """
    @overload
    def enableIMUSensor(self, sensors: list[depthai.IMUSensor], reportRate: int) -> None:
        """enableIMUSensor(*args, **kwargs)
        Overloaded function.

        1. enableIMUSensor(self: depthai.node.IMU, sensorConfig: depthai.IMUSensorConfig) -> None

        Enable a new IMU sensor with explicit configuration

        2. enableIMUSensor(self: depthai.node.IMU, sensorConfigs: list[depthai.IMUSensorConfig]) -> None

        Enable a list of IMU sensors with explicit configuration

        3. enableIMUSensor(self: depthai.node.IMU, sensor: depthai.IMUSensor, reportRate: int) -> None

        Enable a new IMU sensor with default configuration

        4. enableIMUSensor(self: depthai.node.IMU, sensors: list[depthai.IMUSensor], reportRate: int) -> None

        Enable a list of IMU sensors with default configuration
        """
    def getBatchReportThreshold(self) -> int:
        """getBatchReportThreshold(self: depthai.node.IMU) -> int

        Above this packet threshold data will be sent to host, if queue is not blocked
        """
    def getMaxBatchReports(self) -> int:
        """getMaxBatchReports(self: depthai.node.IMU) -> int

        Maximum number of IMU packets in a batch report
        """
    def setBatchReportThreshold(self, batchReportThreshold: int) -> None:
        """setBatchReportThreshold(self: depthai.node.IMU, batchReportThreshold: int) -> None

        Above this packet threshold data will be sent to host, if queue is not blocked
        """
    def setMaxBatchReports(self, maxBatchReports: int) -> None:
        """setMaxBatchReports(self: depthai.node.IMU, maxBatchReports: int) -> None

        Maximum number of IMU packets in a batch report
        """
    @property
    def mockIn(self) -> depthai.Node.Input: ...
    @property
    def out(self) -> depthai.Node.Output: ...

class ImageAlign(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.ImageAlignProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def setInterpolation(self, interp: depthai.Interpolation) -> ImageAlign:
        """setInterpolation(self: depthai.node.ImageAlign, interp: depthai.Interpolation) -> depthai.node.ImageAlign

        Specify interpolation method to use when resizing
        """
    def setNumFramesPool(self, numFramesPool: int) -> ImageAlign:
        """setNumFramesPool(self: depthai.node.ImageAlign, numFramesPool: int) -> depthai.node.ImageAlign

        Specify number of frames in the pool
        """
    def setNumShaves(self, numShaves: int) -> ImageAlign:
        """setNumShaves(self: depthai.node.ImageAlign, numShaves: int) -> depthai.node.ImageAlign

        Specify number of shaves to use for this node
        """
    def setOutKeepAspectRatio(self, keep: bool) -> ImageAlign:
        """setOutKeepAspectRatio(self: depthai.node.ImageAlign, keep: bool) -> depthai.node.ImageAlign

        Specify whether to keep aspect ratio when resizing
        """
    def setOutputSize(self, alignWidth: int, alignHeight: int) -> ImageAlign:
        """setOutputSize(self: depthai.node.ImageAlign, alignWidth: int, alignHeight: int) -> depthai.node.ImageAlign

        Specify the output size of the aligned image
        """
    @property
    def initialConfig(self) -> depthai.ImageAlignConfig: ...
    @property
    def input(self) -> depthai.Node.Input: ...
    @property
    def inputAlignTo(self) -> depthai.Node.Input: ...
    @property
    def inputConfig(self) -> depthai.Node.Input: ...
    @property
    def outputAligned(self) -> depthai.Node.Output: ...
    @property
    def passthroughInput(self) -> depthai.Node.Output: ...

class ImageManip(depthai.DeviceNode):
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getWaitForConfigInput(self) -> bool:
        """getWaitForConfigInput(self: depthai.node.ImageManip) -> bool

        See also:
            setWaitForConfigInput

        Returns:
            True if wait for inputConfig message, false otherwise
        """
    def setCenterCrop(self, arg0: float, arg1: float) -> None:
        """setCenterCrop(self: depthai.node.ImageManip, arg0: float, arg1: float) -> None"""
    def setCropRect(self, arg0: float, arg1: float, arg2: float, arg3: float) -> None:
        """setCropRect(self: depthai.node.ImageManip, arg0: float, arg1: float, arg2: float, arg3: float) -> None"""
    def setFrameType(self, arg0: depthai.ImgFrame.Type) -> None:
        """setFrameType(self: depthai.node.ImageManip, arg0: depthai.ImgFrame.Type) -> None"""
    def setHorizontalFlip(self, arg0: bool) -> None:
        """setHorizontalFlip(self: depthai.node.ImageManip, arg0: bool) -> None"""
    def setKeepAspectRatio(self, arg0: bool) -> None:
        """setKeepAspectRatio(self: depthai.node.ImageManip, arg0: bool) -> None"""
    def setMaxOutputFrameSize(self, arg0: int) -> None:
        """setMaxOutputFrameSize(self: depthai.node.ImageManip, arg0: int) -> None

        Specify maximum size of output image.

        Parameter ``maxFrameSize``:
            Maximum frame size in bytes
        """
    def setNumFramesPool(self, arg0: int) -> None:
        """setNumFramesPool(self: depthai.node.ImageManip, arg0: int) -> None

        Specify number of frames in pool.

        Parameter ``numFramesPool``:
            How many frames should the pool have
        """
    def setResize(self, arg0: int, arg1: int) -> None:
        """setResize(self: depthai.node.ImageManip, arg0: int, arg1: int) -> None"""
    def setResizeThumbnail(self, arg0: int, arg1: int, arg2: int, arg3: int, arg4: int) -> None:
        """setResizeThumbnail(self: depthai.node.ImageManip, arg0: int, arg1: int, arg2: int, arg3: int, arg4: int) -> None"""
    def setWaitForConfigInput(self, wait: bool) -> None:
        """setWaitForConfigInput(self: depthai.node.ImageManip, wait: bool) -> None

        Specify whether or not wait until configuration message arrives to inputConfig
        Input.

        Parameter ``wait``:
            True to wait for configuration message, false otherwise.
        """
    @overload
    def setWarpMesh(self, arg0: list[depthai.Point2f], arg1: int, arg2: int) -> None:
        """setWarpMesh(*args, **kwargs)
        Overloaded function.

        1. setWarpMesh(self: depthai.node.ImageManip, arg0: list[depthai.Point2f], arg1: int, arg2: int) -> None

        2. setWarpMesh(self: depthai.node.ImageManip, arg0: list[tuple[float, float]], arg1: int, arg2: int) -> None
        """
    @overload
    def setWarpMesh(self, arg0: list[tuple[float, float]], arg1: int, arg2: int) -> None:
        """setWarpMesh(*args, **kwargs)
        Overloaded function.

        1. setWarpMesh(self: depthai.node.ImageManip, arg0: list[depthai.Point2f], arg1: int, arg2: int) -> None

        2. setWarpMesh(self: depthai.node.ImageManip, arg0: list[tuple[float, float]], arg1: int, arg2: int) -> None
        """
    @property
    def initialConfig(self) -> depthai.ImageManipConfig: ...
    @property
    def inputConfig(self) -> depthai.Node.Input: ...
    @property
    def inputImage(self) -> depthai.Node.Input: ...
    @property
    def out(self) -> depthai.Node.Output: ...

class ImageManipV2(depthai.DeviceNode):
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def setMaxOutputFrameSize(self, arg0: int) -> None:
        """setMaxOutputFrameSize(self: depthai.node.ImageManipV2, arg0: int) -> None

        Specify maximum size of output image.

        Parameter ``maxFrameSize``:
            Maximum frame size in bytes
        """
    def setNumFramesPool(self, arg0: int) -> None:
        """setNumFramesPool(self: depthai.node.ImageManipV2, arg0: int) -> None

        Specify number of frames in pool.

        Parameter ``numFramesPool``:
            How many frames should the pool have
        """
    def setRunOnHost(self, arg0: bool) -> ImageManipV2:
        """setRunOnHost(self: depthai.node.ImageManipV2, arg0: bool) -> depthai.node.ImageManipV2

        Specify whether to run on host or device

        Parameter ``runOnHost``:
            Run node on host
        """
    @property
    def initialConfig(self) -> depthai.ImageManipConfigV2: ...
    @property
    def inputConfig(self) -> depthai.Node.Input: ...
    @property
    def inputImage(self) -> depthai.Node.Input: ...
    @property
    def out(self) -> depthai.Node.Output: ...

class MessageDemux(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.MessageDemuxProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    @property
    def input(self) -> depthai.Node.Input: ...
    @property
    def outputs(self) -> depthai.Node.OutputMap: ...

class MobileNetDetectionNetwork(DetectionNetwork):
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class MobileNetSpatialDetectionNetwork(SpatialDetectionNetwork):
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""

class MonoCamera(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.MonoCameraProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getBoardSocket(self) -> depthai.CameraBoardSocket:
        """getBoardSocket(self: depthai.node.MonoCamera) -> depthai.CameraBoardSocket

        Retrieves which board socket to use

        Returns:
            Board socket to use
        """
    def getCamId(self) -> int:
        """getCamId(self: depthai.node.MonoCamera) -> int"""
    def getCamera(self) -> str:
        """getCamera(self: depthai.node.MonoCamera) -> str

        Retrieves which camera to use by name

        Returns:
            Name of the camera to use
        """
    def getFps(self) -> float:
        """getFps(self: depthai.node.MonoCamera) -> float

        Get rate at which camera should produce frames

        Returns:
            Rate in frames per second
        """
    def getFrameEventFilter(self) -> list[depthai.FrameEvent]:
        """getFrameEventFilter(self: depthai.node.MonoCamera) -> list[depthai.FrameEvent]"""
    def getImageOrientation(self) -> depthai.CameraImageOrientation:
        """getImageOrientation(self: depthai.node.MonoCamera) -> depthai.CameraImageOrientation

        Get camera image orientation
        """
    def getNumFramesPool(self) -> int:
        """getNumFramesPool(self: depthai.node.MonoCamera) -> int

        Get number of frames in main (ISP output) pool
        """
    def getRawNumFramesPool(self) -> int:
        """getRawNumFramesPool(self: depthai.node.MonoCamera) -> int

        Get number of frames in raw pool
        """
    def getResolution(self) -> depthai.MonoCameraProperties.SensorResolution:
        """getResolution(self: depthai.node.MonoCamera) -> depthai.MonoCameraProperties.SensorResolution

        Get sensor resolution
        """
    def getResolutionHeight(self) -> int:
        """getResolutionHeight(self: depthai.node.MonoCamera) -> int

        Get sensor resolution height
        """
    def getResolutionSize(self) -> tuple[int, int]:
        """getResolutionSize(self: depthai.node.MonoCamera) -> tuple[int, int]

        Get sensor resolution as size
        """
    def getResolutionWidth(self) -> int:
        """getResolutionWidth(self: depthai.node.MonoCamera) -> int

        Get sensor resolution width
        """
    def setBoardSocket(self, boardSocket: depthai.CameraBoardSocket) -> None:
        """setBoardSocket(self: depthai.node.MonoCamera, boardSocket: depthai.CameraBoardSocket) -> None

        Specify which board socket to use

        Parameter ``boardSocket``:
            Board socket to use
        """
    def setCamId(self, arg0: int) -> None:
        """setCamId(self: depthai.node.MonoCamera, arg0: int) -> None"""
    def setCamera(self, name: str) -> None:
        """setCamera(self: depthai.node.MonoCamera, name: str) -> None

        Specify which camera to use by name

        Parameter ``name``:
            Name of the camera to use
        """
    def setFps(self, fps: float) -> None:
        """setFps(self: depthai.node.MonoCamera, fps: float) -> None

        Set rate at which camera should produce frames

        Parameter ``fps``:
            Rate in frames per second
        """
    def setFrameEventFilter(self, events: list[depthai.FrameEvent]) -> None:
        """setFrameEventFilter(self: depthai.node.MonoCamera, events: list[depthai.FrameEvent]) -> None"""
    def setImageOrientation(self, imageOrientation: depthai.CameraImageOrientation) -> None:
        """setImageOrientation(self: depthai.node.MonoCamera, imageOrientation: depthai.CameraImageOrientation) -> None

        Set camera image orientation
        """
    def setIsp3aFps(self, arg0: int) -> None:
        """setIsp3aFps(self: depthai.node.MonoCamera, arg0: int) -> None

        Isp 3A rate (auto focus, auto exposure, auto white balance, camera controls
        etc.). Default (0) matches the camera FPS, meaning that 3A is running on each
        frame. Reducing the rate of 3A reduces the CPU usage on CSS, but also increases
        the convergence rate of 3A. Note that camera controls will be processed at this
        rate. E.g. if camera is running at 30 fps, and camera control is sent at every
        frame, but 3A fps is set to 15, the camera control messages will be processed at
        15 fps rate, which will lead to queueing.
        """
    def setNumFramesPool(self, arg0: int) -> None:
        """setNumFramesPool(self: depthai.node.MonoCamera, arg0: int) -> None

        Set number of frames in main (ISP output) pool
        """
    def setRawNumFramesPool(self, arg0: int) -> None:
        """setRawNumFramesPool(self: depthai.node.MonoCamera, arg0: int) -> None

        Set number of frames in raw pool
        """
    def setRawOutputPacked(self, packed: bool) -> None:
        """setRawOutputPacked(self: depthai.node.MonoCamera, packed: bool) -> None

        Configures whether the camera `raw` frames are saved as MIPI-packed to memory.
        The packed format is more efficient, consuming less memory on device, and less
        data to send to host: RAW10: 4 pixels saved on 5 bytes, RAW12: 2 pixels saved on
        3 bytes. When packing is disabled (`false`), data is saved lsb-aligned, e.g. a
        RAW10 pixel will be stored as uint16, on bits 9..0: 0b0000'00pp'pppp'pppp.
        Default is auto: enabled for standard color/monochrome cameras where ISP can
        work with both packed/unpacked, but disabled for other cameras like ToF.
        """
    def setResolution(self, resolution: depthai.MonoCameraProperties.SensorResolution) -> None:
        """setResolution(self: depthai.node.MonoCamera, resolution: depthai.MonoCameraProperties.SensorResolution) -> None

        Set sensor resolution
        """
    @property
    def frameEvent(self) -> depthai.Node.Output: ...
    @property
    def initialControl(self) -> depthai.CameraControl: ...
    @property
    def inputControl(self) -> depthai.Node.Input: ...
    @property
    def out(self) -> depthai.Node.Output: ...
    @property
    def raw(self) -> depthai.Node.Output: ...

class NeuralNetwork(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.NeuralNetworkProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def build(self, input: depthai.Node.Output, nnArchive: depthai.NNArchive) -> NeuralNetwork:
        """build(*args, **kwargs)
        Overloaded function.

        1. build(self: depthai.node.NeuralNetwork, input: depthai.Node.Output, nnArchive: depthai.NNArchive) -> depthai.node.NeuralNetwork

        Build NeuralNetwork node. Connect output to this node's input. Also call
        setNNArchive() with provided NNArchive.

        Parameter ``output:``:
            Output to link

        Parameter ``nnArchive:``:
            Neural network archive

        Returns:
            Shared pointer to NeuralNetwork node

        2. build(self: depthai.node.NeuralNetwork, input: depthai.node.Camera, model: depthai.NNModelDescription, fps: float = 30.0) -> depthai.node.NeuralNetwork

        3. build(self: depthai.node.NeuralNetwork, input: depthai.node.Camera, nnArchive: depthai.NNArchive, fps: float = 30.0) -> depthai.node.NeuralNetwork

        4. build(self: depthai.node.NeuralNetwork, input: depthai.node.ReplayVideo, model: depthai.NNModelDescription, fps: float = 30.0) -> depthai.node.NeuralNetwork

        5. build(self: depthai.node.NeuralNetwork, input: depthai.node.ReplayVideo, nnArchive: depthai.NNArchive, fps: float = 30.0) -> depthai.node.NeuralNetwork
        """
    def getNumInferenceThreads(self) -> int:
        """getNumInferenceThreads(self: depthai.node.NeuralNetwork) -> int

        How many inference threads will be used to run the network

        Returns:
            Number of threads, 0, 1 or 2. Zero means AUTO
        """
    def setBackend(self, setBackend: str) -> None:
        """setBackend(self: depthai.node.NeuralNetwork, setBackend: str) -> None

        Specifies backend to use

        Parameter ``backend``:
            String specifying backend to use
        """
    def setBackendProperties(self, setBackendProperties: dict[str, str]) -> None:
        """setBackendProperties(self: depthai.node.NeuralNetwork, setBackendProperties: dict[str, str]) -> None

        Set backend properties

        Parameter ``backendProperties``:
            backend properties map
        """
    @overload
    def setBlob(self, blob: depthai.OpenVINO.Blob) -> None:
        """setBlob(*args, **kwargs)
        Overloaded function.

        1. setBlob(self: depthai.node.NeuralNetwork, blob: depthai.OpenVINO.Blob) -> None

        Load network blob into assets and use once pipeline is started.

        Parameter ``blob``:
            Network blob

        2. setBlob(self: depthai.node.NeuralNetwork, path: Path) -> None

        Same functionality as the setBlobPath(). Load network blob into assets and use
        once pipeline is started.

        Throws:
            Error if file doesn't exist or isn't a valid network blob.

        Parameter ``path``:
            Path to network blob
        """
    @overload
    def setBlob(self, path: Path) -> None:
        """setBlob(*args, **kwargs)
        Overloaded function.

        1. setBlob(self: depthai.node.NeuralNetwork, blob: depthai.OpenVINO.Blob) -> None

        Load network blob into assets and use once pipeline is started.

        Parameter ``blob``:
            Network blob

        2. setBlob(self: depthai.node.NeuralNetwork, path: Path) -> None

        Same functionality as the setBlobPath(). Load network blob into assets and use
        once pipeline is started.

        Throws:
            Error if file doesn't exist or isn't a valid network blob.

        Parameter ``path``:
            Path to network blob
        """
    def setBlobPath(self, path: Path) -> None:
        """setBlobPath(self: depthai.node.NeuralNetwork, path: Path) -> None

        Load network blob into assets and use once pipeline is started.

        Throws:
            Error if file doesn't exist or isn't a valid network blob.

        Parameter ``path``:
            Path to network blob
        """
    def setFromModelZoo(self, description: depthai.NNModelDescription, useCached: bool) -> None:
        """setFromModelZoo(self: depthai.node.NeuralNetwork, description: depthai.NNModelDescription, useCached: bool) -> None

        Download model from zoo and set it for this Node

        Parameter ``description:``:
            Model description to download

        Parameter ``useCached:``:
            Use cached model if available
        """
    def setModelPath(self, modelPath: Path) -> None:
        """setModelPath(self: depthai.node.NeuralNetwork, modelPath: Path) -> None

        Load network xml and bin files into assets.

        Parameter ``xmlModelPath``:
            Path to the neural network model file.
        """
    def setNNArchive(self, nnArchive: depthai.NNArchive) -> None:
        """setNNArchive(*args, **kwargs)
        Overloaded function.

        1. setNNArchive(self: depthai.node.NeuralNetwork, nnArchive: depthai.NNArchive) -> None

        Set NNArchive for this Node. If the archive's type is SUPERBLOB, use default
        number of shaves.

        Parameter ``nnArchive:``:
            NNArchive to set

        2. setNNArchive(self: depthai.node.NeuralNetwork, nnArchive: depthai.NNArchive, numShaves: int) -> None

        Set NNArchive for this Node, throws if the archive's type is not SUPERBLOB

        Parameter ``nnArchive:``:
            NNArchive to set

        Parameter ``numShaves:``:
            Number of shaves to use
        """
    def setNumInferenceThreads(self, numThreads: int) -> None:
        """setNumInferenceThreads(self: depthai.node.NeuralNetwork, numThreads: int) -> None

        How many threads should the node use to run the network.

        Parameter ``numThreads``:
            Number of threads to dedicate to this node
        """
    def setNumNCEPerInferenceThread(self, numNCEPerThread: int) -> None:
        """setNumNCEPerInferenceThread(self: depthai.node.NeuralNetwork, numNCEPerThread: int) -> None

        How many Neural Compute Engines should a single thread use for inference

        Parameter ``numNCEPerThread``:
            Number of NCE per thread
        """
    def setNumPoolFrames(self, numFrames: int) -> None:
        """setNumPoolFrames(self: depthai.node.NeuralNetwork, numFrames: int) -> None

        Specifies how many frames will be available in the pool

        Parameter ``numFrames``:
            How many frames will pool have
        """
    def setNumShavesPerInferenceThread(self, numShavesPerInferenceThread: int) -> None:
        """setNumShavesPerInferenceThread(self: depthai.node.NeuralNetwork, numShavesPerInferenceThread: int) -> None

        How many Shaves should a single thread use for inference

        Parameter ``numShavesPerThread``:
            Number of shaves per thread
        """
    @property
    def input(self) -> depthai.Node.Input: ...
    @property
    def inputs(self) -> depthai.Node.InputMap: ...
    @property
    def out(self) -> depthai.Node.Output: ...
    @property
    def passthrough(self) -> depthai.Node.Output: ...
    @property
    def passthroughs(self) -> depthai.Node.OutputMap: ...

class ObjectTracker(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.ObjectTrackerProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def setDetectionLabelsToTrack(self, labels: list[int]) -> None:
        """setDetectionLabelsToTrack(self: depthai.node.ObjectTracker, labels: list[int]) -> None

        Specify detection labels to track.

        Parameter ``labels``:
            Detection labels to track. Default every label is tracked from image
            detection network output.
        """
    def setMaxObjectsToTrack(self, maxObjectsToTrack: int) -> None:
        """setMaxObjectsToTrack(self: depthai.node.ObjectTracker, maxObjectsToTrack: int) -> None

        Specify maximum number of object to track.

        Parameter ``maxObjectsToTrack``:
            Maximum number of object to track. Maximum 60 in case of SHORT_TERM_KCF,
            otherwise 1000.
        """
    def setTrackerIdAssignmentPolicy(self, type: depthai.TrackerIdAssignmentPolicy) -> None:
        """setTrackerIdAssignmentPolicy(self: depthai.node.ObjectTracker, type: depthai.TrackerIdAssignmentPolicy) -> None

        Specify tracker ID assignment policy.

        Parameter ``type``:
            Tracker ID assignment policy.
        """
    def setTrackerThreshold(self, threshold: float) -> None:
        """setTrackerThreshold(self: depthai.node.ObjectTracker, threshold: float) -> None

        Specify tracker threshold.

        Parameter ``threshold``:
            Above this threshold the detected objects will be tracked. Default 0, all
            image detections are tracked.
        """
    def setTrackerType(self, type: depthai.TrackerType) -> None:
        """setTrackerType(self: depthai.node.ObjectTracker, type: depthai.TrackerType) -> None

        Specify tracker type algorithm.

        Parameter ``type``:
            Tracker type.
        """
    def setTrackingPerClass(self, trackingPerClass: bool) -> None:
        """setTrackingPerClass(self: depthai.node.ObjectTracker, trackingPerClass: bool) -> None

        Whether tracker should take into consideration class label for tracking.
        """
    @property
    def inputDetectionFrame(self) -> depthai.Node.Input: ...
    @property
    def inputDetections(self) -> depthai.Node.Input: ...
    @property
    def inputTrackerFrame(self) -> depthai.Node.Input: ...
    @property
    def out(self) -> depthai.Node.Output: ...
    @property
    def passthroughDetectionFrame(self) -> depthai.Node.Output: ...
    @property
    def passthroughDetections(self) -> depthai.Node.Output: ...
    @property
    def passthroughTrackerFrame(self) -> depthai.Node.Output: ...

class PointCloud(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.PointCloudProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def setNumFramesPool(self, arg0: int) -> None:
        """setNumFramesPool(self: depthai.node.PointCloud, arg0: int) -> None

        Specify number of frames in pool.

        Parameter ``numFramesPool``:
            How many frames should the pool have
        """
    @property
    def initialConfig(self) -> depthai.PointCloudConfig: ...
    @property
    def inputConfig(self) -> depthai.Node.Input: ...
    @property
    def inputDepth(self) -> depthai.Node.Input: ...
    @property
    def outputPointCloud(self) -> depthai.Node.Output: ...
    @property
    def passthroughDepth(self) -> depthai.Node.Output: ...

class RTABMapSLAM(ThreadedHostNode):
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getLocalTransform(self) -> depthai.TransformData:
        """getLocalTransform(self: depthai.node.RTABMapSLAM) -> depthai.TransformData"""
    def saveDatabase(self) -> None:
        """saveDatabase(self: depthai.node.RTABMapSLAM) -> None"""
    def setAlphaScaling(self, alpha: float) -> None:
        """setAlphaScaling(self: depthai.node.RTABMapSLAM, alpha: float) -> None

        Set the alpha scaling factor for the camera model.
        """
    def setDatabasePath(self, path: str) -> None:
        '''setDatabasePath(self: depthai.node.RTABMapSLAM, path: str) -> None

        Set RTABMap database path. "/tmp/rtabmap.tmp.db" by default.
        '''
    def setFreq(self, f: float) -> None:
        """setFreq(self: depthai.node.RTABMapSLAM, f: float) -> None

        Set the frequency at which the node processes data. 1Hz by default.
        """
    def setLoadDatabaseOnStart(self, load: bool) -> None:
        """setLoadDatabaseOnStart(self: depthai.node.RTABMapSLAM, load: bool) -> None

        Whether to load the database on start. False by default.
        """
    def setLocalTransform(self, transform: depthai.TransformData) -> None:
        """setLocalTransform(self: depthai.node.RTABMapSLAM, transform: depthai.TransformData) -> None"""
    def setParams(self, params: dict[str, str]) -> None:
        """setParams(self: depthai.node.RTABMapSLAM, params: dict[str, str]) -> None

        Set RTABMap parameters.
        """
    def setPublishGrid(self, publish: bool) -> None:
        """setPublishGrid(self: depthai.node.RTABMapSLAM, publish: bool) -> None

        Whether to publish the ground point cloud. True by default.
        """
    def setPublishGroundCloud(self, publish: bool) -> None:
        """setPublishGroundCloud(self: depthai.node.RTABMapSLAM, publish: bool) -> None

        Whether to publish the ground point cloud. True by default.
        """
    def setPublishObstacleCloud(self, publish: bool) -> None:
        """setPublishObstacleCloud(self: depthai.node.RTABMapSLAM, publish: bool) -> None

        Whether to publish the obstacle point cloud. True by default.
        """
    def setSaveDatabaseOnClose(self, save: bool) -> None:
        """setSaveDatabaseOnClose(self: depthai.node.RTABMapSLAM, save: bool) -> None

        Whether to save the database on close. False by default.
        """
    def setSaveDatabasePeriod(self, period: float) -> None:
        """setSaveDatabasePeriod(self: depthai.node.RTABMapSLAM, period: float) -> None

        Set the interval at which the database is saved. 30.0s by default.
        """
    def setSaveDatabasePeriodically(self, save: bool) -> None:
        """setSaveDatabasePeriodically(self: depthai.node.RTABMapSLAM, save: bool) -> None

        Whether to save the database periodically. False by default.
        """
    def setUseFeatures(self, useFeatures: bool) -> None:
        """setUseFeatures(self: depthai.node.RTABMapSLAM, useFeatures: bool) -> None

        Whether to use input features for SLAM. False by default.
        """
    def triggerNewMap(self) -> None:
        """triggerNewMap(self: depthai.node.RTABMapSLAM) -> None

        Trigger a new map.
        """
    @property
    def depth(self) -> depthai.Node.Input: ...
    @property
    def features(self) -> depthai.Node.Input: ...
    @property
    def groundPCL(self) -> depthai.Node.Output: ...
    @property
    def obstaclePCL(self) -> depthai.Node.Output: ...
    @property
    def occupancyGridMap(self) -> depthai.Node.Output: ...
    @property
    def odom(self) -> depthai.Node.Input: ...
    @property
    def odomCorrection(self) -> depthai.Node.Output: ...
    @property
    def passthroughDepth(self) -> depthai.Node.Output: ...
    @property
    def passthroughFeatures(self) -> depthai.Node.Output: ...
    @property
    def passthroughOdom(self) -> depthai.Node.Output: ...
    @property
    def passthroughRect(self) -> depthai.Node.Output: ...
    @property
    def rect(self) -> depthai.Node.Input: ...
    @property
    def transform(self) -> depthai.Node.Output: ...

class RTABMapVIO(ThreadedHostNode):
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def reset(self, transform: depthai.TransformData) -> None:
        """reset(self: depthai.node.RTABMapVIO, transform: depthai.TransformData) -> None

        Reset Odometry.
        """
    def setLocalTransform(self, transform: depthai.TransformData) -> None:
        """setLocalTransform(self: depthai.node.RTABMapVIO, transform: depthai.TransformData) -> None"""
    def setParams(self, params: dict[str, str]) -> None:
        """setParams(self: depthai.node.RTABMapVIO, params: dict[str, str]) -> None

        Set RTABMap parameters.
        """
    def setUseFeatures(self, useFeatures: bool) -> None:
        """setUseFeatures(self: depthai.node.RTABMapVIO, useFeatures: bool) -> None

        Whether to use input features or calculate them internally.
        """
    @property
    def depth(self) -> depthai.Node.Input: ...
    @property
    def features(self) -> depthai.Node.Input: ...
    @property
    def imu(self) -> depthai.Node.Input: ...
    @property
    def passthroughDepth(self) -> depthai.Node.Output: ...
    @property
    def passthroughFeatures(self) -> depthai.Node.Output: ...
    @property
    def passthroughRect(self) -> depthai.Node.Output: ...
    @property
    def rect(self) -> depthai.Node.Input: ...
    @property
    def transform(self) -> depthai.Node.Output: ...

class RecordMetadataOnly(ThreadedHostNode):
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getCompressionLevel(self, *args, **kwargs):
        """getCompressionLevel(self: depthai.node.RecordMetadataOnly) -> dai::RecordConfig::CompressionLevel"""
    def getRecordFile(self) -> os.PathLike:
        """getRecordFile(self: depthai.node.RecordMetadataOnly) -> os.PathLike"""
    def setCompressionLevel(self, compressionLevel) -> RecordMetadataOnly:
        """setCompressionLevel(self: depthai.node.RecordMetadataOnly, compressionLevel: dai::RecordConfig::CompressionLevel) -> depthai.node.RecordMetadataOnly"""
    def setRecordFile(self, recordFile: os.PathLike) -> RecordMetadataOnly:
        """setRecordFile(self: depthai.node.RecordMetadataOnly, recordFile: os.PathLike) -> depthai.node.RecordMetadataOnly"""
    @property
    def input(self) -> depthai.Node.Input: ...

class RecordVideo(ThreadedHostNode):
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getCompressionLevel(self, *args, **kwargs):
        """getCompressionLevel(self: depthai.node.RecordVideo) -> dai::RecordConfig::CompressionLevel"""
    def getRecordMetadataFile(self) -> os.PathLike:
        """getRecordMetadataFile(self: depthai.node.RecordVideo) -> os.PathLike"""
    def getRecordVideoFile(self) -> os.PathLike:
        """getRecordVideoFile(self: depthai.node.RecordVideo) -> os.PathLike"""
    def setCompressionLevel(self, compressionLevel) -> RecordVideo:
        """setCompressionLevel(self: depthai.node.RecordVideo, compressionLevel: dai::RecordConfig::CompressionLevel) -> depthai.node.RecordVideo"""
    def setRecordMetadataFile(self, recordFile: os.PathLike) -> RecordVideo:
        """setRecordMetadataFile(self: depthai.node.RecordVideo, recordFile: os.PathLike) -> depthai.node.RecordVideo"""
    def setRecordVideoFile(self, recordFile: os.PathLike) -> RecordVideo:
        """setRecordVideoFile(self: depthai.node.RecordVideo, recordFile: os.PathLike) -> depthai.node.RecordVideo"""
    @property
    def input(self) -> depthai.Node.Input: ...

class ReplayMetadataOnly(ThreadedHostNode):
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getFps(self) -> float:
        """getFps(self: depthai.node.ReplayMetadataOnly) -> float"""
    def getLoop(self) -> bool:
        """getLoop(self: depthai.node.ReplayMetadataOnly) -> bool"""
    def getReplayFile(self) -> os.PathLike:
        """getReplayFile(self: depthai.node.ReplayMetadataOnly) -> os.PathLike"""
    def setFps(self, fps: float) -> ReplayMetadataOnly:
        """setFps(self: depthai.node.ReplayMetadataOnly, fps: float) -> depthai.node.ReplayMetadataOnly"""
    def setLoop(self, loop: bool) -> ReplayMetadataOnly:
        """setLoop(self: depthai.node.ReplayMetadataOnly, loop: bool) -> depthai.node.ReplayMetadataOnly"""
    def setReplayFile(self, replayFile: os.PathLike) -> ReplayMetadataOnly:
        """setReplayFile(self: depthai.node.ReplayMetadataOnly, replayFile: os.PathLike) -> depthai.node.ReplayMetadataOnly"""
    @property
    def out(self) -> depthai.Node.Output: ...

class ReplayVideo(ThreadedHostNode):
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getFps(self) -> float:
        """getFps(self: depthai.node.ReplayVideo) -> float"""
    def getLoop(self) -> bool:
        """getLoop(self: depthai.node.ReplayVideo) -> bool"""
    def getOutFrameType(self) -> depthai.ImgFrame.Type:
        """getOutFrameType(self: depthai.node.ReplayVideo) -> depthai.ImgFrame.Type"""
    def getReplayMetadataFile(self) -> os.PathLike:
        """getReplayMetadataFile(self: depthai.node.ReplayVideo) -> os.PathLike"""
    def getReplayVideoFile(self) -> os.PathLike:
        """getReplayVideoFile(self: depthai.node.ReplayVideo) -> os.PathLike"""
    def getSize(self) -> tuple[int, int]:
        """getSize(self: depthai.node.ReplayVideo) -> tuple[int, int]"""
    def setFps(self, fps: float) -> ReplayVideo:
        """setFps(self: depthai.node.ReplayVideo, fps: float) -> depthai.node.ReplayVideo"""
    def setLoop(self, loop: bool) -> ReplayVideo:
        """setLoop(self: depthai.node.ReplayVideo, loop: bool) -> depthai.node.ReplayVideo"""
    def setOutFrameType(self, frameType: depthai.ImgFrame.Type) -> ReplayVideo:
        """setOutFrameType(self: depthai.node.ReplayVideo, frameType: depthai.ImgFrame.Type) -> depthai.node.ReplayVideo"""
    def setReplayMetadataFile(self, replayFile: os.PathLike) -> ReplayVideo:
        """setReplayMetadataFile(self: depthai.node.ReplayVideo, replayFile: os.PathLike) -> depthai.node.ReplayVideo"""
    def setReplayVideoFile(self, replayVideoFile: os.PathLike) -> ReplayVideo:
        """setReplayVideoFile(self: depthai.node.ReplayVideo, replayVideoFile: os.PathLike) -> depthai.node.ReplayVideo"""
    @overload
    def setSize(self, width: int, height: int) -> ReplayVideo:
        """setSize(*args, **kwargs)
        Overloaded function.

        1. setSize(self: depthai.node.ReplayVideo, width: int, height: int) -> depthai.node.ReplayVideo

        2. setSize(self: depthai.node.ReplayVideo, size: tuple[int, int]) -> depthai.node.ReplayVideo
        """
    @overload
    def setSize(self, size: tuple[int, int]) -> ReplayVideo:
        """setSize(*args, **kwargs)
        Overloaded function.

        1. setSize(self: depthai.node.ReplayVideo, width: int, height: int) -> depthai.node.ReplayVideo

        2. setSize(self: depthai.node.ReplayVideo, size: tuple[int, int]) -> depthai.node.ReplayVideo
        """
    @property
    def out(self) -> depthai.Node.Output: ...

class SPIIn(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.SPIInProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getBusId(self) -> int:
        """getBusId(self: depthai.node.SPIIn) -> int

        Get bus id
        """
    def getMaxDataSize(self) -> int:
        """getMaxDataSize(self: depthai.node.SPIIn) -> int

        Get maximum messages size in bytes
        """
    def getNumFrames(self) -> int:
        """getNumFrames(self: depthai.node.SPIIn) -> int

        Get number of frames in pool
        """
    def getStreamName(self) -> str:
        """getStreamName(self: depthai.node.SPIIn) -> str

        Get stream name
        """
    def setBusId(self, id: int) -> None:
        """setBusId(self: depthai.node.SPIIn, id: int) -> None

        Specifies SPI Bus number to use

        Parameter ``id``:
            SPI Bus id
        """
    def setMaxDataSize(self, maxDataSize: int) -> None:
        """setMaxDataSize(self: depthai.node.SPIIn, maxDataSize: int) -> None

        Set maximum message size it can receive

        Parameter ``maxDataSize``:
            Maximum size in bytes
        """
    def setNumFrames(self, numFrames: int) -> None:
        """setNumFrames(self: depthai.node.SPIIn, numFrames: int) -> None

        Set number of frames in pool for sending messages forward

        Parameter ``numFrames``:
            Maximum number of frames in pool
        """
    def setStreamName(self, name: str) -> None:
        """setStreamName(self: depthai.node.SPIIn, name: str) -> None

        Specifies stream name over which the node will receive data

        Parameter ``name``:
            Stream name
        """
    @property
    def out(self) -> depthai.Node.Output: ...

class SPIOut(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.SPIOutProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def setBusId(self, id: int) -> None:
        """setBusId(self: depthai.node.SPIOut, id: int) -> None

        Specifies SPI Bus number to use

        Parameter ``id``:
            SPI Bus id
        """
    def setStreamName(self, name: str) -> None:
        """setStreamName(self: depthai.node.SPIOut, name: str) -> None

        Specifies stream name over which the node will send data

        Parameter ``name``:
            Stream name
        """
    @property
    def input(self) -> depthai.Node.Input: ...

class Script(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.ScriptProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getProcessor(self) -> depthai.ProcessorType:
        """getProcessor(self: depthai.node.Script) -> depthai.ProcessorType

        Get on which processor the script should run

        Returns:
            Processor type - Leon CSS or Leon MSS
        """
    def getScriptName(self) -> str:
        '''getScriptName(self: depthai.node.Script) -> str

        Get the script name in utf-8.

        When name set with setScript() or setScriptPath(), returns that name. When
        script loaded with setScriptPath() with name not provided, returns the utf-8
        string of that path. Otherwise, returns "<script>"

        Returns:
            std::string of script name in utf-8
        '''
    def setProcessor(self, arg0: depthai.ProcessorType) -> None:
        """setProcessor(self: depthai.node.Script, arg0: depthai.ProcessorType) -> None

        Set on which processor the script should run

        Parameter ``type``:
            Processor type - Leon CSS or Leon MSS
        """
    @overload
    def setScript(self, script: str, name: str = ...) -> None:
        """setScript(*args, **kwargs)
        Overloaded function.

        1. setScript(self: depthai.node.Script, script: str, name: str = '') -> None

        Sets script data to be interpreted

        Parameter ``script``:
            Script string to be interpreted

        Parameter ``name``:
            Optionally set a name of this script

        2. setScript(self: depthai.node.Script, data: list[int], name: str = '') -> None

        Sets script data to be interpreted

        Parameter ``data``:
            Binary data that represents the script to be interpreted

        Parameter ``name``:
            Optionally set a name of this script
        """
    @overload
    def setScript(self, data: list[int], name: str = ...) -> None:
        """setScript(*args, **kwargs)
        Overloaded function.

        1. setScript(self: depthai.node.Script, script: str, name: str = '') -> None

        Sets script data to be interpreted

        Parameter ``script``:
            Script string to be interpreted

        Parameter ``name``:
            Optionally set a name of this script

        2. setScript(self: depthai.node.Script, data: list[int], name: str = '') -> None

        Sets script data to be interpreted

        Parameter ``data``:
            Binary data that represents the script to be interpreted

        Parameter ``name``:
            Optionally set a name of this script
        """
    @overload
    def setScriptPath(self, arg0: Path, arg1: str) -> None:
        """setScriptPath(*args, **kwargs)
        Overloaded function.

        1. setScriptPath(self: depthai.node.Script, arg0: Path, arg1: str) -> None

        Specify local filesystem path to load the script

        Parameter ``path``:
            Filesystem path to load the script

        Parameter ``name``:
            Optionally set a name of this script, otherwise the name defaults to the
            path

        2. setScriptPath(self: depthai.node.Script, path: Path, name: str = '') -> None

        Specify local filesystem path to load the script

        Parameter ``path``:
            Filesystem path to load the script

        Parameter ``name``:
            Optionally set a name of this script, otherwise the name defaults to the
            path
        """
    @overload
    def setScriptPath(self, path: Path, name: str = ...) -> None:
        """setScriptPath(*args, **kwargs)
        Overloaded function.

        1. setScriptPath(self: depthai.node.Script, arg0: Path, arg1: str) -> None

        Specify local filesystem path to load the script

        Parameter ``path``:
            Filesystem path to load the script

        Parameter ``name``:
            Optionally set a name of this script, otherwise the name defaults to the
            path

        2. setScriptPath(self: depthai.node.Script, path: Path, name: str = '') -> None

        Specify local filesystem path to load the script

        Parameter ``path``:
            Filesystem path to load the script

        Parameter ``name``:
            Optionally set a name of this script, otherwise the name defaults to the
            path
        """
    @property
    def inputs(self) -> depthai.Node.InputMap: ...
    @property
    def outputs(self) -> depthai.Node.OutputMap: ...

class SpatialDetectionNetwork(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.SpatialDetectionNetworkProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    @overload
    def build(self, input: Camera, stereo: StereoDepth, model: depthai.NNModelDescription, fps: float = ...) -> SpatialDetectionNetwork:
        """build(*args, **kwargs)
        Overloaded function.

        1. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.Camera, stereo: depthai.node.StereoDepth, model: depthai.NNModelDescription, fps: float = 30.0) -> depthai.node.SpatialDetectionNetwork

        2. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.Camera, stereo: depthai.node.StereoDepth, model: str, fps: float = 30.0) -> depthai.node.SpatialDetectionNetwork

        3. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.Camera, stereo: depthai.node.StereoDepth, nnArchive: depthai.NNArchive, fps: float = 30.0) -> depthai.node.SpatialDetectionNetwork

        4. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.ReplayVideo, stereo: depthai.node.StereoDepth, model: depthai.NNModelDescription, fps: float = 30.0, cameraSocket: depthai.CameraBoardSocket = <CameraBoardSocket.???: -1>) -> depthai.node.SpatialDetectionNetwork

        5. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.ReplayVideo, stereo: depthai.node.StereoDepth, nnArchive: depthai.NNArchive, fps: float = 30.0, cameraSocket: depthai.CameraBoardSocket = <CameraBoardSocket.???: -1>) -> depthai.node.SpatialDetectionNetwork
        """
    @overload
    def build(self, input: Camera, stereo: StereoDepth, model: str, fps: float = ...) -> SpatialDetectionNetwork:
        """build(*args, **kwargs)
        Overloaded function.

        1. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.Camera, stereo: depthai.node.StereoDepth, model: depthai.NNModelDescription, fps: float = 30.0) -> depthai.node.SpatialDetectionNetwork

        2. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.Camera, stereo: depthai.node.StereoDepth, model: str, fps: float = 30.0) -> depthai.node.SpatialDetectionNetwork

        3. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.Camera, stereo: depthai.node.StereoDepth, nnArchive: depthai.NNArchive, fps: float = 30.0) -> depthai.node.SpatialDetectionNetwork

        4. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.ReplayVideo, stereo: depthai.node.StereoDepth, model: depthai.NNModelDescription, fps: float = 30.0, cameraSocket: depthai.CameraBoardSocket = <CameraBoardSocket.???: -1>) -> depthai.node.SpatialDetectionNetwork

        5. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.ReplayVideo, stereo: depthai.node.StereoDepth, nnArchive: depthai.NNArchive, fps: float = 30.0, cameraSocket: depthai.CameraBoardSocket = <CameraBoardSocket.???: -1>) -> depthai.node.SpatialDetectionNetwork
        """
    @overload
    def build(self, input: Camera, stereo: StereoDepth, nnArchive: depthai.NNArchive, fps: float = ...) -> SpatialDetectionNetwork:
        """build(*args, **kwargs)
        Overloaded function.

        1. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.Camera, stereo: depthai.node.StereoDepth, model: depthai.NNModelDescription, fps: float = 30.0) -> depthai.node.SpatialDetectionNetwork

        2. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.Camera, stereo: depthai.node.StereoDepth, model: str, fps: float = 30.0) -> depthai.node.SpatialDetectionNetwork

        3. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.Camera, stereo: depthai.node.StereoDepth, nnArchive: depthai.NNArchive, fps: float = 30.0) -> depthai.node.SpatialDetectionNetwork

        4. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.ReplayVideo, stereo: depthai.node.StereoDepth, model: depthai.NNModelDescription, fps: float = 30.0, cameraSocket: depthai.CameraBoardSocket = <CameraBoardSocket.???: -1>) -> depthai.node.SpatialDetectionNetwork

        5. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.ReplayVideo, stereo: depthai.node.StereoDepth, nnArchive: depthai.NNArchive, fps: float = 30.0, cameraSocket: depthai.CameraBoardSocket = <CameraBoardSocket.???: -1>) -> depthai.node.SpatialDetectionNetwork
        """
    @overload
    def build(self, input: ReplayVideo, stereo: StereoDepth, model: depthai.NNModelDescription, fps: float = ..., cameraSocket: depthai.CameraBoardSocket = ...) -> SpatialDetectionNetwork:
        """build(*args, **kwargs)
        Overloaded function.

        1. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.Camera, stereo: depthai.node.StereoDepth, model: depthai.NNModelDescription, fps: float = 30.0) -> depthai.node.SpatialDetectionNetwork

        2. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.Camera, stereo: depthai.node.StereoDepth, model: str, fps: float = 30.0) -> depthai.node.SpatialDetectionNetwork

        3. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.Camera, stereo: depthai.node.StereoDepth, nnArchive: depthai.NNArchive, fps: float = 30.0) -> depthai.node.SpatialDetectionNetwork

        4. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.ReplayVideo, stereo: depthai.node.StereoDepth, model: depthai.NNModelDescription, fps: float = 30.0, cameraSocket: depthai.CameraBoardSocket = <CameraBoardSocket.???: -1>) -> depthai.node.SpatialDetectionNetwork

        5. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.ReplayVideo, stereo: depthai.node.StereoDepth, nnArchive: depthai.NNArchive, fps: float = 30.0, cameraSocket: depthai.CameraBoardSocket = <CameraBoardSocket.???: -1>) -> depthai.node.SpatialDetectionNetwork
        """
    @overload
    def build(self, input: ReplayVideo, stereo: StereoDepth, nnArchive: depthai.NNArchive, fps: float = ..., cameraSocket: depthai.CameraBoardSocket = ...) -> SpatialDetectionNetwork:
        """build(*args, **kwargs)
        Overloaded function.

        1. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.Camera, stereo: depthai.node.StereoDepth, model: depthai.NNModelDescription, fps: float = 30.0) -> depthai.node.SpatialDetectionNetwork

        2. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.Camera, stereo: depthai.node.StereoDepth, model: str, fps: float = 30.0) -> depthai.node.SpatialDetectionNetwork

        3. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.Camera, stereo: depthai.node.StereoDepth, nnArchive: depthai.NNArchive, fps: float = 30.0) -> depthai.node.SpatialDetectionNetwork

        4. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.ReplayVideo, stereo: depthai.node.StereoDepth, model: depthai.NNModelDescription, fps: float = 30.0, cameraSocket: depthai.CameraBoardSocket = <CameraBoardSocket.???: -1>) -> depthai.node.SpatialDetectionNetwork

        5. build(self: depthai.node.SpatialDetectionNetwork, input: depthai.node.ReplayVideo, stereo: depthai.node.StereoDepth, nnArchive: depthai.NNArchive, fps: float = 30.0, cameraSocket: depthai.CameraBoardSocket = <CameraBoardSocket.???: -1>) -> depthai.node.SpatialDetectionNetwork
        """
    def getClasses(self) -> list[str] | None:
        """getClasses(self: depthai.node.SpatialDetectionNetwork) -> Optional[list[str]]

        Get classes labels
        """
    def getConfidenceThreshold(self) -> float:
        """getConfidenceThreshold(self: depthai.node.SpatialDetectionNetwork) -> float

        Retrieves threshold at which to filter the rest of the detections.

        Returns:
            Detection confidence
        """
    def getNumInferenceThreads(self) -> int:
        """getNumInferenceThreads(self: depthai.node.SpatialDetectionNetwork) -> int

        How many inference threads will be used to run the network

        Returns:
            Number of threads, 0, 1 or 2. Zero means AUTO
        """
    def setBackend(self, setBackend: str) -> None:
        """setBackend(self: depthai.node.SpatialDetectionNetwork, setBackend: str) -> None

        Specifies backend to use

        Parameter ``backend``:
            String specifying backend to use
        """
    def setBackendProperties(self, setBackendProperties: dict[str, str]) -> None:
        """setBackendProperties(self: depthai.node.SpatialDetectionNetwork, setBackendProperties: dict[str, str]) -> None

        Set backend properties

        Parameter ``backendProperties``:
            backend properties map
        """
    @overload
    def setBlob(self, blob: depthai.OpenVINO.Blob) -> None:
        """setBlob(*args, **kwargs)
        Overloaded function.

        1. setBlob(self: depthai.node.SpatialDetectionNetwork, blob: depthai.OpenVINO.Blob) -> None

        Load network blob into assets and use once pipeline is started.

        Parameter ``blob``:
            Network blob

        2. setBlob(self: depthai.node.SpatialDetectionNetwork, path: Path) -> None

        Same functionality as the setBlobPath(). Load network blob into assets and use
        once pipeline is started.

        Throws:
            Error if file doesn't exist or isn't a valid network blob.

        Parameter ``path``:
            Path to network blob
        """
    @overload
    def setBlob(self, path: Path) -> None:
        """setBlob(*args, **kwargs)
        Overloaded function.

        1. setBlob(self: depthai.node.SpatialDetectionNetwork, blob: depthai.OpenVINO.Blob) -> None

        Load network blob into assets and use once pipeline is started.

        Parameter ``blob``:
            Network blob

        2. setBlob(self: depthai.node.SpatialDetectionNetwork, path: Path) -> None

        Same functionality as the setBlobPath(). Load network blob into assets and use
        once pipeline is started.

        Throws:
            Error if file doesn't exist or isn't a valid network blob.

        Parameter ``path``:
            Path to network blob
        """
    def setBlobPath(self, path: Path) -> None:
        """setBlobPath(self: depthai.node.SpatialDetectionNetwork, path: Path) -> None

        Load network blob into assets and use once pipeline is started.

        Throws:
            Error if file doesn't exist or isn't a valid network blob.

        Parameter ``path``:
            Path to network blob
        """
    def setBoundingBoxScaleFactor(self, scaleFactor: float) -> None:
        """setBoundingBoxScaleFactor(self: depthai.node.SpatialDetectionNetwork, scaleFactor: float) -> None

        Custom interface

        Specifies scale factor for detected bounding boxes.

        Parameter ``scaleFactor``:
            Scale factor must be in the interval (0,1].
        """
    def setConfidenceThreshold(self, thresh: float) -> None:
        """setConfidenceThreshold(self: depthai.node.SpatialDetectionNetwork, thresh: float) -> None

        Specifies confidence threshold at which to filter the rest of the detections.

        Parameter ``thresh``:
            Detection confidence must be greater than specified threshold to be added to
            the list
        """
    def setDepthLowerThreshold(self, lowerThreshold: int) -> None:
        """setDepthLowerThreshold(self: depthai.node.SpatialDetectionNetwork, lowerThreshold: int) -> None

        Specifies lower threshold in depth units (millimeter by default) for depth
        values which will used to calculate spatial data

        Parameter ``lowerThreshold``:
            LowerThreshold must be in the interval [0,upperThreshold] and less than
            upperThreshold.
        """
    def setDepthUpperThreshold(self, upperThreshold: int) -> None:
        """setDepthUpperThreshold(self: depthai.node.SpatialDetectionNetwork, upperThreshold: int) -> None

        Specifies upper threshold in depth units (millimeter by default) for depth
        values which will used to calculate spatial data

        Parameter ``upperThreshold``:
            UpperThreshold must be in the interval (lowerThreshold,65535].
        """
    def setFromModelZoo(self, description: depthai.NNModelDescription, useCached: bool) -> None:
        """setFromModelZoo(self: depthai.node.SpatialDetectionNetwork, description: depthai.NNModelDescription, useCached: bool) -> None

        Download model from zoo and set it for this Node

        Parameter ``description:``:
            Model description to download

        Parameter ``useCached:``:
            Use cached model if available
        """
    def setModelPath(self, modelPath: Path) -> None:
        """setModelPath(self: depthai.node.SpatialDetectionNetwork, modelPath: Path) -> None

        Load network file into assets.

        Parameter ``modelPath``:
            Path to the model file.
        """
    def setNNArchive(self, archive: depthai.NNArchive) -> None:
        """setNNArchive(*args, **kwargs)
        Overloaded function.

        1. setNNArchive(self: depthai.node.SpatialDetectionNetwork, archive: depthai.NNArchive) -> None

        Set NNArchive for this Node. If the archive's type is SUPERBLOB, use default
        number of shaves.

        Parameter ``nnArchive:``:
            NNArchive to set

        2. setNNArchive(self: depthai.node.SpatialDetectionNetwork, archive: depthai.NNArchive, numShaves: int) -> None

        Set NNArchive for this Node. If the archive's type is SUPERBLOB, use default
        number of shaves.

        Parameter ``nnArchive:``:
            NNArchive to set
        """
    def setNumInferenceThreads(self, numThreads: int) -> None:
        """setNumInferenceThreads(self: depthai.node.SpatialDetectionNetwork, numThreads: int) -> None

        How many threads should the node use to run the network.

        Parameter ``numThreads``:
            Number of threads to dedicate to this node
        """
    def setNumNCEPerInferenceThread(self, numNCEPerThread: int) -> None:
        """setNumNCEPerInferenceThread(self: depthai.node.SpatialDetectionNetwork, numNCEPerThread: int) -> None

        How many Neural Compute Engines should a single thread use for inference

        Parameter ``numNCEPerThread``:
            Number of NCE per thread
        """
    def setNumPoolFrames(self, numFrames: int) -> None:
        """setNumPoolFrames(self: depthai.node.SpatialDetectionNetwork, numFrames: int) -> None

        Specifies how many frames will be available in the pool

        Parameter ``numFrames``:
            How many frames will pool have
        """
    def setNumShavesPerInferenceThread(self, numShavesPerInferenceThread: int) -> None:
        """setNumShavesPerInferenceThread(self: depthai.node.SpatialDetectionNetwork, numShavesPerInferenceThread: int) -> None

        How many Shaves should a single thread use for inference

        Parameter ``numShavesPerThread``:
            Number of shaves per thread
        """
    def setSpatialCalculationAlgorithm(self, calculationAlgorithm: depthai.SpatialLocationCalculatorAlgorithm) -> None:
        """setSpatialCalculationAlgorithm(self: depthai.node.SpatialDetectionNetwork, calculationAlgorithm: depthai.SpatialLocationCalculatorAlgorithm) -> None

        Specifies spatial location calculator algorithm: Average/Min/Max

        Parameter ``calculationAlgorithm``:
            Calculation algorithm.
        """
    @property
    def boundingBoxMapping(self) -> depthai.Node.Output: ...
    @property
    def input(self) -> depthai.Node.Input: ...
    @property
    def inputDepth(self) -> depthai.Node.Input: ...
    @property
    def out(self) -> depthai.Node.Output: ...
    @property
    def outNetwork(self) -> depthai.Node.Output: ...
    @property
    def passthrough(self) -> depthai.Node.Output: ...
    @property
    def passthroughDepth(self) -> depthai.Node.Output: ...
    @property
    def spatialLocationCalculatorOutput(self) -> depthai.Node.Output: ...

class SpatialLocationCalculator(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.SpatialLocationCalculatorProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getWaitForConfigInput(self) -> bool:
        """getWaitForConfigInput(self: depthai.node.SpatialLocationCalculator) -> bool

        See also:
            setWaitForConfigInput

        Returns:
            True if wait for inputConfig message, false otherwise
        """
    def setWaitForConfigInput(self, wait: bool) -> None:
        """setWaitForConfigInput(self: depthai.node.SpatialLocationCalculator, wait: bool) -> None

        Specify whether or not wait until configuration message arrives to inputConfig
        Input.

        Parameter ``wait``:
            True to wait for configuration message, false otherwise.
        """
    @property
    def initialConfig(self) -> depthai.SpatialLocationCalculatorConfig: ...
    @property
    def inputConfig(self) -> depthai.Node.Input: ...
    @property
    def inputDepth(self) -> depthai.Node.Input: ...
    @property
    def out(self) -> depthai.Node.Output: ...
    @property
    def passthroughDepth(self) -> depthai.Node.Output: ...

class StereoDepth(depthai.DeviceNode):
    class PresetMode:
        HIGH_ACCURACY: ClassVar[StereoDepth.PresetMode] = ...  # read-only
        HIGH_DENSITY: ClassVar[StereoDepth.PresetMode] = ...  # read-only
        __members__: ClassVar[dict] = ...  # read-only
        DEFAULT: ClassVar[StereoDepth.PresetMode] = ...
        FACE: ClassVar[StereoDepth.PresetMode] = ...
        HIGH_DETAIL: ClassVar[StereoDepth.PresetMode] = ...
        ROBOTICS: ClassVar[StereoDepth.PresetMode] = ...
        __entries: ClassVar[dict] = ...
        def __init__(self, value: int) -> None:
            """__init__(self: depthai.node.StereoDepth.PresetMode, value: int) -> None"""
        def __eq__(self, other: object) -> bool:
            """__eq__(self: object, other: object) -> bool"""
        def __hash__(self) -> int:
            """__hash__(self: object) -> int"""
        def __index__(self) -> int:
            """__index__(self: depthai.node.StereoDepth.PresetMode) -> int"""
        def __int__(self) -> int:
            """__int__(self: depthai.node.StereoDepth.PresetMode) -> int"""
        def __ne__(self, other: object) -> bool:
            """__ne__(self: object, other: object) -> bool"""
        @property
        def name(self) -> str: ...
        @property
        def value(self) -> int: ...
    Properties: ClassVar[type[depthai.StereoDepthProperties]] = ...
    @overload
    def __init__(self, left: depthai.Node.Output, right: depthai.Node.Output, presetMode: StereoDepth.PresetMode = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.node.StereoDepth, left: depthai.Node.Output, right: depthai.Node.Output, presetMode: depthai.node.StereoDepth.PresetMode = <PresetMode.HIGH_DENSITY: 1>) -> None

        2. __init__(self: depthai.node.StereoDepth, autoCreateCameras: bool, presetMode: depthai.node.StereoDepth.PresetMode = <PresetMode.HIGH_DENSITY: 1>) -> None
        """
    @overload
    def __init__(self, autoCreateCameras: bool, presetMode: StereoDepth.PresetMode = ...) -> None:
        """__init__(*args, **kwargs)
        Overloaded function.

        1. __init__(self: depthai.node.StereoDepth, left: depthai.Node.Output, right: depthai.Node.Output, presetMode: depthai.node.StereoDepth.PresetMode = <PresetMode.HIGH_DENSITY: 1>) -> None

        2. __init__(self: depthai.node.StereoDepth, autoCreateCameras: bool, presetMode: depthai.node.StereoDepth.PresetMode = <PresetMode.HIGH_DENSITY: 1>) -> None
        """
    @overload
    def build(self, left: depthai.Node.Output, right: depthai.Node.Output, presetMode: StereoDepth.PresetMode = ...) -> StereoDepth:
        """build(*args, **kwargs)
        Overloaded function.

        1. build(self: depthai.node.StereoDepth, left: depthai.Node.Output, right: depthai.Node.Output, presetMode: depthai.node.StereoDepth.PresetMode = <PresetMode.HIGH_DENSITY: 1>) -> depthai.node.StereoDepth

        2. build(self: depthai.node.StereoDepth, autoCreateCameras: bool, presetMode: depthai.node.StereoDepth.PresetMode = <PresetMode.HIGH_DENSITY: 1>) -> depthai.node.StereoDepth
        """
    @overload
    def build(self, autoCreateCameras: bool, presetMode: StereoDepth.PresetMode = ...) -> StereoDepth:
        """build(*args, **kwargs)
        Overloaded function.

        1. build(self: depthai.node.StereoDepth, left: depthai.Node.Output, right: depthai.Node.Output, presetMode: depthai.node.StereoDepth.PresetMode = <PresetMode.HIGH_DENSITY: 1>) -> depthai.node.StereoDepth

        2. build(self: depthai.node.StereoDepth, autoCreateCameras: bool, presetMode: depthai.node.StereoDepth.PresetMode = <PresetMode.HIGH_DENSITY: 1>) -> depthai.node.StereoDepth
        """
    def enableDistortionCorrection(self, arg0: bool) -> None:
        """enableDistortionCorrection(self: depthai.node.StereoDepth, arg0: bool) -> None

        Equivalent to useHomographyRectification(!enableDistortionCorrection)
        """
    def getMaxDisparity(self) -> float:
        """getMaxDisparity(self: depthai.node.StereoDepth) -> float

        Useful for normalization of the disparity map.

        Returns:
            Maximum disparity value that the node can return
        """
    def loadMeshData(self, dataLeft: list[int], dataRight: list[int]) -> None:
        """loadMeshData(self: depthai.node.StereoDepth, dataLeft: list[int], dataRight: list[int]) -> None

        Specify mesh calibration data for 'left' and 'right' inputs, as vectors of
        bytes. Overrides useHomographyRectification behavior. See `loadMeshFiles` for
        the expected data format
        """
    def loadMeshFiles(self, pathLeft: Path, pathRight: Path) -> None:
        """loadMeshFiles(self: depthai.node.StereoDepth, pathLeft: Path, pathRight: Path) -> None

        Specify local filesystem paths to the mesh calibration files for 'left' and
        'right' inputs.

        When a mesh calibration is set, it overrides the camera intrinsics/extrinsics
        matrices. Overrides useHomographyRectification behavior. Mesh format: a sequence
        of (y,x) points as 'float' with coordinates from the input image to be mapped in
        the output. The mesh can be subsampled, configured by `setMeshStep`.

        With a 1280x800 resolution and the default (16,16) step, the required mesh size
        is:

        width: 1280 / 16 + 1 = 81

        height: 800 / 16 + 1 = 51
        """
    def setAlphaScaling(self, arg0: float) -> None:
        """setAlphaScaling(self: depthai.node.StereoDepth, arg0: float) -> None

        Free scaling parameter between 0 (when all the pixels in the undistorted image
        are valid) and 1 (when all the source image pixels are retained in the
        undistorted image). On some high distortion lenses, and/or due to rectification
        (image rotated) invalid areas may appear even with alpha=0, in these cases alpha
        < 0.0 helps removing invalid areas. See getOptimalNewCameraMatrix from opencv
        for more details.
        """
    def setBaseline(self, arg0: float) -> None:
        """setBaseline(self: depthai.node.StereoDepth, arg0: float) -> None

        Override baseline from calibration. Used only in disparity to depth conversion.
        Units are centimeters.
        """
    def setConfidenceThreshold(self, arg0: int) -> None:
        """setConfidenceThreshold(self: depthai.node.StereoDepth, arg0: int) -> None

        Confidence threshold for disparity calculation

        Parameter ``confThr``:
            Confidence threshold value 0..255
        """
    def setCustomPixelDescriptors(self, arg0: bool) -> None:
        """setCustomPixelDescriptors(self: depthai.node.StereoDepth, arg0: bool) -> None

        Whether to use custom pixel descriptors sent from host to device for debugging
        purposes. Default value is false.
        """
    def setDefaultProfilePreset(self, arg0: StereoDepth.PresetMode) -> None:
        """setDefaultProfilePreset(self: depthai.node.StereoDepth, arg0: depthai.node.StereoDepth.PresetMode) -> None

        Sets a default preset based on specified option.

        Parameter ``mode``:
            Stereo depth preset mode
        """
    @overload
    def setDepthAlign(self, align: depthai.StereoDepthConfig.AlgorithmControl.DepthAlign) -> None:
        """setDepthAlign(*args, **kwargs)
        Overloaded function.

        1. setDepthAlign(self: depthai.node.StereoDepth, align: depthai.StereoDepthConfig.AlgorithmControl.DepthAlign) -> None

        Parameter ``align``:
            Set the disparity/depth alignment: centered (between the 'left' and 'right'
            inputs), or from the perspective of a rectified output stream

        2. setDepthAlign(self: depthai.node.StereoDepth, camera: depthai.CameraBoardSocket) -> None

        Parameter ``camera``:
            Set the camera from whose perspective the disparity/depth will be aligned
        """
    @overload
    def setDepthAlign(self, camera: depthai.CameraBoardSocket) -> None:
        """setDepthAlign(*args, **kwargs)
        Overloaded function.

        1. setDepthAlign(self: depthai.node.StereoDepth, align: depthai.StereoDepthConfig.AlgorithmControl.DepthAlign) -> None

        Parameter ``align``:
            Set the disparity/depth alignment: centered (between the 'left' and 'right'
            inputs), or from the perspective of a rectified output stream

        2. setDepthAlign(self: depthai.node.StereoDepth, camera: depthai.CameraBoardSocket) -> None

        Parameter ``camera``:
            Set the camera from whose perspective the disparity/depth will be aligned
        """
    def setDepthAlignmentUseSpecTranslation(self, arg0: bool) -> None:
        """setDepthAlignmentUseSpecTranslation(self: depthai.node.StereoDepth, arg0: bool) -> None

        Use baseline information for depth alignment from specs (design data) or from
        calibration. Default: true
        """
    def setDisparityToDepthUseSpecTranslation(self, arg0: bool) -> None:
        """setDisparityToDepthUseSpecTranslation(self: depthai.node.StereoDepth, arg0: bool) -> None

        Use baseline information for disparity to depth conversion from specs (design
        data) or from calibration. Default: true
        """
    def setEmptyCalibration(self) -> None:
        """setEmptyCalibration(self: depthai.node.StereoDepth) -> None

        Specify that a passthrough/dummy calibration should be used, when input frames
        are already rectified (e.g. sourced from recordings on the host)
        """
    def setExtendedDisparity(self, enable: bool) -> None:
        """setExtendedDisparity(self: depthai.node.StereoDepth, enable: bool) -> None

        Disparity range increased from 0-95 to 0-190, combined from full resolution and
        downscaled images.

        Suitable for short range objects. Currently incompatible with sub-pixel
        disparity
        """
    def setFocalLength(self, arg0: float) -> None:
        """setFocalLength(self: depthai.node.StereoDepth, arg0: float) -> None

        Override focal length from calibration. Used only in disparity to depth
        conversion. Units are pixels.
        """
    def setFocalLengthFromCalibration(self, arg0: bool) -> None:
        """setFocalLengthFromCalibration(self: depthai.node.StereoDepth, arg0: bool) -> None

        Whether to use focal length from calibration intrinsics or calculate based on
        calibration FOV. Default value is true.
        """
    @overload
    def setInputResolution(self, width: int, height: int) -> None:
        """setInputResolution(*args, **kwargs)
        Overloaded function.

        1. setInputResolution(self: depthai.node.StereoDepth, width: int, height: int) -> None

        Specify input resolution size

        Optional if MonoCamera exists, otherwise necessary

        2. setInputResolution(self: depthai.node.StereoDepth, resolution: tuple[int, int]) -> None

        Specify input resolution size

        Optional if MonoCamera exists, otherwise necessary
        """
    @overload
    def setInputResolution(self, resolution: tuple[int, int]) -> None:
        """setInputResolution(*args, **kwargs)
        Overloaded function.

        1. setInputResolution(self: depthai.node.StereoDepth, width: int, height: int) -> None

        Specify input resolution size

        Optional if MonoCamera exists, otherwise necessary

        2. setInputResolution(self: depthai.node.StereoDepth, resolution: tuple[int, int]) -> None

        Specify input resolution size

        Optional if MonoCamera exists, otherwise necessary
        """
    def setLeftRightCheck(self, enable: bool) -> None:
        """setLeftRightCheck(self: depthai.node.StereoDepth, enable: bool) -> None

        Computes and combines disparities in both L-R and R-L directions, and combine
        them.

        For better occlusion handling, discarding invalid disparity values
        """
    def setMedianFilter(self, arg0: depthai.MedianFilter) -> None:
        """setMedianFilter(self: depthai.node.StereoDepth, arg0: depthai.MedianFilter) -> None

        Parameter ``median``:
            Set kernel size for disparity/depth median filtering, or disable
        """
    def setMeshStep(self, width: int, height: int) -> None:
        """setMeshStep(self: depthai.node.StereoDepth, width: int, height: int) -> None

        Set the distance between mesh points. Default: (16, 16)
        """
    def setNumFramesPool(self, arg0: int) -> None:
        """setNumFramesPool(self: depthai.node.StereoDepth, arg0: int) -> None

        Specify number of frames in pool.

        Parameter ``numFramesPool``:
            How many frames should the pool have
        """
    def setOutputDepth(self, arg0: bool) -> None:
        """setOutputDepth(self: depthai.node.StereoDepth, arg0: bool) -> None"""
    def setOutputKeepAspectRatio(self, keep: bool) -> None:
        """setOutputKeepAspectRatio(self: depthai.node.StereoDepth, keep: bool) -> None

        Specifies whether the frames resized by `setOutputSize` should preserve aspect
        ratio, with potential cropping when enabled. Default `true`
        """
    def setOutputRectified(self, arg0: bool) -> None:
        """setOutputRectified(self: depthai.node.StereoDepth, arg0: bool) -> None"""
    def setOutputSize(self, width: int, height: int) -> None:
        """setOutputSize(self: depthai.node.StereoDepth, width: int, height: int) -> None

        Specify disparity/depth output resolution size, implemented by scaling.

        Currently only applicable when aligning to RGB camera
        """
    def setPostProcessingHardwareResources(self, arg0: int, arg1: int) -> None:
        """setPostProcessingHardwareResources(self: depthai.node.StereoDepth, arg0: int, arg1: int) -> None

        Specify allocated hardware resources for stereo depth. Suitable only to increase
        post processing runtime.

        Parameter ``numShaves``:
            Number of shaves.

        Parameter ``numMemorySlices``:
            Number of memory slices.
        """
    def setRectification(self, enable: bool) -> None:
        """setRectification(self: depthai.node.StereoDepth, enable: bool) -> None

        Rectify input images or not.
        """
    def setRectificationUseSpecTranslation(self, arg0: bool) -> None:
        """setRectificationUseSpecTranslation(self: depthai.node.StereoDepth, arg0: bool) -> None

        Obtain rectification matrices using spec translation (design data) or from
        calibration in calculations. Should be used only for debugging. Default: false
        """
    def setRectifyEdgeFillColor(self, color: int) -> None:
        """setRectifyEdgeFillColor(self: depthai.node.StereoDepth, color: int) -> None

        Fill color for missing data at frame edges

        Parameter ``color``:
            Grayscale 0..255, or -1 to replicate pixels
        """
    def setRectifyMirrorFrame(self, arg0: bool) -> None:
        """setRectifyMirrorFrame(self: depthai.node.StereoDepth, arg0: bool) -> None

        DEPRECATED function. It was removed, since rectified images are not flipped
        anymore. Mirror rectified frames, only when LR-check mode is disabled. Default
        `true`. The mirroring is required to have a normal non-mirrored disparity/depth
        output.

        A side effect of this option is disparity alignment to the perspective of left
        or right input: `false`: mapped to left and mirrored, `true`: mapped to right.
        With LR-check enabled, this option is ignored, none of the outputs are mirrored,
        and disparity is mapped to right.

        Parameter ``enable``:
            True for normal disparity/depth, otherwise mirrored
        """
    def setRuntimeModeSwitch(self, arg0: bool) -> None:
        """setRuntimeModeSwitch(self: depthai.node.StereoDepth, arg0: bool) -> None

        Enable runtime stereo mode switch, e.g. from standard to LR-check. Note: when
        enabled resources allocated for worst case to enable switching to any mode.
        """
    def setSubpixel(self, enable: bool) -> None:
        """setSubpixel(self: depthai.node.StereoDepth, enable: bool) -> None

        Computes disparity with sub-pixel interpolation (3 fractional bits by default).

        Suitable for long range. Currently incompatible with extended disparity
        """
    def setSubpixelFractionalBits(self, subpixelFractionalBits: int) -> None:
        """setSubpixelFractionalBits(self: depthai.node.StereoDepth, subpixelFractionalBits: int) -> None

        Number of fractional bits for subpixel mode. Default value: 3. Valid values:
        3,4,5. Defines the number of fractional disparities: 2^x. Median filter
        postprocessing is supported only for 3 fractional bits.
        """
    def setVerticalStereo(self, arg0: bool) -> None:
        """setVerticalStereo(self: depthai.node.StereoDepth, arg0: bool) -> None

        Whether to perform vertical stereo matching or not. Default value is false. If
        set to true rectification process includes 90 degree clock wise rotation to
        perform vertical matching.
        """
    def useHomographyRectification(self, arg0: bool) -> None:
        """useHomographyRectification(self: depthai.node.StereoDepth, arg0: bool) -> None

        Use 3x3 homography matrix for stereo rectification instead of sparse mesh
        generated on device. Default behaviour is AUTO, for lenses with FOV over 85
        degrees sparse mesh is used, otherwise 3x3 homography. If custom mesh data is
        provided through loadMeshData or loadMeshFiles this option is ignored.

        Parameter ``useHomographyRectification``:
            true: 3x3 homography matrix generated from calibration data is used for
            stereo rectification, can't correct lens distortion. false: sparse mesh is
            generated on-device from calibration data with mesh step specified with
            setMeshStep (Default: (16, 16)), can correct lens distortion. Implementation
            for generating the mesh is same as opencv's initUndistortRectifyMap
            function. Only the first 8 distortion coefficients are used from calibration
            data.
        """
    @property
    def confidenceMap(self) -> depthai.Node.Output: ...
    @property
    def debugDispCostDump(self) -> depthai.Node.Output: ...
    @property
    def debugDispLrCheckIt1(self) -> depthai.Node.Output: ...
    @property
    def debugDispLrCheckIt2(self) -> depthai.Node.Output: ...
    @property
    def debugExtDispLrCheckIt1(self) -> depthai.Node.Output: ...
    @property
    def debugExtDispLrCheckIt2(self) -> depthai.Node.Output: ...
    @property
    def depth(self) -> depthai.Node.Output: ...
    @property
    def disparity(self) -> depthai.Node.Output: ...
    @property
    def initialConfig(self) -> depthai.StereoDepthConfig: ...
    @property
    def inputAlignTo(self) -> depthai.Node.Input: ...
    @property
    def inputConfig(self) -> depthai.Node.Input: ...
    @property
    def inputLeftPixelDescriptor(self) -> depthai.Node.Input: ...
    @property
    def inputRightPixelDescriptor(self) -> depthai.Node.Input: ...
    @property
    def left(self) -> depthai.Node.Input: ...
    @property
    def outConfig(self) -> depthai.Node.Output: ...
    @property
    def pixelDescriptorsLeft(self) -> depthai.Node.Output: ...
    @property
    def pixelDescriptorsRight(self) -> depthai.Node.Output: ...
    @property
    def rectifiedLeft(self) -> depthai.Node.Output: ...
    @property
    def rectifiedRight(self) -> depthai.Node.Output: ...
    @property
    def right(self) -> depthai.Node.Input: ...
    @property
    def syncedLeft(self) -> depthai.Node.Output: ...
    @property
    def syncedRight(self) -> depthai.Node.Output: ...

class Sync(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.SyncProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getSyncAttempts(self) -> int:
        """getSyncAttempts(self: depthai.node.Sync) -> int

        Gets the number of sync attempts
        """
    def getSyncThreshold(self) -> datetime.timedelta:
        """getSyncThreshold(self: depthai.node.Sync) -> datetime.timedelta

        Gets the maximal interval between messages in the group in milliseconds
        """
    def runOnHost(self) -> bool:
        """runOnHost(self: depthai.node.Sync) -> bool

        Check if the node is set to run on host
        """
    def setRunOnHost(self, runOnHost: bool) -> None:
        """setRunOnHost(self: depthai.node.Sync, runOnHost: bool) -> None

        Specify whether to run on host or device By default, the node will run on
        device.
        """
    def setSyncAttempts(self, maxDataSize: int) -> None:
        """setSyncAttempts(self: depthai.node.Sync, maxDataSize: int) -> None

        Set the number of attempts to get the specified max interval between messages in
        the group

        Parameter ``syncAttempts``:
            Number of attempts to get the specified max interval between messages in the
            group: - if syncAttempts = 0 then the node sends a message as soon at the
            group is filled - if syncAttempts > 0 then the node will make syncAttemts
            attempts to synchronize before sending out a message - if syncAttempts = -1
            (default) then the node will only send a message if successfully
            synchronized
        """
    def setSyncThreshold(self, syncThreshold: datetime.timedelta) -> None:
        """setSyncThreshold(self: depthai.node.Sync, syncThreshold: datetime.timedelta) -> None

        Set the maximal interval between messages in the group

        Parameter ``syncThreshold``:
            Maximal interval between messages in the group
        """
    @property
    def inputs(self) -> depthai.Node.InputMap: ...
    @property
    def out(self) -> depthai.Node.Output: ...

class SystemLogger(depthai.DeviceNode):
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getRate(self) -> float:
        """getRate(self: depthai.node.SystemLogger) -> float

        Gets logging rate, at which messages will be sent out
        """
    def setRate(self, hz: float) -> None:
        """setRate(self: depthai.node.SystemLogger, hz: float) -> None

        Specify logging rate, at which messages will be sent out

        Parameter ``hz``:
            Sending rate in hertz (messages per second)
        """
    @property
    def out(self) -> depthai.Node.Output: ...

class Thermal(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.ThermalProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def build(self, boardSocket: depthai.CameraBoardSocket = ..., fps: float = ...) -> Thermal:
        """build(self: depthai.node.Thermal, boardSocket: depthai.CameraBoardSocket = <CameraBoardSocket.???: -1>, fps: float = 25.0) -> depthai.node.Thermal

        Build with a specific board socket and fps.
        """
    def getBoardSocket(self) -> depthai.CameraBoardSocket:
        """getBoardSocket(self: depthai.node.Thermal) -> depthai.CameraBoardSocket

        Retrieves which board socket to use

        Returns:
            Board socket to use
        """
    @property
    def color(self) -> depthai.Node.Output: ...
    @property
    def initialConfig(self) -> depthai.ThermalConfig: ...
    @property
    def inputConfig(self) -> depthai.Node.Input: ...
    @property
    def temperature(self) -> depthai.Node.Output: ...

class ThreadedHostNode(depthai.ThreadedNode):
    createSubnode: ClassVar[Callable] = ...
    def __init__(self) -> None:
        """__init__(self: depthai.node.ThreadedHostNode) -> None"""
    def createInput(self, name: str = ..., group: str = ..., blocking: bool = ..., queueSize: int = ..., types: list[depthai.Node.DatatypeHierarchy] = ..., waitForMessage: bool = ...) -> depthai.Node.Input:
        """createInput(self: depthai.node.ThreadedHostNode, name: str = '', group: str = '', blocking: bool = True, queueSize: int = 3, types: list[depthai.Node.DatatypeHierarchy] = [<depthai.Node.DatatypeHierarchy object at 0x7fff4171b230>], waitForMessage: bool = False) -> depthai.Node.Input"""
    def createOutput(self, name: str = ..., group: str = ..., possibleDatatypes: list[depthai.Node.DatatypeHierarchy] = ...) -> depthai.Node.Output:
        """createOutput(self: depthai.node.ThreadedHostNode, name: str = '', group: str = '', possibleDatatypes: list[depthai.Node.DatatypeHierarchy] = [<depthai.Node.DatatypeHierarchy object at 0x7fff41741030>]) -> depthai.Node.Output"""
    def onStart(self) -> None:
        """onStart(self: depthai.node.ThreadedHostNode) -> None"""
    def onStop(self) -> None:
        """onStop(self: depthai.node.ThreadedHostNode) -> None"""
    def run(self) -> None:
        """run(self: depthai.node.ThreadedHostNode) -> None"""

class ToF(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.ToFProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def build(self, boardSocket: depthai.CameraBoardSocket = ..., fps: float = ...) -> ToF:
        """build(self: depthai.node.ToF, boardSocket: depthai.CameraBoardSocket = <CameraBoardSocket.???: -1>, fps: float = 30.0) -> depthai.node.ToF

        Build with a specific board socket
        """
    def getBoardSocket(self) -> depthai.CameraBoardSocket:
        """getBoardSocket(self: depthai.node.ToF) -> depthai.CameraBoardSocket

        Retrieves which board socket to use

        Returns:
            Board socket to use
        """
    @property
    def amplitude(self) -> depthai.Node.Output: ...
    @property
    def depth(self) -> depthai.Node.Output: ...
    @property
    def initialConfig(self) -> depthai.ToFConfig: ...
    @property
    def inputConfig(self) -> depthai.Node.Input: ...
    @property
    def intensity(self) -> depthai.Node.Output: ...
    @property
    def phase(self) -> depthai.Node.Output: ...

class UVC(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.UVCProperties]] = ...
    def __init__(self, USBVideoClass) -> Any:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def setGpiosOnInit(self, list: dict[int, int]) -> None:
        """setGpiosOnInit(self: depthai.node.UVC, list: dict[int, int]) -> None

        Set GPIO list <gpio_number, value> for GPIOs to set (on/off) at init
        """
    def setGpiosOnStreamOff(self, list: dict[int, int]) -> None:
        """setGpiosOnStreamOff(self: depthai.node.UVC, list: dict[int, int]) -> None

        Set GPIO list <gpio_number, value> for GPIOs to set when streaming is disabled
        """
    def setGpiosOnStreamOn(self, list: dict[int, int]) -> None:
        """setGpiosOnStreamOn(self: depthai.node.UVC, list: dict[int, int]) -> None

        Set GPIO list <gpio_number, value> for GPIOs to set when streaming is enabled
        """
    @property
    def input(self) -> depthai.Node.Input: ...

class VideoEncoder(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.VideoEncoderProperties]] = ...
    def __init__(self, input: depthai.Node.Output, bitrate: float = ..., frameRate: float = ..., profile: depthai.VideoEncoderProperties.Profile = ..., keyframeFrequency: int = ..., lossless: bool = ..., quality: int = ...) -> None:
        """__init__(self: depthai.node.VideoEncoder, input: depthai.Node.Output, bitrate: float = 0, frameRate: float = 30.0, profile: depthai.VideoEncoderProperties.Profile = <Profile.H264_BASELINE: 0>, keyframeFrequency: int = 30, lossless: bool = False, quality: int = 80) -> None"""
    def build(self, input: depthai.Node.Output, bitrate: float = ..., frameRate: float = ..., profile: depthai.VideoEncoderProperties.Profile = ..., keyframeFrequency: int = ..., lossless: bool = ..., quality: int = ...) -> VideoEncoder:
        """build(self: depthai.node.VideoEncoder, input: depthai.Node.Output, bitrate: float = 0, frameRate: float = 30.0, profile: depthai.VideoEncoderProperties.Profile = <Profile.H264_BASELINE: 0>, keyframeFrequency: int = 30, lossless: bool = False, quality: int = 80) -> depthai.node.VideoEncoder"""
    def getBitrate(self) -> int:
        """getBitrate(self: depthai.node.VideoEncoder) -> int

        Get bitrate in bps
        """
    def getBitrateKbps(self) -> int:
        """getBitrateKbps(self: depthai.node.VideoEncoder) -> int

        Get bitrate in kbps
        """
    def getFrameRate(self) -> float:
        """getFrameRate(self: depthai.node.VideoEncoder) -> float

        Get frame rate
        """
    def getHeight(self) -> int:
        """getHeight(self: depthai.node.VideoEncoder) -> int

        Get input height
        """
    def getKeyframeFrequency(self) -> int:
        """getKeyframeFrequency(self: depthai.node.VideoEncoder) -> int

        Get keyframe frequency
        """
    def getLossless(self) -> bool:
        """getLossless(self: depthai.node.VideoEncoder) -> bool

        Get lossless mode. Applies only when using [M]JPEG profile.
        """
    def getMaxOutputFrameSize(self) -> int:
        """getMaxOutputFrameSize(self: depthai.node.VideoEncoder) -> int"""
    def getNumBFrames(self) -> int:
        """getNumBFrames(self: depthai.node.VideoEncoder) -> int

        Get number of B frames
        """
    def getNumFramesPool(self) -> int:
        """getNumFramesPool(self: depthai.node.VideoEncoder) -> int

        Get number of frames in pool

        Returns:
            Number of pool frames
        """
    def getProfile(self) -> depthai.VideoEncoderProperties.Profile:
        """getProfile(self: depthai.node.VideoEncoder) -> depthai.VideoEncoderProperties.Profile

        Get profile
        """
    def getQuality(self) -> int:
        """getQuality(self: depthai.node.VideoEncoder) -> int

        Get quality
        """
    def getRateControlMode(self) -> depthai.VideoEncoderProperties.RateControlMode:
        """getRateControlMode(self: depthai.node.VideoEncoder) -> depthai.VideoEncoderProperties.RateControlMode

        Get rate control mode
        """
    def getSize(self) -> tuple[int, int]:
        """getSize(self: depthai.node.VideoEncoder) -> tuple[int, int]

        Get input size
        """
    def getWidth(self) -> int:
        """getWidth(self: depthai.node.VideoEncoder) -> int

        Get input width
        """
    def setBitrate(self, bitrate: int) -> None:
        """setBitrate(self: depthai.node.VideoEncoder, bitrate: int) -> None

        Set output bitrate in bps, for CBR rate control mode. 0 for auto (based on frame
        size and FPS)
        """
    def setBitrateKbps(self, bitrateKbps: int) -> None:
        """setBitrateKbps(self: depthai.node.VideoEncoder, bitrateKbps: int) -> None

        Set output bitrate in kbps, for CBR rate control mode. 0 for auto (based on
        frame size and FPS)
        """
    @overload
    def setDefaultProfilePreset(self, fps: float, profile: depthai.VideoEncoderProperties.Profile) -> None:
        """setDefaultProfilePreset(*args, **kwargs)
        Overloaded function.

        1. setDefaultProfilePreset(self: depthai.node.VideoEncoder, fps: float, profile: depthai.VideoEncoderProperties.Profile) -> None

        Sets a default preset based on specified frame rate and profile

        Parameter ``fps``:
            Frame rate in frames per second

        Parameter ``profile``:
            Encoding profile

        2. setDefaultProfilePreset(self: depthai.node.VideoEncoder, arg0: int, arg1: int, arg2: float, arg3: depthai.VideoEncoderProperties.Profile) -> None

        Sets a default preset based on specified input size, frame rate and profile

        Parameter ``width``:
            Input frame width

        Parameter ``height``:
            Input frame height

        Parameter ``fps``:
            Frame rate in frames per second

        Parameter ``profile``:
            Encoding profile

        3. setDefaultProfilePreset(self: depthai.node.VideoEncoder, arg0: tuple[int, int], arg1: float, arg2: depthai.VideoEncoderProperties.Profile) -> None

        Sets a default preset based on specified input size, frame rate and profile

        Parameter ``size``:
            Input frame size

        Parameter ``fps``:
            Frame rate in frames per second

        Parameter ``profile``:
            Encoding profile
        """
    @overload
    def setDefaultProfilePreset(self, arg0: int, arg1: int, arg2: float, arg3: depthai.VideoEncoderProperties.Profile) -> None:
        """setDefaultProfilePreset(*args, **kwargs)
        Overloaded function.

        1. setDefaultProfilePreset(self: depthai.node.VideoEncoder, fps: float, profile: depthai.VideoEncoderProperties.Profile) -> None

        Sets a default preset based on specified frame rate and profile

        Parameter ``fps``:
            Frame rate in frames per second

        Parameter ``profile``:
            Encoding profile

        2. setDefaultProfilePreset(self: depthai.node.VideoEncoder, arg0: int, arg1: int, arg2: float, arg3: depthai.VideoEncoderProperties.Profile) -> None

        Sets a default preset based on specified input size, frame rate and profile

        Parameter ``width``:
            Input frame width

        Parameter ``height``:
            Input frame height

        Parameter ``fps``:
            Frame rate in frames per second

        Parameter ``profile``:
            Encoding profile

        3. setDefaultProfilePreset(self: depthai.node.VideoEncoder, arg0: tuple[int, int], arg1: float, arg2: depthai.VideoEncoderProperties.Profile) -> None

        Sets a default preset based on specified input size, frame rate and profile

        Parameter ``size``:
            Input frame size

        Parameter ``fps``:
            Frame rate in frames per second

        Parameter ``profile``:
            Encoding profile
        """
    @overload
    def setDefaultProfilePreset(self, arg0: tuple[int, int], arg1: float, arg2: depthai.VideoEncoderProperties.Profile) -> None:
        """setDefaultProfilePreset(*args, **kwargs)
        Overloaded function.

        1. setDefaultProfilePreset(self: depthai.node.VideoEncoder, fps: float, profile: depthai.VideoEncoderProperties.Profile) -> None

        Sets a default preset based on specified frame rate and profile

        Parameter ``fps``:
            Frame rate in frames per second

        Parameter ``profile``:
            Encoding profile

        2. setDefaultProfilePreset(self: depthai.node.VideoEncoder, arg0: int, arg1: int, arg2: float, arg3: depthai.VideoEncoderProperties.Profile) -> None

        Sets a default preset based on specified input size, frame rate and profile

        Parameter ``width``:
            Input frame width

        Parameter ``height``:
            Input frame height

        Parameter ``fps``:
            Frame rate in frames per second

        Parameter ``profile``:
            Encoding profile

        3. setDefaultProfilePreset(self: depthai.node.VideoEncoder, arg0: tuple[int, int], arg1: float, arg2: depthai.VideoEncoderProperties.Profile) -> None

        Sets a default preset based on specified input size, frame rate and profile

        Parameter ``size``:
            Input frame size

        Parameter ``fps``:
            Frame rate in frames per second

        Parameter ``profile``:
            Encoding profile
        """
    def setFrameRate(self, frameRate: float) -> None:
        """setFrameRate(self: depthai.node.VideoEncoder, frameRate: float) -> None

        Sets expected frame rate

        Parameter ``frameRate``:
            Frame rate in frames per second
        """
    def setKeyframeFrequency(self, freq: int) -> None:
        """setKeyframeFrequency(self: depthai.node.VideoEncoder, freq: int) -> None

        Set keyframe frequency. Every Nth frame a keyframe is inserted.

        Applicable only to H264 and H265 profiles

        Examples:

        - 30 FPS video, keyframe frequency: 30. Every 1s a keyframe will be inserted

        - 60 FPS video, keyframe frequency: 180. Every 3s a keyframe will be inserted
        """
    def setLossless(self, arg0: bool) -> None:
        """setLossless(self: depthai.node.VideoEncoder, arg0: bool) -> None

        Set lossless mode. Applies only to [M]JPEG profile

        Parameter ``lossless``:
            True to enable lossless jpeg encoding, false otherwise
        """
    def setMaxOutputFrameSize(self, maxFrameSize: int) -> None:
        """setMaxOutputFrameSize(self: depthai.node.VideoEncoder, maxFrameSize: int) -> None

        Specifies maximum output encoded frame size
        """
    def setNumBFrames(self, numBFrames: int) -> None:
        """setNumBFrames(self: depthai.node.VideoEncoder, numBFrames: int) -> None

        Set number of B frames to be inserted
        """
    def setNumFramesPool(self, frames: int) -> None:
        """setNumFramesPool(self: depthai.node.VideoEncoder, frames: int) -> None

        Set number of frames in pool

        Parameter ``frames``:
            Number of pool frames
        """
    @overload
    def setProfile(self, profile: depthai.VideoEncoderProperties.Profile) -> None:
        """setProfile(*args, **kwargs)
        Overloaded function.

        1. setProfile(self: depthai.node.VideoEncoder, profile: depthai.VideoEncoderProperties.Profile) -> None

        Set encoding profile

        2. setProfile(self: depthai.node.VideoEncoder, arg0: tuple[int, int], arg1: depthai.VideoEncoderProperties.Profile) -> None

        Set encoding profile

        3. setProfile(self: depthai.node.VideoEncoder, arg0: int, arg1: int, arg2: depthai.VideoEncoderProperties.Profile) -> None

        Set encoding profile
        """
    @overload
    def setProfile(self, arg0: tuple[int, int], arg1: depthai.VideoEncoderProperties.Profile) -> None:
        """setProfile(*args, **kwargs)
        Overloaded function.

        1. setProfile(self: depthai.node.VideoEncoder, profile: depthai.VideoEncoderProperties.Profile) -> None

        Set encoding profile

        2. setProfile(self: depthai.node.VideoEncoder, arg0: tuple[int, int], arg1: depthai.VideoEncoderProperties.Profile) -> None

        Set encoding profile

        3. setProfile(self: depthai.node.VideoEncoder, arg0: int, arg1: int, arg2: depthai.VideoEncoderProperties.Profile) -> None

        Set encoding profile
        """
    @overload
    def setProfile(self, arg0: int, arg1: int, arg2: depthai.VideoEncoderProperties.Profile) -> None:
        """setProfile(*args, **kwargs)
        Overloaded function.

        1. setProfile(self: depthai.node.VideoEncoder, profile: depthai.VideoEncoderProperties.Profile) -> None

        Set encoding profile

        2. setProfile(self: depthai.node.VideoEncoder, arg0: tuple[int, int], arg1: depthai.VideoEncoderProperties.Profile) -> None

        Set encoding profile

        3. setProfile(self: depthai.node.VideoEncoder, arg0: int, arg1: int, arg2: depthai.VideoEncoderProperties.Profile) -> None

        Set encoding profile
        """
    def setQuality(self, quality: int) -> None:
        """setQuality(self: depthai.node.VideoEncoder, quality: int) -> None

        Set quality

        Parameter ``quality``:
            Value between 0-100%. Approximates quality
        """
    def setRateControlMode(self, mode: depthai.VideoEncoderProperties.RateControlMode) -> None:
        """setRateControlMode(self: depthai.node.VideoEncoder, mode: depthai.VideoEncoderProperties.RateControlMode) -> None

        Set rate control mode
        """
    @property
    def bitstream(self) -> depthai.Node.Output: ...
    @property
    def input(self) -> depthai.Node.Input: ...
    @property
    def out(self) -> depthai.Node.Output: ...

class Warp(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.WarpProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getHwIds(self) -> list[int]:
        """getHwIds(self: depthai.node.Warp) -> list[int]

        Retrieve which hardware warp engines to use
        """
    def getInterpolation(self) -> depthai.Interpolation:
        """getInterpolation(self: depthai.node.Warp) -> depthai.Interpolation

        Retrieve which interpolation method to use
        """
    def setHwIds(self, arg0: list[int]) -> None:
        """setHwIds(self: depthai.node.Warp, arg0: list[int]) -> None

        Specify which hardware warp engines to use

        Parameter ``ids``:
            Which warp engines to use (0, 1, 2)
        """
    def setInterpolation(self, arg0: depthai.Interpolation) -> None:
        """setInterpolation(self: depthai.node.Warp, arg0: depthai.Interpolation) -> None

        Specify which interpolation method to use

        Parameter ``interpolation``:
            type of interpolation
        """
    def setMaxOutputFrameSize(self, arg0: int) -> None:
        """setMaxOutputFrameSize(self: depthai.node.Warp, arg0: int) -> None

        Specify maximum size of output image.

        Parameter ``maxFrameSize``:
            Maximum frame size in bytes
        """
    def setNumFramesPool(self, arg0: int) -> None:
        """setNumFramesPool(self: depthai.node.Warp, arg0: int) -> None

        Specify number of frames in pool.

        Parameter ``numFramesPool``:
            How many frames should the pool have
        """
    @overload
    def setOutputSize(self, arg0: int, arg1: int) -> None:
        """setOutputSize(*args, **kwargs)
        Overloaded function.

        1. setOutputSize(self: depthai.node.Warp, arg0: int, arg1: int) -> None

        Sets output frame size in pixels

        Parameter ``size``:
            width and height in pixels

        2. setOutputSize(self: depthai.node.Warp, arg0: tuple[int, int]) -> None
        """
    @overload
    def setOutputSize(self, arg0: tuple[int, int]) -> None:
        """setOutputSize(*args, **kwargs)
        Overloaded function.

        1. setOutputSize(self: depthai.node.Warp, arg0: int, arg1: int) -> None

        Sets output frame size in pixels

        Parameter ``size``:
            width and height in pixels

        2. setOutputSize(self: depthai.node.Warp, arg0: tuple[int, int]) -> None
        """
    @overload
    def setWarpMesh(self, arg0: list[depthai.Point2f], arg1: int, arg2: int) -> None:
        """setWarpMesh(*args, **kwargs)
        Overloaded function.

        1. setWarpMesh(self: depthai.node.Warp, arg0: list[depthai.Point2f], arg1: int, arg2: int) -> None

        2. setWarpMesh(self: depthai.node.Warp, arg0: list[tuple[float, float]], arg1: int, arg2: int) -> None
        """
    @overload
    def setWarpMesh(self, arg0: list[tuple[float, float]], arg1: int, arg2: int) -> None:
        """setWarpMesh(*args, **kwargs)
        Overloaded function.

        1. setWarpMesh(self: depthai.node.Warp, arg0: list[depthai.Point2f], arg1: int, arg2: int) -> None

        2. setWarpMesh(self: depthai.node.Warp, arg0: list[tuple[float, float]], arg1: int, arg2: int) -> None
        """
    @property
    def inputImage(self) -> depthai.Node.Input: ...
    @property
    def out(self) -> depthai.Node.Output: ...

class XLinkIn(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.XLinkInProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getMaxDataSize(self) -> int:
        """getMaxDataSize(self: depthai.node.XLinkIn) -> int

        Get maximum messages size in bytes
        """
    def getNumFrames(self) -> int:
        """getNumFrames(self: depthai.node.XLinkIn) -> int

        Get number of frames in pool
        """
    def getStreamName(self) -> str:
        """getStreamName(self: depthai.node.XLinkIn) -> str

        Get stream name
        """
    def setMaxDataSize(self, maxDataSize: int) -> None:
        """setMaxDataSize(self: depthai.node.XLinkIn, maxDataSize: int) -> None

        Set maximum message size it can receive

        Parameter ``maxDataSize``:
            Maximum size in bytes
        """
    def setNumFrames(self, numFrames: int) -> None:
        """setNumFrames(self: depthai.node.XLinkIn, numFrames: int) -> None

        Set number of frames in pool for sending messages forward

        Parameter ``numFrames``:
            Maximum number of frames in pool
        """
    def setStreamName(self, streamName: str) -> None:
        """setStreamName(self: depthai.node.XLinkIn, streamName: str) -> None

        Specifies XLink stream name to use.

        The name should not start with double underscores '__', as those are reserved
        for internal use.

        Parameter ``name``:
            Stream name
        """
    @property
    def out(self) -> depthai.Node.Output: ...

class XLinkOut(depthai.DeviceNode):
    Properties: ClassVar[type[depthai.XLinkOutProperties]] = ...
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getFpsLimit(self) -> float:
        """getFpsLimit(self: depthai.node.XLinkOut) -> float

        Get rate limit in messages per second
        """
    def getMetadataOnly(self) -> bool:
        """getMetadataOnly(self: depthai.node.XLinkOut) -> bool

        Get whether to transfer only messages attributes and not buffer data
        """
    def getStreamName(self) -> str:
        """getStreamName(self: depthai.node.XLinkOut) -> str

        Get stream name
        """
    def setFpsLimit(self, fpsLimit: float) -> None:
        """setFpsLimit(self: depthai.node.XLinkOut, fpsLimit: float) -> None

        Specifies a message sending limit. It's approximated from specified rate.

        Parameter ``fps``:
            Approximate rate limit in messages per second
        """
    def setMetadataOnly(self, arg0: bool) -> None:
        """setMetadataOnly(self: depthai.node.XLinkOut, arg0: bool) -> None

        Specify whether to transfer only messages attributes and not buffer data
        """
    def setStreamName(self, streamName: str) -> None:
        """setStreamName(self: depthai.node.XLinkOut, streamName: str) -> None

        Specifies XLink stream name to use.

        The name should not start with double underscores '__', as those are reserved
        for internal use.

        Parameter ``name``:
            Stream name
        """
    @property
    def input(self) -> depthai.Node.Input: ...

class YoloDetectionNetwork(DetectionNetwork):
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getAnchorMasks(self) -> dict[str, list[int]]:
        """getAnchorMasks(self: depthai.node.YoloDetectionNetwork) -> dict[str, list[int]]

        Get anchor masks
        """
    def getAnchors(self) -> list[float]:
        """getAnchors(self: depthai.node.YoloDetectionNetwork) -> list[float]

        Get anchors
        """
    def getCoordinateSize(self) -> int:
        """getCoordinateSize(self: depthai.node.YoloDetectionNetwork) -> int

        Get coordianate size
        """
    def getIouThreshold(self) -> float:
        """getIouThreshold(self: depthai.node.YoloDetectionNetwork) -> float

        Get Iou threshold
        """
    def getNumClasses(self) -> int:
        """getNumClasses(self: depthai.node.YoloDetectionNetwork) -> int

        Get num classes
        """
    def setAnchorMasks(self, anchorMasks: dict[str, list[int]]) -> None:
        """setAnchorMasks(self: depthai.node.YoloDetectionNetwork, anchorMasks: dict[str, list[int]]) -> None

        Set anchor masks
        """
    @overload
    def setAnchors(self, anchors: list[list[list[float]]]) -> None:
        """setAnchors(*args, **kwargs)
        Overloaded function.

        1. setAnchors(self: depthai.node.YoloDetectionNetwork, anchors: list[list[list[float]]]) -> None

        Set anchors

        2. setAnchors(self: depthai.node.YoloDetectionNetwork, anchors: list[float]) -> None

        Sets anchors with masks included.

        Parameter ``anchors``:
            Anchors grouped by masks from biggest mask(ex.: side26) to smallest(ex.:
            side13)

        Ordering should be from biggest to smallest (example: { side26Anchors,
        side13Anchors, side7Anchors }). Format is: { { // side26Anchors { 10, // width
        14 // height }, { 23, // width 27 // height }, { 37, // width 58 // height } },
        { // side13Anchors { 81, // width 82 // height }, { 135, // width 169 // height
        }, { 344, // width 319 // height }, ... other anchors for side13 }, ... other
        sides (ordered from biggest to smallest) anchors }
        """
    @overload
    def setAnchors(self, anchors: list[float]) -> None:
        """setAnchors(*args, **kwargs)
        Overloaded function.

        1. setAnchors(self: depthai.node.YoloDetectionNetwork, anchors: list[list[list[float]]]) -> None

        Set anchors

        2. setAnchors(self: depthai.node.YoloDetectionNetwork, anchors: list[float]) -> None

        Sets anchors with masks included.

        Parameter ``anchors``:
            Anchors grouped by masks from biggest mask(ex.: side26) to smallest(ex.:
            side13)

        Ordering should be from biggest to smallest (example: { side26Anchors,
        side13Anchors, side7Anchors }). Format is: { { // side26Anchors { 10, // width
        14 // height }, { 23, // width 27 // height }, { 37, // width 58 // height } },
        { // side13Anchors { 81, // width 82 // height }, { 135, // width 169 // height
        }, { 344, // width 319 // height }, ... other anchors for side13 }, ... other
        sides (ordered from biggest to smallest) anchors }
        """
    def setCoordinateSize(self, coordinates: int) -> None:
        """setCoordinateSize(self: depthai.node.YoloDetectionNetwork, coordinates: int) -> None

        Set coordianate size
        """
    def setIouThreshold(self, thresh: float) -> None:
        """setIouThreshold(self: depthai.node.YoloDetectionNetwork, thresh: float) -> None

        Set Iou threshold
        """
    def setNumClasses(self, numClasses: int) -> None:
        """setNumClasses(self: depthai.node.YoloDetectionNetwork, numClasses: int) -> None

        Set num classes
        """

class YoloSpatialDetectionNetwork(SpatialDetectionNetwork):
    def __init__(self, *args, **kwargs) -> None:
        """Initialize self.  See help(type(self)) for accurate signature."""
    def getAnchorMasks(self) -> dict[str, list[int]]:
        """getAnchorMasks(self: depthai.node.YoloSpatialDetectionNetwork) -> dict[str, list[int]]

        Get anchor masks
        """
    def getAnchors(self) -> list[float]:
        """getAnchors(self: depthai.node.YoloSpatialDetectionNetwork) -> list[float]

        Get anchors
        """
    def getCoordinateSize(self) -> int:
        """getCoordinateSize(self: depthai.node.YoloSpatialDetectionNetwork) -> int

        Get coordianate size
        """
    def getIouThreshold(self) -> float:
        """getIouThreshold(self: depthai.node.YoloSpatialDetectionNetwork) -> float

        Get Iou threshold
        """
    def getNumClasses(self) -> int:
        """getNumClasses(self: depthai.node.YoloSpatialDetectionNetwork) -> int

        Get num classes
        """
    def setAnchorMasks(self, anchorMasks: dict[str, list[int]]) -> None:
        """setAnchorMasks(self: depthai.node.YoloSpatialDetectionNetwork, anchorMasks: dict[str, list[int]]) -> None

        Set anchor masks
        """
    def setAnchors(self, anchors: list[float]) -> None:
        """setAnchors(self: depthai.node.YoloSpatialDetectionNetwork, anchors: list[float]) -> None

        Set anchors
        """
    def setCoordinateSize(self, coordinates: int) -> None:
        """setCoordinateSize(self: depthai.node.YoloSpatialDetectionNetwork, coordinates: int) -> None

        Set coordianate size
        """
    def setIouThreshold(self, thresh: float) -> None:
        """setIouThreshold(self: depthai.node.YoloSpatialDetectionNetwork, thresh: float) -> None

        Set Iou threshold
        """
    def setNumClasses(self, numClasses: int) -> None:
        """setNumClasses(self: depthai.node.YoloSpatialDetectionNetwork, numClasses: int) -> None

        Set num classes
        """
